//------------------------------------------------------------------------------
// API Ambiguouslist.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Cthota, keithkin
//
// <header>	$Ambiguouslist$</header>
//------------------------------------------------------------------------------
function VEAmbiguouslist(vemap)
{
	VEValidator.ValidateNonNull(vemap, "vemap");
	this.m_vemap = vemap;
	var self=this;
	this.ID = this.m_vemap.ID + "_veplacelistpanel";

	this.Show = function(a, onSelectCallback)
	{
		var body = null;
		
		if(this.veplacelistpanel == null || this.veplacelistpanel == "undefined")
		{
			var e= document.createElement("div");
			e.id = this.ID;
			e.className = "VE_PlaceList";
			e.style.top = this.m_vemap.GetHeight()/2 - Msn.VE.API.Globals.veplacelistpanelheight/2 + "px";
			e.style.left = this.m_vemap.GetWidth()/2 - Msn.VE.API.Globals.veplacelistpanelwidth/2 + "px";
			e.style.width = Msn.VE.API.Globals.veplacelistpanelwidth + "px";
			e.style.height = Msn.VE.API.Globals.veplacelistpanelheight  + "px";
			e.style.position = "absolute";
			this.veplacelistpanel=e;

			// Create the title element
			var title = document.createElement("a");
			title.className = "VE_PlaceList_Title";
			title.style.zIndex = parseInt(Msn.VE.API.Globals.veplacelistpanelzIndex) + 1;
			title.style.width = parseInt(Msn.VE.API.Globals.veplacelistpanelwidth) - 5 + "px";
			title.style.top = "1px";
			title.style.left = "1px";
			title.innerHTML = IOSec.EncodeHtml(L_selectlocation_text);
			title.unselectable = "on";
			this.veplacelistpanel.appendChild(title);

			// Create the close button
			var cb = document.createElement("a");
			cb.className = "VE_PlaceList_Close";
			cb.style.zIndex = parseInt(Msn.VE.API.Globals.veplacelistpanelzIndex) + 2;
			cb.style.top = "1px";
			cb.style.right = "1px";
			cb.onclick = self.Hide;
			cb.unselectable = "on";
			cb.innerHTML = L_close_text;	
			this.veplacelistpanel.appendChild(cb);

			body = document.createElement("div");
			body.id = this.m_vemap.ID + "_veplacelistbody";
			body.style.zIndex = 300;
			body.className = "VE_PlaceList_Body";
			this.veplacelistpanel.appendChild(body);

			// Add the panel to the document
			this.m_vemap.AddControl(this.veplacelistpanel, Msn.VE.API.Globals.veplacelistpanelzIndex);
		}
		else
		{
			body = document.getElementById(this.m_vemap.ID + "_veplacelistbody");
		}
		
		body.innerHTML = "";	
		for(var i=0;i<a.length;i++)
		{
			if(a[i] == null || a[i] == "undefined")
				continue;
			var loc = document.createElement("div");
			loc.id = "veplacelistpanel_body_loc" + i;
			loc.className = "VE_PlaceList_Location";
			loc.style.position = "relative";
			loc.style.zIndex = parseInt(Msn.VE.API.Globals.veplacelistpanelzIndex) + 4;
			loc.unselectable = "on";
			//only works for dd
			
			var veambiglistHide = "VEMap._GetMapFromGUID('" + this.m_vemap.GUID + "').m_veambiguouslist.Hide();";
			var veambiglistSetViewport = "VEMap._GetMapFromGUID('" + this.m_vemap.GUID + "').vemapcontrol.SetViewport";
			if(a[i].name)
			{
				if(onSelectCallback != null && onSelectCallback != "undefined")
					loc.innerHTML = "<a onclick=\"javascript:" + veambiglistHide + onSelectCallback + "('" + a[i].name + "', "  + a[i].latitude + ", " + a[i].longitude + ");\">" + a[i].name + "</a>";
				else
					loc.innerHTML = "<a onclick=\"javascript:" + veambiglistHide + "\">" + a[i].name + "</a>";
			}
			else
			{
				if(onSelectCallback != null && onSelectCallback != "undefined")
					loc.innerHTML = "<a onclick=\"javascript:" + veambiglistHide + onSelectCallback + "('" + a[i][0] + "', "  + a[i][1] + ", " + a[i][2] + ", " + a[i][3] + ", " + a[i][4] + ");\">" + a[i][0]+ "</a>";
				else
					loc.innerHTML = "<a onclick=\"javascript:" + veambiglistHide + veambiglistSetViewport + "(" + a[i][1] + ", " + a[i][2] + ", " + a[i][3] + ", " + a[i][4] + ");\">" + a[i][0]+ "</a>";			
			}
			body.appendChild(loc);
		}

		this.veplacelistpanel.style.display = "block";
	}

	this.Hide = function()
	{
		if ((self.veplacelistpanel != null) &&
			(self.veplacelistpanel != "undefined"))
		{
			self.veplacelistpanel.style.display = "none";
		}
	}

	//IsVisible: returns true if the ambiguous list is visible. 
	//returns false otherwise.
	this.IsVisible = function()
	{
		var isVisible = false;
		if((this.veplacelistpanel != null) && 
			(this.veplacelistpanel != "undefined") && 
			(this.veplacelistpanel.style.display != "none"))
		{
			isVisible = true;
		}
		return isVisible;
	}

	this.Dispose = function()
	{
		if ((this.veplacelistpanel != null) &&
			(this.veplacelistpanel != "undefined"))
		{	    
			this.veplacelistpanel = null;
		}
	}
}
