//------------------------------------------------------------------------------
// API/Network.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Cthota
//
// <header>	$Network$</header>
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//Parameter class
//==================================================================================================
function VEParameter(pramName, paramValue){
this.Name=pramName; 
this.Value=paramValue;
}
VEParameter.prototype.Name=this.name;
VEParameter.prototype.Value=this.value;
//End Parameter class
//==================================================================================================
//==================================================================================================
//Network class
function VENetwork(url, onBeginInvoke, onEndInvoke){
	if(url != null && url != "undefined")
		this.ServiceUrl = url;
		
	//Attach begin and end invoke
	if(onBeginInvoke != null && onBeginInvoke != "undefined")
		Msn.VE.API.Globals.veonbegininvokeevent = onBeginInvoke;
	if(onEndInvoke != null && onEndInvoke != "undefined")		
		Msn.VE.API.Globals.veonendinvokeevent = onEndInvoke;		
}
function BeginInvoke(endinvokeMethod, parameters, fnCallback, endInvokeTarget)
{
	if(this.ServiceUrl==null || this.ServiceUrl=="undefined" || this.ServiceUrl.length==0)
		throw new VEException("VENetwork:BeginInvoke", "err_noserviceurl", L_noserviceurl_text)	
	
	//fire begin invoke
	if(Msn.VE.API.Globals.veonbegininvokeevent)
	{
		Msn.VE.API.Globals.veonbegininvokeevent();
	}

	var executionid = VENetwork.GetExecutionID();
	if(parameters)
	{
		var methodurl = this.ServiceUrl + "?";
		for(var i=0;i<parameters.length;i++)
		{
			methodurl = methodurl + parameters[i].Name;
			methodurl = methodurl + "=";
			methodurl = methodurl + parameters[i].Value;		
			methodurl = methodurl + "&";	
		}
	}	
	else
	{
		var methodurl = this.ServiceUrl;
	}
	
	if(Msn.VE.API.Globals.vedebug)
		alert(methodurl);
				
	//Now attach script
	var elScript = document.createElement("script");
	elScript.type="text/javascript";
	elScript.language="javascript";
	elScript.id=executionid;	
	elScript.src=methodurl;
	//IE Only
	if(navigator.userAgent.indexOf("IE")>=0)
	{
		//onreadystatechange	
		elScript.onreadystatechange=function(){
			if (elScript && ("loaded"==elScript.readyState || "complete"==elScript.readyState))
			{			
				elScript.onreadystatechange = null;
				EndInvoke(endInvokeTarget, fnCallback, endinvokeMethod, elScript, executionid);
			}		
		}
	}
	else
	{
		//Mozilla only
		elScript.onload=function(){
			elScript.onload = null;		
			EndInvoke(endInvokeTarget, fnCallback, endinvokeMethod, elScript, executionid);
		}		
	}	
	//Attach to document
	VENetwork.GetAttachTarget().appendChild(elScript);		
}

function EndInvoke(endInvokeTarget, fnCallback, endInvokeMethod, elScript, executionId)
{	
	//get the variables
	var objects = null;
	if(endInvokeMethod)
	{
		eval("objects = " + endInvokeMethod + "();");				
	}
	//remove javascript child
	document.getElementsByTagName("head")[0].removeChild(elScript);
	elScript = null;			
	//call callback method
	if(fnCallback != null && fnCallback != "undefined")		
		fnCallback(objects, endInvokeTarget);	
	//fire end invoke
	if(Msn.VE.API.Globals.veonendinvokeevent)
	{
		Msn.VE.API.Globals.veonendinvokeevent();
	}
}

VENetwork.GetExecutionID = function()
{
	var date = new Date();
	var id = Date.UTC(date.getFullYear(), 
		date.getMonth(),
		date.getDate(),
		date.getHours(),
		date.getMinutes(),
		date.getSeconds(),
		date.getMilliseconds());
	
	id += Math.round(Math.random() * 1000000);
	
	return id;
	
}

//Get xmlhttp stuff
function GetXmlHttp()
{
	var xmlhttp = null;
	try
	{ 
		xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
	}
	catch (ex)
	{ 
		try
		{
			xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
		}
		catch (ex)
		{
			xmlhttp = null;
		}
	}	
	if (!xmlhttp && typeof XMLHttpRequest != "undefined")
	{xmlhttp = new XMLHttpRequest();}	
	return xmlhttp;
}
VENetwork.AttachStyleSheetCallback = function(fnCallback)
{
	if(fnCallback)
	{
		fnCallback();
	}
}
VENetwork.AttachStyleSheet = function(stylesUrl, fnCallback)
{	
	if(stylesUrl == null || stylesUrl == "undefined" || stylesUrl.length == 0)
		throw new VEException("VENetwork:AttachStylesheet", "err_nostylesurl", L_nostylesurl_text)		

	elStyle = document.createElement("link");	
	elStyle.rel="stylesheet";
	elStyle.type="text/css";
	elStyle.rev="stylesheet";
	elStyle.id=VENetwork.GetExecutionID();
	elStyle.href=stylesUrl;
	//Attach to document	
	VENetwork.GetAttachTarget().appendChild(elStyle);				
	//IE Only
	if(navigator.userAgent.indexOf("IE")>=0)
	{
		//onreadystatechange	
		elStyle.onreadystatechange=function(){
			if (elStyle && ("loaded"==elStyle.readyState || "complete"==elStyle.readyState))
			{
				elStyle.onreadystatechange = null;
				VENetwork.AttachStyleSheetCallback(fnCallback);
			}		
		}
	}
	else
	{
		//Mozilla only
		VENetwork.AttachStyleSheetCallback(fnCallback);
	}	
	return;	
}
VENetwork.DownloadScriptCallback = function(fnCallback)
{
	if(fnCallback)
	{
		fnCallback();
	}
}
VENetwork.DownloadScript = function (scriptUrl, fnCallback)
{	
	if(scriptUrl == null || scriptUrl == "undefined" || scriptUrl.length == 0)
		throw new VEException("VENetwork:DownloadScript", "err_noscripturl", L_noscripturl_text)		

	elScript = document.createElement("script");
	elScript.type="text/javascript";
	elScript.language="javascript";
	elScript.id=VENetwork.GetExecutionID();
	elScript.src=scriptUrl;
	//IE Only
	if(navigator.userAgent.indexOf("IE")>=0)
	{
		//onreadystatechange	
		elScript.onreadystatechange=function(){
			if (elScript && ("loaded"==elScript.readyState || "complete"==elScript.readyState))
			{
				elScript.onreadystatechange = null;
				VENetwork.DownloadScriptCallback(fnCallback);
			}		
		}
	}
	else
	{
		//Mozilla only
		elScript.onload=function(){
			elScript.onload = null;		
			VENetwork.DownloadScriptCallback(fnCallback);
		}		
	}	
	//Attach to document
	VENetwork.GetAttachTarget().appendChild(elScript);			
	return;
}
VENetwork.DownloadXml = function (xmlUrl, method, fnCallback)
{
	var xmlhttp = GetXmlHttp();
	xmlhttp.open(method, xmlUrl ,true);	
	xmlhttp.onreadystatechange=function() 
	{	
		if (xmlhttp.readyState == 4) 
		{
			if(fnCallback)
			{
				fnCallback(xmlhttp.responseXML);
			}
			xmlhttp	= null;
		}
	}
	xmlhttp.send(null);		
}
VENetwork.GetAttachTarget = function()
{
	if(document.getElementsByTagName("head")[0] != null)
		return document.getElementsByTagName("head")[0];
	else
		throw new VEException("VENetwork:cstr", "err_noheadelement", L_noheadelement_text);
}

//Prototype assignment
VENetwork.prototype.BeginInvoke=BeginInvoke;
VENetwork.prototype.EndInvoke=EndInvoke;
//End Network class
//========================================================================
