//------------------------------------------------------------------------------
// API Validator.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Cthota, keithkin
//
// <header>	$Globals$</header>
//------------------------------------------------------------------------------
function VEValidator()
{
	//do nothing
}

VEValidator.ValidateFloat = function(argvalue, argname)
{
	var method = "";
	if(arguments != null && arguments.caller != null)
	{
		method = VEValidator.GetCaller(arguments.caller);
	}
	if(method == "")
	{
		method = "VEValidator.ValidateFloat";
	}
	if(argvalue == null || argvalue == "undefined")
	{
		throw new VEException(method, "err_invalidargument", L_invalidargument_text.replace("%1", argname).replace("%2", "float"));
	}
		
	try
	{
		if(isNaN(parseFloat(argvalue)))
			throw new VEException(method, "err_invalidargument", L_invalidargument_text.replace("%1", argname).replace("%2", "float"));		
		
		return true;
	}
	catch(err)
	{
		throw new VEException(method, "err_invalidargument", L_invalidargument_text.replace("%1", argname).replace("%2", "float"));			
	}		
}
VEValidator.ValidateInt = function(argvalue, argname)
{
	var method = "";
	if(arguments != null && arguments.caller != null)
	{
		method = VEValidator.GetCaller(arguments.caller);
	}
	if(method == "")
	{
		method = "VEValidator.ValidateInt";
	}
	if(argvalue == null || argvalue == "undefined")
	{
		throw new VEException(method, "err_invalidargument", L_invalidargument_text.replace("%1", argname).replace("%2", "int"));
	}
		
	try
	{
		if(isNaN(parseInt(argvalue)))
			throw new VEException(method, "err_invalidargument", L_invalidargument_text.replace("%1", argname).replace("%2", "int"));
		
		return true;
	}
	catch(err)
	{
		throw new VEException(method, "err_invalidargument", L_invalidargument_text.replace("%1", argname).replace("%2", "int"));			
	}		
}
VEValidator.ValidateNonNull = function(argvalue, argname)
{
	var method = "";
	if(arguments != null && arguments.caller != null)
	{
		method = VEValidator.GetCaller(arguments.caller);
	}
	if(method == "")
	{
		method = "VEValidator.ValidateNonNull";
	}
	if(argvalue == null || argvalue == "undefined")
	{
		throw new VEException(method, "err_invalidargument", L_invalidargument_text.replace("%1", argname).replace("%2", "non null"));
	}	
}

VEValidator.ValidateMapStyle = function(argvalue, argname)
{
	var method = "";
	if(arguments != null && arguments.caller != null)
	{
		method = VEValidator.GetCaller(arguments.caller);
	}
	if(method == "")
	{
		method = "VEValidator.ValidateMapStyle";
	}
	
	if(argvalue == null || argvalue == "undefined")
	{
		throw new VEException(method, "err_invalidargument", L_invalidargument_text.replace("%1", argname).replace("%2", "MapStyle"));
	}	
	
	if(argvalue == "r" || argvalue == "R" || 
	argvalue == "a" || argvalue == "A" || 
	argvalue == "o" || argvalue == "O" || 
	argvalue == "h" || argvalue == "H")
	{
		return true;
	}
	
	throw new VEException(method, "err_invalidargument", L_invalidargument_text.replace("%1", argname).replace("%2", "MapStyle"));
	
}

//ValidateLayerType
VEValidator.ValidateLayerType = function(argvalue, argname)
{
	var method = "";
	if(arguments != null && arguments.caller != null)
	{
		method = VEValidator.GetCaller(arguments.caller);
	}
	if(method == "")
	{
		method = "VEValidator.ValidateLayerType";
	}
	
	if(argvalue == null || argvalue == "undefined")
	{
		throw new VEException(method, "err_invalidargument", L_invalidargument_text.replace("%1", argname).replace("%2", "VELayerType"));
	}	
	
	if((argvalue == VELayerType.GeoRSS) || (argvalue == VELayerType.VECollection))
	{
		return true;
	}
	
	throw new VEException(method, "err_invalidargument", L_invalidargument_text.replace("%1", argname).replace("%2", "VELayerType"));
	
}

//ValidateObject
VEValidator.ValidateObject = function (argvalue, argname, classType, className)
{
	var method = "";
	if(arguments != null && arguments.caller != null)
	{
		method = VEValidator.GetCaller(arguments.caller);
	}
	if(method == "")
	{
		method = "VEValidator.ValidateObject";
	}
	
	if(argvalue == null || argvalue == "undefined")
	{
		throw new VEException(method, "err_invalidargument", L_invalidargument_text.replace("%1", argname).replace("%2", "non null"));
	}

	if(!classType.prototype.isPrototypeOf(argvalue))
	{
		throw new VEException(method, "err_invalidargument", L_invalidargument_text.replace("%1", argname).replace("%2", className));
	}
}


VEValidator.GetCaller = function (func) {
	if(func!=null || func != "" )
	{
		try
		{
			var s = func.toString().match(/function (\w*)/)[1];
		}
		catch(err)
		{
			s="";
		}
		if((s == null) || (s.length == 0)) 
			return "";
		else
			return s;	
	}
	else
	{
		return "";
	}
}