//------------------------------------------------------------------------------
// Ambiglist.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Rtorres
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

var ambiguousList = new Array();
var viewportSetFromAmbiguousSelect = false;

//
// true when the disambiguation menu has appeared and no item has been
// selected
var placeAmbiguousPin = false;

//populate the disambiguator dropdown box with results
function UpdateAmbiguousList(content)
{
/*
content[i][0] = name
content[i][1] = northeast lat
content[i][2] = northeast lon
content[i][3] = southwest lat
content[i][4] = southwest lon
content[i][5] = center lat
content[i][6] = center lon
content[i][7] = place pushpin?
*/

	var el = document.getElementById('whereambiglist');
	
	if (!content || content.constructor != Array)
	{
		placeAmbiguousPin = false;
		el.style.visibility='hidden'; 
		return;
	}
	
	//keep content in memory to SetViewPort when selected
	ambiguousList = content;
	
	// get left and top position of 'where' element and set to ambiguous list	
	var xPos = GetElementLeftPosition('where');
	var yPos = GetElementTopPosition('where');
	el.style.left = xPos + 'px';
	el.style.top = yPos + document.getElementById('where').offsetHeight + 'px';
	
	// remove any child elements if any, from previous ambiguous 'where' search
	removeAmbiguousListContents();
	
	// add current found addresses
	for(var i = 0; i < content.length; i++)
	{
		var d = document.createElement('div');
		d.id = i;
		d.className = ((i==0)?'item_on':'item');
		d.onmouseover = item_MouseOver;
		d.onmouseout = item_MouseOut;
		d.onclick = SetAmbiguousViewport;		
		d.innerHTML = content[i][0];
		el.appendChild(d);
		
	}

	//document.wwf.where.value = el.firstChild.innerText;	
	Msn.VE.Search.strLastWhere = content[0][0];
	document.body.attachEvent("onclick", HideAmbiguousList);
	el.style.visibility="visible";
	if (document.all)
		el.setCapture(false);	
	placeAmbiguousPin = true;
	//
	// this throws an exception in firefox. someone should address this
	el.focus();
}

// sets viewport for selected ambiguous location
// and place a pushpin for appropriate items
function SetAmbiguousViewport(e)
{	
	viewportSetFromAmbiguousSelect = true;

	placeAmbiguousPin = false;
	var i = this.id;
	var lat1 = ambiguousList[i][1];
	var lon1 = ambiguousList[i][2];
	var lat2 = ambiguousList[i][3];
	var lon2 = ambiguousList[i][4];
	
	// set viewport	
	map.SetViewport(lat1, lon1, lat2, lon2);
	
	//We no longer look at the PlacePushpin attribute to set a pushpin.
	//WorkItem: 3512 asks that all Find Queries get a pushpin now.
	//if ( ambiguousList[i][7] == 1 )
	//{
		// Add to scratchpad
		VE_Scratchpad.AddLocation(VE_Annotations.GetTextValue(ambiguousList[i][0]), ambiguousList[i][5], ambiguousList[i][6], "");

	//}
	
	/*	Sync the where box w/ the newly selected location.
			Note: Since the data being sent to the ambiguousList is already HTML encoded (may have &# entity symbols embedded in it), we need a way
			to ensure that the actual international characters are displayed (not the entity symbols).
			The call to createElement('span') creates a temporary element whose innerHTML will be set to the escaped HTML.  Once we have this
			temporary element, we can get a referene to its TextNode object (firstChild) and pull out the nodeValue of the TextNode, which
			should always have international characters preserved. */
			var tmp = document.createElement('span');
			tmp.innerHTML = ambiguousList[i][0];
			var itemText = tmp.firstChild.nodeValue;
			document.forms['wwf']['where'].value = itemText;
			tmp = null;					// don't need this anymore
	
	//To Handle Bug # 2880 : Remove ambiguousList content
	HideAmbiguousList();
	
	/*	For some reason, IE feels compelled to "select" the entire screen when an item it double-clicked from the ambiguous list.
			Calling document.selection.clear() (for IE only -- FF does not suffer froms this) seems to alleviate the problem */
	if (document.selection)
		document.selection.clear();
}

//Remove all Items from "whereambiglist" element
function removeAmbiguousListContents()
{
	var el = document.getElementById('whereambiglist');
	var options = el.childNodes;	
	while ( options.length > 0)
	{
		el.removeChild(options[0]);
	}

	//el.style.visibility = "hidden";
}
