//------------------------------------------------------------------------------
// Analytics.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, Cthota
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// Empty constructor, needed to use the class name.
function VE_Analytics()
{
	
}


function VE_Range(min,max)
{
	this.min = min;
	this.max = max;
}

VE_Range.prototype.IsInRange=function(val)
{
	return val >= this.min && 
	       val <= this.max;
	       
};

VE_Range.prototype.toString=function()
{
	return this.min+"-"+this.max;
};
                                        
VE_Analytics.distanceBuckets = new Array(new VE_Range(0,10),
									   new VE_Range(11,25),
									   new VE_Range(26,100),
									   new VE_Range(101,200),
									   new VE_Range(201,500),
									   new VE_Range(501,1000));
// Whether or not analytics is enabled.
VE_Analytics.analyticsEnabled = true;

// Logs the user opening the help from the main header.
VE_Analytics.LogHelp=function()
{
	VE_Analytics.Log("VE | Help Pane","Help");
};
// Logs the user opening the about page from the main header.
VE_Analytics.LogAbout=function()
{
	VE_Analytics.Log("VE | About Pane","About");
};

// Logs the user printing the details from the Details page
VE_Analytics.LogPrintDetailsPage=function()
{
	VE_Analytics.Log("VE | Details Page","Print");
};

// Logs the user getting directions(to/from) from the Details page
VE_Analytics.LogGetDirectionsDetailsPage=function()
{
	VE_Analytics.Log("VE | Details Page","Get Directions");
};

// Logs the user getting more info from the Details page
VE_Analytics.LogGetMoreInfoDetailsPage=function()
{
	VE_Analytics.Log("VE | Details Page","MSN Search");
};

// Logs the user opening the locate me page from the main header
VE_Analytics.LogLocate=function()
{
	VE_Analytics.Log("VE | Locate Me","Locate Me");
};

VE_Analytics.LogResponseTimes=function()
{
	//Note[a-pratin]: We assign all the calculation to tempVar and then apply toFixed() method because JSRewrite tool 
	//				  used for compression in the release build breaks the javascript format in this function if not applied.	
	
	var tempVar = map.GetFailureRate()*100;
	s.prop33 = tempVar.toFixed(1);
	
	tempVar = map.GetResponseRangeCounts()[0]*100;
	s.prop34 = tempVar.toFixed(1);//taget response time	
	
	tempVar = map.GetResponseRangeCounts()[2]*100;
	s.prop35 = tempVar.toFixed(1);//outlies response time
	
	VE_Analytics.Log("VE | Response Times");
	map.ResetResponseRangeCounts();
};
// Logs the user zooming the map in or out
VE_Analytics.LogZoom=function()
{	
	VE_Analytics.Log(map.GetMapStyle() == Msn.VE.MapStyle.Oblique ? "VE | Oblique Imagery" : "VE | Home Page","Zoom","Mouse/Game Control/Keyboard");
};

VE_Analytics.LogPan=function()
{
	VE_Analytics.Log(map.GetMapStyle() == Msn.VE.MapStyle.Oblique ? "VE | Oblique Imagery" : "VE | Home Page","Pan","Mouse/Game Control/Keyboard");
};

VE_Analytics.LogFailedSearch=function()
{
	s.prop11 = "No Search Results";
	VE_Analytics.Log("VE | Exception","Search");
};

VE_Analytics.LogJSWatson=function(errorMessage)
{
	if(errorMessage != null && errorMessage != "undefined" && errorMessage.length > 0)
	{
		s.prop11 = errorMessage;
		VE_Analytics.Log("VE | Exception", "JSWatson");
	}
};


VE_Analytics.LogScrachPadItems=function()
{
	s.prop12 = VE_Scratchpad.highWaterCount;
	VE_Analytics.Log("VE | Scratch Pad","Exit");
};

VE_Analytics.LogAds=function(what, eventName, pagename, numberOfAds, indexOfAdClicked, adsProvider)
{
	s.events = eventName;
	
	if(what == null || what == "undefined")
		s.eVar8 = document.getElementById("what") ? (document.getElementById("what").value == L_MainWhatHelp_Text ? "" : document.getElementById("what").value) : "";
	else
		s.eVar8 = what;
		
	s.eVar9 = document.getElementById("where") ? (document.getElementById("where").value == L_SearchUseCurrentViewText_Text ? VE_Analytics.FormatLatLong(map.GetCenterLatitude(),map.GetCenterLongitude()) : document.getElementById("where").value) : "";
	
	if(eventName == "Event6")
	{
		s.eVar11 = indexOfAdClicked;
	}
	else
	{
		s.eVar10 = numberOfAds;		
	}
	
	if(adsProvider != null && adsProvider != "undefined")
	{
		s.eVar12 = adsProvider;		
	}
	else
	{
		s.eVar12 = "";		
	}
	
	//alert(s.events + ":" + s.eVar8 + ":" + s.eVar9 + ":" + s.eVar11 + ":" + s.eVar10 + ":" + s.eVar12);
	
	VE_Analytics.Log("VE | " + pagename,null);
};

//Set campaign id
VE_Analytics.SetCampaignId=function(cid)
{
	if(cid != null && cid != "" && cid != "undefined")
	{
		if(s)
		{
			s.campaign = cid;
			VE_Analytics.Log("VE | Home Page","Campaign Page View");
		}
	}
};

VE_Analytics.LogClick2Call=function(source)
{
	//Source is not supported yet. So it always logs 
	//Search Pane ERO as default
	//Ideally we should be populating s.prop37 
	//Since we dont have source at this point from MPC
	//We will pass default.
	if(source != null && source != "undefined")
	{
		if(source == "1")
			VE_Analytics.Log("VE | Search Pane ERO", "C2C call Entry Point");			
		else if(source == "2")		
			VE_Analytics.Log("VE | Map ERO", "C2C call Entry Point");			
		else if(source == "3")		
			VE_Analytics.Log("VE | Details Page", "C2C call Entry Point");			
		else
			VE_Analytics.Log("VE | Click-2-Call", "C2C call Entry Point");					
	}
	else
	{
		VE_Analytics.Log("VE | Click-2-Call", "C2C call entry point");		
	}
}

VE_Analytics.LogAPI=function(pageName,NavAction)
{
	//currently turn off logging for the API - see Bug 4794
	return; 
	
	if ( window.s == 'undefined' || window.s == null )
		return;
		
	// Only log if analytics is enabled.
	if (!VE_Analytics.analyticsEnabled)
	{
		return;
	}
	
	s.pageName = pageName;		
	s.prop6 = NavAction ? NavAction : "";	
		
	var elm = document.getElementById("logging");
	if(elm)
	{
		elm.innerHTML = s.t();
	}
	VE_Analytics.ResetLogProps();
}

VE_Analytics.Log=function(pageName,NavAction,NavControl,routeLengthObj)
{
	if ( window.s == 'undefined' || window.s == null )
		return;
		
	// Only log if analytics is enabled.
	if (!VE_Analytics.analyticsEnabled)
	{
		return;
	}
	
	s.pageName = pageName;
	s.prop3 = window["map"] ? map.GetMapStyle() : "";
	s.prop4 = window["map"] ? map.GetZoomLevel() : "" ;
	s.prop5 = window["map"] ? VE_Analytics.FormatLatLong(map.GetCenterLatitude(),map.GetCenterLongitude()) : "";
	s.prop6 = NavAction ? NavAction : "";
	s.prop7 = NavControl ? NavControl : "";
	s.prop8 = document.getElementById("what") ? (document.getElementById("what").value == L_MainWhatHelp_Text ? "" : document.getElementById("what").value) : "";
	s.prop9 = document.getElementById("where") ? (document.getElementById("where").value == L_SearchUseCurrentViewText_Text ? "" : document.getElementById("where").value) : "";
	s.prop36 = ( window.usertype == undefined ) ? 1 : usertype; 
	
	if(routeLengthObj) /* routing information is available */
	{
		
		s.prop10 = VE_Analytics.ConvertDistanceToBucket(routeLengthObj);	
		
		s.prop32 = 	routeLengthObj.numberOfWaypoints;
		
	}
	else 
	{
		s.prop10 = "";
	}
	
	var elm = document.getElementById("logging");
	if(elm)
	{
		elm.innerHTML = s.t();
	}
	VE_Analytics.ResetLogProps();
};
/* For Ominiture logging region codes needs to be formatted as follows
 * latitude (1 decimal place)+","+longitude (0 decimal places or an integer)

 */
VE_Analytics.FormatLatLong=function(latitude,longitude)
{
	if(!latitude || !longitude)
	{
		if(state && state.GetLatitude() && state.GetLongitude()) 
		{	
			return state.GetLatitude().toFixed(1)+","+Math.round(state.GetLongitude());
		}
		return "0.0,0";
	}
	return latitude.toFixed(1)+","+Math.round(longitude);
};

VE_Analytics.ConvertDistanceToBucket=function(routeLengthObj)
{
	var distance  = routeLengthObj.distance;
	
	if(!distance)
	{
		return "";
	}
    
	if(routeLengthObj.distanceUnit && 
	   routeLengthObj.distanceUnit.indexOf("mi") != -1)
	{ /* convert miles to kilometers first */
		distance = Math.round(distance*1.6093);
	}
	//find the range bucket
	
	for(var i =0;i < VE_Analytics.distanceBuckets.length; i++)
	{
		if(VE_Analytics.distanceBuckets[i].IsInRange(distance))
		{
			return VE_Analytics.distanceBuckets[i].toString();
		}
	}
	
	return "1001 and Above";
};

VE_Analytics.ResetLogProps=function()
{
	s.prop11 = "";
	s.prop12 = "";
	s.prop32 = "";
	s.prop33 = "";
	s.prop34 = "";
	s.prop35 = "";
	
	//Clear all events stuff
	s.events = "";
	s.eVar8 = "";
	s.eVar9 = "";
	s.eVar10 = "";
	s.eVar11 = "";		
	s.eVar12 = "";		
	
	//Clear campaign
	s.campaign = "";	

};