//------------------------------------------------------------------------------
// AutoLocate.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


// Attempts to locate the user.  
// First detects if the WiFi scanner is available.
// Second, executes a scan and looks for access points.
// Third, builds an HTTP request to the WiFi service
// Fourth, executes the request
var reverseIPUrl = "http://" + location.host + "/WiFiIPService/locate.ashx?mkt={0}&pos=";
var wifiUrl =  "https://" + location.host + "/locate.ashx?mkt={0}&pos=";

function AutoLocate()
{
	var wifi = GetWiFiControl();
	if(!wifi && !state.GetDontAskWifiLocator())
    {
		ShowWifiInstallPanel();
		return;
    }
	if(wifi)
	{
		try
		{
			wifi.ServiceEndPoint = 	wifiUrl.replace(/\{0\}/, locale);

			var results = wifi.GetLocation();
			if (results && results.length > 0)
			{
				eval(results);
				return;
			}
		}
		catch(ex)
		{
			// swallow and fall back to reverse ip
		}
	}
	var url = reverseIPUrl.replace(/\{0\}/, locale);
	ExecuteAutoLocateRequest(url);
}


// Gets the WiFi control, if available
// Returns null otherwise
function GetWiFiControl()
{
	var wifi = null;
    try { wifi = new ActiveXObject("WiFiScanner"); } 
    catch (e) { try { wifi = new ActiveXObject("Microsoft.MapPoint.WiFiScanner.2"); }
	catch (e) { try { wifi = new WiFiScanner("Microsoft.MapPoint.WiFiScanner.2"); } 
	catch (e) { /* swallow */ } } }
	return wifi;
}


// Executes the request to the WiFiService over XmlHttp
function ExecuteAutoLocateRequest(url)
{
	var xmlhttp = GetXmlHttp();
	if(xmlhttp)
	{
		xmlhttp.open("GET", url, true);
		xmlhttp.onreadystatechange=function() 
		{
			if(xmlhttp.readyState==4) 
			{
				var code = xmlhttp.responseText;
				try
				{
					eval(code);
				}
				catch(ex)
				{
					ShowMessage( L_ErrorServerBusy_Text );
				}
				finally
				{
					VE_Help.ClosePanel();				
				}
			}
		};
		xmlhttp.send(null);
	}
}

// Sets the viewport for a latitutde and longitude determined by the auto locate service
function SetAutoLocateViewport(latitude, longitude, zoom, pin, message)
{
	if(!zoom)
	{
		zoom = 14;
	}
	
	if(pin)
	{
		var ts = new Date();
		var h = ts.getHours();
		var a = h > 12 ? "pm" : "am";
		if(h > 12)
		{
			h -= 12;
		}
		var m = ts.getMinutes();
		if(m < 10)
		{
			m = "0" + m;
		}
		var name = "You Are Here";
		var desc = "As of " + h + ":" + m + a;
		//VE_Scratchpad.AddLocation(name, latitude, longitude, desc, "aN");
		var pinId = 'autolocate';
		pinDOM = map.AddPushpin(pinId,																			// pushpinID
							latitude,                                 // latitude
							longitude,                                // longitude
							23,                                       // width
							26,                                       // height
							'VE_Pushpin VE_Pushpin_al',				// className
							'',                                // innerHTML
							VE_MapPushpin.baseZIndex,			// zIndex, should be highest, except for when things are hovered over.
							Msn.VE.PushPinTypes.YouAreHere);
		
		pinDOM.onmouseover = function() 
					{
						if (VE_ContextMenu.MenuOpen) 
						{
							VE_ContextMenu.RemoveContextPin();
							VE_ContextMenu.CloseMenu();
						}
						
						// close the annotations panel if it's open						
						VE_Annotations.ClosePanel ();
						
						// Push the pin of the previously open pop up back to its place.
						VE_SearchManager._RestorePushpinZIndex();
						
						//alert(pinDOM.vePushpin);
						var latitude = pinDOM.vePushpin.GetLatitude();
						var longitude = pinDOM.vePushpin.GetLongitude();	
						
						var content = CreateAutoLocatePopupContent(name, desc, latitude, longitude);	
						ero.setContent(content);
						ero.dockToElement(pinDOM);						// dock ERO to the POI icon in the SearchResults list (or possibly, a POI on the map)
						
					};

		pinDOM.onmouseout = function()
					{		
						ero.hide();
					};
	}
	
	map.SetCenterAndZoom(latitude, longitude, zoom);
	
	// Show a message if we have one.
	if (message)
	{ 
		ShowMessage(message.replace(/%1/g,Msn.VE.Features.ProductName));
	}
}

CreateAutoLocatePopupContent=function(name, desc, latitude, longitude)
{
	var content = '<div class = "title">' + name + '</div>';
		
	ero.clearActions();	
	
	var deletelink = 'javascript:map.RemovePushpin(\'autolocate\');ero.hide();';
	ero.addAction('<a href="javascript://hover" onclick="'+ deletelink + '" class="VE_Panel_sublink">'+ L_AnnotationPopupDelete_Text + '</a>');
	
	// Add To Collection Action
	if (Msn.VE.Marketization.IsEnabled( !Msn.VE.Features.MapAction.Collections.DisplayNone ))
	{
		var addtocollectionlink = 'javascript:VE_Scratchpad.AddLocation(\'' + name
		 + '\',' + latitude + ',' + longitude + ',\'' + desc + '\',\'aN\');ero.hide();';
		ero.addAction('<a href="javascript://hover" onclick = "' + addtocollectionlink + '" class = "VE_Panel_sublink" oncontextmenu = "return false;">' + L_SearchPopupAddToScratchPad_Text + '</a>');	
	}
	
	// Drive from / to Action
	if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MapAction.DrivingDirections ) )
	{
		var drivefromlink = 'javascript:VE_Directions.SetStart(\'' + name + '\',' + latitude + ',' + longitude + ');ero.hide();';
		var drivetolink = 'javascript:VE_Directions.SetEnd(\'' + name + '\',' + latitude + ',' + longitude + ');ero.hide();';
	
		var driveAction =
		'<a href="javascript://hover" onclick = "' + drivefromlink + '; VE_Analytics.Log(\'VE | Push Pin Popup\', \'Get Directions\');" class = "VE_Panel_sublink">' + L_SearchPopupDriveFrom_Text + '</a>' +
		' ' + L_Or_Text + ' ' +
		'<a href="javascript://hover" onclick = "' + drivetolink + '; VE_Analytics.Log(\'VE | Push Pin Popup\', \'Get Directions\');" class = "VE_Panel_sublink">' + L_SearchPopupDriveTo_Text + '</a>';
		ero.addAction(driveAction);
	}

	// Zoom to [ city | street ] level
	if (map.GetZoomLevel() < VE_ContextMenu.StreetZoomLevel && map.GetMapStyle() != 'o' && Msn.VE.Marketization.IsEnabled(Msn.VE.Features.MenuOption.ZoomToStreet))
	{
		var zoomlink = 'javascript:map.SetCenterAndZoom(' + latitude + ',' + longitude + ',' + VE_ContextMenu.StreetZoomLevel + ');ero.hide();';
		ero.addAction('<a href="javascript://hover" onclick="'+ zoomlink + '" class="VE_Panel_sublink">'+ L_SearchPopupZoomToStreetLevel_Text + '</a>');
	}	
	return content;
}

// Shows the Help Panel which contains the option for the user to download the VE WiFi client component. They also have the option to never see the WiFi panel again or just to close the panel
function ShowWifiInstallPanel()
{
	VE_Help.Open(L_AutoLocateHelpWindowTitle_Text , "Help/" + window.locale + "/WiFiInstall.htm");
}

// Opens a new window where the user can download the VE WiFi client component.
function InstallWifi()
{
	OpenNewWindow(state.GetWifiDownloadUrl(), L_AutoLocateWiFiDownloadWindowTitle_Text , "all");
	VE_Help.Open(L_AutoLocateHelpWindowTitle_Text , "Help/" + window.locale + "/DuringInstall.htm");
}

// Close help panel and write cookie that indicates user does not want to ever install Wifi client component.
function IPLookup()
{	
	
	var url = reverseIPUrl.replace(/\{0\}/, locale);
	ExecuteAutoLocateRequest(url);
}


