//------------------------------------------------------------------------------
// Compass.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Codye
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


// Constructor, unused but necessary to set members
function VE_Compass()
{
}


// The dom element for the control
VE_Compass.element = null;

// Represents whether or not the control is currently panning
VE_Compass.panning = false;

// The maximum speed that the pan control will allow
VE_Compass.maxScrollSpeed = 15;


// Creates the control and sets up the event listeners
VE_Compass.CreateControl=function()
{
	var el = document.createElement("div");
	el.id = "VE_Compass";
	el.style.background = "url(i/compass.gif)";
	el.onmousedown = VE_Compass._MouseDown;
	el.onmouseup = VE_Compass._MouseUp;
	el.onmousemove = VE_Compass._MouseMove;
	
	VE_Compass.element = el;
	document.body.appendChild(el);
}


// Handles the mouse down event, starting the continuous pan.
VE_Compass._MouseDown=function(e)
{	
	var el = VE_Compass.element;
	if(el.setCapture)
	{
		el.setCapture();
	}
	
	if(!e) e = window.event;
	var m = VE_Compass.maxScrollSpeed;
	var dx = GetMousePosX(e) - el.offsetLeft - (el.offsetWidth/2);
	var dy = GetMousePosY(e) - el.offsetTop - (el.offsetHeight/2);
	dx = Math.min(Math.max(dx, -m), m);
	dy = Math.min(Math.max(dy, -m), m);
	map.ContinuousPan(dx, dy);
	VE_Compass.panning = true;
	AutoRefresh();
}


// Handles the mouse up event, ending the continuous pan.
VE_Compass._MouseUp=function()
{
	var el = VE_Compass.element;
	if(el.releaseCapture)
	{
		el.releaseCapture();
	}
	
	map.StopContinuousPan();
	VE_Compass.panning = false;
}


// Handles the mouse move event, adjusting the speed and direction of the pan.
VE_Compass._MouseMove=function(e)
{
	if (!e) var e = window.event;
	if(VE_Compass.panning)
	{
		var el = VE_Compass.element;
		var m = VE_Compass.maxScrollSpeed;
		var dx = GetMousePosX(e) - el.offsetLeft - (el.offsetWidth/2);
		var dy = GetMousePosY(e) - el.offsetTop - (el.offsetHeight/2);
		dx = Math.min(Math.max(dx, -m), m);
		dy = Math.min(Math.max(dy, -m), m);
		map.ContinuousPan(dx, dy);
	}
}
