//------------------------------------------------------------------------------
// ContextMenu/ContextZoom.js - Zoom logic for the context menu
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: BayardB, sstchur, keithkin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

//TODO: <Localization> : Need to set the following values based on Locales
VE_ContextMenu.RegionZoomLevel = 6;
VE_ContextMenu.CityZoomLevel = 11;
VE_ContextMenu.StreetZoomLevel = 16;

VE_ContextMenu._ContextMenuZoomContent = function()
{
	var text = '';
	var zoom = map.GetZoomLevel ();
	var streetZoomLink = VE_ContextMenu._ContextMenuHandlerLink("zoom", VE_ContextMenu.StreetZoomLevel);
	var cityZoomLink = VE_ContextMenu._ContextMenuHandlerLink("zoom", VE_ContextMenu.CityZoomLevel);
	var regionZoomLink = VE_ContextMenu._ContextMenuHandlerLink("zoom", VE_ContextMenu.RegionZoomLevel);
	
	// further than region
	if (VE_ContextMenu.RegionZoomLevel > zoom)
	{
		text += ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ZoomToRegion ) )? '<tr><td><a class="VE_Context_Link" href="' + regionZoomLink + '">' + L_ContextZoomZoomToRegion_Text + '</a></td></tr>' : '';
		text += ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ZoomToCity ) )? '<tr><td><a class="VE_Context_Link" href="' + cityZoomLink + '">'+L_ContextZoomZoomToCity_Text +'</a></td></tr>' : '';
	}
	// region
	else if (VE_ContextMenu.RegionZoomLevel == zoom)
	{
		text += ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ZoomToCity ) )? '<tr><td><a class="VE_Context_Link" href="' + cityZoomLink + '">' + L_ContextZoomZoomToCity_Text  +'</a></td></tr>' : '';
		text += ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ZoomToStreet ) )? '<tr><td><a class="VE_Context_Link" href="' + streetZoomLink + '">'+L_ContextZoomZoomToStreet_Text +'</a></td></tr>' : '';
	}
	// between region and city
	else if (VE_ContextMenu.RegionZoomLevel < zoom && VE_ContextMenu.CityZoomLevel > zoom)
	{
		text += ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ZoomToCity ) )? '<tr><td><a class="VE_Context_Link" href="' + cityZoomLink + '">' + L_ContextZoomZoomToCity_Text +'</a></td></tr>' : '';
		text += ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ZoomToRegion ) )? '<tr><td><a class="VE_Context_Link" href="' + regionZoomLink + '">' + L_ContextZoomZoomToRegion_Text + '</a></td></tr>' : '';
	}
	// city
	else if (VE_ContextMenu.CityZoomLevel == zoom)
	{
		text += ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ZoomToStreet ) )? '<tr><td><a class="VE_Context_Link" href="' + streetZoomLink + '">' + L_ContextZoomZoomToStreet_Text  +'</a></td></tr>' : '';
		text += ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ZoomToRegion ) )? '<tr><td><a class="VE_Context_Link" href="' + regionZoomLink + '">' + L_ContextZoomZoomToRegion_Text +'</a></td></tr>' : '';
	}
	// between city and street
	else if (VE_ContextMenu.CityZoomLevel < zoom && VE_ContextMenu.StreetZoomLevel > zoom)
	{
		text += ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ZoomToStreet ) )? '<tr><td><a class="VE_Context_Link" href="' + streetZoomLink + '">' + L_ContextZoomZoomToStreet_Text +'</a></td></tr>' : '';
		text += (  Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ZoomToCity ) )? '<tr><td><a class="VE_Context_Link" href="' + cityZoomLink + '">'+ L_ContextZoomZoomToCity_Text +'</a></td></tr>' : '';
	}
	// street
	else if (VE_ContextMenu.StreetZoomLevel == zoom)
	{
		text += ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ZoomToCity ) )? '<tr><td><a class="VE_Context_Link" href="' + cityZoomLink + '">' + L_ContextZoomZoomToCity_Text +'</a></td></tr>' : '';
		text += ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ZoomToRegion ) )? '<tr><td><a class="VE_Context_Link" href="' + regionZoomLink + '">'+ L_ContextZoomZoomToRegion_Text + '</a></td></tr>' : '';
	}
	// closer than street
	else
	{
		text += ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ZoomToStreet ) )? '<tr><td><a class="VE_Context_Link" href="' + streetZoomLink + '">' + L_ContextZoomZoomToStreet_Text +'</a></td></tr>' : '';
		text += ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ZoomToCity ) )? '<tr><td><a class="VE_Context_Link" href="' + cityZoomLink + '">'+ L_ContextZoomZoomToCity_Text +'</a></td></tr>' : '';
	}
	
	return text;
}
