//------------------------------------------------------------------------------
// CrossBrowser.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Eshinn
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


// Cleans up potentially unsafe strings for display on an HTML page.
function SanitizeHtmlString(s)
{
	if (!s || typeof(s) != "string") 
	{
		return s;
	}
	
	return IOSec.EncodeHtml(s);
}

// Returns the X position of the mouse when the event was fired.
function GetMousePosX(e)
{
	var posX = 0;
	if (e.pageX)
	{
		posX = e.pageX;
	}
	else if (e.clientX)
	{
		posX = e.clientX + document.body.scrollLeft;
	}
	return posX;
}

// Returns the Y position of the mouse when the event was fired.
function GetMousePosY(e)
{
	var posY = 0;
	if (e.pageY)
	{
		posY = e.pageY;
	}
	else if (e.clientY)
	{
		posY = e.clientY + document.body.scrollTop;
	}
	return posY;
}

// Returns the target of the event
function GetTarget(e)
{
	if (!e) var e = window.event;
	var eventTarget;
	if (e.srcElement) eventTarget = e.srcElement;
	else if (e.target) eventTarget =  e.target;
	if (eventTarget.nodeType == 3) // defeat Safari bug
		eventTarget = targ.parentNode;
	return eventTarget;
}

// Selects the character range specified in the textbox passed in.
function SelectText(textbox, start, end)
{
	if (!textbox) return;
	
	// IE specific
	if (textbox.createTextRange)
	{
		var textRange = textbox.createTextRange();
		textRange.moveStart("character", start);
		textRange.moveEnd("character", end);
		textRange.select();
	}
	// Mozilla specific
	else if (textbox.setSelectionRange)
	{
		textbox.setSelectionRange(start, end);
	}
}

// Gets left position of element
function GetElementLeftPosition(elemID) 
{
    var offsetTrail = document.getElementById(elemID);
    var offsetLeft = 0;
    while (offsetTrail) {
        offsetLeft += offsetTrail.offsetLeft;
        offsetTrail = offsetTrail.offsetParent;
    }
    if (navigator.userAgent.indexOf("Mac") != -1 && 
        typeof(document.body.leftMargin) != "undefined") {
        offsetLeft += document.body.leftMargin;
    }
    return offsetLeft;
}

// Gets top position of element
function GetElementTopPosition(elemID) 
{
    var offsetTrail = document.getElementById(elemID);
    var offsetTop = 0;
    while (offsetTrail) {
        offsetTop += offsetTrail.offsetTop;
        offsetTrail = offsetTrail.offsetParent;
    }
    if (navigator.userAgent.indexOf("Mac") != -1 && 
        typeof(document.body.topMargin) != "undefined") {
        offsetTop += document.body.topMargin;
    }
    return offsetTop;
}

function SelectedTextLength(textbox)
{
	if ( !textbox ) return 0;
	
	// IE specific
	if (textbox.document)
	{
		var selectedTextObj = textbox.document.selection.createRange();
		return selectedTextObj.text.length;
	}
	// Mozilla specific
	else 
	{
		var selStart = textbox.selectionStart;
		var selEnd = textbox.selectionEnd;
		return (selEnd-selStart); 		
	}
}