
var tab = null;
var map = null;
var MinTabHeight = 100;
var MinContentWidth = 700;

// Map pushpin container.  Used for legacy support.
function VE_MapPushpin(){}

// Pushpins.
// Base is 11.  Each search should be sequentially higher.
// Searches on top have higher numbers.
VE_MapPushpin.baseZIndex = 11;

// This is for when we absolutely want to ripple a pushpin to the top.
VE_MapPushpin.topZIndex = 20;

function init()
{
	window.attachEvent('onresize', onWindowResize);

	// set the Window Title
	window.document.title = L_DetailsWindowTitle_Text.replace(/%1/g,Msn.VE.Features.ProductName);
		
	if (click2callenabled && Msn.VE.Marketization.IsEnabled(Msn.VE.Features.Click2Call.Enabled))
 	{
 		if (VE_Click2Call.isAllowedCountry(YPCountry))
 		{
 			var Click2Call = VE_Click2Call.getClick2CallManager(Click2CallEntryPoint.DetailsPage);
 			Click2Call.CreateRenderWidget('mpc.' + YPId + '@search.msn.com', 'c2cIntro');
 		}
 	}
 	
	refreshContentWidth();
	buildFooter();
	tabLoad();
	refreshTabHeight();
		
	//var menu = document.getElementById('menu').firstChild;
	//pseudoHoverForChildren(menu);
}

function DetailsPageEnterHandler()
{
	setupClick2Call();
	SetupDetailsMap();
}

function setupClick2Call()
 {	
 	if (click2callenabled && Msn.VE.Marketization.IsEnabled(Msn.VE.Features.Click2Call.Enabled))
 	{
 		if (VE_Click2Call.isAllowedCountry(YPCountry))
 		{	
 			var Click2Call = VE_Click2Call.getClick2CallManager(Click2CallEntryPoint.DetailsPage);
 			Click2Call.CreateRenderWidget('mpc.' + YPId + '@search.msn.com', 'c2cDetails');
 		}
 	}
 }

function onWindowResize()
{
	refreshTabHeight();
	refreshContentWidth();
}

function buildFooter()
{
	var wll_FooterLeft = document.getElementById('details_listOne');
	// Privacy link
	if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.Footer.Privacy ) )
	{
		var oNewItem = document.createElement('li');			
		oNewItem.innerHTML = '<a href = ' + privacyStatement + ' target = "_new">' + L_Privacy_Text + '</a>';
		BuildHeaderFooterItem( oNewItem , wll_FooterLeft );
		oNewItem = null;
	}
}

function BuildHeaderFooterItem( element, containerElement )
{	
	containerElement.appendChild( element );
}

function tabLoad()
{
	var tabparent = document.getElementById('tabdiv');
	tab = new Tab(tabparent);
	
	var backlinkText = L_DetailsBackHome_Text.replace(/%1/g,Msn.VE.Features.ProductName);
	
	//tab.addTabPage('Editorial Profile','');
	var maphtml = '<div id="mapArea">' + 
								'<div id="mapContainer"></div>' +
								'<div id="directions">' +
								'<span id="idDirections"></span><br>' +
								'<a id="toDirLink" href="#" onclick="' + DriveToOnClick + '"></a><span class="bluepipe">|</span>' +
								'<a id="fromDirLink" href="#" onclick="' + DriveFromOnClick + '"></a>' +
								'<br><a href="http://local.live.com/">' + backlinkText + '</a>' +
								'</div>' +
					 '</div>';
	var divDetailsContent = '<div id="divDetailsContent">' + DetailsContent + '</div>';
	var page = tab.addTabPage('Details',divDetailsContent + maphtml);
	page.setEnterHandler(DetailsPageEnterHandler);
	page.setLeavingHandler(DestroyMap);
	//tab.addTabPage('Reviews','');
	tab.addTabPage('WebResults','<iframe src="' + msnResultsLink + '" id="WebResultIframe" border = "0" frameborder = "0" width="100%" height="100%"></iframe>');
	tab.selectTabPage(page);
}

function getWindowWidth() 
{
	var width;	
	if(typeof(window.innerWidth) == 'number')
	{
		width =  window.innerWidth;
	}
	else if(document.documentElement && document.documentElement.clientWidth)
	{
		width =  document.documentElement.clientWidth;
	}
	else if(document.body && document.body.clientWidth)
	{
		width =  document.body.clientWidth;
	}	
	return width;
}

function getWindowHeight()
{
	var height;
	if(typeof(window.innerHeight) == 'number')
	{
		height = window.innerHeight;		
	}
	else if(document.documentElement && document.documentElement.clientHeight)
	{ 
		height = document.documentElement.clientHeight;
	}
	else if(document.body && document.body.clientHeight)
	{ 
		height = document.body.clientHeight;
	}
	return height;
}

function refreshContentWidth()
{	
	var winWidth = getWindowWidth();
	var contentwidth;
	if (document.all)	
		contentwidth = winWidth - 20;	
	else
		contentwidth = winWidth - 40;
	if (contentwidth < MinContentWidth)
		contentwidth = MinContentWidth;
	document.getElementById('wl_ve_ContentCell').style.width = contentwidth + 'px';	
}

function refreshTabHeight()
{
	var winHeight = getWindowHeight();
	var headerHeight = document.getElementById('wl_ve_headerCell').offsetHeight;	
	//var menuHeight = document.getElementById('menu').offsetHeight;
	var menuHeight = 0;	
	var introHeight = document.getElementById('intro').offsetHeight;
	var tabHeaderHeight = document.getElementById('TabHeaderDiv').offsetHeight;	
	var footerHeight = document.getElementById('wl_ve_footerCell').offsetHeight;	
	var margins = 40;
	var tabHeight = winHeight - headerHeight - menuHeight - introHeight - tabHeaderHeight - footerHeight - margins;
	if (tabHeight < MinTabHeight)
		tabHeight = MinTabHeight;
	
	document.getElementById('divTabFrame').style.height = tabHeight + 'px';
	
	//IE can not update the iframe height, so we reset the height.
	var WebResultIframe = document.getElementById('WebResultIframe');
	if (WebResultIframe)
		WebResultIframe.style.height=tabHeight+'px';	
}

function DestroyMap()
{
	if (map) map.Destroy();
}

function SetupDetailsMap()
{	
	if ( document.getElementById('mapContainer') != null )
	{
		document.getElementById('idDirections').innerText = L_DetailsGetDirections_Text;
		document.getElementById('toDirLink').innerText = L_DetailsToDirLink_Text;
		document.getElementById('fromDirLink').innerText = L_DetailsFromDirLink_Text;
		
	}
	else
	{
		document.getElementById('idError').innerText = L_DetailsError_Text;
		return;
	}
	
	
	if(latitude == null || longitude == null)
	{
		return;
	}

	//TODO: <Localization> : Need to set the following values based on Locales
	var zoom = 12;
	if (mapStyle == null) {
		mapStyle = "r";
	}
	
	StartMap(latitude, longitude, zoom, mapStyle, "absolute", 0, 0, 300, 200);
	
	LogAnalytics();
}


// Creates the initial map.  This method should only be called once!!
function StartMap(latitude, longitude, zoom, mapStyle, position, x, y, windowW, windowH)
{
	// Create the control	
	var params = new Object();
	params.latitude = latitude;
	params.longitude = longitude;
	params.zoomlevel = zoom;
	params.mapstyle = mapStyle;
	params.showScaleBar = false;
	params.showDashboard = true;
	params.dashboardX = 0;
	params.dashboardY = 5;
	params.dashboardSize = "small";
	params.obliqueEnabled = false;
	params.fixedView = false;
	params.disableLogo = true;

	if ( document.getElementById('mapContainer'))
	{
		map = new Msn.VE.MapControl(document.getElementById("mapContainer"), params);
		map.Init();
			
		map.AddPushpin(
			"myPin",                         // pushpinID
			latitude,                        // latitude
			longitude,                       // longitude
			24,                              // width
			24,                              // height
			"VE_Pushpin",    // className
			"<img src=\"i/pins/poi_businesslisting.gif\"/>",							 // innerHTML 
			VE_MapPushpin.baseZIndex,		// z-index
			Msn.VE.PushPinTypes.Annotation
			);
	}
}


// Changes the map style.
function ChangeMapStyle(mapStyle)
{
	map.SetMapStyle(mapStyle);
}

function LogAnalytics()
{
	// Disable the omniture onclick event handler stuck to the body of the element.
	// This will get around the bug in their element type detection code.
	document.body.detachEvent("onclick", s.bc);

	s.linkInternalFilters="javascript:,.msn.";
	s_account  = omnitureAccount;
	s.server   = location.hostname;
	s.pageName = "Details Page";
	s.channel  = "VirtualEarth";
	/* Product Name */
	s.prop1 = "VirtualEarth";
	/* Culture and Language */
	s.prop2 = window.locale;
	/* MapTheme */
	s.prop3 = "";
	/* ZoomLevel */
	s.prop4 = "";
	/* Region Code */
	s.prop5 = "";
	/* Navigation Action */
	s.prop6 = "";
	/* Navigation Control */
	s.prop7 = "";
	/* Search Keyword */
	s.prop8 = "";
	/* Search Location */
	s.prop9 = "";
	/* YPID */
	s.prop38 = YPId;

	//Log Analytics	
	var elm = document.getElementById("logging");
	if(elm)
	{
		elm.innerHTML = s.t();
	}	
}
