//------------------------------------------------------------------------------
// ./Details/Tab.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Hao
//
//  
// <header>	$Header$</header>
//------------------------------------------------------------------------------


//Tab class
var Tab = function(parent)
{
	var tabPages = new Array();
	
	//tabPage inner class
	var tabPage = function(header, content, parentTab)
	{
		var _EnterHandler = null;
		var _LeavingHandler = null;
		
		pagecounter++;
		var id = "tab_" + header + pagecounter;
		var pageHeader = document.createElement('li');
		
		pageHeader.className = 'tabOff';
		pageHeader.attachEvent('onclick', function() {parentTab.selectTabPagebyId(id);});
		pageHeader.innerHTML = '<p>' + header + '</p>';
		
		var pageContent = content;
				
		this.Destroy = function()
		{
			pageHeader.onclick = null;
			pageHeader = null;
			//here may leak memory, for the pageContent inner html could cause circular reference which is unknown for Tab. 
			pageContent = null;
		}
		
		this.setEnterHandler = function(handler)
		{
			_EnterHandler = handler;			
		}
		
		this.setLeavingHandler = function(handler)
		{
			_LeavingHandler = handler;
		}
		
		this.fireLeavingHandler = function()
		{
			pageHeader.className = "tabOff";
			if (_LeavingHandler)	_LeavingHandler();
		}
		
		this.fireEnterHandler = function()
		{
			pageHeader.className = "tabOn";			
			if (_EnterHandler)	_EnterHandler();
		}
		
		this.id = id;
		this.pageHeader = pageHeader;
		this.pageContent = pageContent;
	}
	
	var selectedIndex = null;
	var pagecounter = 0;
	
	//Tab Header
	var tdiv = document.createElement('div');
	tdiv.id = 'TabHeaderDiv';
	parent.appendChild(tdiv);
	
	var TabHeader = document.createElement('ul');
	TabHeader.id = 'TabHeaderul';
	tdiv.appendChild(TabHeader);
	
	//Tab content frame
	var divTabFrame = document.createElement('div');
	divTabFrame.id = 'divTabFrame';
	parent.appendChild(divTabFrame);
			
	this.addTabPage = function(header, content)
	{
		var page = new tabPage(header, content, this);
		tabPages.push(page);
		TabHeader.appendChild(page.pageHeader);
		return page;
	}
	
	this.getTabPageById = function(id)
	{
		for (var i=0; i<tabPages.length; i++)
		{
			var p = tabPages[i];
			if(p.id == id)
				return p;
		}
	}
	
	this.RemoveTabPage = function(id)
	{
		for (var i=0; i<tabPages.length; i++)
		{
			var p = tabPages[i];
			if(p.id == id)
			{
				TabHeader.removeChild(p.pageHeader);
				p.pageHeader = null;
				tabPages.splice(i, 1);
				p.Destroy();
				return;
			}
		}
	}
	
	this.selectTabPagebyId = function(id)
	{
		var tabPage = this.getTabPageById(id);
		
		//fire LeavingEvent for the previous tabpage.
		for (var i=0; i<tabPages.length; i++)
		{
			var p = tabPages[i];
			if (selectedIndex == p.id) p.fireLeavingHandler();
		}
		
		selectedIndex = id;
		divTabFrame.innerHTML = tabPage.pageContent;
		
		//fire the EnteringEvent for the currrent tabpage.
		tabPage.fireEnterHandler();
	}
	
	this.selectTabPage = function(page)
	{
		if (page && page.id)
			this.selectTabPagebyId(page.id);
	}
	
	this.Destroy = function()
	{
		for (var i=0; i<tabPages.length; i++)
		{
			p.Destroy();
		}
	}
}

