//------------------------------------------------------------------------------
// ./ero/ero.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: sstchur
// Dependencies: Microsoft.Web.Geometry (microsoft.web.geometry.js)
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


/* HIG Style ERO */


var ERO = 
{
	Classes:
	{
		Container: 'ero',
		Shadow: 'ero-shadow',
		Body: 'ero-body',
		Actions: 'ero-actions',
		ActionsBackground: 'ero-actionsBackground',
		PreviewArea: 'ero-previewArea',
		LeftBeak: 'ero-leftBeak',
		RightBeak: 'ero-rightBeak',
		PaddingHack: 'ero-paddingHack',
		ProgressAnimation: 'ero-progressAnimation'
	},
	
	BeakDirection:
	{
		Right: 0,
		Left: 1
	},
	
	DockPosition:
	{
		Top: 0,
		Center: 1
	},
	
	m_theEro: null,
	BeakHeight: 34,

	
	getInstance: function(parent)
	{
		// Shortcut the Microsoft.Web.Geometry Namespace Chain
		var geo = Microsoft.Web.Geometry;	
	
		if (!ERO.m_theEro)		
		{		
			ERO.m_theEro = new Ero();		
			ERO.m_theEro.setBoundingArea(new geo.Point(0, 5), new geo.Point(document.body.clientWidth, document.body.clientHeight));
		}
		
		//parent = parent || document.body;				
		//var eroElement = ERO.m_theEro.getElement();
		//eroElement.style.visibility = 'hidden';
		//parent.appendChild(eroElement);
		
		ERO.m_theEro.addToPage();
		return ERO.m_theEro;
				
		function Ero()
		{
			// Account for IE 'this' bug
			var self = this;
			
			var m_boundingArea = null;
			var m_entity = null;
			var m_bIsInUse = false;			
			
			var ero = document.createElement('div');			
			ero.className = ERO.Classes.Container;				
			
			// The atlas version of attachEvent seems to be causing Firefox a problem (no idea why), so we'll do an explicit check here and use the appropriate event model for each browser
			if (typeof ero.addEventListener != 'undefined')
			{
				ero.addEventListener('mouseover', EROMouseOver, false);
				ero.addEventListener('mouseout', EROMouseOut, false);				
			}
			else	// assume IE and use .attachEvent
			{
				ero.attachEvent('onmouseover', EROMouseOver);
				ero.attachEvent('onmouseout', EROMouseOut);
			}
			
			var eroShadow = document.createElement('div');						
			eroShadow.className = ERO.Classes.Shadow;
			
			var eroBody = document.createElement('div');
			eroBody.className = ERO.Classes.Body;
			
			var eroActions = document.createElement('div');
			eroActions.className = ERO.Classes.Actions;
			
			var eroActionsList = document.createElement('ul');	
			// doesn't need a CSS class
			
			var eroActionsBackground = document.createElement('div');
			eroActionsBackground.className = ERO.Classes.ActionsBackground;
			
			var eroPreviewArea = document.createElement('div');
			eroPreviewArea.className = ERO.Classes.PreviewArea;
			
			var eroBeak = document.createElement('div');
			eroBeak.className = ERO.Classes.LeftBeak;			
			
			var eroPaddingHack = document.createElement('div');
			eroPaddingHack.className = ERO.Classes.PaddingHack;
			
			
			// put it all together			
			ero.appendChild(eroShadow);
			ero.appendChild(eroBeak);
			
			eroShadow.appendChild(eroBody);
			eroBody.appendChild(eroActionsBackground);
			eroActionsBackground.appendChild(eroPreviewArea);
			eroActionsBackground.appendChild(eroActions);
			eroActions.appendChild(eroActionsList);
			
			eroActionsBackground.appendChild(eroPaddingHack);
			
			var prog = document.createElement('div');
			prog.className = ERO.Classes.ProgressAnimation;
			var ani = new Microsoft.Web.Animation.Movie(prog, 75);			
			ani.addFrame('<div class = "frame1"></div>');
			ani.addFrame('<div class = "frame2"></div>');
			ani.addFrame('<div class = "frame3"></div>');
			ani.addFrame('');
			ani.addFrame('');
			ani.addFrame('<div class = "frame2"></div><div class = "frame3"></div>', false);			
			ani.addFrame('<div class = "frame3"></div>', false);			
			ani.Repeat = false;
			
		
			this.destroy = function()
			{
				if (ero)
				{
					// The atlas version of detachEvent seems to be causing Firefox a problem (no idea why), so we'll do an explicit check here and use the appropriate event model for each browser
					if (typeof ero.removeEventListener != 'undefined')
					{
						ero.removeEventListener('mouseover', EROMouseOver, false);
						ero.removeEventListener('mouseout', EROMouseOut, false);
					}
					else	// assume IE and use .detacEvent
					{
						ero.detachEvent('onmouseover', EROMouseOver);
						ero.detachEvent('onmouseout', EROMouseOut);
					}
					
					ero = null;
					eroShadow = null;
					eroBody = null;
					eroActions = null;
					eroActionsList = null;
					eroActionsBackground = null;
					eroPreviewArea = null;
					eroBeak = null;
					eroPaddingHack = null;
				}
				
				m_entity = null;				
			}
			
			this.getElement = function() { return ero; }
			this.getAnimation = function() { return ani; }
			
			this.setBeak = function(direction, position)
			{
				if (direction == ERO.BeakDirection.Right)
					eroBeak.className = ERO.Classes.RightBeak;
				else
					eroBeak.className = ERO.Classes.LeftBeak;
			}
	
			this.setContent = function(markup)
			{
				// sstchur:  temporary fix to "no padding on the right" issue,is to wrap the markup in a <div> and style the <div> tag externally
				var div = document.createElement('div');
				div.className = 'firstChild';								// because IE does not understand :firstChild				
				div.innerHTML = markup;
				
				var firstChild = eroPreviewArea.firstChild;
				if (firstChild)
					eroPreviewArea.replaceChild(div, firstChild);
				else
					eroPreviewArea.appendChild(div);
					
				div = null;
				firstChild = null;
			}
			
			this.addAction = function(markup)
			{
				var li = document.createElement('li');
				if (!markup)
					return;
				li.innerHTML = markup;
				eroActionsList.appendChild(li);
				
				li = null;
			}
			
			this.clearActions = function()
			{
				var children = eroActionsList.getElementsByTagName('li');
				var len = children.length;
				for (var i = 0; i < len; i++)
				{
					eroActionsList.removeChild(children[0]);
				}				
			}
			
			this.dockToText = function(elem, evt)
			{
				self.display(elem, ERO.DockPosition.Top, evt);
			}
			
			this.dockToElement = function(elem)
			{
				self.display(elem, ERO.DockPosition.Center);
			}
			
			this.display = function(elem, dockPosition, evt)
			{
				// Handle the event ref first
				evt = (typeof evt != 'undefined') ? evt : ((typeof window.event != 'undefined') ? window.event : null);
				
				m_bIsInUse = true;
				m_entity = elem;				
				self.addToPage();

				var UNITS = 'px'
				
				var p = geo.Functions.getElementPosition(elem);				
				var beakYOffset = eroPreviewArea.offsetHeight - ERO.BeakHeight;

				var x, y;
				if (dockPosition == ERO.DockPosition.Top)				
				{
					var mouseX;

					if (evt == null)
					{
						mouseX = p.x;
					}
					else
					{
						mouseX = (typeof event.pageX != 'undefined') ? evt.pageX : evt.clientX;
					}
					
					prog.style.top = p.y - prog.offsetHeight - 2 + UNITS;
					prog.style.left = mouseX + UNITS;
					x = mouseX + prog.offsetWidth + 2;
					y = p.y - beakYOffset - (ERO.BeakHeight / 2) - prog.offsetHeight;
				}
				else
				{
					prog.style.top = p.y - prog.offsetHeight - 2 + UNITS;				
					prog.style.left = p.x + elem.offsetWidth - prog.offsetWidth + UNITS;					
					x = p.x + elem.offsetWidth;
					y = p.y - beakYOffset;
				}				
		
				var r1 = self.getSize();
				var eroHeight = r1.getP2().y - r1.getP1().y;
				var eroWidth = r1.getP2().x - r1.getP1().x;					
				
				var r2 = new geo.Rectangle(new geo.Point(x, y), new geo.Point(x + eroWidth, y + eroHeight));
				var ol = m_boundingArea.getOverlap(r2);
				var rng = ol.getRange();
				self.setBeak(ERO.BeakDirection.Left);
				
				var top, right, bottom, left;
				top = right = bottom = left = 'auto';
									
				if (rng & geo.Overlap.Range.InXRange)				
					left = x;
				
				if (rng & geo.Overlap.Range.InYRange)					
					top = y;					

				if (rng & geo.Overlap.Range.GreaterThanX)
				{	
					self.setBeak(ERO.BeakDirection.Right);					
					if (x > m_boundingArea.getP2().x)
						right = document.body.clientWidth - m_boundingArea.getP2().x;
					else
						left = x - eroWidth - elem.offsetWidth;
				}							
				
				if (rng & geo.Overlap.Range.LessThanX)
				{
					self.setBeak(ERO.BeakDirection.Left);
					left = m_boundingArea.getP1().x;
				}
					
				if (rng & geo.Overlap.Range.GreaterThanY)
				{	
					bottom = (document.body.clientHeight - m_boundingArea.getP2().y);
					var yBleed = ol.getBottomYBleed();
					
					beakYOffset += yBleed;
					if (beakYOffset > ero.offsetHeight - ERO.BeakHeight)
						beakYOffset = ero.offsetHeight - ERO.BeakHeight - 4;								
				}

				if (rng & geo.Overlap.Range.LessThanY)
				{
					top = m_boundingArea.getP1().y;
					var yBleed = ol.getTopYBleed();

					beakYOffset -= yBleed;
					if (beakYOffset < 0)
						beakYOffset = 0;
				}				
				
				ani.start();
				setTimeout(innerFn, 500);
				
				function innerFn()
				{	
					if (m_entity != elem)
						return;				
					
					ero.style.top = top == 'auto' ? top : top + UNITS;				
					ero.style.bottom = bottom == 'auto' ? bottom : bottom + UNITS;				
					ero.style.left = left == 'auto' ? left : left + UNITS;
					ero.style.right = right == 'auto' ? right : right + UNITS;
					
					eroBeak.style.top = beakYOffset + 'px';
					
					FadeIn();			
				}
			}
			
			function FadeIn()
			{
				if (ero.style && typeof ero.style.filter != 'undefined')
				{
					ero.style.filter = 'progid:DXImageTransform.Microsoft.Fade(duration=.5)';
					ero.filters[0].Apply();
					ero.style.visibility = 'visible';
					ero.style.display = 'block';
					ero.filters[0].Play();
				}
				else	// W3C way
				{
					window.__eroFadeValue__ = 1;
					
					ero.style.visibility = 'visible';
					ero.style.display = 'block';
					ero.style.opacity = 0;
					
					var i;
					for (i = 1; i <= 10; i++)
					{					
						setTimeout(function() {
							var opacity = __eroFadeValue__++ * .09999999;
							ero.style.opacity = opacity;
						}, 50*i);
					}
				}
			}
						
			this.hide = function(immediately)
			{
				m_bIsInUse = false;
				
				// In some cases, we want to hide the ERO immediately and not wait 50ms.
				// In such cases, we'll make a direct call to innerFn() rather than
				// use setTimeout(...)
				if (immediately && immediately == true)
					innerFn();
				else
					setTimeout(innerFn, 500);				
				
				function innerFn()
				{
					if (!m_bIsInUse)			
					{
						ero.style.visibility = 'hidden';
						ani.hide();
						m_entity = null;
					}
				}
			}
			
			this.setBoundingArea = function(p1, p2)
			{
				m_boundingArea = new geo.Rectangle(p1, p2);
			}			
			
			this.isInUse = function()
			{
				return m_bIsInUse;
			}
			
			this.addToPage = function()
			{
				ero.style.visibility = 'hidden';
				prog.style.visibility = 'hidden';
				document.body.appendChild(ero);
				document.body.appendChild(prog);
			}			
			
			this.getSize = function()
			{
				var x1 = ero.offsetLeft;
				var y1 = ero.offsetTop;
				var x2 = x1 + ero.offsetWidth;
				var y2 = y1 + ero.offsetHeight;
				
				var size = new geo.Rectangle(new geo.Point(x1, y1), new geo.Point(x2, y2));
				return size;					
			}
		

		
			// -- PRIVATE FUNCTIONS -- //
			function EROMouseOver()
			{
				m_bIsInUse = true;
			}
			
			function EROMouseOut()
			{
				self.hide();
			}
		}
	}
}
