//------------------------------------------------------------------------------
// Header/Header.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Rtorres
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

//
// make sure our namespace exists
RegisterNamespaces ( "Msn.VE" );

// Display tool list
function DisplayToolsList()
{
	var t = document.getElementById("toolslist");
	
	// get leftcoord of element and set the toolslist
	t.style.left = GetElementLeftPosition('toolslink');
	
	if(t.style.visibility == "visible")
	{
		t.style.visibility = "hidden";
		if(t.releaseCapture)
		{
			t.releaseCapture();
		}
	}
	else
	{
		window.attachEvent("onclick", HideToolsList);
		t.style.visibility = "visible";
		t.setCapture(false);
		t.focus();
	}
}

// Hide and release capture on tools list
function HideToolsList()
{
	var t = document.getElementById("toolslist");
	t.style.visibility = "hidden";
	if(t.releaseCapture)
	{
		t.releaseCapture();
	}
}

// Hide and release capture for ambiguous list
function HideAmbiguousList()
{
	var m = document.getElementById("whereambiglist");	
	// if ambig list is already hidden, do not try to hide it again, just return
	if (m.style.visibility == 'hidden' || m.style.display == 'none')
		return;
		
	if(document.all && m.releaseCapture)
	{
		m.releaseCapture();
	}
		
		
	m.style.visibility = "hidden";			
	removeAmbiguousListContents();
}

// Highlight the item in the list
function keydown_Go(list)
{
	if (!list)
		list = GetTarget();
	
	/*	A control that is not visible can still have focus, in which case (for Firefox) the events will still be sent to the DOM element
			in question.  Problem is, if the element is hidden, we can't possible succeed in selecting an item, so Firefox will chuck a wobbly.
			The easiest solution for now is to return prematurely from this function */
	if (list.style.visibility == 'hidden')
		{ return; }
	
	var txtWhere = document.forms['wwf']['where'];
	var items = list.childNodes;
	var max = items.length;
	
	var i, selectedIndex = -1;
	for (i = 0; i < max; i++)
	{
		if (items[i].className == 'item_on')
		{
			selectedIndex = i;
			break;
		}
	}
	
	var evt = event || window.event;
	
	switch (evt.keyCode)
	{
			// down arrow key
			case 40:				
				if (selectedIndex > -1)
					items[selectedIndex].className = 'item';
					
				if (++selectedIndex >= max)
					selectedIndex = 0;
					
				items[selectedIndex].className = 'item_on';
				break;
				
			// up arrow key
			case 38:
				if (selectedIndex > -1)
					items[selectedIndex].className = 'item';
				
				if (--selectedIndex < 0)
					selectedIndex = max - 1;
			
				items[selectedIndex].className = 'item_on';
				break;
				
			// enter
			case 13:
				if (selectedIndex > -1)
					items[selectedIndex].onclick();
				break;
			
			// tab	
			case 9:
				HideAmbiguousList();
				txtWhere.focus();
				
				/*	Default tab action for Firefox is to place focus on the next item.  We want to override this behavhior,
						so we prevent the default action from occurring when the key press is a tab */
				if (evt.preventDefault)
					evt.preventDefault();
				break;
	}
}

//onmouseover event handler for items
function item_MouseOver(e)
{
	var evt = e || window.event;	
	var target = evt.srcElement || evt.target;
	
	var list = target.parentNode;
	
	if (!list)
		return;
	
	var i, len = list.childNodes.length;
	for (i = 0; i < len; i++)
		list.childNodes[i].className = 'item';
		
	target.className = 'item_on';
	Msn.VE.Search.strLastWhere = target.firstChild.nodeValue;
}

//onmouseout event handler for items
function item_MouseOut(e)
{
	var evt = e || window.event;
	var target = evt.srcElement || evt.target;
	target.className = 'item';
}
