//------------------------------------------------------------------------------
// XmlHttp.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, sstchur
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

var HelpHistory=new Array();

// Constructor.  Unused, but needed to declare variables
function VE_Help()
{
}

// z-index of help panel
VE_Help.helpZIndex = 31;

// z-index of panel
VE_Help.introZIndex = 31;

// Reference to the intro panel
VE_Help.introPanel = null;

// Reference to the help panel
VE_Help.helpPanel = null;

VE_Help.margins = 110;


// Creates the help panel
VE_Help.CreateHelpPanel=function()
{
	var helpFrame = "<iframe id=\"helpFrame\" src=\"about:blank\" width=\"100%\" height=\"100%\" allowtransparency=\"true\" frameborder=\"0\"></iframe>";
	var p = new VE_Panel(
		"help",                      // id
		220,                         // x
		160,                         // y
		"windowWidth-430",           // width
		"windowHeight-190",          // height
		"blue",                      // color
		VE_Help.helpZIndex,          // z index
		L_Help_Text,                 // title
		helpFrame,                   // body
		"");                         // footer
	
	p.body.className = "VE_Panel_body_help";
	
	p.Hide();
	p.SetToolbarSize(0);
	p.SetFooterSize(0);	
	p.SetOpacity(95);
	
	p.onCloseClick = function(e)
	{
		VE_Help.ClosePanel();
	};
	
	VE_Help.helpPanel = p;
}

VE_Help.EnablePreventLayer = function()
{
	//We may need this again but according to bug 4400
	//this is all broken - so just return.
	return;
	var preventLayer = document.getElementById('__preventLayer__');
	if (!preventLayer) { preventLayer = document.createElement('div'); }
	preventLayer.id = '__preventLayer__';
	preventLayer.className = 'preventLayer';	
	document.body.appendChild(preventLayer);	
}

VE_Help.DisablePreventLayer = function()
{
	return;
	var preventLayer = document.getElementById('__preventLayer__');
	if (preventLayer)
		document.body.removeChild(preventLayer);
}


// Creates the intro panel
VE_Help.CreateIntroPanel=function()
{
	var db = map.GetDashboard();
	var introFrame = "<iframe id=\"introFrame\" src=" + welcomeUrl + " width=\"100%\" height=\"100%\" allowtransparency=\"true\" frameborder=\"0\"></iframe>";	
	var p = new VE_Panel(	"intro",										// id
												0,													// x
												0,                          // y
												'auto',											// width
												'auto',											// height
												'welcomePanel',							// type
												VE_Help.introZIndex,        // z index
												L_Welcome_Text,							// title
												introFrame,									// body
												"",													// footer
												"",													// mouseovertitle
												true,											// bOpaque	
												taskArea_data);											// parent
		
	p.el.className = "welcomePanel";
	p.body.className = "VE_Panel_body_help";
	
	// Make IE obey the pseudo class :hover for the Welcome Panel's TitleBar
	pseudoHover(p.title);
	
	p.SetToolbarSize(0);
	p.SetFooterSize(0);	
	
	p.onTitleClick = function(e)
	{
		taskArea.setCurrent(this);
	}
	
	p.onCloseClick = function(e)
	{
		var parent = this.el.parentElement;
		if (parent)
			parent.removeChild(this.el);
			
		taskArea.removeItem(this);
		VE_Help.introPanel = null;
	}
	
	p.onMaximize = function(e)
	{
		resetWhatBox();
	}
	
	// Add this panel to the TaskArea
	taskArea.addItem(p);	
		
	VE_Help.introPanel = p;
}


// Opens an url into the help panel
VE_Help.Open=function(title, url)
{
	VE_Help.EnablePreventLayer();
	VE_Help.helpPanel.Show();	
	VE_Help.helpPanel.SetTitle(title);	
	VE_Help.helpPanel.SetBody('<iframe id = "helpFrame" src = "about:blank" width = "100%" allowtransparency = "true" scrolling = "auto" frameborder = "0"></iframe>');
	var helpFrame = document.getElementById('helpFrame');
	helpFrame.src = url;
	
	VE_Help.Redraw();	
}

VE_Help.Redraw = function(force)
{
	
	var panel = VE_Help.helpPanel;
	if (!panel)
		return;
	
	if (!force)
	{
		var taskAreaWidth = taskArea_transparency ? taskArea_transparency.offsetWidth : 0;
		var scratchPadWidth = scratchPad ? scratchPad.getElement().offsetWidth : 0;
		//pure hack for 8X6 screens
		if(document.body.clientWidth > 800)
			var width = document.body.clientWidth - taskAreaWidth - scratchPadWidth - VE_Help.margins;	
		else
			var width = document.body.clientWidth - taskAreaWidth - scratchPadWidth - 50;
		var height = document.body.clientHeight - header.offsetHeight - mapActionBar.offsetHeight - VE_Help.margins;
		
		// sstchur:  A width or height less than or equal to 0 is an invalid property for CSS, so we only set the panel property if the value is positive	
		if (width > 0)
			panel.width = width;
			
		if (height > 0)
			panel.height = height;		
	}
	panel.x = 278;
	panel.Resize();
}


// Closes the intro panel if it is open
VE_Help.CloseIntro=function()
{
	if(VE_Help.introPanel)
	{
		VE_Help.introPanel.Hide();		
	}
}

// Opens the intro panel or creates it if it doesn't exist, and resize search panels
VE_Help.OpenIntro=function()
{
	// sstchur:  If the taskArea isn't visible, make it visible (required in order to show the introPanel 
	toggleTaskArea(true);
	
	// Create and show the panel if it does not exist.  If it does exist, just show it
	if (!VE_Help.introPanel)			
		VE_Help.CreateIntroPanel();											// creates the panel, adds it to the taskArea, sets it to be the current panel
	else
		taskArea.setCurrent(VE_Help.introPanel);
		
	VE_Analytics.Log("VE | Welcome Pane","Welcome");	
}

// Closes the help panel if it is open
VE_Help.ClosePanel=function()
{
	if(VE_Help.helpPanel)
	{
		VE_Help.helpPanel.Hide();
		VE_Help.DisablePreventLayer();
	}
}