//------------------------------------------------------------------------------
// Map.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Codye, sstchur, a-jayab
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

var map = null;

// Map pushpin container.  Used for legacy support.
function VE_MapPushpin(){}

// Pushpins.
// Base is 11.  Each search should be sequentially higher.
// Searches on top have higher numbers.

		/*	sstchur:
		TODO:  Test heavily what impact this will have on the application */
		
		VE_MapPushpin.baseZIndex = 200;

		// This is for when we absolutely want to ripple a pushpin to the top.
		VE_MapPushpin.topZIndex = 300;
//

// Creates the initial map.  This method should only be called once!!
function StartMap(params, windowWidth, windowHeight)
{
	// Create the control
	var mapDiv = document.createElement("div");
	mapDiv.style.position = "absolute";
	mapDiv.style.overflow = "hidden";
	mapDiv.style.top = "0px";
	mapDiv.style.left = "0px";
	mapDiv.style.width = windowWidth + "px";
	mapDiv.style.height = windowHeight + "px";	
	mapDiv.id = 'mapContainer';
	document.body.appendChild(mapDiv);
	
	params.disableLogo = true;
	params.showScaleBar = true;
	params.showDashboard = true;
	params.dashboardSize = Msn.VE.DashboardSize.Normal;	
	params.dashboardX = 270;
	params.dashboardY = 113;
	params.obliqueEnabled = true;
	params.obliqueUrl = "imagery.ashx";

	map = new Msn.VE.MapControl(mapDiv, params);	
	map.Init();
	
	map.SetCopyrightOffset(0, 28);
	
	// On start continuous pan, close the popup if it is open.
	map.AttachEvent("onstartcontinuouspan", function(e)
	{
		VE_ContextMenu.RemoveContextPin();
		VE_ContextMenu.CloseMenu();
		VE_SearchManager._CancelAllRequests();
		VE_Directions.ClosePopup();
		VE_SearchManager.CloseSearchPopup();
		VE_Annotations.ClosePanel ();
		VE_Annotations.ClosePopup (true);
	});
	
	// At the end of a continuous pan, update the permalink, map scale bar, and search results.
	map.AttachEvent("onendcontinuouspan", function(e)
	{
		window.setTimeout(VE_TrafficManager._ViewChangeNotification, 10);		
	});
	
	// At the start of a zoom, close the popup if it is open.
	map.AttachEvent("onstartzoom", function(e)
	{
		VE_SearchManager._CancelAllRequests();
		VE_Directions.ClosePopup();
		VE_SearchManager.CloseSearchPopup();
		VE_ContextMenu.RemoveContextPin ();
		VE_ContextMenu.CloseMenu();
		VE_Annotations.ClosePanel ();
		VE_Annotations.ClosePopup ();
	});
	
	// At the end of a zoom, the permalink, zoom widget, and map scale bar all need to be updated.
	map.AttachEvent("onchangeview", OnMapViewChangeActions);
	
	// use the context menu to annotate the map
	map.AttachEvent("oncontextmenu", function(e)
	{
		VE_ContextMenu.OpenContextMenuAtLocation(e);
	});
	
	map.AttachEvent("onmouseclick", function(e)
	{
		VE_ContextMenu.RemoveContextPin();
		VE_ContextMenu.CloseMenu();
	});
	
	map.AttachEvent("onchangemapstyle", function(e)
	{
		state.UpdateFromMap();
		window.setTimeout(VE_SearchManager.ResizePanels, 1);
		if(map.GetMapStyle() == Msn.VE.MapStyle.Oblique )
		{
			VE_Analytics.Log("VE | Oblique Imagery","","Oblique");
		}
		VE_ContextMenu.RemoveContextPin();
		VE_ContextMenu.CloseMenu();
	});
	
	map.AttachEvent("onobliqueenter", function(e)
	{
		window.setTimeout(VE_SearchManager.ResizePanels, 1);		
	});
	
	map.AttachEvent("onobliqueleave", function(e)
	{
		window.setTimeout(VE_SearchManager.ResizePanels, 1);
	});
	
	map.AttachEvent("onobliquechange", function(e)
	{
		state.UpdateFromMap();
		VE_ContextMenu.RemoveContextPin();
		VE_ContextMenu.CloseMenu();
		VE_SearchManager._CancelAllRequests();
		VE_Directions.ClosePopup();
		VE_SearchManager.CloseSearchPopup();
		VE_Annotations.ClosePanel ();
		VE_Annotations.ClosePopup ();
		AutoRefresh();
	});
	
	map.AttachEvent("onerror", function(e)
	{
		if (e.error)
		{
			ShowMessage(e.error);
		}
	});
}


// Changes the map style.  Updates the map style widget and the permalink.
function ChangeMapStyle(mapStyle)
{
	map.SetMapStyle(mapStyle);
	VE_Analytics.LogMapStyle(mapStyle);
}

// Sets the map viewport.  This is the callback for when the server needs
// to change the viewport.
function SetViewport(lat1, lon1, lat2, lon2)
{
	// Set the viewport and force a jump
	var flag = map.SetViewport(lat1, lon1, lat2, lon2);
	if(flag == false)
	{
		//Bug# 4563
		//No need to fire auto-refresh in case of a successful view change
		//Because onviewchange will fire auto refresh
		//We manually need to auto-refresh
		OnMapViewChangeActions(null);
	}
}
//OverLay Traffic Tiles.
function GetTraffic()
{		 
	if(map == null)
		return;
	map.RemoveTrafficLayer();
	if(!map.GetTrafficAvailability())
	{	
		window.setTimeout(map.SetTrafficView, 1);
	}
}

function OnMapViewChangeActions(e)
{
		window.setTimeout(AutoRefresh, 100);
		window.setTimeout("state.UpdateFromMap()", 200);
		window.setTimeout(VE_TrafficManager._ViewChangeNotification, 10);
		
		/*	We don't want to clear the where box if it was set from an AmbiguousList selection.  Problem is, this check needs to occurr
				AFTER the above 3 lines of code (which are all being called via setTimeout).  Therefore, our check needs to use setTimeout
				as well, so that the order of execution remains faithful. */
		window.setTimeout(function()
											{
												if (viewportSetFromAmbiguousSelect)
												{
													viewportSetFromAmbiguousSelect = false;
													return;
												}

												var list = document.getElementById('whereambiglist');												
												if (list.style.display == 'none' || list.style.visibility == 'hidden')
													resetWhereBox();
												
												list = null;												
											}, 200);
}