//------------------------------------------------------------------------------
// MapControl/Bounds.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, keithkin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// Clips a view
function ClipView(view, bounds)
{
	ShiftView(view, bounds, 0, 0);
}
	
// Shifts the view over by a delta.  Clips the resulting view.
function ShiftView(view, bounds, deltaX, deltaY)
{
	//If the bounds are not set, do nothing
	if ((bounds != null) && (bounds != "undefined"))
	{
		deltaX = ClipDelta(deltaX, width, view.center.x - width/2, view.zoomLevel, bounds.z1, bounds.x1, bounds.x2);
		deltaY = ClipDelta(deltaY, height, view.center.y - height/2, view.zoomLevel, bounds.z1, bounds.y1, bounds.y2);
		view.SetCenter(new Msn.VE.Pixel(view.center.x + deltaX, view.center.y + deltaY));
	}
}

// Clips a delta value
function ClipDelta(delta, size, offset, zoomLevel, boundsZoom, boundsMin, boundsMax)
{
	var min = tileSize * boundsMin * Math.pow(2, zoomLevel - boundsZoom);
	var max = tileSize * boundsMax * Math.pow(2, zoomLevel - boundsZoom);
	
	if (size > (max - min))
	{
		return ((max - min - size) / 2) - offset + min;
	}
	else if (offset + delta < min)
	{
		return min - offset;
	}
	else if (offset + size + delta > max)
	{
		return max - offset - size;
	}
	
	return delta;
}
