//------------------------------------------------------------------------------
// MapControl/Dashboard/ObliqueZoomBar.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: a-bwrigh
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


function ObliqueZoomBar(parent)
{
	var container       = document.createElement("div");
	var smallViewButton = document.createElement("div");
	var largeViewButton = document.createElement("div");
	
	container.title = L_ObliqueZoomBarSelectZoom_Text;
	
	container.setAttribute("id","obliqueZoomContainer");
	smallViewButton.setAttribute("id","obliqueZoomSmall");
	smallViewButton.className = "obliqueZoomSmallOn";
	
	largeViewButton.setAttribute("id","obliqueZoomLarge");
	largeViewButton.className = "obliqueZoomLargeOff";
	
	smallViewButton.attachEvent("onclick",OnSmallClick);
	
	largeViewButton.attachEvent("onclick",OnLargeClick);
	
	container.appendChild(smallViewButton);
	container.appendChild(largeViewButton);
	
	
	parent.appendChild(container);
	
	function Show()
	{
		container.style.display = "block";
	}
	
	function Hide()
	{
		container.style.display = "none";
	}
	
	function OnSmallClick(e)
	{
		map.ZoomOut();
		smallViewButton.className = "obliqueZoomSmallOn";
		largeViewButton.className = "obliqueZoomLargeOff";
	}
	
	function OnLargeClick(e)
	{
		map.ZoomIn();
		smallViewButton.className = "obliqueZoomSmallOff";
		largeViewButton.className = "obliqueZoomLargeOn";
	}
	
	function Destroy()
	{
		smallViewButton.detachEvent("onclick",OnSmallClick);
		largeViewButton.detachEvent("onclick",OnLargeClick);
		container.removeChild(smallViewButton);
		container.removeChild(largeViewButton);
		smallViewButton = null;
		largeViewButton = null;
		container.parentNode.removeChild(container);
		container = null;
	}
	// Updates the slider position based on the map's current zoom level
	function UpdateFromMap()
	{
		if(map.GetZoomLevel() == 1)
		{
			smallViewButton.className = "obliqueZoomSmallOn";
			largeViewButton.className = "obliqueZoomLargeOff";
		}
		else 
		{
			smallViewButton.className = "obliqueZoomSmallOff";
			largeViewButton.className = "obliqueZoomLargeOn";
		}
	}
	
	this.Destroy = Destroy;
	this.Show = Show;
	this.Hide = Hide;
	this.UpdateFromMap = UpdateFromMap;
}
