//------------------------------------------------------------------------------
// MapControl/Keyboard.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


// Handles key down events for panning and zooming.
function KeyDown(e)
{
	e = GetEvent(e);
	
	var s = keyboardPanSpeed;
	var x = panningX;
	var y = panningY;
	
	switch (e.keyCode)
	{
		case 9: // tab
		case 18: // alt
			// we want to stop keyboard panning if focus is moving away from the map control.
			if (panning && keyboardPan)
			{
				StopContinuousPan();
			}
			return true;
			
		case 37: // left
			x = -s;
			break;
			
		case 38: // up
			y = -s;
			break;
			
		case 39: // right
			x = s;
			break;
			
		case 40: // down
			y = s;
			break;
			
		case 107: // + (numpad)
		case 187: // + (IE)
		case 61: // '=' (FF)
		case 43: // '+' (FF)
			x = 0;
			y = 0;
			ZoomIn();
			break;
			
		case 109: // - (numpad)
		case 189: // -
			x = 0;
			y = 0;
			ZoomOut();
			break;
			
		case 65: // a (aerial)
			x = 0;
			y = 0;
			SetMapStyle(aerialStyle);
			break;
			
		case 72: // h (hybrid)
			x = 0;
			y = 0;
			SetMapStyle(hybridStyle);
			break;
			
		case 82: // r (road)
		case 86: // v (vector)
			x = 0;
			y = 0;
			SetMapStyle(roadStyle);
			break;
		
		case 66: // b (bird's eye)
		case 79: // o (oblique)
			//if (obliqueMode && obliqueMode.IsAvailable())
			//{
				x = 0;
				y = 0;
				SetMapStyle(obliqueStyle);
			//}
			break;
			
		default:
			return false;
	}
	
	if (x || y)
	{
		ContinuousPan(x, y, null, true);
	}
	
	return false;
}

// Handles key up events
function KeyUp(e)
{
	e = GetEvent(e);

	var x = panningX;
	var y = panningY;
	
	switch (e.keyCode)
	{
		case 37: // left
			x = 0;
			break;
			
		case 38: // up
			y = 0;
			break;
			
		case 39: // right
			x = 0;
			break;
			
		case 40: // down
			y = 0;
			break;
			
		default:
			return false;
	}

	ContinuousPan(x, y, null, true);
	return false;
}
