//------------------------------------------------------------------------------
// MapControl/LatLongRectangle.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

Msn.VE.LatLongRectangle = function(northwest, southeast)
{
	this.northwest = northwest;
	this.southeast = southeast;
	
	this.ToString = function()
	{
		return "(" + (this.northwest ? this.northwest.ToString() : "null") + ", " + (this.southeast ? this.southeast.ToString() : "null") + ")";
	};
	
	this.Copy = function(rect)
	{
		if (!rect)
		{
			return;
		}
		
		if (!this.northwest)
		{
			this.northwest = new Msn.VE.LatLong();
		}
		
		if (!this.southeast)
		{
			this.southeast = new Msn.VE.LatLong();
		}
		
		this.northwest.Copy(rect.northwest);
		this.southeast.Copy(rect.southeast);
	};
	
	// Computes the center latlong of the rectangle.
	this.Center = function()
	{
		var sinLat1 = Math.sin(this.northwest.latitude * Math.PI / 180.0);
		var sinLat2 = Math.sin(this.southeast.latitude * Math.PI / 180.0);
		var average = 0.25 * (Math.log((1.0 + sinLat1) / (1.0 - sinLat1)) + Math.log((1.0 + sinLat2) / (1.0 - sinLat2)));

		var center = new Msn.VE.LatLong();
		center.latitude = Math.atan(Math.exp(average)) * 360.0 / Math.PI - 90.0;
		center.longitude = 0.5 * (this.northwest.longitude + this.southeast.longitude);

		return center;
	};
	
	// Determines if a latlong is inside this latlong rectangle
	this.Contains = function(latlong)
	{
		return latlong.latitude <= northwest.latitude && 
			latlong.longitude >= northwest.longitude && 
			latlong.latitude >= southeast.latitude && 
			latlong.longitude <= southeast.longitude;
	};
};

