//------------------------------------------------------------------------------
// MapControl/Layer.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: a-jayab, cthota
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// The current tiles list is a 1-dimensional array of Traffic tile objects.  The order of the tiles
// array is very important and must be preserved for UpdateView to function properly.
// The order starts at the top left, moves to the right across the top row, then starts
// again at the left most tile on the next row down.
var currentTrafficTilesList = new Array();	
	
var oldTrafficList = null;

var layerRequestedView = null;
	
//This function is called when we have to clear the layers
function ClearLayer()
{
	if(trafficAvailable && trafficAvailable == true)
		ClearTrafficLayer();
}

//This function is called to overlay a layer of tiles(eg traffic tiles) over existing route
function SetLayer()
{
	if(trafficAvailable && trafficAvailable == true)
		SetTrafficLayer();	
}

//This function is called to request tiles layer from the tile server
function SetLayerView()
{
	if(trafficAvailable && trafficAvailable == true)
		SetTrafficView();
}

//This function is called to swap tile layer tiles during zoom.
function SwapLayer()
{
	if(trafficAvailable && trafficAvailable == true)
		SwapTrafficLayer();
}

//This function is called to update tile layer tiles during panning.
function UpdateLayer()
{	
	if(trafficAvailable && trafficAvailable == true)
	{		
		UpdateTrafficLayer();
	}
}
