//------------------------------------------------------------------------------
// MapControl/Math.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// A collection of mathematic functions.  Many functions are simple wrappers around
// the existing Math functions.  They are wrapped for better source compression and
// obfuscation.

// If one of the simple wrapped methods is deeply nested in a performance-critical
// loop, it might be useful to experiment with not using the wrapper.  Otherwise,
// it is recommended for better compression and obfuscation.

// Returns the greatest integer less than x.
function MathFloor(x)
{
	return Math.floor(x);
}

// Returns the smallest integer greater than x.
function MathCeil(x)
{
	return Math.ceil(x);
}

// Returns the greater of x and y.
function MathMax(x, y)
{
	return Math.max(x, y);
}

// Returns the lesser of x and y.
function MathMin(x, y)
{
	return Math.min(x, y);
}

// Returns the absolute value of x.
function MathAbs(x)
{
	return Math.abs(x);
}

// Returns the integer nearest to x.
function MathRound(x)
{
	return Math.round(x);
}

// Converts degrees to radians
function DegToRad(d)
{
	return d * Math.PI / 180.0;
}

// Converts radians to degrees
function RadToDeg(r)
{
	return r * 180.0 / Math.PI;
}

