//------------------------------------------------------------------------------
// MapControl/Tools/BoxTool.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Codye
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

function BoxTool()
{
	var bg = document.createElement("div");
	var fg = document.createElement("div");
	var x1=0, y1=0, x2=0, y2=0;
	
	this.Init = function()
	{
		bg.className = "ZoomBox_bg";
		fg.className = "ZoomBox_fg";
		
		// The elements have to reference the parent map control's mouse handlers.
		// This is only for firefox, because it lacks setCapture/releaseCapture capabilities
		bg.attachEvent("onmouseup", MouseUp);
		fg.attachEvent("onmouseup", MouseUp);
		
		if(map != null)
		{
			map.appendChild(bg);
			map.appendChild(fg);
		}
	};
	
	this.Destroy = function()
	{
		bg.detachEvent("onmouseup", MouseUp);
		fg.detachEvent("onmouseup", MouseUp);
		if(map != null)
		{
			map.removeChild(bg);
			map.removeChild(fg);
		}
	};

	function OnMouseDown(e)
	{
		if(VE_ContextMenu != null)
		{
			VE_ContextMenu.RemoveContextPin();
			VE_ContextMenu.CloseMenu();
		}
		x1 = x2 = GetMouseX(e) - x + offsetX;
		y1 = y2 = GetMouseY(e) - y + offsetY;

		SetBox(x1, y1, 1, 1);
		Show();
		
		if (fg.setCapture)
		{
			fg.setCapture();
		}
	}
	
	function OnMouseMove(e)
	{
		x2 = GetMouseX(e) - x + offsetX;
		y2 = GetMouseY(e) - y + offsetY;
		SetBox(
			MathMin(x1, x2), 
			MathMin(y1, y2), 
			MathMax(1, MathAbs(x2 - x1)), 
			MathMax(1, MathAbs(y2 - y1)));
	}
	
	function OnMouseUp(e)
	{
		if (MathAbs(x1 - x2) > 1 && MathAbs(y1 - y2) > 1)
		{
			var view = preferredView.MakeCopy();
			view.SetZoomLevel(currentView.zoomLevel); // Have to first specify what zoom level the pixel coordinates are coming in at.
			view.SetPixelRectangle(new Msn.VE.PixelRectangle(new Msn.VE.Pixel(originX + x1, originY + y1), new Msn.VE.Pixel(originX + x2, originY + y2)));
			SetView(view);
		}
		
		Hide();
		
		if (fg.releaseCapture)
		{
			fg.releaseCapture();
		}
	}
	
	function SetBox(x, y, w, h)
	{
		SetElement(bg, x+1, y+1, w, h);
		SetElement(fg, x, y, w, h);
	}
	
	function SetElement(el, x, y, w, h)
	{
		el.style.left = x + "px";
		el.style.top = y + "px";
		el.style.width = w + "px";
		el.style.height = h + "px";
	}
		
	function Show()
	{
		bg.style.display = "block";
		fg.style.display = "block";
	}
	
	function Hide()
	{
		bg.style.display = "none";
		fg.style.display = "none";
	}
	
	this.OnMouseDown = OnMouseDown;
	this.OnMouseMove = OnMouseMove;
	this.OnMouseUp = OnMouseUp;
}

