//------------------------------------------------------------------------------
// Messages.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Codye
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


// Creates the message control and adds it to the document
function CreateMessageControl()
{
	var c = new VE_MessageControl();
    document.body.appendChild(VE_MessageControl.control);
}


// Adds a new message to the message control
function ShowMessage(message)
{
	if(VE_MessageControl.messages.length > 0)
	{
		VE_MessageControl._RemoveMessage();
	}
	
	VE_MessageControl._AddMessage(message);
}


// Contructor for the message control
function VE_MessageControl()
{
    if(!VE_MessageControl.control)
    {
		VE_MessageControl.control = document.createElement("div");
		VE_MessageControl.control.id = "VE_MessageControl";
	}   
    
    return VE_MessageControl.control;
}


// Static members, one for the dom object and another for the arry of messages.
VE_MessageControl.control = null;
VE_MessageControl.messages = new Array();


// Adds a new message to the control.  The message is displayed,
// and scheduled to be removed in 10 seconds
VE_MessageControl._AddMessage=function(message)
{
	VE_MessageControl.messages.unshift(message);
	window.setTimeout("VE_MessageControl._RemoveMessage()", 10000);
	VE_MessageControl._Update();
}


// Removes the oldest message from the list.
VE_MessageControl._RemoveMessage=function()
{
	VE_MessageControl.messages.pop();
	VE_MessageControl._Update();
}


// Re-renders the html for the message control.
VE_MessageControl._Update=function()
{
	var c = VE_MessageControl.control;
	var m = VE_MessageControl.messages;
	if(!m.length)
	{
		c.innerHTML = "";
		c.style.display = "none";
		return;
	}
	
	var html = "";
	for(var i=0; i<m.length; i++)
	{
		html += "<div class=\"VE_MessageControl_message\">" + m[i] + "</div>";
	}
	html += "<div class=\"VE_MessageControl_close\" onclick=\"VE_MessageControl.Hide()\" unselectable=\"on\">X</div>";
	c.innerHTML = html;
	c.style.display = "block";
}


// Hides the message control
VE_MessageControl.Hide=function()
{
	VE_MessageControl.control.style.display = "none";
}
