//------------------------------------------------------------------------------
// Network.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: a-jayab
//
// <header>	$Network$</header>
//------------------------------------------------------------------------------

//Network class
function VENetwork()
{	
}

VENetwork.GetExecutionID = function()
{	
	var date = new Date();
	var id = Date.UTC(date.getFullYear(), 
		date.getMonth(),
		date.getDate(),
		date.getHours(),
		date.getMinutes(),
		date.getSeconds(),
		date.getMilliseconds());
	
	id += Math.round(Math.random() * 1000000);
	
	return id;
	
}


VENetwork.DownloadScriptCallback = function(fnCallback)
{	
	if(fnCallback)
	{
		fnCallback();
	}
}

VENetwork.DownloadScript = function (scriptUrl, fnCallback)
{		
	try{		
		if(scriptUrl == null || scriptUrl == "undefined" || scriptUrl.length == 0)
			throw new VEException("VENetwork:DownloadScript", "err_noscripturl", L_noscripturl_text)		

		elScript = document.createElement("script");
		elScript.type="text/javascript";
		elScript.language="javascript";
		elScript.id=VENetwork.GetExecutionID();
		elScript.src=scriptUrl;
		//IE Only
		if(navigator.userAgent.indexOf("IE")>=0)
		{
			//onreadystatechange	
			elScript.onreadystatechange=function(){
				if (elScript && ("loaded"==elScript.readyState || "complete"==elScript.readyState))
				{
					elScript.onreadystatechange = null;
					VENetwork.DownloadScriptCallback(fnCallback);
				}		
			}
		}
		else
		{
			//Mozilla only
			elScript.onload=function(){
				elScript.onload = null;		
				VENetwork.DownloadScriptCallback(fnCallback);
			}		
		}	
		//Attach to document
		VENetwork.GetAttachTarget().appendChild(elScript);			
		return elScript.id;
	}
	catch(ex)
	{
		ShowMessage( L_ErrorServerBusy_Text );
	}
}

VENetwork.GetAttachTarget = function()
{
	if(document.getElementsByTagName("head")[0] != null)
		return document.getElementsByTagName("head")[0];
	else
		throw new VEException("VENetwork:cstr", "err_noheadelement", L_noheadelement_text);
}
//End Network class
//========================================================================

//==================================================================================================
//Exception class
//==================================================================================================
function VEException(source, name, message){
this.source=source; 
this.name=name;
this.message=message;
}
VEException.prototype.Name=this.name;
VEException.prototype.Source=this.source;
VEException.prototype.Message=this.message;
//End Exception class

