//------------------------------------------------------------------------------
// JS/Scratchpad.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, sstchur,a-pratin, shankak, keithkin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// Constructor, unused but necessary to define members
function VE_Scratchpad()
{
}

// Maximum number of items in the scratchpad
VE_Scratchpad.maxScratchpadItems = 10;

// Introductory text
VE_Scratchpad._introText = L_ScratchPadIntroText_Text.replace(/%1/g, "<a href=\"javascript:VE_Help.Open(\'Help\',\'Help/%3/ScratchPad.html\');\" oncontextmenu=\"return false;\">" ).replace(/%2/g,"</a>");

// Scratchpad Full text
VE_Scratchpad._fullText = L_ScratchPadFullText_Text;

VE_Scratchpad._emailTruncationMsg = "\n\n<" + L_ScratchPadTruncateText_Text + ">";

VE_Scratchpad._blogTruncationMsg = "\"</a><br /><br />" + L_ScratchPadTruncateText_Text;

// The array of entities in the scratchpad
VE_Scratchpad.entities = new Array();

// A reference to the panel
VE_Scratchpad.panel = null;

// A running counter of the locations used.  Locations do not
// have a persistent id, so a local id is used
VE_Scratchpad.locationCounter = 1;

// The panel color for the scratchpad
VE_Scratchpad.panelColor = "blue";

// Scratchpad panel z-index.
VE_Scratchpad.panelZIndex = 31;

// Scratchpad push pin z-index.
VE_Scratchpad.pinZIndex = 300;

// Entity Type -> color associative array.
VE_Scratchpad._typeToColor = { "adr" : "anno", "yp" : "anno", "al" : "orange", "aN" : "anno" };

// XML HTTP Request object used for requests to deserialize scratchpad entities
VE_Scratchpad.xmlHttp = null;

// High water count of items on the scratchpad throughout the session
VE_Scratchpad.highWaterCount = 0;

//Reference to prepopulation entityIds.
VE_Scratchpad.PrePopulationEntityIds = null;

// Create the scratchpad panel
VE_Scratchpad.CreatePanel=function()
{
	//replace the %3 placeholder with locale value	
	VE_Scratchpad._introText = VE_Scratchpad._introText.replace(/%3/g,window.locale);
	var p = new VE_Panel(	"scratchpad",										// id
												'auto',													// x
												'auto',													// y
												180,														// width
												"windowHeight-150",							// height 
												'',															// sstchur:  No CSS class is necessary here
												VE_Scratchpad.panelZIndex,			// z index
												L_ScratchPadWindowTitle_Text,		// title
												VE_Scratchpad._introText,				// body
												"");														// footer
	
	p.SetToolbar(VE_Scratchpad._GetToolbar());
	p.SetFooterSize(0);
	p.Hide();
	p.el.className = 'msve_Scratchpad';	
	p.onTitleClick = function(e)
	{
		/*	sstchur:
			TODO:  Add a specific link/image to expand/collapse the Scratchpad so that the titlebar is not doubling as a minimize / maximize bar */
			return;
				
		if (VE_Scratchpad.panel.min)
		{
			VE_Scratchpad.panel.el.className = 'msve_Scratchpad';
			VE_Scratchpad.panel.min = false;
		}
		else
		{
			VE_Scratchpad.panel.el.className = 'msve_Scratchpad_minimized';
			VE_Scratchpad.panel.min = true;
		}		
	}
		
	p.onCloseClick = function(e)
	{
		VE_Scratchpad.panel.Hide();
		VE_Scratchpad._HidePins();
		VE_SearchManager.CloseSearchPopup();
		VE_Annotations.ClosePopup ();		
	};
	
	VE_Scratchpad.panel = p;
}

// Show Scratchpad
VE_Scratchpad.Show=function()
{
	//VE_Scratchpad.panel.Show();		
	scratchPad.show();
	
	if (!spRoller.isExpanded())
		spRoller.rollOut(Microsoft.Web.Animation.RollDirection.TopDown);
	
	VE_Scratchpad._ShowPins();		
}

// Show all entities on map.
VE_Scratchpad.ShowAllOnMap=function()
{
	VE_Scratchpad.SetBestMapView();
}

// Prepopulates the scratchpad with entities
VE_Scratchpad.Populate=function(entityIDs, doBestFit)
{	
	if(!entityIDs || entityIDs.length == 0)
	{
		return;
	}
	
	//storing the prepopulation entityIds list.
	VE_Scratchpad.PrePopulationEntityIds = new Array();
	VE_Scratchpad.PrePopulationEntityIds = VE_Scratchpad.PrePopulationEntityIds.concat(entityIDs);
	
	// returns null if all pins are annotations
	entityIDs = VE_AnnotationData.DeserializeAnnotationList ( entityIDs );

	// update state
	state.UpdateFromScratchpad ();
	
	// if there are only annotations, don't bother going to the server
	if ( !entityIDs )
	{
		if ( doBestFit )
		{
			// Make a delayed call so all panels are open and the viewport size can
			// be accurately computed.
			window.setTimeout("VE_Scratchpad.SetBestMapView ()", 500);
		}
		
		return;
	}
	

	// Try to instantiate an instance of XmlHttpRequest
	VE_Scratchpad.xmlHttp = GetXmlHttp();	
	var x = VE_Scratchpad.xmlHttp;
		
	// If we do have an XmlHttpRequest...
	if(x)
	{
		// Build the URL.
		var primarySeparator = VE_SerializationConstants.primarySeparator[currentUrlApiVersion];
		var url = "entities.ashx?fitmap=" + doBestFit + "&ids=" + escape ( entityIDs.join ( primarySeparator ) ) + "&mkt=" +locale ;
		
		// Send the request.
		x.open("POST", url, true);
		x.onreadystatechange = VE_Scratchpad._ResponseHandler;
		x.send("");
	}
}

VE_Scratchpad.SetBestMapView = function ()
{
	//shankak : modification to acheive best of both worlds 
	//old scratchpad and new scratchpad. fixes map all bug
	
	var mapAllArray = new Array();
	
	if(VE_CollectionsManager.collectionIndex == VE_CollectionsManager.unsavedCollectionIndex)
	{
		if (VE_Scratchpad.entities && VE_Scratchpad.entities.length > 0)
		{	
			map.SetBestMapView(VE_Scratchpad.entities);
		}
		else if(VE_CollectionsManager.Collection)
		{
			
			for( var i=0; i < VE_CollectionsManager.Collection.Annotations.length; i++)
			{
				var latlong = new Msn.VE.LatLong(VE_CollectionsManager.Collection.Annotations[i].Latitude, VE_CollectionsManager.Collection.Annotations[i].Longitude);
				mapAllArray.push(latlong);
				VE_Scratchpad._SwitchBestMapViewForBirdsEye(latlong);
			}
			
			if(mapAllArray.length > 0)
				map.SetBestMapView(mapAllArray);
		}
	}
	else if(VE_CollectionsManager.Annotations)
	{	
			for( var i=0; i < VE_CollectionsManager.Annotations.length; i++)
			{
				var latlong = new Msn.VE.LatLong( VE_CollectionsManager.Annotations[i].Latitude, VE_CollectionsManager.Annotations[i].Longitude);
				mapAllArray.push(latlong);
				VE_Scratchpad._SwitchBestMapViewForBirdsEye(latlong);				
			}
			
			if(mapAllArray.length > 0)
				map.SetBestMapView(mapAllArray);
	}
	
	while(mapAllArray.length)
	{
		var item = mapAllArray.pop();
		item = null;
	}
	
	mapAllArray = null;
}


VE_Scratchpad._SwitchBestMapViewForBirdsEye = function(veLatLong)
{
	if(veLatLong == null || veLatLong == "undefined")
		return;
	if (map.GetMapStyle() == Msn.VE.MapStyle.Oblique)
	{	
		var scene = map.GetObliqueScene();
		if (!scene || !scene.ContainsLatLong(veLatLong))
		{
			map.SetMapStyle('r');
		}
	}
}

// Handles the server response from a scratchpad deserialization call
VE_Scratchpad._ResponseHandler = function()
{
	var x = VE_Scratchpad.xmlHttp;
	if(x.readyState==4) 
	{
		var code = x.responseText;
		try
		{
			eval(code);			
		}
		catch(ex)
		{
			// Swallow exceptions.  Don't display JavaScript errors to the user.
		}
		
		VE_Scratchpad.xmlHttp == null;
	}
}

// Looks up specified entity id in search result & adds it to scratch pad.
VE_Scratchpad.AddSearchResult=function(searchIndex, entityID)
{
	//close current popup
	CloseOpenPopup();
	
	//find the search
	var s = VE_SearchManager.FindByIndex(searchIndex);
	if(!s)
	{
		return;
	}
	
	var e = s.GetEntity(entityID);
	if(!e)
	{
		return;
	}
	
	//prevents adding the same entity to scratchpad if it exists
	if(VE_Scratchpad.Contains(entityID,e.type))
	{
		//VE_Scratchpad.panel.Show();
		VE_Scratchpad._ShowPins();
		return;
	}
	
	//find the entity	
	VE_Scratchpad.AddResult(e, entityID);
	
	// Execute post events if any
	if (this.onAddSearchResult)
	{
		this.onAddSearchResult();
	}
	VE_Analytics.Log("VE | Push Pin Popup","Add to Scratch Pad");
}


// Determines if an entity exists in the scratchpad
VE_Scratchpad.Contains=function(id, type)
{
	var e = VE_Scratchpad.entities;
	for(var i=0; i<e.length; i++)
	{
		if(e[i].id == id && e[i].type == type)
			return true;
	}
	return false;
}

VE_Scratchpad.UpdateLocation=function(pinId, name, description, infoUrl, photoUrl)
{
	var entity = VE_Scratchpad.GetEntityFromPinId(pinId);
	if (entity)
	{
		if(name && name != "undefined")
		{
			entity.name = unescape(name);
		}
			
		if(description && description != "undefined")
		{
			entity.description = unescape(description);
		}
		
		if(infoUrl && infoUrl != "undefined")
		{
			entity.infoUrl = unescape(infoUrl);
		}
		
		if(photoUrl && photoUrl != "undefined")
		{
			entity.photoUrl = unescape(photoUrl);
		}
	}
	
	// Update the scratchpad panel
	//VE_Scratchpad._UpdatePanel();
	
	// Close any open popups
	VE_Directions.ClosePopup ();
	VE_SearchManager.CloseSearchPopup();
	VE_Annotations.ClosePopup ();	
}


// Adds a location to the scratch pad
// returns the id of the pin created
VE_Scratchpad.AddLocation=function(name, latitude, longitude, description, type, infoUrl, photoUrl, keywords)
{
	if(!description)
	{
		description = "";
	}

	if (type != "adr" && type != "al" && type != "aN")
	{
		type = "adr";
	}
	
	//prevents adding the same address to scratchpad if it exists
	if (type == "adr")
	{
		var e = VE_Scratchpad.entities;
		for(var i=0; i<e.length; i++)
		{
			if(e[i].name == name && e[i].type == 'aN')
			{
				if(!VE_Scratchpad.IsVisible())
					scratchPad.show();

				VE_Scratchpad._ShowPins();
				return;
			}
		}
	}
	
	var id = VE_Scratchpad.locationCounter++;
	
	var location = new VE_SearchResult(id, name, description, "", "", type, latitude, longitude, infoUrl, photoUrl, keywords);
	var pinId = VE_Scratchpad.AddResult(location);
	location.pinId = pinId;
	
	// Execute post events if any
	if (this.onAddLocation)
	{
		this.onAddLocation();
	}
	
	return pinId;
}



// Adds an array of entities to the scratch pad
VE_Scratchpad.AddResults=function(entities)
{
	var isSynchronizedInsert = false;
	
	if(!entities || entities.constructor != Array)
	{
		return;
	}
	
	var lengthItemsToAdd = Math.min(entities.length,VE_Scratchpad.maxScratchpadItems);
	var insertPositions = VE_Scratchpad.InferEntityPositions();
	
	if(insertPositions  && insertPositions != '' && insertPositions != "undefined" && insertPositions.length > 0 && insertPositions.length == lengthItemsToAdd)
	{
		isSynchronizedInsert = true;
	}
	
	for(var i=0; i<lengthItemsToAdd; i++)
	{
	
		var insertPos = null;
		
		// Make sure it's valid.
		if(!entities[i] || entities[i].constructor != VE_SearchResult)
		{
			continue;
		}
		
		if(isSynchronizedInsert)
		{
			insertPos = insertPositions[i];
		}
		
		// If it is an entity and the id hasn't been set, set it.
		if(entities[i].type == "adr" && entities[i].id == null)
		{
			entities[i].id = VE_Scratchpad.locationCounter++;
		}
		
		//Here we are adding search result...Not a annotation....
		VE_Scratchpad.AddResult(entities[i], entities[i].id, insertPos);
	}	
	
	//Reset the display orders as items have been inserted.
	if(VE_CollectionsManager.Collection instanceof VE_Collection)
	{
		//To get the push pins in order....
		VE_Scratchpad._HidePins();
	
		VE_CollectionsManager.Collection.ResetOrder();
	}
	
	//this gets the scratchPad in order.
	scratchPad.selectTitle(VE_CollectionsManager.unsavedCollectionIndex);
	
	// Execute post events if any
	if (this.onAddResults)
	{
		this.onAddResults();
	}
}


//DeSerialize the annotationlist from state / url and 
//infer the positions of the YP entities and return an array containing 
//the positions.
VE_Scratchpad.InferEntityPositions = function()
{
	var serializedPins = VE_Scratchpad.PrePopulationEntityIds;
	
	if(serializedPins && serializedPins != "undefined" && serializedPins != '' && serializedPins.length > 0)
	{
	
		// length decreases with splicing (ii used for elements that are not annotations and should not contribute to length)
		for ( var ii=0; ii < serializedPins.length ; ii++ )
		{
			// see if first unknown element is an annotation
			if( !VE_Annotations.SerializedRepIsAnno ( serializedPins[ii] )  )
			{
				serializedPins[ii] = ii;
			}
			else
				serializedPins[ii] = null;
		}
		
		// length decreases with splicing (ii used for elements that are not annotations and should not contribute to length)
		for ( var ii=0; 0 < serializedPins.length - ii; )
		{
			// see if first unknown element is an annotation
			if (typeof(serializedPins[ii]) == "number")
			{
				// not an annotation, subtract it from arySerializedPins.length
				ii++;
			}
			else
			{
				// cut the first annotation element out of the list
				serializedPins.splice ( ii + 0, 1 );
			}
		}
		
		if ( 0 < serializedPins.length )
		{
			return serializedPins;
		}
		else
		{
			return null;
		}
		
	}
}


// Generates the ID of the Pushpin for a Scratchpad entry.
VE_Scratchpad.GeneratePinId=function(entity)
{
	if (!entity)
	{
		return;
	}
	
	return "scratchpin_" + entity.id + "_" + entity.type;
}

// returns the color for a entity based on its type.
VE_Scratchpad.GetColorForEntity=function(entity)
{
	if (!entity)
	{
		return VE_Scratchpad.panelColor;
	}

	var color = VE_Scratchpad._typeToColor[entity.type];

	if (color == null)
	{
		color = VE_Scratchpad.panelColor;
	}
	
	return color;
}

// Add a single result to the scratchpad
// returns the id of the pin created
VE_Scratchpad.AddResult=function(entity, entityID, insertPos)
{
	
	if(!entity)
	{
		return;
	}

	var e = VE_Scratchpad.entities;
	
	for ( var ii=0; ii < e.length; ii++ )
	{
		if ( entity.Equals ( e[ii] ) )
		{
			return;
		}		
	}
	
	if(VE_CollectionsManager.collectionIndex == VE_CollectionsManager.unsavedCollectionIndex && VE_CollectionsManager.Collection instanceof VE_Collection)
	{
		if(VE_CollectionsManager.Collection.AnnotationCount() >= 10)
		{
			ShowMessage(VE_Annotations.ScratchPadFullMsg);
			return;
		}
	}
	else if(VE_CollectionsManager.Annotations && 
			VE_CollectionsManager.Annotations != 'undefined' && 
			VE_CollectionsManager.Annotations != '')
	{
		if(VE_CollectionsManager.Annotations.length >= VE_CollectionsManagerConstants.MAX_COLLECTION_SIZE)
		{
			ShowMessage ( L_CollectionManagerMaxLimitReached_Text );
			if(entity.latitude && entity.latitude != 'undefined' && entity.latitude != '' && entity.longitude && entity.longitude != 'undefined' && entity.longitude != '')
				map.PanToLatLong(parseFloat(entity.latitude),parseFloat(entity.longitude));
			return false;
		}
	}
	
	if (entity.type == 'adr')
		entity.type = 'aN';

	e.push(entity);
		
	var pinId = VE_Scratchpad.GeneratePinId(entity);
	
	var pin = null;
	
	if(VE_CollectionsManager.collectionIndex == VE_CollectionsManager.unsavedCollectionIndex || VE_CollectionsManager.collectionIndex == null)
	{
		if(VE_CollectionsManager.Collection)
			pin =  VE_Scratchpad._AddEntityPushpin(entity, VE_CollectionsManager.Collection.AnnotationCount() + 1);
		else 
			pin =  VE_Scratchpad._AddEntityPushpin(entity, 1);
	}
	else if(VE_CollectionsManager.collectionIndex != VE_CollectionsManager.unsavedCollectionIndex && VE_CollectionsManager.collectionIndex)
	{
		if(VE_CollectionsManager.Annotations)
			pin =  VE_Scratchpad._AddEntityPushpin(entity, VE_CollectionsManager.Annotations.length + 1 );
		else 
			pin =  VE_Scratchpad._AddEntityPushpin(entity, 1);
	}
		
	// sstchur:  New ScratchPad Code
	var collections = Microsoft.Web.VirtualEarth.Collections;			// shortcut
	var spGUID = pinId;	
	
	var itemType;
	if (entity.type == 'adr')
		itemType = collections.ScratchPadItemTypes.Address;
	else if (entity.type == 'aN')
		itemType = collections.ScratchPadItemTypes.Annotation;
	else  // default to BusinessListing (yp)
		itemType = collections.ScratchPadItemTypes.BusinessListing;

	var spItem = scratchPad.createItem(spGUID, itemType, entity.latitude, entity.longitude);


	var entityName = unescape(entity.name);
	var entityDesc = unescape(entity.description);

	if(entity.infoUrl != null && entity.infoUrl != "undefined")
		var entityInfo = unescape(entity.infoUrl);
	else
		var entityInfo = "";	
		
	if(entity.photoUrl != null && entity.photoUrl != "undefined")
		var entityPhoto = unescape(entity.photoUrl);
	else
		var entityPhoto = "";	
		
	if(entity.keywords != null && entity.keywords != "undefined")
		var entityKywrds = unescape(entity.keywords);
	else
		var entityKywrds = "";	
		
	//Fix Bug: 4760: Search pushpins show %20 characters in the ERO
	//we store the unescaped data in all data structures like annotation, scratchpad item etc.
	//but not for scractchpad entities. The following reassignment of entity properties fixes the issue.
		
	entity.name = entityName;
	entity.description = entityDesc;
	entity.infoUrl = entityInfo;
	entity.photoUrl = entityPhoto;
	entity.keywords = entityKywrds;			

	spItem.setTitle(entityName);
	spItem.setDescription(entityDesc.replace(/\n/g," "));	
	//shankak : added new fields for new spec.
	spItem.setKeywords(entityKywrds);
	spItem.setInfoUrl(entityInfo);
	spItem.setPhotoUrl(entityPhoto);
	if(entity.type != 'aN')
	{
		spItem.setBusinessListingId(entityID);
	}
	
	
	if(typeof(insertPos) == "number")
	{
		spItem.setDisplayOrder(insertPos);	
		scratchPad.insertItem(spItem,insertPos);	
	}
	else
	{
		spItem.setDisplayOrder(scratchPad.getItems().getCount());
		scratchPad.addItem(spItem);		
	}

	// New Code End	
	
	
	
	if (entity.type == 'aN')
	{
			var r = VE_Scratchpad.GetEntity(entity.id, entity.type);			
			VE_AnnotationData.StoreAnnotation(pinId, entity.latitude, entity.longitude, entityName, entityDesc);
			pin.onmouseover = VE_Annotations.OpenPopup;
			pin.onmouseout = VE_Annotations.ClosePopup;
	}
	else
	{
		pin.onmouseover = VE_SearchManager._ShowScratchpadPopup;
		pin.onmouseout = function() { ero.hide(); }
	}		

	VE_Scratchpad._ShowPins();
	VE_Scratchpad._UpdatePanel();	
	
	VE_Scratchpad.highWaterCount = Math.max(VE_Scratchpad.highWaterCount, e.length);
	
	return pinId;
}


// Appends the HTML that represents the passed in entity into the scratch pad panel
VE_Scratchpad._UpdatePanel=function()
{
	// Don't believe this function is being used anymore
	return;
	
	var e = VE_Scratchpad.entities;
	var p = VE_Scratchpad.panel;
	var html = "";

	// If entirely empty, set to the introductory text.	
	if (e.length == 0)
	{
		html = VE_Scratchpad._introText;
	}
	//build opening href tag used for pin and name links
	else
	{
		html += "<div>";
		html += "<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\">";	
		for(var i=0; i<e.length; i++)
		{
			//build opening href tag used for pin and name links
			var href = "<a onmouseover=\"javascript:VE_SearchManager._ShowScratchpadPopup(null, '" + e[i].id + "', '" + e[i].type + "');return true;\"";
			href += " onmouseout=\"window.status='';return true;\"";
			href += " href=\"javascript:map.PanToLatLong(" + e[i].latitude + "," + e[i].longitude + ");CloseOpenPopup(); if (!map.IsAnimationEnabled()) {VE_SearchManager._ShowScratchpadPopup(null, '" + e[i].id + "', '" + e[i].type + "');}\" oncontextmenu=\"return false;\">";
		
			html += "<tr><td width = \"35\" height = \"30\" valign=\"top\">" + href + "<div class=\"VE_Pushpin VE_Pushpin_" + VE_Scratchpad.GetColorForEntity(e[i]) + "\">" + (i + 1) + "</div></a></td>";
			html += "<td";
			
			if (e[i].type == "al")
			{
				html += " class=\"VE_Scratchpad_Autolocate\"";
			}
			html += " align=\"left\" valign=\"top\" class=\"VE_Scratchpad_ItemTextCell\">" + href + IOSec.EncodeHtml ( e[i].name ) + "</a>&nbsp;<br>";
			html += IOSec.EncodeHtml ( e[i].description ) + "</td><td width=\"15\" valign=\"top\" align=\"right\" class=\"VE_Scratchpad_ItemRemoveCell\"><a href=\"javascript:VE_Scratchpad.RemoveEntity('" + e[i].id + "')\" oncontextmenu=\"return false;\"><img border=\"0\" src=\"i/remove.gif\"></a></td></tr>";	
				
			var pin = document.getElementById("scratchpin_" + e[i].id + "_" + e[i].type);
			if(pin)
			{
				pin.innerHTML = (i + 1) + "";
			}
		}
		
		html += "</table>";
		html += "</div>";
	}	
	
	p.SetBody(html);
	VE_Scratchpad.Show();	
}

// Removes the entity that corresponds to the specified entity id from the scratch pad.
VE_Scratchpad.RemoveEntity=function(entityId, pinId)
{
	var e = VE_Scratchpad.entities;
	if (pinId == null && entityId == null)
	{
		return false;
	}
	
	// find the pushpin corresponding to an entityId
	// unfortunately, document.getElementById () does not work on entities
	//remove entity from scratchpad array
	var ii;
	for (ii = 0; e.length > ii; ii++)
	{
		if ( e[ii].id == entityId || entityId == null )
		{
			var spPinId = VE_Scratchpad.GeneratePinId( e[ ii ] );
			if(spPinId == pinId || pinId == null)
			{
				VE_Scratchpad._RemoveEntityPushpin(e[ii]);
				VE_AnnotationData.RemoveAnnotation (spPinId);
				e.splice(ii,1);
				break;
			}
		}
	}
	
	// Update the scratchpad panel
	VE_Scratchpad._UpdatePanel();
	
	// Close any open popups
	VE_Directions.ClosePopup ();
	VE_SearchManager.CloseSearchPopup();
	VE_Annotations.ClosePopup ();
	
	// Execute post events if any
	if (VE_Scratchpad.onRemoveEntity)
	{
		VE_Scratchpad.onRemoveEntity();
	}
}


// Gets an entity by id and type
VE_Scratchpad.GetEntity=function(id, type)
{
	var e = VE_Scratchpad.entities;
	if(!e || e.length == 0)
	{
		return null;
	}
	
	for(var i=0; i<e.length; i++)
	{
		if(e[i].id == id && e[i].type == type)
		{
			return e[i];
		}
	}
	
	return null;
}


// Gets an entity by id and type
VE_Scratchpad.UpdateEntityCoordinates = function(id, lat, lon)
{
	var e = VE_Scratchpad.entities;
	if(!e || e.length == 0)
	{
		return null;
	}
	
	for(var i=0; i<e.length; i++)
	{
		var entityId = id;
		try
		{
			var match = id.match(REGEX_PUSHPIN_ID);
			if (match)
			{
				entityId = match[2];
			}		
		}
		catch(ex){/*swallow*/}		
		
		
		if(e[i] != null && e[i].id == entityId)
		{
			e[i].latitude = lat;
			e[i].longitude = lon;
			break;
		}
	}
}


VE_Scratchpad.GetEntityFromPinId = function(pinId)
{
	var match = pinId.match(REGEX_PUSHPIN_ID);
	if (match)
	{
		var entityId = match[2];
		var entities = VE_Scratchpad.entities;
		var i;
		
		for (i = 0; i < entities.length; i++)
		{			
			if (entities[i] != null && entities[i].id == entityId)
			{
				return entities[i];
			} 
		}
	}
	
	// Entity not found
	return null;
}

// Shows all the pins on the scratchpad.  If a pin doesn't exist, create it
VE_Scratchpad._ShowPins=function()
{
	var e = VE_Scratchpad.entities;
	for (var i=0; i<e.length; i++)
	{
		if (e[i] && e[i].constructor == VE_SearchResult)
		{
			VE_Scratchpad._AddEntityPushpin(e[i], i+1);
		}
	}
}

// Hides all the pins on the scratchpad by removing them from the map.
VE_Scratchpad._HidePins=function()
{
	var e = VE_Scratchpad.entities;
	for (var i=0; i<e.length; i++)
	{
		if (e[i] && e[i].constructor == VE_SearchResult)
		{
			VE_Scratchpad._RemoveEntityPushpin(e[i]);
		}
	}
}

// Adds a pin for a scratchpad entity.  If the pin already exists, this is ignored.
VE_Scratchpad._AddEntityPushpin=function(e, number)
{	
	//var color = VE_Scratchpad.GetColorForEntity(e);	
	var className = 'VE_Pushpin VE_Pushpin_' + e.type;
	var pinId = VE_Scratchpad.GeneratePinId(e);
	var pinw = (e.type == "aN") ? 22 : 23; // different dimensions for annotations
	var pinh = 17;
	
	var pin = document.getElementById(pinId);
	if (pin)	
		return pin;
	else
	{
		pin = map.AddPushpin(pinId,																			// pushpinID
												e.latitude,                                 // latitude
												e.longitude,                                // longitude
												pinw,                                       // width
												pinh,                                       // height
												className,																	// className
												number + '',                                // innerHTML
												VE_Scratchpad.pinZIndex,					// zIndex, should be highest, except for when things are hovered over.
												Msn.VE.PushPinTypes.Annotation);		      		// pin type
	}
	
	return pin;
}

// Removes a scratchpad pin from the map
VE_Scratchpad._RemoveEntityPushpin=function(e)
{
	var pinId = VE_Scratchpad.GeneratePinId(e);
	map.RemovePushpin(pinId);
}

// Scratchpad toolbar markup
VE_Scratchpad._GetToolbar=function()
{
	var menu =
	'<ul id = "scratchPad_menu" class = "wll_dropDownMenu">' +
		'<li><a href = "javascript://Share">' + L_Share_Text + '</a>' +
			'<ul>' +
				(( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ShareScratchPadItems.SendIM ) )? '<li><a href = "">' + L_ShareSendIM_Text + '</a></li>' : '' ) +
				(( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ShareScratchPadItems.SendEmail ) )? '<li><a href = "javascript:void VE_Scratchpad.Email()">' + L_ShareEmail_Text + '</a></li>' : '' )  +
				(( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ShareScratchPadItems.CopyToClipboard ) ) ? '<li><a href = "javascript:void window.clipboardData.setData(\'Text\', state.GetPermalink())">' + L_ShareCopyToClipboard_Text + '</a></li>' : '') +
				(( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ShareScratchPadItems.AddBlogEntry ) ) ? '<li><a href = "javascript:void VE_Scratchpad.Blog()">' + L_ShareAddBlogEntry_Text + '</a></li>' : '' ) +
			'</ul>' +
		'</li>' +
		(( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.MapAllScratchPadItems ) )? '<li><a href = "javascript: void VE_Scratchpad.SetBestMapView()">' + L_MapAll_Text + '</a></li>' : '' ) +
		'<li><a href = "javascript: void VE_Scratchpad.Clear()">' + L_Delete_Text + '</a></li>' +
	'</ul>';
	
	return menu;
}


// Clears all Scratchpad items and pushpins
VE_Scratchpad.Clear=function()
{
	closeAllPopups();
	
	scratchPad.clear();
	
	//remove all entities from scratchpad array
	var e = VE_Scratchpad.entities;
	while(e.length)
	{
		VE_Scratchpad.RemoveEntity(e[0].id);	
	}
	
	VE_Scratchpad._UpdatePanel();
	VE_Analytics.Log("VE | Scratch Pad","Clear");

	VE_CollectionsManager.DeleteAllAnnotations(VE_CollectionsManager.collectionIndex,window.locale);	
}


// Email Scratchpad
VE_Scratchpad.Email=function(collectionId)
{
	var e = VE_Scratchpad.entities;

	//if the following condition is false an appropriate message
	//is shown to the user and the execution returns
	if(!VE_Scratchpad.CheckAccess(collectionId, e))
		return;			
	
	var body = "";
	var urlprefix = GetUrlPrefix() + "?v=" + state.GetCurrentUrlApiVersion() + "&";
	
	var first = true;

	var ids = VE_Scratchpad.ScratchpadSerializer(true);
	
	var primarySeparator = VE_SerializationConstants.primarySeparator[state.GetCurrentUrlApiVersion()];
	
	if(collectionId == VE_CollectionsManager.unsavedCollectionIndex)
	{
		if(!VE_CollectionsManager.Collection || VE_CollectionsManager.Collection == 'undefined')
			return;
			
		e = VE_CollectionsManager.Collection.Annotations;
			
		for(var i = 0; i < e.length; i++)
		{
			if(e[i] != null && e[i] != 'undefined' && e[i] instanceof VE_Annotation)
			{
				body += escape(e[i].Title + "\n" + e[i].Notes);
				if (i < e.length - 1)
				{
					body += escape("\n\n");
				}
			}
		}
	}
	
	var allids = escape( L_ScratchPadWindowsLiveLocal_Text.replace(/%1/g,Msn.VE.Features.ProductName) + "\n" + urlprefix + ids + "\n\n");	
	var url = 'mailto:?subject=' + escape(L_ScratchPadWindowsLiveLocal_Text.replace(/%1/g,Msn.VE.Features.ProductName)) + '&body=' + allids + body;
	url = IOSec.TruncateUrlSafe ( url, 2020, VE_Scratchpad._emailTruncationMsg );
	document.location.href = url;	
}

// Check Shareability
VE_Scratchpad.CheckAccess = function (collectionId, entityList)
{
	if(collectionId == VE_CollectionsManager.unsavedCollectionIndex || collectionId == null)
	{
		if(entityList == null || entityList.length == 0)
		{
			if(!VE_CollectionsManager.Collection || VE_CollectionsManager.Collection == 'undefined')
			{
				ShowMessage( L_ScratchPadEmptyScratchPad_Text );
				return false;
			}
			else if(VE_CollectionsManager.Collection.Annotations.length == 0)
			{
				ShowMessage( L_ScratchPadEmptyScratchPad_Text );
				return false;
			}
		}
		
		return true;
	}
	else
	{
		var cItem = VE_CollectionsManager.RetrieveByKey(collectionId);
		
		if(cItem)
		{
			if(cItem.IsPublic && VE_CollectionsManager.Annotations)
			{
				if(VE_CollectionsManager.Annotations.length == 0)
				{
					ShowMessage( L_ScratchPadEmptyScratchPad_Text );
					return false;
				}
			}
			else
			{
				ShowMessage (L_ScratchPadMakeCollectionAccessWarning_Text);
				return false;
			}
		}
		
		cItem = null;	
		
		return true;
	}
	return false;
}

//Copy to Clipboard
VE_Scratchpad.CopyToClipboard = function(collectionId)
{
	var e = VE_Scratchpad.entities;

	//if the following condition is false an appropriate message
	//is shown to the user and the execution returns
	if(!VE_Scratchpad.CheckAccess(collectionId, e))
		return;			
	
	var urlprefix = GetUrlPrefix() + "?v=" + state.GetCurrentUrlApiVersion() + "&";
	
	var first = true;

	var ids = VE_Scratchpad.ScratchpadSerializer(true);
	
	var primarySeparator = VE_SerializationConstants.primarySeparator[state.GetCurrentUrlApiVersion()];
	
	var allids = urlprefix + ids;	
	var url = IOSec.TruncateUrlSafe ( allids, 2020, VE_Scratchpad._emailTruncationMsg );
	
	//if the following condition is true then the appropriate permalink
	//is generated
	if(VE_Scratchpad.CheckAccess(collectionId, e))
		 window.clipboardData.setData('Text', url);
}

// Blog Scratchpad
VE_Scratchpad.Blog=function(collectionId)
{
	var e = VE_Scratchpad.entities;
	
	//if the following condition is false an appropriate message
	//is shown to the user and the execution returns
	if(!VE_Scratchpad.CheckAccess(collectionId, e))
		return;

	var blog = "http://spaces.msn.com/BlogIt.aspx?Title=" + L_ScratchPadWindowsLiveLocal_Text.replace(/%1/g,Msn.VE.Features.ProductName);	
	var primarySeparator = VE_SerializationConstants.primarySeparator[state.GetCurrentUrlApiVersion()];
	var ids = VE_Scratchpad.ScratchpadSerializer (true);
	var urlprefix = GetUrlPrefix() + "?v=" + state.GetCurrentUrlApiVersion() + "&";
	var description = "<a href=\"" + urlprefix + ids + "\">"+ L_ScratchPadWindowsLiveLocal_Text.replace(/%1/g,Msn.VE.Features.ProductName) +"</a><br /><br />";
	
	for(var i = 0; i < e.length; i++)
	{
		description += e[i].name + ( ( e[i].description ) ? "<br>" + e[i].description : "" );
		if (i < e.length - 1)
		{
			description += "<br /><br />";
		}
	}
	
	blog += "&description=" + escape ( description );
	blog = IOSec.TruncateUrlSafe ( blog, 2020, VE_Scratchpad._blogTruncationMsg );
	window.open(blog);	
}

//
// Returns a string representation of the scratchpad.
//
// see VE_ConfigItem.prototype.ToString () (overides)
// and VE_State.prototype._LoadStateDefault () for details
VE_Scratchpad.ScratchpadSerializer = function(isCallFromScratchPad)
{
	var returnString = "";

	//Only Store the scratchpad string in the serialized string if the scratchpad is visible.
	//This alleviates privacy concerns so if the user has the scratchpad hidden, 
	//permalinks will not include the scratchpad.
	if (VE_Scratchpad.IsVisible())
	{
		//If its the unsaved collection, serialize the scratchpad parameters on the URL
		if (VE_CollectionsManager.collectionIndex == VE_CollectionsManager.unsavedCollectionIndex)
		{
			if(!VE_CollectionsManager.Collection || VE_CollectionsManager.Collection == 'undefined')
				return;
			
			returnString = VE_State.ItemScratchpadIds + "=";
			var primarySeparator = VE_SerializationConstants.primarySeparator[currentUrlApiVersion];
			var isFirst = true;
			var strItems = "";
			var spItems =  VE_CollectionsManager.Collection.Annotations;//VE_Scratchpad.entities;
			
			//
			// move the annotations to the end of the url string for truncation
			if(spItems)
			{
				for (var ii = 0; ii < spItems.length; ii++)
				{
					if(spItems[ii] instanceof VE_Annotation)
					{
						var isAnno = ( parseInt(spItems[ii].BusinessListingId) == 0 || !spItems[ii].BusinessListingId );
						var item = VE_CollectionsManager.SerializeScratchPadItem(spItems[ii].Id,spItems[ii]);//spItems[ii].GetSerializedId ();
						item = IOSec.EncodeUrl ( item );
						//
						// bin the item as either an annotation or other pushpin
						if ( strItems.length > 0 )
						{
							strItems += primarySeparator;
						}
						strItems += item;
					}
				}
			}
			
			// now concatenate everything with annotations last
			returnString += strItems;
			
			if(	VE_CollectionsManager.Viewer instanceof VE_CollectionsViewer && !isCallFromScratchPad)
			{
				returnString += "&" + VE_CollectionsManager.Viewer.Serialize();
			}
		}
		else
		{
			if(	VE_CollectionsManager.Viewer instanceof VE_CollectionsViewer && !isCallFromScratchPad )
			{
				returnString = VE_CollectionsManager.Viewer.Serialize();
			}
			else 
			{
				var cItem = VE_CollectionsManager.RetrieveByKey(VE_CollectionsManager.collectionIndex);
				
				if(cItem instanceof VE_CollectionListItem)
				{
					if(cItem.IsPublic && VE_CollectionsManager.Annotations)
					{
						if(VE_CollectionsManager.Annotations.length > 0)
						{
							//If its a saved collection and has 1 or more annotations , just use the Collection ID on the URL
							returnString = VE_CollectionsManagerConstants.C_Id + "=" + VE_CollectionsManager.collectionIndex;	
						}
					}
				}
			}
		}
	}
	else
	{
		if(	VE_CollectionsManager.Viewer instanceof VE_CollectionsViewer && !isCallFromScratchPad)
		{
			returnString = VE_CollectionsManager.Viewer.Serialize();
		}
	}


	return returnString;
}

//VE_Scratchpad.IsVisible
//Returns true if the scratchpad is visible. Returns false otherwise.
VE_Scratchpad.IsVisible = function()
{
	return scratchPad.isVisible();
}