// 1. Loads the JS/WebSite.jsproj file and updates the FileVersion attribute for each SourceFile Node
// 2. Create locale.txt file with list of supported locales read from the web.config ( webSite/markets )
// 3. Update Setup\Deployment\setupWebsite.bat
// 4. Update Setup\BuildScripts\buildworker.bat


var strWebConfigFileName = "Web.config";
var strJsProjFileName = "JS/WebSite.jsproj";
var fso = new ActiveXObject("Scripting.FileSystemObject");

var xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
xmlDoc.async="false";
	
// Load web.config 
xmlDoc.load(strWebConfigFileName);


/***********************************************/
// 2. Create locale.txt file
/***********************************************/
// get reference to WebSite/markets/add nodes	
var locales = xmlDoc.selectNodes("//webSite/markets/add");
if (xmlDoc.parseError.errorCode != 0) 
{
	var myErr = xmlDoc.parseError;
	WScript.Echo("You have error " + myErr.reason);		
}
else
{
	if ( locales != null && locales.length > 0 )
	{
		//write to file				
		var localeFile = fso.CreateTextFile("locale.txt", true);			

		for ( var i = 0; i <locales.length; i++ )
		{				
			localeFile.WriteLine( locales[i].getAttribute("language").toLowerCase() + "-" + locales[i].getAttribute("locale").toLowerCase() );					
		}
		localeFile.Close();
	}
}

var Version = "";
// get reference to JSBuildVersion node	and get the Buildversion from web.config
var jsBuildversion = xmlDoc.selectSingleNode("//webSite/jsBuildVersion/add") ;
if (xmlDoc.parseError.errorCode != 0) 
{
var myErr = xmlDoc.parseError;
  WScript.Echo("You have error12 " + myErr.reason);		
}
else
{		
	if ( jsBuildversion != null )
		Version = jsBuildversion.getAttribute("value");
}		

/***********************************************/
// 1. Update WebSite.jsproj with Version #		
/***********************************************/
//Load Website.jsproj
xmlDoc.load(strJsProjFileName);
// get reference to SourceFile nodes
var sourceFiles = xmlDoc.selectNodes("//SourceFile") ;
if (xmlDoc.parseError.errorCode != 0) 
{
	var myErr = xmlDoc.parseError;
	WScript.Echo("You have error " + myErr.reason);		
}
else
{
	if ( sourceFiles != null )
	{		
		for ( var i= 0; i< sourceFiles.length ; i++ )
		{	
			// set the version argument to the FileVersion attribute for each SourceFile node.
			if ( sourceFiles[i].getAttribute("FileVersion") != null )
			{
				sourceFiles[i].setAttribute("FileVersion", Version ) ;						
			}					
		}				
				
		var fileWebSiteJSProj = fso.GetFile(strJsProjFileName);
		
		//mark WebSite.jsproj file's readonly attribute to false
		if (fileWebSiteJSProj.attributes & 1) 
      		fileWebSiteJSProj.attributes = fileWebSiteJSProj.attributes - 1;

		// commit the changes
		xmlDoc.save(strJsProjFileName)
		
		//mark WebSite.jsproj file's readonly attribute to true
		if ( !(fileWebSiteJSProj.attributes & 1) ) 
      		fileWebSiteJSProj.attributes = fileWebSiteJSProj.attributes + 1;
		
	}
}

/*******************************************************************/
//3. Update Setup\Deployment\setupWebsite.bat with Version#
/*******************************************************************/
UpdateBuildVersion( "..\\Setup\\Deployment\\SetupWebsite.bat" );

/*******************************************************************/
//4. Update Setup\BuildScripts\buildworker.bat with Version#
/*******************************************************************/
UpdateBuildVersion( "..\\Setup\\BuildScripts\\buildworker.bat" );    		


/***********************************************/
// Common function to update Version#
/***********************************************/
function UpdateBuildVersion( filename )
{
	// Open file to read content
	var file = fso.GetFile(filename);
	var stringContent = file.OpenAsTextStream(1).ReadAll();
	
	// get the string to replace
	var str = "set version#=\"";
	var ipos = stringContent.indexOf(str);
	var stringToReplace = eval("/" + stringContent.substring( ipos + str.length, stringContent.indexOf( "\"", ipos + str.length ) )+ "/g");
	
	// Update string with new Version#
	stringContent = stringContent.replace(stringToReplace, Version );
	
	//mark file's readonly attribute to false
	if ( file.attributes & 1) 
 		file.attributes = file.attributes - 1;
      		
	//Write updated content into file
	file.OpenAsTextStream(2).Write( stringContent )

	//mark SetupWebsite.bat file's readonly attribute to true
	if ( !(file.attributes & 1) ) 
		file.attributes = file.attributes + 1;	
}


	