//------------------------------------------------------------------------------
// Traffic/TrafficManager.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: a-jayab, cthota, a-pratin, keithkin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------
// Constructor for the Traffic manager.  Unused, but needed to declare traffic members.
function VE_TrafficManager()
{
	
}

// Represents whether the traffic manager is actively searching right now
//1-jayab-- handle searching for panning
VE_TrafficManager.searching = false;

// The array of Market objects
VE_TrafficManager.markets = new Array();

//Array of Incident Objects
VE_TrafficManager.incidents = new Array();

// The array that holds js file ids
VE_TrafficManager.incidentJSFiles = new Array();

// the z-index for incidents
VE_TrafficManager.zIndex = 31;

//Panel for displaying traffic information
VE_TrafficManager.panel = null;

//Turn on the feature
VE_TrafficManager.turnedOn = false;

//Track MapZoom level
VE_TrafficManager.prevZoomLevel = 0;

//Trac MapStyle 
VE_TrafficManager.prevMapStyle = "";

//Traffic manager view flag
VE_TrafficManager.isViewDirty = false;

VE_TrafficManager.showConstructionIncidents = false;

//Pushpin Z-Index
VE_TrafficManager.pinZIndex = VE_MapPushpin.baseZIndex;

//Variables to check whether incident or Tile layer information is available
VE_TrafficManager.incidentsAvailable = false;
VE_TrafficManager.flowAvailable = false;

VE_TrafficManager.loadingMarkets = false;
VE_TrafficManager.loadingIncidents = false;

VE_TrafficManager.incidentsRetrieved = null;

VE_TrafficManager.masterTimer = null;
VE_TrafficManager.slaveTimer = null;

VE_TrafficManager.showingMarkets = new Array();

// Execute a search to get all available markets
VE_TrafficManager.GetMarkets=function()
{			
	try
	{
		VE_TrafficManager.loadingMarkets = true;
		//Abort all requests if nothing is happening
		//Set abort timer for 30 seconds
		window.setTimeout(VE_TrafficManager.AbortTrafficRequests, 30000);				
		VENetwork.DownloadScript(map.GetMarketsFile(), "");		
	}
	catch(ex)
	{
	}
}

//Main Entry Point
// Execute a search to get traffic and incidents
//flag is set to true coming from the toolbar
VE_TrafficManager.GetTrafficInfo=function(flag)
{	
	if(flag != null && flag == true)
	{
		//User explicitly asked for traffic info
		VE_TrafficManager.turnedOn	= true;
	}	
	
	//If user has not asked for it, don't do anything
	if(!VE_TrafficManager.turnedOn)
	{
		return;
	}
		
	try
	{						
		var zoomLevel = map.GetZoomLevel();			
		
		//traffic turned on with BE View then show Traffic Panel with message.
		if(map.GetMapStyle() == Msn.VE.MapStyle.Oblique )
		{	
			VE_TrafficManager._UpdatePanel(true); 
			return;
		}
		else 
		{
			VE_TrafficManager.prevZoomLevel = zoomLevel;		
			VE_TrafficManager.prevMapStyle = map.GetMapStyle();
			VE_TrafficManager._GetShowIncidentStatus();
			VE_TrafficManager.CreatePanel(flag);
		}
				
		//If markets are not loaded yet, it does not make sense to continue;		
		if(VE_TrafficManager.loadingMarkets)
		{
			throw new VE_TrafficException("Loading Market files.");
		}
				
		if(flag)
		{
			toggleTaskArea(true);
		}
		
		//Initialize the flags
		VE_TrafficManager.incidentsAvailable = false;		
		VE_TrafficManager.flowAvailable = false;
		
		//Remove all existing traffic related pins on the map
		VE_TrafficManager._ClearPins();	
		
		//if Zoom level is more than 8 then get incidents
		if(zoomLevel >= 9)		
		{
			VE_TrafficManager._GetIncidents();
			if(VE_TrafficManager.flowAvailable && zoomLevel <= 15)
			{
				GetTraffic();	
			}
		}
		else
		{
			//just show markets
			VE_TrafficManager._RenderTrafficInfo();
		}
			
		//Finally renew auto refresh
		//IF this is an explicit user action
		if(flag)
		{
			VE_TrafficManager.RenewAutoRefresh();
		}
		
		//Remember traffic state is ON
		state.SetTraffic(1);
	}
	catch(ex)
	{
		if(VE_TrafficManager.panel != null)
		{
			VE_TrafficManager._UpdatePanel(true);
		}
		else
		{
			ShowMessage( L_TrafficManagerNotAllTrafficAvailable_Text.replace( /%1/g, '<a href="#" onclick="VE_Analytics.Log(\'VE | Traffic Pane\',\'Traffic manual refresh - Error\');VE_TrafficManager.GetTrafficInfo(true);">' ).replace( /%2/g, '</a>' )  );			
		}		
	}
	finally
	{
		//do nothing?
	}
}

// Get all incidents
//Get lat long to get the incidents
VE_TrafficManager._GetIncidents=function()
{	
	//Check the markets in which the bounding box belongs.	
	VE_TrafficManager.showingMarkets = VE_TrafficManager._GetIncidentMarkets();
	
	//if bounding box belongs to atleast 1 market.
	if(VE_TrafficManager.showingMarkets.length > 0 )
	{		
		VE_TrafficManager.incidentsAvailable = true;		
		for(var m = 0; m < VE_TrafficManager.showingMarkets.length; m++)
		{						
			try
			{
				//Get the incidents for every market that the bounding box falls in.
				if(!VE_TrafficManager.loadingIncidents)
				{					
					VE_TrafficManager.loadingIncidents = true;
					//Abort all requests if nothing is happening
					//Set abort timer for 30 seconds
					window.setTimeout(VE_TrafficManager.AbortTrafficRequests, 30000);
				}
				
				var scriptid = VENetwork.DownloadScript(map.GetIncidentsFile() + "-" + VE_TrafficManager.showingMarkets[m] + ".js", null);
				VE_TrafficManager.incidentJSFiles.push(scriptid);								
			}
			catch(ex)
			{
			}
		}			
	} 
	else
	{		
		VE_TrafficManager._UpdatePanel();
	}			
}
//Store the available markets returned by traffic server.
VE_TrafficManager._ProcessMarkets=function(marketArray)
{
	VE_TrafficManager.loadingMarkets = false;
	if(VE_TrafficManager.markets[0] == null)
		VE_TrafficManager.markets[0] = new Array();
		
	if(marketArray != null && marketArray.length > 0)		
	{
		var len = marketArray.length;
		for(var i=0;i<len;i++)
		{
			if(marketArray[i] != null)
				VE_TrafficManager.markets[0].push(marketArray[i]);	
		}
	}
}

//Store the incidents returned by traffic servers
VE_TrafficManager._ProcessIncidents=function(incidentArray)
{
	
	VE_TrafficManager.loadingIncidents = false;
	
	if(incidentArray == null || incidentArray.length <= 0)
		return;
		
	var market = incidentArray[0].MarketId;
		
	if(VE_TrafficManager.incidents[market] == null)
		VE_TrafficManager.incidents[market] = new Array();
	else
	{
		VE_TrafficManager._ClearPins(false, market);							
		var len = VE_TrafficManager.incidents[market].length;
		for(var i=0;i<len;i++)
		{
			VE_TrafficManager.incidents[market].pop();			
		}
	}
	
		
	if(incidentArray != null && incidentArray.length > 0)
	{		
		var len = incidentArray.length;
		for(var i=0;i<len;i++)
		{
			if(incidentArray[i] != null)
			{
				VE_TrafficManager.incidents[market].push(incidentArray[i]);
			}
		}
	}
	
	
	VE_TrafficManager._DisplayIncidents();	
	window.setTimeout(VE_TrafficManager._RemoveScripts, 30000);	
}

//Combining all incidents returned from multiple markets
VE_TrafficManager._DisplayIncidents = function()
{			
	if(VE_TrafficManager.showingMarkets != null && VE_TrafficManager.showingMarkets.length > 0)
	{
		var len = VE_TrafficManager.showingMarkets.length;
		
		for(var i=0;i<len;i++)
		{
			var market = VE_TrafficManager.showingMarkets[i];
			if(VE_TrafficManager.incidents[market] != null && VE_TrafficManager.incidents[market].length > 0)
			{			
				VE_TrafficManager._RemoveDuplicates(market);
				VE_TrafficManager._RenderTrafficInfo(market);			
			}
		}
	}
}


//Check the market in which the current bounding box falls
VE_TrafficManager._GetIncidentMarkets = function()
{		
	
	var topLeft = map.PixelToLatLong(new Msn.VE.Pixel(0, 0));
	var bottomRight = map.PixelToLatLong(new Msn.VE.Pixel(windowWidth, windowHeight));

	if (topLeft == null || bottomRight == null)
		return;

	var b = topLeft.latitude;
	var c = bottomRight.longitude;
	var d = bottomRight.latitude;
	var e = topLeft.longitude;
	
	// Swap latitudes if they are in the wrong order.
	if (b < d)
	{
		var t = b;
		b = d;
		b = t;
	}
	
	// Swap longitudes if they are in the wrong order.
	if (c < e)
	{
		var t = c;
		c = e;
		e = t;
	}	

	var marketIds = new Array();
	if(VE_TrafficManager.markets.length == 0)
		return marketIds;
	var screenBoundingBox = new Msn.VE.LatLongRectangle(new Msn.VE.LatLong(b,e), new Msn.VE.LatLong(d,c));
	var len = VE_TrafficManager.markets[0].length;
	for(var i = 0; i<len; i++)
	{
		var marketBoundingBox = new Msn.VE.LatLongRectangle(new Msn.VE.LatLong(VE_TrafficManager.markets[0][i].NELatitude, VE_TrafficManager.markets[0][i].SWLongitude), new Msn.VE.LatLong(VE_TrafficManager.markets[0][i].SWLatitude,VE_TrafficManager.markets[0][i].NELongitude)); 
		
		if( VE_TrafficManager._isBBOverlap(screenBoundingBox, marketBoundingBox))
		{
			if(VE_TrafficManager.markets[0][i].Incident == "Incidents")
			{				
				marketIds.push(VE_TrafficManager.markets[0][i].Id);
			}			
			if(VE_TrafficManager.markets[0][i].Flow == "Flow")
			{
				VE_TrafficManager.flowAvailable	= true;		
			}
		}					
	}
	return marketIds;	
}
//Check if Bounding boxes overlap
VE_TrafficManager._isBBOverlap = function(screenBoundingBox, marketBoundingBox)
{
	return (VE_TrafficManager._IsRectInBoundingBox(screenBoundingBox, marketBoundingBox) || VE_TrafficManager._IsRectInBoundingBox(marketBoundingBox, screenBoundingBox ))
}

//Logic to check if both bounding boxes overlap.
VE_TrafficManager._IsRectInBoundingBox = function(Rectangle1, Rectangle2)
{
	return !( (Rectangle1.southeast.latitude > Rectangle2.northwest.latitude) ||
			  (Rectangle1.southeast.longitude < Rectangle2.northwest.longitude) ||
		      (Rectangle1.northwest.latitude < Rectangle2.southeast.latitude) ||
	          (Rectangle1.northwest.longitude > Rectangle2.southeast.longitude) );
}

////Logic to check if both bounding boxes overlap.
VE_TrafficManager._IsLatLongInRect = function(RectLatLong, RectangleBB)
{
	return ( RectLatLong.latitude <= RectangleBB.northwest.latitude && 
			RectLatLong.latitude >= RectangleBB.southeast.latitude  &&
			RectLatLong.longitude >= RectangleBB.northwest.longitude &&
			RectLatLong.longitude <= RectangleBB.southeast.longitude ); 
}

// Creates pushpins for the displayed results
VE_TrafficManager._RenderTrafficInfo=function(market)
{	
	//Remove any existing pins
	if(market)
		VE_TrafficManager._ClearPins(false, market);
	else
		VE_TrafficManager._ClearPins();		
	ero.hide();	
	var zoomLevel = map.GetZoomLevel();
	//if zoom is greater than 8 then display all incidents as they appear.
	if( zoomLevel > 8 )
	{		
		//Show incidents for all showing markets
		
		if(market == null)
			return;	
		
		if(VE_TrafficManager.incidents[market] != null)
		{
			var r = VE_TrafficManager.incidents[market];	
			var len = VE_TrafficManager.incidents[market].length;
								
			for(var i=0; i<len; i++)
			{
				//Filter weather for now
				//Filter Mass Transit for now 
				if(r[i].Type != VE_TrafficIncidentType.Weather &&
				r[i].Type != VE_TrafficIncidentType.MassTransit)						
				{			
					if(!VE_TrafficManager.showConstructionIncidents)
					{
						if(r[i].Type == VE_TrafficIncidentType.UnscheduledConstruction ||
		  				r[i].Type == VE_TrafficIncidentType.ScheduledConstruction)
						{
								continue;
						}
					}
					
					//Filter out congestion issues from the traffic overlay when flow is not available
					if( VE_TrafficManager.flowAvailable && 
						r[i].Type == VE_TrafficIncidentType.Congestion)
					{						
						continue;
					}
				
					r[i].pushPin = map.AddPushpin("pin_traffic_incident_" + market + "_" +  r[i].Id,  // pushpinID
															r[i].Latitude,                            // latitude
															r[i].Longitude,                           // longitude
															23,                                       // width
															17,                                       // height
															"VE_Pushpin VE_Traffic_"+VE_TrafficManager.GetColor(r[i].Criticality),	// className
															'',           // innerHTML 
															VE_TrafficManager.GetZIndex(r[i].Criticality),			// z-index
															Msn.VE.PushPinTypes.TrafficOthers
															);
																											
					r[i].pushPin.onmouseover = VE_TrafficManager._ShowTrafficIncidentPopup;
					r[i].pushPin.onmouseout = VE_TrafficManager.CloseTrafficPopup; 
				}
			}
		}				
	}
	else
	{	
		//if zoom < 8 then just put a traffic icon at the centre . Do not display all incidents.	
		if(VE_TrafficManager.markets != null && VE_TrafficManager.markets.length > 0 && VE_TrafficManager.markets[0] != null)
		{
			var len = VE_TrafficManager.markets[0].length;
			for(var i=0;i<len;i++)
			{				
				if(VE_TrafficManager.markets[0][i] == null)
					continue;
					
				try
				{
					var lat =  parseFloat(VE_TrafficManager.markets[0][i].SWLatitude) + parseFloat(VE_TrafficManager.markets[0][i].NELatitude);
					var lon =  parseFloat(VE_TrafficManager.markets[0][i].SWLongitude) + parseFloat(VE_TrafficManager.markets[0][i].NELongitude);			
								
					VE_TrafficManager.markets[0][i].pushPin = map.AddPushpin("pin_traffic_market_" + VE_TrafficManager.markets[0][i].Id,
												lat/2,
												lon/2,  
												23,
												17,
												"VE_Pushpin VE_Traffic_zoom",
												'',
												VE_TrafficManager.pinZIndex,
												Msn.VE.PushPinTypes.TrafficOthers
												);		
												
					VE_TrafficManager.markets[0][i].pushPin.onmouseover = VE_TrafficManager._ShowTrafficMarketPopup;
					VE_TrafficManager.markets[0][i].pushPin.onmouseout = VE_TrafficManager.CloseTrafficPopup;
				}
				catch(ex)
				{
					//ShowMessage(ex.message);
				}
			}
		}		
	}
	
	VE_TrafficManager._UpdatePanel();
}

//Remove duplicates if same incident is returned in multiple markets
VE_TrafficManager._RemoveDuplicates = function(market)
{
	if(market == null || market == "undefined")
		return;
				
	var r = VE_TrafficManager.incidents[market];	
	
	if(r == null)
		return;
	
	for(var i=0; i<r.length; i++)
	{
		for(var j=i+1; j<r.length; j++)
		{
			if(r[i].Id == r[j].Id)
			{
				r.splice(i,1);
			}				
		}
	}	
}


//Maps the incident color to criticality
VE_TrafficManager.GetZIndex =function(criticality)
{	
	switch(criticality)
	{	
		case 0:
			return VE_TrafficManager.pinZIndex+3;
			break;
		case 1:
			return VE_TrafficManager.pinZIndex+2;
			break;
		case 2:			
			return VE_TrafficManager.pinZIndex+1;
			break;
		default:
			return VE_TrafficManager.pinZIndex;
	}
}


//Maps the incident color to criticality
VE_TrafficManager.GetColor =function(criticality)
{	
	switch(criticality)
	{	
		case 0:
			return Msn.VE.UI.Color.Red;
			break;
		case 1:
			return Msn.VE.UI.Color.Orange;
			break;
		case 2:			
			return Msn.VE.UI.Color.Yellow;
			break;
		default:
			return Msn.VE.UI.Color.Yellow;
	}
}

//Returns an incident object for the specified id
VE_TrafficManager.GetEntity = function(id)
{
	if(id == "" || id == null)
		return null;

	var index = "";		
	var cache = null;

	if(id.indexOf("pin_traffic_incident_") > -1)
	{	
	
		index = id.replace("pin_traffic_incident_", "");
		//index of the actual id
		var incidentidindex = index.indexOf("_");		
		var incidentId = index.substring(incidentidindex+1);				
		var marketId = index.substring(0, incidentidindex);
		cache = VE_TrafficManager.incidents[marketId];	
		index = incidentId;
	}
	else if(id.indexOf("pin_traffic_market_") > -1)
	{
		index = id.replace("pin_traffic_market_", "");		
		cache = VE_TrafficManager.markets[0];			
	}
	else
	{
		return id;
	}
						
	if(cache == null || cache.length<= 0)
	{
		return null;
	}
	
	var len = cache.length;
	for(var i=0; i<len; i++)
	{		
		if(cache[i].Id == index)
		{
			return cache[i];
		}
	}	
	return null;
}
//function to create the traffic legend-panel.
//flag indicates user explicit call so you MUST
//show the panel in task area
VE_TrafficManager.CreatePanel = function(flag)
{		
	if(VE_TrafficManager.panel == null)
	{				
		//Set Body
		var panelcontent = '<div class= "VE_Traffic_Panel">';		
		panelcontent += '<div id="VE_Traffic_Legend_Header"><div class="infoBar infoBar-loading"><P>' + L_TrafficManagerGettingTraffic_Text + '</P></div></div>';
		panelcontent += '</div>';
			
		VE_TrafficManager.panel = new VE_Panel("traffic",     // id - need not be localized
								8,                          // x
								0,	                        // y
								'auto',                     // width
								'auto',                     // height
								'traffic',            // type
								VE_TrafficManager.zIndex,						// z index
								L_Traffic_Text,											// title
								panelcontent ,      // body
								'',													// footer
								true,												// show mouseover for title bar 			
								true,												// bOpaque
								taskArea_data);											// parent
								
																						
		VE_TrafficManager.panel.title.className +=  ' VE_Panel_title_traffic';
			
		VE_TrafficManager.panel.SetToolbarSize(0);
		VE_TrafficManager.panel.SetFooterSize(12);	
						
		//VE_TrafficManager.panel.index = 0;//this.index;
		VE_TrafficManager.panel.foot.style.overflow = "auto";
		
		// sstchur:  Add this panel to the TaskArea; bring it to the front
		taskArea.addItem(VE_TrafficManager.panel);		
		
		//Add Traffic provider text in TrafficPanel Footer
		VE_TrafficManager.panel.SetFooter(VE_TrafficManager._GetPanelFooter());
		
		// Make IE obey the pseudo class :hover for any search's TitleBar
		pseudoHover(VE_TrafficManager.panel.title);
			
		VE_TrafficManager.panel.onTitleClick = function(e)
		{		
			var p = e.srcPanel;
			taskArea.setCurrent(p);
		}
		VE_TrafficManager.panel.onCloseClick = function(e)
		{	
			VE_TrafficManager.ClearTraffic();						
		}	
		
		VE_TrafficManager.panel.onMaximize = function(e)
		{
			resetWhatBox();
		}
	}
	
	//Show stuff only when ta is expanded and the feature is turned on
	if(VE_TrafficManager.turnedOn)
	{
		/* Note:	flag is true only when Traffic is invoked form the MapActionBar, in which case a traffic panel
							will have been maximized (or created and maximized).  Either way, traffic panel must be the current
							panel if flag is true.
		*/	
		if (flag == true)
		{	
			//now show the panel
			VE_TrafficManager.panel.Show();
			VE_TrafficManager.panel.Maximize();
			taskArea.setCurrent(VE_TrafficManager.panel);	
			toggleTaskArea(true);			
		}
	}
}

VE_TrafficManager.AbortTrafficRequests = function()
{
	if(VE_TrafficManager.loadingIncidents ||
		VE_TrafficManager.loadingMarkets)
	{
		VE_TrafficManager.loadingIncidents = false;
		VE_TrafficManager.loadingMarkets = false;
		if(VE_TrafficManager.panel != null)
		{
			VE_TrafficManager._UpdatePanel(true);
		}
		else
		{
			//ShowMessage("Not all traffic information is available. <a href='#' onclick='VE_TrafficManager.GetTrafficInfo(true)'>Try again</a>.");
		}	
	}
}

//Function to clear traffic when Legend closed
VE_TrafficManager.ClearTraffic=function(keepPanelAlive)
{		
	VE_TrafficManager._ClearPins();	
	if(map != null)
		map.RemoveTrafficLayer();		
	VE_TrafficManager.turnedOn = false;
	VE_TrafficManager.CloseTrafficPopup();	
	//Check if panel exist
	if( VE_TrafficManager.panel != null && (!keepPanelAlive))
	{
		taskArea.removeItem(VE_TrafficManager.panel);	
		VE_TrafficManager.panel.Destroy();
		VE_TrafficManager.panel = null;	
	}
	VE_TrafficManager.ExpireAutoRefresh();
	
	//Remember traffic state is OFF
	state.SetTraffic(0);
}

//Destroy
VE_TrafficManager.Destroy=function()
{		
	VE_TrafficManager.ClearTraffic();
	VE_TrafficManager.incidentsAvailable = false;
	VE_TrafficManager.flowAvailable = false;
	
	//Remove incident array
	if(VE_TrafficManager.incidents != null)
	{
		var len = VE_TrafficManager.incidents.length;
		for(var i=0;i<len;i++)
		{
			var incident = VE_TrafficManager.incidents[i].pop();
			if(incident == null)
				continue;
			for(var j=0;j<incident.length;j++)
			{
				var incidentinstance = incident.pop();
				incidentinstance = null;
			}
			incident = null;
		}
		VE_TrafficManager.incidents[i] = null;
	}		
	
	//Remove market array
	if(VE_TrafficManager.markets != null && 
		VE_TrafficManager.markets[0] != null &&
		VE_TrafficManager.markets[0].length > 0)
	{
		var len = VE_TrafficManager.markets[0].length;
		for(var i=0;i<len;i++)
		{
			var market = VE_TrafficManager.markets[0].pop();
			market = null;
		}
		VE_TrafficManager.markets[0] = null;
	}
	
	//Remember traffic state is OFF
	state.SetTraffic(0);			
}


VE_TrafficManager._RemoveScripts = function()
{
	//Remove all scripts that are attached
	if(VE_TrafficManager.incidentJSFiles != null &&
		VE_TrafficManager.incidentJSFiles.length > 0)
	{
		var at = VENetwork.GetAttachTarget();
		var len = VE_TrafficManager.incidentJSFiles.length;
		for(var i=0;i<len;i++)
		{
			var id = VE_TrafficManager.incidentJSFiles.pop();
			var script = null;
			try			
			{
				if(at != null)
				{
					script = document.getElementById(id);
					if(script != null)
						at.removeChild(script);
				}
			}
			catch(ex)
			{
			}
		}		
	}
}

VE_TrafficManager._GetShowIncidentStatus = function()
{
	var flag = false;
	var check = document.getElementById("ve_traffic_constr_incidentfilter_check");
	if(check != null)
	{
		flag = check.checked;
	}
	if(flag)
	{
		VE_TrafficManager.showConstructionIncidents = true;
	}
	else
	{
		VE_TrafficManager.showConstructionIncidents = false;
	}
	
	return VE_TrafficManager.showConstructionIncidents;
}

VE_TrafficManager._ToggleIncidentPushpins=function(type)
{		
	VE_TrafficManager._GetShowIncidentStatus();
	
	if(VE_TrafficManager.showingMarkets != null)
	{
		var len = VE_TrafficManager.showingMarkets.length;		
		for(var i=0;i<len;i++)
		{
			var market = VE_TrafficManager.showingMarkets[i];
			VE_TrafficManager._RenderTrafficInfo(market);	
		}
	}
}

// Clears all the active pushpins off of the map
VE_TrafficManager._ClearPins=function(onlyMarket, marketId)
{	
	if(VE_TrafficManager.markets == null ||
		VE_TrafficManager.markets.length <= 0)
	{
		return;
	}
	
	var m = VE_TrafficManager.markets[0];
	if(m != null && m.length > 0)
	{		
		for(var i=0; i<m.length; i++)
		{
			if(m[i].pushPin)
			{
				map.RemovePushpin(m[i].pushPin.id);
				m[i].pushPin = null;
			}
		}		
	}

	if(onlyMarket == true)
	{
		return;
	}
	
	if(VE_TrafficManager.incidents == null ||
		VE_TrafficManager.incidents.length <= 0)
		return;

	if(marketId)
	{
		//Remove only market specific
		var r = VE_TrafficManager.incidents[marketId];		
		if(r == null)
			return;
		//clear pushpins created for zoom > 8
		for(var i=0; i<r.length; i++)
		{
			if(r[i].pushPin)
			{
				map.RemovePushpin(r[i].pushPin.id);
				r[i].pushPin = null;
			}
		}	
	}
	else
	{	
		for(var j=0; j<VE_TrafficManager.markets[0].length; j++)
		{		
			var mkt = VE_TrafficManager.markets[0][j].Id;
						
			var r = VE_TrafficManager.incidents[mkt];		
			if(r == null)
				continue;
										
			//clear pushpins created for zoom > 8
			for(var i=0; i<r.length; i++)
			{
				if(r[i].pushPin)
				{	
					map.RemovePushpin(r[i].pushPin.id);
					r[i].pushPin = null;
				}
			}	
			
			r = null;
		}
	}
}

VE_TrafficManager._ViewChangeNotification=function()
{

	//Disable in Oblique
	if(map.GetMapStyle() == Msn.VE.MapStyle.Oblique )
	{
		VE_TrafficManager._ObliqueModeNotification();
		return;
	}
	
	if(!VE_TrafficManager.turnedOn)
		return;	
		
	var zoomLevel = map.GetZoomLevel();
		
	if(VE_TrafficManager.prevZoomLevel <= 8 && zoomLevel > 8)
	{
			VE_TrafficManager.isViewDirty = true;					
	}
	else if(VE_TrafficManager.prevZoomLevel > 8 && zoomLevel <= 8)
	{
			VE_TrafficManager.isViewDirty = true;			
	}
	else if(VE_TrafficManager.prevMapStyle == Msn.VE.MapStyle.Oblique)
	{
			VE_TrafficManager.isViewDirty = true;			
	}	
	else
	{
		//TODO: See if this really means dirty for us (bounding box for market etc)
		var visibleMarkets = VE_TrafficManager._GetIncidentMarkets();
		
		//See if the view is dirty	
		if(visibleMarkets != null && visibleMarkets.length > 0)
		{
			for(var i=0;i<visibleMarkets.length;i++)
			{
				var present = false;
				for(var j=0; j<VE_TrafficManager.showingMarkets.length;j++)
				{
					if(visibleMarkets[i] == VE_TrafficManager.showingMarkets[j])
					{
						present = true;
						break;
					}				
				}
				if(!present)
				{				
					VE_TrafficManager.isViewDirty = true;
					break;
				}
				else
				{
					VE_TrafficManager.isViewDirty = false;
				}
			}
		}
		else
		{	
			VE_TrafficManager.isViewDirty = true;
		}
	}	
	
	VE_TrafficManager.prevZoomLevel = zoomLevel;
	VE_TrafficManager.prevMapStyle = map.GetMapStyle();	
		
	if(VE_TrafficManager.isViewDirty)
	{
		window.setTimeout('VE_TrafficManager.GetTrafficInfo(false)', 1);
	}
	else
	{
		//Just update status		
		VE_TrafficManager._UpdatePanel();

	}
	//Renew Auto Refresh
	VE_TrafficManager.RenewAutoRefresh();
}

VE_TrafficManager._ObliqueModeNotification=function()
{	
	if(!VE_TrafficManager.turnedOn)
		return;

	//Keep the panel
	VE_TrafficManager.ClearTraffic(true);
	VE_TrafficManager._UpdatePanel(true);	
	//Set it back to true since I was here.
	VE_TrafficManager.turnedOn = true;
	//Set Prev
	VE_TrafficManager.prevMapStyle = map.GetMapStyle();		
}

//called when incident.js file is retrieved.
VE_SearchManager.onSearchComplete = function()
{	
}

//Traffic Exception type
VE_TrafficException = function(message)
{
	this.message = message;
}

//Auto Refresh implementation
VE_TrafficManager.ExpireAutoRefresh = function(showWarning)
{	
	if(VE_TrafficManager.masterTimer != null)
	{
		window.clearInterval(VE_TrafficManager.masterTimer);		
	}	
	if(VE_TrafficManager.slaveTimer != null)
	{
		window.clearInterval(VE_TrafficManager.slaveTimer);				
	}
	
	//Indicate users that they are looking at old data after 30 min
	if(showWarning)
	{
		//Set isError to true
		VE_TrafficManager._UpdatePanel(true);
	}
}
VE_TrafficManager.RenewAutoRefresh = function()
{
	if(!VE_TrafficManager.turnedOn)
		return;	

	VE_TrafficManager.ExpireAutoRefresh();
	//Expire in 30 minutes - 
	VE_TrafficManager.masterTimer = window.setInterval("VE_TrafficManager.ExpireAutoRefresh(true)", map.GetSlidingExpirationForAutoRefresh());
	//Refresh every five minutes - 
	VE_TrafficManager.slaveTimer = window.setInterval(VE_TrafficManager.AutoRefresh, map.GetAutoRefreshRate());
}

VE_TrafficManager.AutoRefresh = function()
{
	try
	{
		//get zoom level
		var zoom = map.GetZoomLevel();
		if(zoom >=9)
		{
			VE_Analytics.Log("VE | Traffic Pane","Traffic automatic refresh");			
			VE_TrafficManager.GetTrafficInfo();
		}
	}
	catch(ex)
	{
	}
}

//Panel update content code
// Updates the contents of the panel
VE_TrafficManager._UpdatePanel=function(isError)
{	

	if(VE_TrafficManager.panel == null)
	{
		VE_TrafficManager.CreatePanel();
	}

	var panelcontent;
	var zoomLevel = map.GetZoomLevel();
	
		//Set toolbar for refresh
	if(zoomLevel <= 8)
		VE_TrafficManager.panel.SetToolbarSize(0);
	else
	{
		if(VE_TrafficManager.incidentsAvailable || VE_TrafficManager.flowAvailable)	
		{
			VE_TrafficManager.panel.SetToolbarSize(30);					
			
			if( ! document.getElementById('traffictoolbar') )
			{
				var toolbarhtml = '<div id="traffictoolbar"><ul class="wll_dropDownMenu"><li onclick="VE_Analytics.Log(\'VE | Traffic Pane\',\'Traffic manual refresh - Update\');VE_TrafficManager.GetTrafficInfo(true)">' + L_TrafficManagerUpdateTraffic_Text + '</li></ul></div>';				

				VE_TrafficManager.panel.SetToolbar(toolbarhtml);
				
				var toolbarDiv = document.getElementById('traffictoolbar');
				if(toolbarDiv)
					pseudoHoverForChildren(toolbarDiv);
			}
		}
		else
		{
			VE_TrafficManager.panel.SetToolbarSize(0);			
		}
	}		
	
	panelcontent = '<div class= "VE_Traffic_Panel">';
	
	if(isError)
	{
		if( map.GetMapStyle() == Msn.VE.MapStyle.Oblique )
			panelcontent += '<div id="VE_Traffic_Legend_Header"><div class="infoBar infoBar-general"><P>' + L_TrafficManagerNotAvailableInBEView_Text + '</P></div></div>';							
		else	
			panelcontent += '<div id="VE_Traffic_Legend_Header"><div class="infoBar infoBar-warning"><P>' + L_TrafficManagerNotAllTrafficAvailable_Text.replace( /%1/g, '<a href="#" onclick="VE_Analytics.Log(\'VE | Traffic Pane\',\'Traffic manual refresh - Error\');VE_TrafficManager.GetTrafficInfo()">' ).replace( /%2/g, '</a>' ) + '</P></div></div>';	
	}
	else if(!VE_TrafficManager.flowAvailable && !VE_TrafficManager.incidentsAvailable)
	{
		if(zoomLevel <= 8)
		{					
			panelcontent += '<div class="VE_Traffic_PanelText">' + L_TrafficManagerForTrafficZoomTo_Text + '</div>';
		}
		else
		{	
			panelcontent += '<div id="VE_Traffic_Legend_Header"><div class="infoBar infoBar-general"><P>' + L_TrafficManagerForTrafficZoomTo_Text + '</P></div></div>';		
		}
	}
	else
	{
		if(zoomLevel <= 8)
		{
			panelcontent += '<div class="VE_Traffic_PanelText">' + L_TrafficManagerForTrafficZoomTo_Text.replace( /%1/g, '<img src="i/Traffic/TrafficZoom.gif">' ) + '</div>';
		}
		else
		{
			panelcontent += VE_TrafficManager._GetIncidentLegend(VE_TrafficManager.incidentsAvailable, zoomLevel);
			panelcontent += VE_TrafficManager._GetSpeedLegend(VE_TrafficManager.flowAvailable, zoomLevel);	
		}
		panelcontent += VE_TrafficManager._GetLegendFooter(zoomLevel);						
	}	
	panelcontent += '</div>';
	
	VE_TrafficManager.panel.SetBody(panelcontent);		
}	

VE_TrafficManager._GetIncidentLegend=function(incidentsAvailable, zoomLevel)
{		
	var content = "";	
	content = '<div class="VE_Traffic_Incident_Divider" >' + L_TrafficManagerIncidents_Text;
	if(incidentsAvailable)
	{
		if(zoomLevel >= 9)
		{	
			content += '<div class="VE_Traffic_Incident_Major">' + L_TrafficManagerSerious_Text + ' </div>' +
						'<div class="VE_Traffic_Incident_Moderate">' + L_TrafficManagerModerate_Text + ' </div>' +
						'<div class="VE_Traffic_Incident_Minor">' + L_TrafficManagerMinor_Text + ' </div>';
		}
		else
		{
			panelcontent += '<div class="VE_Traffic_PanelText">' + L_TrafficManagerForTrafficZoomTo_Text.replace ( /%1/g, '<img src="i/Traffic/TrafficZoom.gif">' ) + '</div>';
		}
	}
	else
	{	
		content += '<div class="VE_Traffic_PanelText">' + L_TrafficManagerIncidentNotAvailable_Text + '</div> ';	
	}
	
	content += '</div>';
	return content;	
}

VE_TrafficManager._GetSpeedLegend=function(flowAvailable, zoomLevel)
{		
	var content = "";
	content = 	'<div class="VE_Traffic_Speed_Divider">' + L_TrafficManagerSpeed_Text;	
	if(flowAvailable)
	{
		if(zoomLevel >= 9 && zoomLevel <=15)
		{
			content += '<div class="VE_Traffic_Flow_Slow">' + Msn.VE.Features.Traffic.Flow.Slow +' </div>' +
						'<div class="VE_Traffic_Flow_Moderate">' + Msn.VE.Features.Traffic.Flow.Moderate + ' </div>' +		
						'<div class="VE_Traffic_Flow_Fast">' + Msn.VE.Features.Traffic.Flow.Fast + ' </div>';						
		}
		else if(zoomLevel >= 16)
		{	
			content += '<div id="trafficZoomout" class="VE_Traffic_PanelText">' + L_TrafficManagerZoomOut_Text.replace( /%1/g, '<a href="javascript:map.SetZoom(15)">' ).replace( /%2/g,'</a>' ) + '</div>';
		}
		else
		{
			panelcontent += '<div class="VE_Traffic_PanelText">' + L_TrafficManagerForTrafficZoomTo_Text.replace ( /%1/g, '<img src="i/Traffic/TrafficZoom.gif">' ) + '</div>';
		}
	}
	else
	{	
		content += '<div class="VE_Traffic_PanelText">' + L_TrafficManagerSpeedInfoNotAvailable_Text + '</div>';							
	}
	content += '</div>';
	return content;	
}

VE_TrafficManager._GetIncidentFilter = function()
{
	var content = "";
	if(VE_TrafficManager.showConstructionIncidents)
	{	
		content += '<div class = "VE_Traffic_Incident_Filter"><input type="checkbox" checked="true" id="ve_traffic_constr_incidentfilter_check" onclick="VE_TrafficManager._ToggleIncidentPushpins();"></input><label for = "ve_traffic_constr_incidentfilter_check">' + L_TrafficManagerShowConstructionIncidents_Text + '</label></div>';
	}
	else
	{
		content += '<div class = "VE_Traffic_Incident_Filter"><input type="checkbox" id="ve_traffic_constr_incidentfilter_check" onclick="VE_TrafficManager._ToggleIncidentPushpins();"></input><label for = "ve_traffic_constr_incidentfilter_check">' + L_TrafficManagerShowConstructionIncidents_Text + '</label></div>';
	}	
	return content;
}

VE_TrafficManager._GetPanelFooter=function()
	{	
	var content =	'';
	content = '<div class="VE_Traffic_Footer" > ' + Msn.VE.Features.Traffic.Attribution + '</div>';	
	return content;
}

VE_TrafficManager._GetLegendFooter=function(zoomLevel)
{
	var content =	'';
	if(zoomLevel > 8)
	{
		if(VE_TrafficManager.incidentsAvailable != null)
		{
			content += VE_TrafficManager._GetIncidentFilter();
		
			try
			{
				var timestamp = "";
				if(VE_TrafficManager.showingMarkets != null && VE_TrafficManager.showingMarkets.length >0)
				{
					var market = VE_TrafficManager.showingMarkets[0];
					if(VE_TrafficManager.incidents[market] != null && 
					   VE_TrafficManager.incidents[market].length > 0)
					 {
						timestamp = VETime.FormatPanelTime(VE_TrafficManager.incidents[market][0].Timestamp, false);				
					 }
				}
			}
			catch(ex)
			{
				
			}
		}
				
		if(timestamp != null && timestamp.length >0)	
			content += '<div class = "VE_Traffic_Update_Time"> ' + L_TrafficManagerUpdated_Text + ' ' + timestamp + '</div>';					
		//else
		//	content += '<div class = "VE_Traffic_Logo"></div>';						
		
	}
	return content;
}


//Incident types
VE_TrafficIncidentType = new function ()
{
	this.ScheduledConstruction = "SCHEDULED CONSTRUCTION";
	this.OtherNews = "OTHER NEWS";
	this.Congestion = "CONGESTION";
	this.Accident = "ACCIDENT";
	this.DisabledVehicle = "DISABLED VEHICILE";
	this.RoadHazard = "ROAD HAZARD";
	this.UnscheduledConstruction = "UNSCHEDULED CONSTRUCTION";
	this.PlannedEvent = "PLANNED EVENT";
	this.MassTransit = "MASS TRANSIT";
	this.Weather = "WEATHER";
	this.Miscellaneous = "MISCELLANEOUS";
}
