//------------------------------------------------------------------------------
// Traffic/TrafficPopup.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: a-jayab, keithkin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// A reference to the one popup window
VE_TrafficManager.popup = null;

// A reference to the entity that the popup is for
VE_TrafficManager.popupEntity = null;

// A reference to the pushpin for the popup
VE_TrafficManager.popupPushpin = null;

// The original z-index of the popup pushpin.
VE_TrafficManager.popupPushpinOrigZIndex;

// popup panel z-index.
VE_TrafficManager.popupZIndex = 21;

// The default popup size.
VE_TrafficManager.defaultPopupWidth = 200;

//Setting the Severity
VE_TrafficManager.Severity = {Serious:L_TrafficManagerSerious_Text, Moderate:L_TrafficManagerModerate_Text, Minor:L_TrafficManagerMinor_Text }

//Latitude/Longitude coordinate for Traffic Manager popup
//Note: this LatLong storage mechanism is required for pictometry contractual purposes
//We legally cannot show lat/long coordinates on the status bar in birdseye mode.
VE_TrafficManager.LatLong = null;

VE_TrafficManager._GetEntityReference=function(e, target) 
{	
	if(!e)
	{
		e = window.event;
	}
		
	var t = target
	
	if (!t)	
		t = GetTarget(e);
		
	if(!t)
	{
		return "";
	}
	
	return t.id;	
}

// Show a popup for a Traffic result
VE_TrafficManager._ShowTrafficIncidentPopup=function(el)
{
	var trafficIndex;
	var entityID;
	var dockElement;
	var target;
	if(el != null && el != "undefined")
	{
		target = GetTarget(el);
	}
	else
	{
		target = GetTarget();			
	}
	if(!trafficIndex && !entityID)
	{
		entityID = VE_TrafficManager._GetEntityReference(null, target);
	} 
	// Based on the traffic index and entity ID, find the result object
	var r = VE_TrafficManager.GetEntity(entityID);
	
	if(r == null)
	{
		return;
	}
		
	// Push the pin of the previously open pop up back to its place.
	VE_TrafficManager._RestorePushpinZIndex();
	
	// Keep track of the pushpin & its original z-index.
	//VE_TrafficManager.popupPushpin = r.pushPin;
	//VE_TrafficManager.popupPushpinOrigZIndex = VE_TrafficManager.zIndex;	
	var content = VE_TrafficManager.CreatePopupContent(r, true);				
	ero.setContent(content);
	ero.dockToElement(target);	
	VE_Analytics.Log("VE | Traffic Ero Popup","Traffic ERO activation");				
}

VE_TrafficManager._ShowTrafficMarketPopup=function(el)
{
	var trafficIndex;
	var entityID;
	var dockElement;
	var target = null;
	if(el != null && el != "undefined")
	{
		target = GetTarget(el);
	}
	else
	{
		target = GetTarget();			
	}
	if(!trafficIndex && !entityID)
	{
		entityID = VE_TrafficManager._GetEntityReference(null, target);
	} 
	// Based on the traffic index and entity ID, find the result object
	var r = VE_TrafficManager.GetEntity(entityID);
	
	if(r == null)
	{
		return;
	}
			
	// Push the pin of the previously open pop up back to its place.
	VE_TrafficManager._RestorePushpinZIndex();
	
	// Keep track of the pushpin & its original z-index.
	//VE_TrafficManager.popupPushpin = r.pushPin;
	//VE_TrafficManager.popupPushpinOrigZIndex = VE_TrafficManager.zIndex;	
	var	content= VE_TrafficManager.CreateZoomPopupContent(r);
	if(content != null && content != "" && content != "undefined")
	{
		ero.setContent(content);
		ero.dockToElement(target);	
	}
}

VE_TrafficManager.SetCenterAndZoom = function(zoom)
{
	map.SetCenterAndZoom(VE_TrafficManager.LatLong.latitude,
						 VE_TrafficManager.LatLong.longitude,
						 zoom);
}

VE_TrafficManager.CreateZoomPopupContent=function(market)
{
	try
	{
		if(market == null || market == "undefined")
			return "";
		var content = '<br><div class = "traffictitle">' + IOSec.EncodeHtml(market.Name) + ' ' + L_Traffic_Text + '</div><br>';
		
		var lat =  parseFloat(market.SWLatitude) + parseFloat(market.NELatitude);
		var lon =  parseFloat(market.SWLongitude) + parseFloat(market.NELongitude);				
			
		ero.clearActions();

		// Note: this LatLong storage mechanism is required for pictometry contractual purposes
		// We legally cannot show lat/long coordinates on the status bar in birdseye mode.
		VE_TrafficManager.LatLong = new Msn.VE.LatLong(lat/2,lon/2);
 		var ZoomTraffic = "<a class=\"VE_Panel_sublink\" href=\"javascript:VE_TrafficManager.SetCenterAndZoom(9)\">"+ L_TrafficPopupZoom_Text +"</a>";

		ero.addAction(ZoomTraffic);	
		return content;
	}
	catch(ex)
	{
		//swallow
	}		
}

// Creates the html content inside the popup that is shown when hovering over map icons or clicking on traffic result or scratchpad links
VE_TrafficManager.CreatePopupContent=function(r, scratchpadLink, trafficIndex)
{	
	var content =		
	'<div class = "traffictitle">' + ((r.Type)?IOSec.EncodeHtml(r.Type.replace(/&amp;/gi,"&")):'') + '</div>' +
	'<div class = "trafficheader">' + L_TrafficPopupSeverity_Text + ':</div> ' + 
	'<div class = "trafficdata">' + VE_TrafficManager._GetSeverity(r.Criticality) + '</div>' +	
	'<div class = "trafficheader">' + L_TrafficPopupLocation_Text + ':</div> ' + 
	'<div class = "trafficdata">' + ((r.Location)?IOSec.EncodeHtml(r.Location.replace(/&amp;/gi,"&")):'') + '</div>' +
	'<div class = "trafficheader">' + L_TrafficPopupDescription_Text + ':</div> ' + 
	'<div class = "trafficdata">' + ((r.Description)?IOSec.EncodeHtml(r.Description.replace(/&amp;/gi,"&")):'') + '</div>' +
	'<BR><div>' +
		'<div class = "trafficlabel">' + L_TrafficPopupStartTime_Text + ':</div>' +
		'<div class = "trafficdata">' + ((r.Starttime)?IOSec.EncodeHtml(VETime.FormatTime(r.Starttime, true)):'') + '</div>' +
	'</div>' +
	'<div>' +
		'<div class = "trafficlabel">' + L_TrafficPopupEstEndTime_Text + ':</div>' +
		'<div class = "trafficdata">' + ((r.Endtime)?IOSec.EncodeHtml(VETime.FormatTime(r.Endtime, true)):'') + '</div>' +
	'</div>'; 		
	ero.clearActions();	

	// Note: this LatLong storage mechanism is required for pictometry contractual purposes
	// We legally cannot show lat/long coordinates on the status bar in birdseye mode.
	VE_ContextMenu.SetLatLong(r.Latitude, r.Longitude);

	//Zoom to Incident
	//Zoom to Street: VE_ContextMenu.StreetZoomLevel
	var ZoomIncident = 
	'<a href = "' + VE_ContextMenu._ContextMenuHandlerLink("zoom", 15) + '; VE_Analytics.Log(\'VE | Traffic Ero Popup\', \'Traffic ERO zoom to incident\');" class = "VE_Panel_sublink">' + L_TrafficPopupZoomToIncident_Text + '</a>' ;
	ero.addAction(ZoomIncident);
	
	//Centre Map
	var CentreMap = 
	'<a href = "' + VE_ContextMenu._ContextMenuHandlerLink("center") + '; VE_Analytics.Log(\'VE | Traffic Ero Popup\', \'Traffic ERO Center on incident\');" class = "VE_Panel_sublink">' + L_ContextPanelCenterMapHere_Text + '</a>';
	ero.addAction(CentreMap);

	return content;
}


// Close the popup if it's open
VE_TrafficManager.CloseTrafficPopup=function()
{
	ero.hide();	
}

// Sets the z-index of the popup pushpin.
VE_TrafficManager._RestorePushpinZIndex=function()
{
	if (!VE_TrafficManager.popupPushpin)
	{
		return;
	}

	VE_TrafficManager.popupPushpin.style.zIndex = VE_TrafficManager.popupPushpinOrigZIndex;
}

//Mapping Criticality and Severity
VE_TrafficManager._GetSeverity = function(criticality)
{
	switch(criticality)
	{
		case 0:
			return VE_TrafficManager.Severity.Serious;
			break;
		
		case 1:
			return VE_TrafficManager.Severity.Moderate;
			break;
		
		case 2:
			return VE_TrafficManager.Severity.Minor;
			break;
			
		default:
			return VE_TrafficManager.Severity.Minor;
	}	
}