//------------------------------------------------------------------------------
// UserCollections/CollectionsConsts.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: shankak, keithkin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

//Resource Enums for Collection Related Actions
VE_CollectionActions = function() {};

VE_CollectionActions.Create = "CreateCollection";
VE_CollectionActions.Update = "UpdateCollection";
VE_CollectionActions.RetrieveAll = "RetrieveAllCollections";
VE_CollectionActions.RetrieveDetails = "RetrieveCollectionDetails";
VE_CollectionActions.Delete = "DeleteCollection";
VE_CollectionActions.DeleteAll = "DeleteAllCollections";
VE_CollectionActions.DeleteAllAnnotations = "DeleteAllAnnotations";


//Resource Enums for Annotation Related Actions
VE_AnnotationActions = function(){};

VE_AnnotationActions.Create = "CreateAnnotation";
VE_AnnotationActions.Delete = "DeleteAnnotation";
VE_AnnotationActions.Update = "UpdateAnnotation";
VE_AnnotationActions.RetrieveAll = "RetrieveAllAnnotations";

VE_AnnotationState = function() {};
VE_AnnotationState.None = "None";
VE_AnnotationState.Added = "Added";
VE_AnnotationState.Updated = "Updated";
VE_AnnotationState.Deleted = "Deleted";

//Resource and Constants for CollectionManager
VE_CollectionsManagerConstants = function(){};

//Common Constants
VE_CollectionsManagerConstants.Handler = "UserCollections.aspx?action=";
VE_CollectionsManagerConstants.Market = "mkt=";
VE_CollectionsManagerConstants.Random = "rand=";

//For Annotations
VE_CollectionsManagerConstants.A_Id = "aid";
VE_CollectionsManagerConstants.A_Title = "atitle";
VE_CollectionsManagerConstants.A_Latitude = "alatitude";
VE_CollectionsManagerConstants.A_Longitude = "alongitude";
VE_CollectionsManagerConstants.A_Notes = "anotes";
VE_CollectionsManagerConstants.A_Keywords = "akeywords";
VE_CollectionsManagerConstants.A_IconId = "aiconid";
VE_CollectionsManagerConstants.A_InfoUrl = "aurl";
VE_CollectionsManagerConstants.A_PhotoUrl = "aphotourl";
VE_CollectionsManagerConstants.A_UserDate = "auserdate";
VE_CollectionsManagerConstants.A_DisplayOrder = "adisplayorder";
VE_CollectionsManagerConstants.A_BusinessId = "abusinesslistingid";
VE_CollectionsManagerConstants.A_CreationId = "acreationid";
VE_CollectionsManagerConstants.A_State = "astate";


//For Collections
VE_CollectionsManagerConstants.C_Id = "cid";
VE_CollectionsManagerConstants.C_Name = "cname";
VE_CollectionsManagerConstants.C_IsPublic = "cispublic";
VE_CollectionsManagerConstants.C_Length = "cannotationcount";
VE_CollectionsManagerConstants.C_Keywords = "ckeywords";

//For Viewer
VE_CollectionsManagerConstants.ViewerDefaultTitle = L_CollectionManagerViewerDefaultTitle_Text;

//For the timer
VE_CollectionsManagerConstants.MinimizedTimerDelay = 1;
VE_CollectionsManagerConstants.TimerDelay = 2000;
VE_CollectionsManagerConstants.ExtendedTimerDelay = 5000;

//For collection Size
VE_CollectionsManagerConstants.MAX_COLLECTION_SIZE = 200;

//Collections Related Help
VE_CollectionsManagerConstants.HELP_FILE_PATH = "/cPublicPrivate.htm";
