
var windowWidth = 0;
var windowHeight = 0;
var scrollbarWidth = null;

// Gets the width of the window, minimum 100 pixels
function GetWindowWidth() 
{
	var width = 0;
	
	if(typeof(window.innerWidth) == 'number')
	{
		width =  window.innerWidth;
	}
	else if(document.documentElement && document.documentElement.clientWidth)
	{
		width =  document.documentElement.clientWidth;
	}
	else if(document.body && document.body.clientWidth)
	{
		width =  document.body.clientWidth;
	}
	
	if(!width || width < 100)
	{
		width = 100;
	}
		
	return width;
}

// Gets the height of the window, minimum 100 pixels
function GetWindowHeight() 
{
	var height = 0;
	
	if(typeof(window.innerHeight) == 'number')
	{
		height = window.innerHeight;
	}
	else if(document.documentElement && document.documentElement.clientHeight)
	{ 
		height = document.documentElement.clientHeight;
	}
	else if(document.body && document.body.clientHeight)
	{ 
		height = document.body.clientHeight;
	}
	
	if(!height || height < 100)
	{
		height = 100;
	}
		
	return height;
}

// creates a div with just a scrollbar and gets its size
// this works in IE but not in firefox.
function GetScrollbarWidth ()
{
	if (scrollbarWidth)
	{
		return scrollbarWidth;
	}

  if(navigator.userAgent.indexOf("IE")>=0)
  {  	
	var div=document.createElement("div");
	var sbWidth = null;
	  
	div.style.visible = 'hidden';
	div.style.overflowY = 'scroll';
	div.style.position = 'absolute';
	div.style.width = 0;
	document.body.insertAdjacentElement("afterBegin", div);
	sbWidth = div.offsetWidth;
	div.parentNode.removeChild(div);
	  
	if ( !sbWidth )
	{
			sbWidth = 16;
	}
	  
	scrollbarWidth = sbWidth;  
	return sbWidth;
  }  
  else
	  return 0;
}

// Returns the full url path up to and including the last forward slash
function GetUrlPrefix()
{
	var lastfslash = window.location.pathname.lastIndexOf("/");
	var hosturl = window.location.protocol+"//"+window.location.hostname+window.location.pathname.substring(0,lastfslash+1);
	return hosturl;
}

function GetUrlParameterString()
{
	var urlParameterString = window.location.search;
	
	// Exit early if we have no parameters passed in the url.
	if (urlParameterString.length == 0 || urlParameterString.indexOf("?") == -1)
	{
		return "";
	}

	// Strip out initial ?
	return urlParameterString.substr(urlParameterString.indexOf("?") + 1);
}

// Constructs an array of the parameters passed in via the url
// Format is [parameter name, value, parameter name, value, ...]
function GetUrlParameters()
{
	var parameters = new Array();
	var urlParameterString = GetUrlParameterString();
	
	if (!urlParameterString)
	{
		return parameters;
	}
	
	// Split into parameter strings on & - ex. abcd=jas%20ew&akw9=29  [abcd=jaw%20ew, akw9=29, etc.]
	var parameterStrings = urlParameterString.split("&");
	
	// Split the parameter strings into name/value pairs on = - ex  abcd=jas%20ew -> [abcd, 'jas ew']
	for (var i = 0; i < parameterStrings.length; i++)
	{
		var parameterParts = parameterStrings[i].split("=");
		// Only bother with those that actually have both a name & value.
		if (parameterParts.length == 2 && parameterParts[0] && parameterParts[1])
		{
			parameters.push(unescape(parameterParts[0]));
			parameters.push(unescape(parameterParts[1]));
		}
	}
	
	return parameters;
}

// It parses for Shift key pressed. To be called from onclick event of an <A> tag.
// This prevent new window from popping up when "Shift" key + hyperlink is clicked.
function ParseShiftKeyForLinks(e) 
{ 
	if(e.shiftKey) 
	{ 
		return false; 
	} 	
	return true; 		
}