var Css =
{
	Position:
	{
		Absolute: 'absolute',
		Relative: 'relative',
		Static: 'static'
	},
	
	Visibility:
	{
		Visible: 'visible',
		Hidden: 'hidden'
	},
	
	Units:
	{
		Pixels: 'px',
		Points: 'pt',
		Ems: 'em',
		Percentage: '%',
		Auto: 'auto'		
	}
}

var Layout =
{
	Fill: -999,
	
	Location:
	{
		Top: 0,
		Right: 1,
		Bottom: 2,
		Left: 3
	}
}


function DockingStation(container)
{
	// fix stupid ID
	var self = this;

	var m_dockedComponents = new Array();
	var m_container = container || document.body;
	
	var m_nTopSum = 0;
	var m_nRightSum = 0;
	var m_nBottomSum = 0;
	var m_nLeftSum = 0;
	
	// public member variables
	this.DefaultUnits = Css.Units.Pixels;
	
	this.redrawLayout = function()
	{
		for (var i = 0; i < m_dockedComponents.length; i++)
			self.drawComponent(m_dockedComponents[i]);
	}
	
	this.dock = function(da)
	{
		m_dockedComponents.push(da);
		m_container.appendChild(da.getElement());
	}
	
	this.drawComponent = function(da)
	{
		// TODO:  make sure da exists in the Docking Station's collection
		//alert(da.getId() + ' has been docked: ' + da.getLayoutLocation() + ', ' + da.getHeight() + ', ' + da.getWidth());
		
		var topSum = 0, rightSum = 0, bottomSum = 0, leftSum = 0;
		for (var i = 0; i < m_dockedComponents.length; i++)
		{
			var dc = m_dockedComponents[i];
			if (da == dc)
				break;
				
			var height = dc.getHeight();
			var width = dc.getWidth();
			var pos = dc.getLayoutLocation();
			
			switch (pos)
			{			
				case Layout.Location.Top:
					topSum += height;
					break;
					
				case Layout.Location.Right:
					rightSum += width;
					break;
					
				case Layout.Location.Bottom:
					bottomSum += height;
					break;
					
				case Layout.Location.Left:
					leftSum += width;
					break;
			}
		}
		
		if (da.FillY)
			da.setHeight(m_container.offsetHeight - topSum - bottomSum);
		if (da.FillX)
			da.setWidth(m_container.offsetWidth - leftSum - rightSum);
			
		if (da.getLayoutLocation() == Layout.Location.Top || da.getLayoutLocation() == Layout.Location.Left)
			da.setPosition(leftSum, topSum);			
			
		if (da.getLayoutLocation() == Layout.Location.Bottom)
			da.setPosition(leftSum, m_container.offsetHeight - bottomSum - da.getHeight());
			
		if (da.getLayoutLocation() == Layout.Location.Right)
			da.setPosition(m_container.offsetWidth - rightSum - da.getWidth(), topSum);
	}

	this.createArea = function(position, size, id)
	{
		var parent = self;
		var da = new DockableArea(position, size, id);		
		return da;
		
		function DockableArea(_position, _size, _id)
		{
			// fix stupid IE
			var self = this;
			
			// private variables
			var m_div = document.createElement('div');
			m_div.style.position = Css.Position.Absolute;
			var m_position = _position;	
			var m_strId = _id;
			var m_nHeight = 0;
			var m_nWidth = 0;
			
			//public properties
			this.Border = { Top: 0, Right: 0, Bottom: 0, Left: 0 }
			this.Padding = { Top: 0, Right: 0, Bottom: 0, Left: 0 }
			this.Margin = { Top: 0, Right: 0, Bottom: 0, Left: 0 }
			this.FillX = false;
			this.FillY = false;	
			
			
			// Constructor Like Code				
				if (_size == Layout.Fill)
				{
					this.FillX = this.FillY = true;
				}
				else if (m_position == Layout.Location.Top || m_position == Layout.Location.Bottom)
				{
					m_nHeight = _size;
					this.FillX = true;
				}
				else
				{
					m_nWidth = _size;
					this.FillY = true;
				}
				
				m_div.style.height = m_nHeight + parent.DefaultUnits;
				m_div.style.width = m_nWidth + parent.DefaultUnits;			
			// End Constructor
			
			// public methods
			this.getElement = function() { return m_div; }
			this.getId = function() { return m_strId; }
			this.getLayoutLocation = function() { return m_position; }
			this.getHeight = function() { return m_nHeight; }
			this.getWidth = function() { return m_nWidth; }
			
			this.setColor = function(color)
			{
				m_div.style.backgroundColor = color;
			}
			
			this.setHeight = function(height)
			{
				m_nHeight = height;
				m_div.style.height = height + parent.DefaultUnits;
			}
			
			this.setWidth = function(width)
			{
				m_nWidth = width;
				m_div.style.width = width + parent.DefaultUnits;
			}
			
			this.setPosition = function(x, y)
			{
				m_div.style.top = y + parent.DefaultUnits;
				m_div.style.left = x + parent.DefaultUnits;
			}			
		}
	}
}