// Copyright 2005 Microsoft Corporation
// Version number : 1.3.0519
//****************************************
//****************Resources***************
//****************************************

//text
//JS/MapControl/Dashboard/Dashboard.js
var L_DashboardRoad_Text = "Road";
var L_DashboardAerial_Text = "Aerial";
var L_DashboardBirdsEye_Text = "Bird's eye";
var L_DashboardBirdsEyeText_Text = "[厓ｱSee this location in bird's eye view.十汁十汁十汁十汁]";
var L_DashboardShowLabels_Text = "[虍袢Show labels十汁]";

//JS/MapControl/Dashboard/ObliqueZoomBar.js
var L_ObliqueZoomBarSelectZoom_Text = "[晙ソChoose the zoom level十汁十汁十]";

//JS/MapControl/Dashboard/ObliqueCompass.js
var L_ObliqueCompassSelectDirection_Text = "[ボ欺Change the direction of the view十汁十汁十汁十]";

//JS/MapControl/Dashboard/ObliqueSelector.js
var L_ObliqueSelectorSelectThumbnail_Text = "[マ旭Choose a thumbnail to display an image from the surrounding area十汁十汁十汁十汁十汁十汁十汁]";

//JS/MapControl/Mode/ObliqueMode.js
var L_ObliqueModeImageNotAvailable_Text = "[啓晙ソ滌噂Bird's eye images are not available for this area.十汁十汁十汁]";

// metric
//JS/MapControl/ScaleBar.js
var L_ScaleBarMiles_Text = "[ミ厓miles十]";
var L_ScaleBarKilometers_Text = "[穴旭km十]";
var L_ScaleBarMeters_Text = "[ゼダm十]";
var L_ScaleBarYards_Text = "[チ漾yds十]";






//------------------------------------------------------------------------------
//	MapControl.Feature.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: a-pratin, keithkin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------
//Localizable Strings
var L_MapControlNavteq_Text = "&copy; [ｱマチボ穴2006 NAVTEQ !!! !]";
var L_MapControlImageCourtesyOfNASA_Text = "[+++穴晙チImage courtesy of NASA十汁十汁十+++]";
var L_MapControlHarrisCorp_Text = "&copy; [+++噂漾ゼHarris Corp, Earthstar Geographics LLC十汁十汁十汁十汁十+++]";
var L_MapControlImageCourtesyOfUSGS_Text = "[+++ソ厓袷Image courtesy of USGS十汁十汁十+++]";
var L_MapControlImageCourtesyOfPictometry_Text = "&copy; [+++袷タポ2005 Pictometry International Corp.十汁十汁十汁十汁+++]";
var L_MapControlImageCourtesyOfEarthData_Text = "&copy; EarthData";
var L_MapControlImageCourtesyOfGetmapping_Text = "&copy; Getmapping plc";
var L_MapControlImageCourtesyOfAND_Text = "&copy; AND";
var L_MapCopyrightMicrosoft = "&copy; 2006 Microsoft Corporation"; 
var L_MapControlPlatformName_Text = "Virtual Earth";

// RegisterNamespace
RegisterNamespaces("MapControl");

MapControl.Features = new function()
{	
	//Platform
	this.PlatformName = L_MapControlPlatformName_Text;

	//Copyright Strings
	this.Copyright = new function()
	{
		this.Navteq = L_MapControlNavteq_Text;
		this.ImageCourtesyOfNASA = L_MapControlImageCourtesyOfNASA_Text;
		this.HarrisCorp = L_MapControlHarrisCorp_Text;
		this.ImageCourtesyOfUSGS = L_MapControlImageCourtesyOfUSGS_Text;
		this.ImageCourtesyOfPictometry = L_MapControlImageCourtesyOfPictometry_Text;
	}	
	// images
	this.Image = new function()
	{
		this.PoweredLogo = "i/logo_powered_by.png";
	}		
	//MapStyle
	this.MapStyle = new function()
	{
		this.Road = true;
		this.Aerial = true;
		this.Hybrid = true;
		this.BirdsEye = true;		
	}
	this.BirdsEyeAtZoomLevel = 10;
		
	//scale
	this.ScaleBarKilometers = false;
}


//------------------------------------------------------------------------------
// MapControl/Map.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, sstchur, keithkin, cthota
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

var windowWidth = 0;
var windowHeight = 0;
var scrollbarWidth = null;

// Gets the width of the window, minimum 100 pixels
function GetWindowWidth() 
{
	var width = 0;
	
	if(typeof(window.innerWidth) == 'number')
	{
		width =  window.innerWidth;
	}
	else if(document.documentElement && document.documentElement.clientWidth)
	{
		width =  document.documentElement.clientWidth;
	}
	else if(document.body && document.body.clientWidth)
	{
		width =  document.body.clientWidth;
	}
	
	if(!width || width < 100)
	{
		width = 100;
	}
		
	return width;
}

// Gets the height of the window, minimum 100 pixels
function GetWindowHeight() 
{
	var height = 0;
	
	if(typeof(window.innerHeight) == 'number')
	{
		height = window.innerHeight;
	}
	else if(document.documentElement && document.documentElement.clientHeight)
	{ 
		height = document.documentElement.clientHeight;
	}
	else if(document.body && document.body.clientHeight)
	{ 
		height = document.body.clientHeight;
	}
	
	if(!height || height < 100)
	{
		height = 100;
	}
		
	return height;
}

// creates a div with just a scrollbar and gets its size
// this works in IE but not in firefox.
function GetScrollbarWidth ()
{
	if (scrollbarWidth)
	{
		return scrollbarWidth;
	}

  if(navigator.userAgent.indexOf("IE")>=0)
  {  	
	var div=document.createElement("div");
	var sbWidth = null;
	  
	div.style.visible = 'hidden';
	div.style.overflowY = 'scroll';
	div.style.position = 'absolute';
	div.style.width = 0;
	document.body.insertAdjacentElement("afterBegin", div);
	sbWidth = div.offsetWidth;
	div.parentNode.removeChild(div);
	  
	if ( !sbWidth )
	{
			sbWidth = 16;
	}
	  
	scrollbarWidth = sbWidth;  
	return sbWidth;
  }  
  else
	  return 0;
}

// Returns the full url path up to and including the last forward slash
function GetUrlPrefix()
{
	var lastfslash = window.location.pathname.lastIndexOf("/");
	var hosturl = window.location.protocol+"//"+window.location.hostname+window.location.pathname.substring(0,lastfslash+1);
	return hosturl;
}

function GetUrlParameterString()
{
	var urlParameterString = window.location.search;
	
	// Exit early if we have no parameters passed in the url.
	if (urlParameterString.length == 0 || urlParameterString.indexOf("?") == -1)
	{
		return "";
	}

	// Strip out initial ?
	return urlParameterString.substr(urlParameterString.indexOf("?") + 1);
}

// Constructs an array of the parameters passed in via the url
// Format is [parameter name, value, parameter name, value, ...]
function GetUrlParameters()
{
	var parameters = new Array();
	var urlParameterString = GetUrlParameterString();
	
	if (!urlParameterString)
	{
		return parameters;
	}
	
	// Split into parameter strings on & - ex. abcd=jas%20ew&akw9=29  [abcd=jaw%20ew, akw9=29, etc.]
	var parameterStrings = urlParameterString.split("&");
	
	// Split the parameter strings into name/value pairs on = - ex  abcd=jas%20ew -> [abcd, 'jas ew']
	for (var i = 0; i < parameterStrings.length; i++)
	{
		var parameterParts = parameterStrings[i].split("=");
		// Only bother with those that actually have both a name & value.
		if (parameterParts.length == 2 && parameterParts[0] && parameterParts[1])
		{
			parameters.push(unescape(parameterParts[0]));
			parameters.push(unescape(parameterParts[1]));
		}
	}
	
	return parameters;
}

// It parses for Shift key pressed. To be called from onclick event of an <A> tag.
// This prevent new window from popping up when "Shift" key + hyperlink is clicked.
function ParseShiftKeyForLinks(e) 
{ 
	if(e.shiftKey) 
	{ 
		return false; 
	} 	
	return true; 		
}
//------------------------------------------------------------------------------
// MapControl/Browser.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Eshinn
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// Returns the event object
function GetEvent(e)
{
	return e ? e : window.event;
}

// Cancels an event
function CancelEvent(e)
{
	e.cancelBubble = true;
}

// Ignore a mouse event.  This can be used for any event handler that is not
// supposed to be bubbled up to the parent.
function IgnoreEvent(e)
{
	e = GetEvent(e);
	CancelEvent(e);
	return false;
}

// Returns the X position of the mouse when the event was fired.
function GetMouseX(e)
{
	var posX = 0;
	if (e.pageX)
	{
		posX = e.pageX;
	}
	else if (e.clientX)
	{
		if (document.documentElement && document.documentElement.scrollLeft)
		{
			posX = e.clientX + document.documentElement.scrollLeft;
		}
		else if (document.body)
		{
			posX = e.clientX + document.body.scrollLeft;
		}
	}

	return posX;
}

// Returns the Y position of the mouse when the event was fired.
function GetMouseY(e)
{
	var posY = 0;
	if (e.pageY)
	{
		posY = e.pageY;
	}
	else if (e.clientY)
	{
		if (document.documentElement && document.documentElement.scrollTop)
		{
			posY = e.clientY + document.documentElement.scrollTop;
		}
		else if (document.body)
		{
			posY = e.clientY + document.body.scrollTop;
		}
	}

	return posY;
}

// Returns the delta when the mouse wheel is scrolled.
function GetMouseScrollDelta(e)
{
	if (e.wheelDelta) // IE
	{
		return e.wheelDelta; 
	}
	else if (e.detail) // mozilla
	{
		return -e.detail; // deltas are the opposite of IE's.
	}
	return 0;
}

// Returns the target of the event
function GetTarget(e)
{
	if (!e)
	{
		e = window.event;
	}
	
	var t = null;
	if (e.srcElement)
	{
		t = e.srcElement;
	}
	else if (e.target)
	{
		t = e.target;
	}
	
	// defeat Safari bug
	if (t && t.nodeType)
	{
		if (t.nodeType == 3)
		{
			t = targ.parentNode;
		}
	}
	
	return t;
}

// Gets left position of element
function GetLeftPosition(el) 
{
    var offsetTrail = el;
    var offsetLeft = 0;
    while (offsetTrail) 
    {
        offsetLeft += offsetTrail.offsetLeft;
        offsetTrail = offsetTrail.offsetParent;
    }
    
    if (navigator.userAgent.indexOf("Mac") != -1 && typeof(document.body.leftMargin) != "undefined") 
    {
        offsetLeft += document.body.leftMargin;
    }
    
    return offsetLeft;
}

// Gets top position of element
function GetTopPosition(el) 
{
    var offsetTrail = el;
    var offsetTop = 0;
    while (offsetTrail) 
    {
        offsetTop += offsetTrail.offsetTop;
        offsetTrail = offsetTrail.offsetParent;
    }
    
    if (navigator.userAgent.indexOf("Mac") != -1 && typeof(document.body.topMargin) != "undefined") 
    {
        offsetTop += document.body.topMargin;
    }
    
    return offsetTop;
}
//------------------------------------------------------------------------------
// MapControl/Math.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// A collection of mathematic functions.  Many functions are simple wrappers around
// the existing Math functions.  They are wrapped for better source compression and
// obfuscation.

// If one of the simple wrapped methods is deeply nested in a performance-critical
// loop, it might be useful to experiment with not using the wrapper.  Otherwise,
// it is recommended for better compression and obfuscation.

// Returns the greatest integer less than x.
function MathFloor(x)
{
	return Math.floor(x);
}

// Returns the smallest integer greater than x.
function MathCeil(x)
{
	return Math.ceil(x);
}

// Returns the greater of x and y.
function MathMax(x, y)
{
	return Math.max(x, y);
}

// Returns the lesser of x and y.
function MathMin(x, y)
{
	return Math.min(x, y);
}

// Returns the absolute value of x.
function MathAbs(x)
{
	return Math.abs(x);
}

// Returns the integer nearest to x.
function MathRound(x)
{
	return Math.round(x);
}

// Converts degrees to radians
function DegToRad(d)
{
	return d * Math.PI / 180.0;
}

// Converts radians to degrees
function RadToDeg(r)
{
	return r * 180.0 / Math.PI;
}

//------------------------------------------------------------------------------
// MapControl/Matrix.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// Multiplies two matrices.  Returns the result of the multiplication
// if the matrices are compatible or null otherwise.
function MatrixMultiply(a, b)
{
	// If the either of the matrices are null or the dimensions are incompatible, 
	// return null
	if (!a || !b || a[0].length != b.length)
	{
		return;
	}
	
	// Calculate the dimensions of the new matrix
	var height = a.length;
	var width = b[0].length;
	
	// Create a 2d array for the new values
	var result = new Array(height);
	
	// The inside shared dimension
	var z = b.length;
	
	for (var i=0; i<height; i++)
	{
		result[i] = new Array(width);
		
		for (var j=0; j<width; j++)
		{
			result[i][j] = 0;
			
			for (var k=0; k<z; k++)
			{
				result[i][j] += a[i][k] * b[k][j];
			}
		}
	}
	
	return result;
}

function RegisterNamespaces()
{
	for (var i=0;i<arguments.length;i++)
	{
		var astrParts = arguments[i].split(".");
		var root = window;
		for (var j=0; j < astrParts.length; j++)
		{
			if (!root[astrParts[j]]) 
			{
				root[astrParts[j]] = new Object(); 
			}
			root = root[astrParts[j]];
		}
	}
}
//------------------------------------------------------------------------------
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: a-bwrigh, keithkin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------
//JS/Graphics/graphics.js
//Note: This string is used as an exception for developers and does not need to be localized
var L_GraphicsInitError_Text = "Your Web browser does not support SVG or VML. Some graphics features may not function properly.";

RegisterNamespaces("Msn.Drawing");

Msn.Drawing.Exception=function(msg)
{
  this.message = msg;
  this.name = "Msn.Drawing.Exception";
};

Msn.Drawing.Exception.prototype.toString=function()
{
  return this.name+": "+this.message;
};

Msn.Drawing.Graphic=function(){};
/**
  * Graphic factory method that is responsible for creating
  * either a VML or SVG Graphic object based on the browser.
  */
Msn.Drawing.Graphic.CreateGraphic=function(pElm)
{
	if(document.all)//IE
	{         
		return new Msn.Drawing.VMLGraphic(pElm);
	}
	else
	{   //SVG support for Firefox 1.5 only. 
		var major = 0;
		var minor = 0;
		var versionRegex =  new RegExp("Firefox/(.*)");
	    
		var match = versionRegex.exec(navigator.userAgent);
	    
		if(match[1])
		{
			var versionNumbers = match[1].split(".");
			if(versionNumbers)
			{
				major = versionNumbers[0];            
				minor = versionNumbers[1];             
				if(parseInt(major) > 0 && parseInt(minor) >= 5)
				{
					return new Msn.Drawing.SVGGraphic(pElm); 	        
				}         
			}                      
		}
		throw new Msn.Drawing.Exception(L_GraphicsInitError_Text);             
	}
};
//------------------------------------------------------------------------------
// Geometry
//------------------------------------------------------------------------------

Msn.Drawing.Point=function(x,y)
{
  this.x = x ? x : 0;
  this.y = y ? y : 0;
};
//This is only useful for SVG
Msn.Drawing.Point.prototype.toString=function()
{
  return this.x+","+this.y;
};

//------------------------------------------------------------------------------
// Shapes
//------------------------------------------------------------------------------
/**
  * Polyline primitive. 
  * @param points in an array of Msn.Drawing.Point 
  */
Msn.Drawing.PolyLine=function(points)
{
    this.id = 0;    
    this.points = points ? points : new Array();
    
    this.AddPoint=function(aPoint)
    {
      this.points.push(aPoint);
    }

};
// This is only useful for VML
Msn.Drawing.PolyLine.prototype.toString=function()
{
  return this.points.join(" ");
};

Msn.Drawing.Stroke=function()
{
  this.width = 1; //VML = weight
  this.linecap = "round";//TODO:make enum, VML = endcap
  this.opacity = 1.0;
  this.linejoin = "miter";//TODO:make enum, VML = joinstyle
  this.color = new Msn.Drawing.Color(255,255,255,1.0);  
};

//TODO: lots of validation on values passed in 
Msn.Drawing.Color=function(r,g,b,a)
{
  this.R = r ? r : 0;
  this.G = g ? g : 0;
  this.B = b ? b : 0;
  this.A = a ? a : 1.0;
  //Return the hex representation of this color.
  //Note that the alpha is not valid and is ignored on this operation
  //Alpha is however used when rendering shapes and setting their color values. 
  this.ToHexString=function()
  {
    return "#"+Number(this.R).toString(16)+(this.R < 16?"0":"")
    +Number(this.G).toString(16)+(this.G < 16?"0":"")+Number(this.B).toString(16)
    +(this.B < 16?"0":"");
  };

};

//VML implementation of the Graphic interface.
//@param parentElm is the parent DOM element that
//all shapes will be a child of.
Msn.Drawing.VMLGraphic=function(parentElm)
{   
    var graphicsElm = parentElm;
    var color = new Msn.Drawing.Color(255,0,0,1.0);
    var stroke = new Msn.Drawing.Stroke();

    var zIndex = 1;
    
    var parentLeft = parentElm.offsetLeft;
    var parentTop  = parentElm.offsetTop;
    
    parentElm.unselectable = "on";
    
    var currentShapes = new Array();   
    
    this.DrawPolyline=function(polyLine)
    {
		var element = null;

		element = document.createElement("v:polyline"); 		
		element.id =  polyLine.id;
		
		element.unselectable = "on";
		element.style.position = "absolute";
		element.points = polyLine.points.join(" ");
		element.style.zIndex = zIndex;
		element.filled = "false";
		graphicsElm.appendChild(element);   

		if(stroke)
		{
			var strokeElm = document.createElement("v:stroke");
			strokeElm.unselectable = "on";
			strokeElm.setAttribute("weight", stroke.width);
			strokeElm.setAttribute("joinstyle",stroke.linejoin);
			strokeElm.setAttribute("color", stroke.color.ToHexString());
			strokeElm.setAttribute("endcap",stroke.linecap);  		
			strokeElm.setAttribute("opacity",(stroke.color.A).toString());
			element.appendChild(strokeElm);
		}    	
		currentShapes.push(element);
    };
    
    this.SetColor=function(aColor)
    {     
      color = aColor;
    };
    
    this.SetStroke=function(aStroke)
    {
      stroke = aStroke;
    };

    this.SetZIndex=function(index) 
    {
      zIndex = index;
    };
    
    this.Clear = function()
    {
      var currentShape = null;
      while(currentShape = currentShapes.pop())
      {
        graphicsElm.removeChild(currentShape);
        currentShape = null;
      }
    };    

    this.Destroy = function()
	{
	   this.Clear();
	   graphicsElm = null;
	};
};

//SVG implementation of the Graphic interface.
//@param parentElm is the parent DOM element that
//all shapes will be a child of.
Msn.Drawing.SVGGraphic=function(parentElm)
{        
    var divElm = document.createElement("div");    
    divElm.id = "svgCanvas";
    divElm.style.position = "absolute";
    //divElm.style.cursor = "pointer";
    var graphicsElm = null;
    var zIndex = 1;
        
    divElm.style.top    = parentElm.offsetTop+"px";
    divElm.style.left   = parentElm.offsetLeft+"px";
   
    parentElm.appendChild(divElm);
    
    
    var currentShapes = new Array();
    
    var color = new Msn.Drawing.Color(255,0,0,1.0);
    var stroke = new Msn.Drawing.Stroke();
   
    //SetDimensions();

    //set the initial width and height of divElm to zero.
	divElm.style.width  = "0px";
	divElm.style.height = "0px";
      
    graphicsElm = document.createElementNS("http://www.w3.org/2000/svg","svg");      

    graphicsElm.setAttribute("height","100%");
    graphicsElm.setAttribute("width","100%");
    divElm.appendChild(graphicsElm); 
    /**
      * if the container element has a height / width of 0 then
      * walk up the DOM until we find a width and height. 
      */
    function SetDimensions()
    {
      var startSearchNode = parentElm;
       //need to compute new width and height for all points      
      //travel up the tree and find a valid width and height
      while(startSearchNode && startSearchNode.offsetWidth == 0)
      {
		startSearchNode = startSearchNode.parentNode;
      }
      divElm.style.position = "absolute";
      divElm.style.width  = startSearchNode.offsetWidth+"px";
      divElm.style.height = startSearchNode.offsetHeight+"px";      
    }
    
    /**
      * Because SVG does not draw negative points we adjust the svg element
      * and translate the points to be positive. This has the same effect but you
      * need to keep in mind that your containing element should have overflow:hidden.
      */
    function ReComputeDimensions(aPolyline)
    { //find max width and height
      if(!aPolyline || !(aPolyline.points) || (aPolyline.points.length < 2))
      {
        return;
      }
      var points = aPolyline.points;
      var pointsLen = points.length;
      var minX = 0;
      var maxX = 0;
      var minY = 0;
      var maxY = 0;
      var maxWidth = 0;
      var maxHeight = 0;
     
      minX =  Math.min(points[0].x,points[1].x);
      maxX = Math.max(points[0].x,points[1].x);
      minY = Math.min(points[0].y,points[1].y);
      maxY = Math.max(points[0].y,points[1].y);
      maxWidth = Math.max(maxX - minX,maxWidth);
      maxHeight = Math.max(maxY - minX,maxHeight);
      for(var i = 2;i < pointsLen; ++i)
      {
        minX = Math.min(points[i].x,minX);
        maxX = Math.max(points[i].x,maxX);
        minY = Math.min(points[i].y,minY);
        maxY = Math.max(points[i].y,maxY);
        maxWidth = Math.max(maxX - minX,maxWidth);
        maxHeight = Math.max(maxY - minY,maxHeight);
      } 
      divElm.style.top =   minY+"px";
      divElm.style.left = minX+"px";
      divElm.style.width  = maxWidth+"px";
      divElm.style.height = maxHeight+"px";   
      //make sure the svg element has the same width and height as container
      graphicsElm.setAttribute("width",maxWidth+"");
      graphicsElm.setAttribute("height",maxHeight+"");
      //translate points, because we have moved the parent containers origin
      for(var i = 0;i < pointsLen ; ++i)
      {
        points[i].x-= minX;
        points[i].y-= minY;
      }
    }
    
    this.DrawPolyline=function(aPolyLine)
    {
      ReComputeDimensions(aPolyLine);      
      var line = document.createElementNS("http://www.w3.org/2000/svg","polyline");
      line.setAttribute("points",aPolyLine.toString());
      line.setAttribute("fill","none");
      line.setAttribute("id",aPolyLine.id);
      
      if(stroke)
  	  {
        line.setAttribute("stroke",stroke.color.ToHexString());
        line.setAttribute("stroke-width",stroke.width);
        line.setAttribute("stroke-opacity",stroke.color.A);
      }
     
      graphicsElm.appendChild(line);
      
      currentShapes.push(line);
    };
    
    this.SetColor=function(aColor)
    {     
      color = aColor;
    };
    this.SetStroke=function(aStroke)
    {
      stroke = aStroke;
    };
    
    this.SetZIndex=function(index) 
    {
      zIndex = index;
      divElm.style.zIndex = zIndex;
    };
    
    this.Destroy = function()
	{
	   this.Clear();
	};
	  
	this.Clear = function()
    {
       var currentShape = null;
       while(currentShape = currentShapes.pop())
       {
        graphicsElm.removeChild(currentShape);
        currentShape = null;
       }    
    };
};

//------------------------------------------------------------------------------
//	Marketization.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: a-pratin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

//Marketization Class
RegisterNamespaces("Msn.VE");

Msn.VE.Marketization = new function()
{
	this.IsEnabled = function ( featureValue )
	{		
		if ( featureValue == undefined )
		{
			throw new VEException( "Msn.VE.Marketization.IsEnabled","err_invalidfeature","Specified feature is invalid.");
		}		
		return( featureValue );		
	}
}

//==================================================================================================
//Exception class
//==================================================================================================
function VEException(source, name, message){
this.source=source; 
this.name=name;
this.message=message;
}
VEException.prototype.Name=this.name;
VEException.prototype.Source=this.source;
VEException.prototype.Message=this.message;
//End Exception class

//------------------------------------------------------------------------------
// Microsoft.Web.UI.Glyph
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: sstchur
// Dependencies: none
//
// Comments:  A IE-Specific Glyph class to handle the various states of glyph icons in VE (unselected, hover, pressed)
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

var Microsoft;
if (!Microsoft) Microsoft = {};
if (!Microsoft.Web) Microsoft.Web = {};
if (!Microsoft.Web.UI) Microsoft.Web.UI = {};

Microsoft.Web.UI.IEGlyphStates = 
{
	Unselected: '-unselected',
	Hover: '-hover',
	Pressed: '-pressed'		
}

Microsoft.Web.UI.IEGlyph = function(_id, _defaultClass)
{
	// Shortcut the Microsoft.Web.UI Namespace Chaind
	var ui = Microsoft.Web.UI;
	
	// -- PRIVATE VARIABLES -- //
	var m_elem;	
	var m_stateHover;
	var m_statePressed;
	var m_defaultClass;
	Construct();
	
	// -- CONSTRUCTOR -- //
	function Construct()
	{
		// Create the container element for the Glyph
		m_elem = document.createElement('div');
		if (_id)
			{ m_elem.id = _id; }
		
		m_defaultClass = _defaultClass || 'ieglyph';		
		m_stateHover = m_defaultClass + ui.IEGlyphStates.Hover
		m_statePressed = m_defaultClass + ui.IEGlyphStates.Pressed;
		
		m_elem.className = m_defaultClass;
		

		// TODO:  Find a better object detection method.  If it weren't for Atlas, if (!document.attachEvent) would be ideal
		if (!document.all)
			return;

		m_elem.attachEvent('onmouseover', Hover);
		m_elem.attachEvent('onmousedown', Press);
		m_elem.attachEvent('onmouseup', Hover);
		m_elem.attachEvent('onmouseout', Unselect);
		window.attachEvent('onunload', Destroy);
	}
	
	// -- PUBLIC FUNCTIONS -- //
	this.getElement = function() { return m_elem; }
	this.setContent = function(_markup) { m_elem.innerHTML = _markup; }
	
	// -- PRIVATE FUNCTIONS -- //
	function Destroy()
	{
		m_elem.detachEvent('onmouseover', Hover);
		m_elem.detachEvent('onmousedown', Press);
		m_elem.detachEvent('onmouseup', Hover);
		m_elem.detachEvent('onmouseout', Unselect);
		
		m_elem = null;
		m_stateHover = null;
		m_statePressed = null;
		m_defaultClass = null;
	}
	
	function Hover()
	{
		Unselect();		
		ApplyState(m_stateHover);
	}
	
	function Press()
	{
		ApplyState(m_statePressed);
	}
	
	function Unselect()
	{
		RemoveState(m_stateHover);
		RemoveState(m_statePressed);
	}
	
	function ApplyState(_glyphState)
	{
		m_elem.className += ' ' + _glyphState;		
	}
	
	function RemoveState(_glyphState)
	{
		var regex = new RegExp(' ' + _glyphState, 'g');
		m_elem.className = m_elem.className.replace(regex, '');		
	}
}


RegisterNamespaces('Msn.VE');

Msn.VE.PushPinTypes =
{
	Default: 0,
	SearchResult: 1,
	Annotation: 2,
	Direction: 3,	
	DirectionTemp: 4,
	TrafficLight: 5,
	TrafficOthers: 6,
	YouAreHere: 7
};

// Constructor - creates and clears all the properties
Msn.VE.MapControl = function(p_elSource, p_htParams)
{

//------------------------------------------------------------------------------
// MapControl/Global.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

var offsetMeters = 20971520;
var baseMetersPerPixel = 163840;
	
var buffer = 0;
var animatedMovementEnabled = true;
var zoomTotalSteps = 6;
var keyboardPanSpeed = 15;
var panToLatLongSpeed = 15;
var earthRadius = 6378137;
var earthCircumference = earthRadius * 2.0 * Math.PI;
var projectionOffset = earthCircumference * 0.5;
var minZoom = 1;
var maxZoom = 19;
var emptyTile = "__emptyTile__";
var minLatitude = -85;
var maxLatitude = 85;
var minLongitude = -180;
var maxLongitude = 180;
var tileSize = 256;
var generations = new Object();

// Z-indexes 
var kbInputZIndex = 0;
var containerZIndex = 0;
var mapZIndex = 1;
var swapZIndex = 1;
var baseZIndex = 2;
var debugZIndex = 3;
var baseZIndex = 11;
var topZIndex = 20;

	// The p_this reference is a way to get a reference to the this object from
	// within anonymous functions.
	var p_this = this;

	var roadStyle = 'r';
	var hybridStyle = 'h';
	var aerialStyle = 'a';
	var obliqueStyle = 'o';
	
	// This represents the current view of the map.
	var currentView = new Msn.VE.MapView();
	
	// The preferred view is used when changing zoom levels or other events that may 
	// change the current restriction on the viewport.  
	// For example, a user may have established that they prefer a latlong just outside
	// of a bounding box.  When the user zooms out, that point might be avaiable in a new
	// bounding box.
	var preferredView = new Msn.VE.MapView();
	
	// The previous zoom level is used after a view transition.  If the zoom levels have changed,
	// then the onendzoom event must be fired.
	var previousZoomLevel = 1;
	
	// The previous map style is used after a view transition.  If the map style has changed,
	// then the onchangemapstyle event must be fired.
	var previousMapStyle = null;
	
	// The last ortho zoom level is used when transitioning from oblique back to ortho.  The oblique
	// and ortho zoom levels are not 100% compatible, so we must go back to the last zoom level.
	var lastOrthoZoomLevel = 15;
	
	// The last ortho map style is used in situations when we need to kick back into ortho, for example
	// when the user moves to an area without oblique or the user needs to zoom out to see multiple points.
	var lastOrthoMapStyle = roadStyle;
	
	// The absolute position and size of the map control.  These values should match the values of
	// the container element in the DOM.  Changing them directly will only mess things up.
	var x = 0, y = 0, width = 0, height = 0;
	
	// The current tiles list is a 1-dimensional array of tile objects.  The order of the tiles
	// array is very important and must be preserved for UpdateView to function properly.
	// The order starts at the top left, moves to the right across the top row, then starts
	// again at the left most tile on the next row down.
	var currentTilesList = new Array();
	
	// The old tiles list is only used during animated zooming where it holds the tiles from the
	// originating view.  During the animated zoom they are synchronously updated with the new tiles
	// coming in to create the animation effect.
	var oldTilesList = null;
	
	var trafficAvailable = false;
	
	var layerTileList = new Array();
	
	// The origin x/y is like an anchor for a view "session".  It represents the absolute distance
	// from the top left corner of the world in pixel space at the current zoom level to an anchor 
	// point that is declared at zoom or a completely new view.
	var originX = 0, originY = 0;
	
	// The offset x/y is the delta between the anchor and the current viewport.
	var offsetX = 0, offsetY = 0;
	
	// The tile viewport definition.  These values represent the boundaries of the map in terms of tile
	// indexes (inclusive).  They are computed in StartView and UpdateView. 
	var tileViewportX1 = 0, tileViewportY1 = 0;
	var tileViewportX2 = 0, tileViewportY2 = 0;
	var tileViewportWidth = 0, tileViewportHeight = 0;
	
	// Tracks whether or not the mouse is currently down and dragged.
	var dragging = false;

	// Tracks if, while panning, the keyboard is being used.
	var keyboardPan = false;
	
	// Tracks the last mouse position for mouse drag panning.
	var lastMouseX = 0, lastMouseY = 0;
	
	// Tracks whether or not the control is in the middle of an animated zoom.
	var zooming = false;
	
	// The zoom counter tracks the progress of an animated zoom.  Animated tiles
	// use the zoomCounter to determine the correct size and position.
	var zoomCounter = 0;
	
	// Tracks whether or not the control is panning (either automatic or manual).
	var panning = false;
	
	// The pan counter tracks the progress of an animated pan.  
	var panCounter = 0;
	
	// The panning deltas keep track of the direction and speed of the pan.
	var panningX = 0, panningY = 0;
	
	// The panning lat/long keeps track of the desired destination of a PanToLatLong call.
	// TODO:  Could this be replaced with preferredView somehow?
	var panLatitude = null, panLongitude = null;
	
	// The pushpins array holds references to all of the pushpins on the map.
	// They are in no particular order.
	var pushpins = new Array();
	
	// The pushpins array holds references to all of the lines on the map.
	// They are in no particular order.
	var lines = new Array();
	
	var map = document.createElement("div");
	var keyboard = document.createElement("input");
	keyboard.id = "wl_ve_mapInput";

	// UI elements
	var logo = null;
	var scaleBar = null;
	var copyright = null;
	
	// Dashboard
	var dashboardContainer = null;
	var dashboard = null;
	
	// Tools
	var boxTool = null;
	var panTool = null;
	var currentTool = null;
	
	// Modes
	var orthoMode = null;
	var obliqueMode = null;
	var currentMode = null;
	
	// The current bounds tracks what is currently being viewed.  This is good to have for panning
	// so it doesn't dig through 100 sets of bounds every time you pan the map.
	var currentBounds = null;
	
	// Event table.  This keeps track of all the other elements out there that have
	// subscribed to the map controls events.  The event table is 2-dimensional -
	// each event can have multiple subscribers which enables multicasting.
	var eventTable = new Array();
	
	// Debug mode overlays image filenames on top of the tiles
	var debug = false;
	
	//SVG/VML Graphic object for drawing driving direction polylines
	var graphicCanvas = null;
	
	// Initialize the control
	// Applies parameters if provided
	// Attaches many events, which are cleaned up in Destroy()
	this.Init = function()
	{
		// Load the generations
		generations[roadStyle] = __roadGeneration__;
		generations[aerialStyle] = __aerialGeneration__;
		generations[hybridStyle] = __hybridGeneration__;
		generations[obliqueStyle] = __obliqueGeneration__;
		
		// Create the ortho view mode
		orthoMode = new OrthoMode();
		orthoMode.Init();
		
		// Create the oblique view mode
		if (p_htParams.obliqueEnabled && p_htParams.obliqueUrl)
		{
			obliqueMode = new ObliqueMode();
			obliqueMode.Init(p_htParams.obliqueUrl);
		}
		
		// Extract location and size info from the parent element
		UpdateFromParent();

		// Prepare the map element
		map.className = "Map";
		map.style.zIndex = mapZIndex;
		p_elSource.appendChild(map);
		
		// Add the keyboard element
		keyboard.className = "KeyboardInput";
		p_elSource.appendChild(keyboard);
		
		// The user can specify that they want a fixed view.  The fixed view does not allow
		// keyboard or mouse interaction.  This can reduce memory usage per control.
		if (!p_htParams.fixedView)
		{
			// The box tool is used for drawing boxes that are converted into new views.
			boxTool = new BoxTool();
			boxTool.Init();
			
			// The pan tool is the most commonly used tool, that allows the user to drag and pan.
			panTool = new PanTool();
			panTool.Init();
			
			// The default tool is the pan tool.
			currentTool = panTool;
		
			// Subscribe to all of the events needed for map nav via mouse and keyboard
			p_elSource.attachEvent("onmousedown", MouseDown);
			p_elSource.attachEvent("onmouseup", MouseUp);
			p_elSource.attachEvent("onmousemove", MouseMove);
			p_elSource.attachEvent("onmousewheel", MouseWheel);
			p_elSource.attachEvent("ondblclick", MouseDoubleClick);
			p_elSource.attachEvent("oncontextmenu", ContextMenu);			
			keyboard.attachEvent("onkeydown", KeyDown);
			keyboard.attachEvent("onkeyup", KeyUp);
			keyboard.attachEvent('onblur', StopKeyboardPan);
			
			// Add the mouse scroll wheel event for Firefox and other gecko based browsers.
			if (window.addEventListener && navigator.product && navigator.product == "Gecko")
			{
				p_elSource.addEventListener("DOMMouseScroll", MouseWheel, false);
			}
			
			// If the view is dynamic, make the buffer the size of 1 tile.
			// If the view is not dynamic, the buffer size will be 0 (no buffer should be needed, right?)
			buffer = tileSize;
		}
		
		// The user can override the buffer if they want.  This is especially useful for fixed views.
		if (p_htParams.buffer != undefined && p_htParams.buffer != null)
		{
			buffer = p_htParams.buffer;
		}
		
		// If the developer specifies a default view, use that.  If it causes an exception or doesn't exist,
		// we can always resort back to the default view (picture of the whole world).
		if (p_htParams.latitude && p_htParams.longitude && p_htParams.zoomlevel && p_htParams.mapstyle)
		{
			try
			{
				var initialView = new Msn.VE.MapView();
				initialView.SetMapStyle(ValidateMapStyle(p_htParams.mapstyle), p_htParams.obliqueSceneId);
				initialView.SetZoomLevel(eval(p_htParams.zoomlevel));
				initialView.SetCenterLatLong(new Msn.VE.LatLong(eval(p_htParams.latitude), eval(p_htParams.longitude)));
				SetView(initialView);
			}
			catch (ex)
			{
				SetDefaultView();
			}
		}
		else
		{
			SetDefaultView();
		}
		
		// Unless explicitly disabled, show the logo
		if (!p_htParams.disableLogo)
		{
			logo = new Logo(p_elSource);
			logo.Init();
		}
		
		// Build the copyright
		copyright = new Copyright(p_elSource);
		copyright.Init();
		copyright.Update();
		
		// If requested, build and display the scale bar
		if (p_htParams.showScaleBar)
		{
			scaleBar = new ScaleBar(p_elSource);
			scaleBar.Init();
			AttachEvent("onendzoom", scaleBar.Update);
			AttachEvent("onendcontinuouspan", scaleBar.Update);
			AttachEvent("onresize", scaleBar.Reposition);
		}
		
		// If requested, build and display the dashboard
		// TODO:  Perhaps the dashboard should be created separately, and manually
		
		if (p_htParams.showDashboard)
		{
			CreateDashboard(p_htParams.dashboardX, p_htParams.dashboardY, p_htParams.dashboardSize, p_htParams.dashboardId);
		}
		
		// Request an oblique update
		if (obliqueMode && currentMode != obliqueMode)
		{
			obliqueMode.UpdateAvailability();
		}
		try 
		{
			graphicCanvas = Msn.Drawing.Graphic.CreateGraphic(map);	
			graphicCanvas.SetZIndex(17);	
		}
		catch(e)
		{
			//ShowMessage(e.message);
		}
	};
	
	// Returns the dashboard.  The dashboard may be null if the user did not request it.
	this.GetDashboard = function()
	{
		return dashboard;
	};
	
	// Deconstructor, detaches events and attempts to clean up memory references
	this.Destroy = function()
	{
		if (!p_htParams.fixedView)
		{
			p_elSource.detachEvent("onmousedown", MouseDown);
			p_elSource.detachEvent("onmouseup", MouseUp);
			p_elSource.detachEvent("onmousemove", MouseMove);
			p_elSource.detachEvent("onmousewheel", MouseWheel);
			p_elSource.detachEvent("ondblclick", MouseDoubleClick);
			p_elSource.detachEvent("oncontextmenu", ContextMenu);
			keyboard.detachEvent("onkeydown", KeyDown);
			keyboard.detachEvent("onkeyup", KeyUp);
			keyboard.detachEvent('onblur', StopKeyboardPan);
		}
		
		//Remove original tile layer
		if(currentTilesList != null)
		{
			ClearTiles(currentTilesList);
			currentTilesList = null;
		}

		//Remove traffic tile layer		
		this.RemoveTrafficLayer();
		
		while (pushpins.length)
		{
			pushpins.pop().Destroy();
		}
		
		pushpins = null;
		
		ClearLines();
		
		if (dashboard)
		{
			dashboard.Destroy();
			dashboard = null;
		}
		
		if (dashboardContainer)
		{
			dashboardContainer.detachEvent("onmousedown", IgnoreEvent);
			dashboardContainer.detachEvent("onmouseup", IgnoreEvent);
			dashboardContainer.detachEvent("onmousemove", IgnoreEvent);
			dashboardContainer.detachEvent("onmousewheel", IgnoreEvent);
			dashboardContainer.detachEvent("ondblclick", IgnoreEvent);
			dashboardContainer.detachEvent("oncontextmenu", IgnoreEvent);
			dashboardContainer.detachEvent("onkeydown", IgnoreEvent);
			dashboardContainer.detachEvent("onkeyup", IgnoreEvent);			
			p_elSource.removeChild(dashboardContainer);			
			dashboardContainer = null;
		}
		
		if (scaleBar)
		{
			DetachEvent("onendzoom", scaleBar.Update);
			DetachEvent("onendcontinuouspan", scaleBar.Update);
			DetachEvent("onresize", scaleBar.Reposition);
			scaleBar.Destroy();
			scaleBar = null;
		}
		
		if (logo)
		{
			logo.Destroy();
			logo = null;
		}
		
		if (copyright)
		{
			copyright.Destroy();
			copyright = null;
		}
		
		if (orthoMode)
		{
			orthoMode.Destroy();
			orthoMode = null;
		}
		
		if (obliqueMode)
		{
			obliqueMode.Destroy();
			obliqueMode = null;
		}
		
		if (boxTool)
		{
			boxTool.Destroy();
			boxTool = null;
		}
		
		if (panTool)
		{
			panTool.Destroy();
			panTool = null;
		}
		
		if(graphicCanvas)
		{
			graphicCanvas.Destroy();
		}
		
		// Clears out all the event handlers that have been attached to the map control.
		DestroyEventTable();
		
		p_elSource = p_this = null;
	};
	
	// Updates the position from the parent element
	function UpdateFromParent()
	{
		x = GetLeftPosition(p_elSource);
		y = GetTopPosition(p_elSource);
		width = p_elSource.offsetWidth;
		height = p_elSource.offsetHeight;
	}
	
	// Optionally, a developer can request the dashboard be created at the same time as the control.
	// The built in dashboard is no different than the developer creating the dashboard manually
	// outside of the control.
	function CreateDashboard(x, y, size, dashboardId)
	{
		if (!size)
		{
			size = Msn.VE.DashboardSize.Normal;
		}
		
		if(size == Msn.VE.DashboardSize.Tiny)
		{
			size = Msn.VE.DashboardSize.Small;
		}
		
		dashboardContainer = document.createElement("div");
		if ((dashboardId == null) || (typeof(dashboardId)=="undefined"))
		{
			dashboardId = "dashboard";
		}
		dashboardContainer.id = dashboardId;
		p_elSource.appendChild(dashboardContainer);		

		dashboardContainer.className = "Dashboard Dashboard_" + size;		
		dashboardContainer.style.top = y + "px";
		dashboardContainer.style.left = x + "px";
		
		// The base dashboard element itself needs to capture and ignore all mouse and key events.
		// Otherwise, they will bubble up to the map control and adjust the map.
		// We don't want a double click on the dashboard to accidentally zoom in the map view.
		
		dashboardContainer.attachEvent("onmousedown", IgnoreEvent);
		dashboardContainer.attachEvent("onmouseup", IgnoreEvent);
		dashboardContainer.attachEvent("onmousemove", IgnoreEvent);
		dashboardContainer.attachEvent("onmousewheel", IgnoreEvent);
		dashboardContainer.attachEvent("ondblclick", IgnoreEvent);
		dashboardContainer.attachEvent("oncontextmenu", IgnoreEvent);
		dashboardContainer.attachEvent("onkeydown", IgnoreEvent);
		dashboardContainer.attachEvent("onkeyup", IgnoreEvent);
		
		dashboard = new Msn.VE.Dashboard(dashboardContainer, p_this, size);
		dashboard.Init();
	}
	
	// Sets the default view and captures it as the preferred zoom.  The default view
	// is an overview of the whole world centered at lat/long 0, 0 with the road style.
	function SetDefaultView()
	{
		var view = new Msn.VE.MapView();
		view.SetCenterLatLong(new Msn.VE.LatLong(0.0, 0.0));
		view.SetZoomLevel(1);
		view.SetMapStyle(roadStyle);
		SetView(view);
	}

	// Set the center point of the map.
	// This will ultimately clear all tiles and start a new set.
	// If you want a smooth transition, you should call PanMap or ContinuousPan
	function SetCenter(latitude, longitude)
	{
		var view = preferredView.MakeCopy();
		view.SetCenterLatLong(new Msn.VE.LatLong(latitude, longitude));
		SetView(view);
	}

	// Sets the map style
	// This will ultimately clear all the tiles and start a new set.
	function SetMapStyle(mapStyle, sceneId, sceneOrientation)
	{
		// Note, this is one of the few methods that uses currentView instead of preferredView
		var view = currentView.MakeCopy();
		view.SetMapStyle(ValidateMapStyle(mapStyle), sceneId, sceneOrientation);
		
		// If we're changing map styles between ortho and oblique
		// then we need to preserve the zoom level
		if (currentView.mapStyle != mapStyle)
		{
			if (mapStyle == obliqueStyle)
			{
				view.SetZoomLevel(1);					
				lastOrthoZoomLevel = currentView.zoomLevel;
				lastOrthoMapStyle = currentView.mapStyle;
			}
			else if (currentView.mapStyle == obliqueStyle)
			{
				view.SetZoomLevel(lastOrthoZoomLevel);
			}
		}
		
		view.latlong.latitude=currentView.latlong.latitude;
		view.latlong.longitude=currentView.latlong.longitude;	
			
		SetView(view);
	}

	// Validates a map style.
	// Accepts aerial, otherwise converts to vector.
	function ValidateMapStyle(mapStyle)
	{
		if (mapStyle == aerialStyle || mapStyle == hybridStyle || mapStyle == obliqueStyle)
		{
			return mapStyle;
		}
		else
		{
			return roadStyle;
		}
	}

	// Returns the center latitude
	function GetCenterLatitude()
	{
		if ((currentView != null) && (currentView != "undefined") && 
			(currentView.latlong != null) && (currentView.latlong != "undefined") &&
			(currentView.latlong.latitude != null) && (currentView.latlong.latitude != "undefined"))
		{
			return currentView.latlong.latitude;
		}
		return null;
	}

	// Returns the center longitude
	function GetCenterLongitude()
	{
		if ((currentView != null) && (currentView != "undefined") && 
			(currentView.latlong != null) && (currentView.latlong != "undefined") &&
			(currentView.latlong.longitude != null) && (currentView.latlong.longitude != "undefined"))
		{
			return currentView.latlong.longitude;
		}
		return null;
	}
	
	// Computes the center point
	function ComputeCenterPoint(capture)
	{
		currentView.latlong = currentMode.PixelToLatLong(currentView.center, currentView.zoomLevel);
		
		if (capture)
		{
			preferredView.Copy(currentView);
		}
	
		// Update oblique availability
		if (obliqueMode)
		{
			obliqueMode.UpdateAvailability();
		}
	}

	// Returns the latitude at a y-coordinate on the display
	function GetLatitude(y)
	{
		var pixel = new Msn.VE.Pixel(originX + offsetX + width/2, originY + offsetY + y);
		var latlong = currentMode.PixelToLatLong(pixel, currentView.zoomLevel);
		if (!latlong)
		{
			return null;
		}
		
		return latlong.latitude;
	}

	// Returns the longitude at an x-coordinate on the display
	function GetLongitude(x)
	{
		var pixel = new Msn.VE.Pixel(originX + offsetX + x, originY + offsetY + height/2);
		var latlong = currentMode.PixelToLatLong(pixel, currentView.zoomLevel);
		if (!latlong)
		{
			return null;
		}
		
		return latlong.longitude;
	}

	// Returns the y-coordinate for a latitude
	function GetY(latitude)
	{
		var latlong = new Msn.VE.LatLong(latitude, currentView.center.longitude);
		var pixel = currentMode.LatLongToPixel(latlong, currentView.zoomLevel);
		if (!pixel)
		{
			return null;
		}
		
		return MathRound(pixel.y - originY - offsetY);
	}

	// Returns the x-coordinate for a longitude
	function GetX(longitude)
	{
		var latlong = new Msn.VE.LatLong(currentView.center.latitude, longitude);
		var pixel = currentMode.LatLongToPixel(latlong, currentView.zoomLevel);
		if (!pixel)
		{
			return null;
		}
		
		return MathRound(pixel.x - originX - offsetX);
	}
	
	// Returns the pixel location of the requested latlong
	function LatLongToPixel(latlong)
	{
		var pixel = currentMode.LatLongToPixel(latlong, currentView.zoomLevel);
		pixel.x -= originX + offsetX;
		pixel.y -= originY + offsetY;
		return pixel;
	}
	
	// Returns the pixel location of the requested latlong
	function PixelToLatLong(pixel)
	{
		var adjPixel = new Msn.VE.Pixel(pixel.x + originX + offsetX, pixel.y + originY + offsetY);
		var latlong = currentMode.PixelToLatLong(adjPixel, currentView.zoomLevel);
		return latlong;
	}

	// Returns the current zoom level
	function GetZoomLevel()
	{
		return currentView.zoomLevel;
	}

	// Returns the current map style
	function GetMapStyle()
	{
		return currentView.mapStyle;
	}

	// Returns the approximate meters per pixel at a latitude and zoom level
	// Both parameters are optional, and will default to the current settings if omitted.
	function GetMetersPerPixel(latitude, zoomLevel)
	{
		if (!latitude)
		{
			latitude = currentView.latlong.latitude;
		}
		
		if (!zoomLevel)
		{
			zoomLevel = currentView.zoomLevel;
		}
		
		return Math.cos(DegToRad(latitude)) * currentMode.MetersPerPixel(zoomLevel);
	}

	// Resize the control.
	function Resize(w, h)
	{
		/*	If w and/or h passed into this function are valid, they will be honored.
				However, if w and/or h are null or invalid, they will default to '100%'				
		*/
			
		var width, height;
		
		if (!w || w <= 0)
			{ width = '100%'; }
		else
			{ width = w + 'px'; }
			 
		if (!h || h <= 0)
			{ height = '100%'; }
		else
			{ height = h + 'px'; }

		p_elSource.style.width = width;
		p_elSource.style.height = height;
		
		UpdateFromParent();
		PanToView(currentView);	
				
		copyright.Reposition();
		scaleBar.Reposition();
		if(logo)
		{
			logo.Reposition();
		}
		Fire("onresize");
	}
	
	// Tests for oblique availability.
	function IsObliqueAvailable()
	{
		return obliqueMode ? obliqueMode.IsAvailable() : false;
	}
	
	// Gets the oblique scene
	function GetObliqueScene()
	{
		return obliqueMode ? obliqueMode.GetScene() : null;
	}
	
	// Turns on or off animated zoom and pan
	function SetAnimationEnabled(enabled)
	{
		animatedMovementEnabled = enabled;
	}
	
	// Checks whether or not animation is enabled
	function IsAnimationEnabled()
	{
		return animatedMovementEnabled;
	}
	
	// Sets the oblique scene
	function SetObliqueScene(id)
	{
		if (obliqueMode)
		{
			SetMapStyle(obliqueStyle, id, null);
		}
	}
	
	// Sets the oblique orientation
	function SetObliqueOrientation(orientation)
	{
		if (obliqueMode)
		{
			SetMapStyle(obliqueStyle, null, orientation);
		}
	}
	
	// Sets the debug status for the control.  When in debug mode, 
	// the map displays filenames over the tiles
	function Debug(d)
	{
		debug = d;
		
		for (var i=0; i<currentTilesList.length; i++)
		{
			currentTilesList[i].Debug(d);
		}
	}
	
	function SetCopyrightOffset(xOffset, yOffset)
	{
		copyright.SetOffset(xOffset, yOffset);
		scaleBar.SetOffset(xOffset, yOffset);
	}
	
	function SetFocus()
	{
		keyboard.focus();
	}
	
	function StopKeyboardPan()
	{
		if (panning && keyboardPan)
		{
			StopContinuousPan();
		}		
	}

//------------------------------------------------------------------------------
// MapControl/Bounds.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, keithkin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// Clips a view
function ClipView(view, bounds)
{
	ShiftView(view, bounds, 0, 0);
}
	
// Shifts the view over by a delta.  Clips the resulting view.
function ShiftView(view, bounds, deltaX, deltaY)
{
	//If the bounds are not set, do nothing
	if ((bounds != null) && (bounds != "undefined"))
	{
		deltaX = ClipDelta(deltaX, width, view.center.x - width/2, view.zoomLevel, bounds.z1, bounds.x1, bounds.x2);
		deltaY = ClipDelta(deltaY, height, view.center.y - height/2, view.zoomLevel, bounds.z1, bounds.y1, bounds.y2);
		view.SetCenter(new Msn.VE.Pixel(view.center.x + deltaX, view.center.y + deltaY));
	}
}

// Clips a delta value
function ClipDelta(delta, size, offset, zoomLevel, boundsZoom, boundsMin, boundsMax)
{
	var min = tileSize * boundsMin * Math.pow(2, zoomLevel - boundsZoom);
	var max = tileSize * boundsMax * Math.pow(2, zoomLevel - boundsZoom);
	
	if (size > (max - min))
	{
		return ((max - min - size) / 2) - offset + min;
	}
	else if (offset + delta < min)
	{
		return min - offset;
	}
	else if (offset + size + delta > max)
	{
		return max - offset - size;
	}
	
	return delta;
}
//------------------------------------------------------------------------------
// MapControl/Copyright.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, sstchur, keithkin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

//VECopyrightTableEntry
//   An entry for the copyright table
//   MinZoomLevel
//   MaxZoomLevel
//   MinLatitude
//   MinLongitude
//   MaxLatitude
//   MaxLongitude
//
//   IsMatch(zoomLevel, latitude, longitude)
//      returns true if the passed in values match within the bounds of the entry
function VECopyrightTableEntry(minZoomLevel, maxZoomLevel, minLat, minLon, maxLat, maxLon)
{
	this.MinZoomLevel = minZoomLevel;
	this.MaxZoomLevel = maxZoomLevel;
	this.MinLatitude = minLat;
	this.MinLongitude = minLon;
	this.MaxLatitude = maxLat;
	this.MaxLongitude = maxLon;
}

VECopyrightTableEntry.prototype.IsMatch = function(zoomLevel, latitude, longitude)
	{
		var isMatch = false;
		if  ( ((zoomLevel >= this.MinZoomLevel) && (zoomLevel <= this.MaxZoomLevel))
				&&
				((latitude >= this.MinLatitude) && (latitude <= this.MaxLatitude))
				&&
				((longitude >= this.MinLongitude) && (longitude <= this.MaxLongitude))
			)
		{
			isMatch = true;
		}
		return isMatch;
	}


//VECopyrightTable
//   Add(veCopyrightTableEntry)
//      Adds VECopyrightTableEntry to the table
//   CreditsForView(view)
//      returns an array of copyright credits for the passed in view
//   CreditsFor(mapStyle, zoomLevel, latitude, longitude)
//      returns an array of copyright credits for the passed in parameters
function VECopyrightTable()
{
	//Create copyright keys for table entries. Each key is a unique copyright credit.
	//The keys are associated with the styles they can apply to.
	//Each time you add a new copyright credit, you need to add it to proper key table
	//for the styles it can apply to.
	var m_tableKeys = new Array();
	m_tableKeys[Msn.VE.MapStyle.Oblique] = [ L_MapControlImageCourtesyOfPictometry_Text ];
	m_tableKeys[Msn.VE.MapStyle.Road] =    [ L_MapControlNavteq_Text, L_MapControlImageCourtesyOfAND_Text ];
	m_tableKeys[Msn.VE.MapStyle.Aerial] =  [ L_MapControlImageCourtesyOfNASA_Text, L_MapControlHarrisCorp_Text, L_MapControlImageCourtesyOfUSGS_Text, L_MapControlImageCourtesyOfEarthData_Text, L_MapControlImageCourtesyOfGetmapping_Text ];
	
	//Create the hierarchical table structure - instantiate array objects so table can be populated.
	//When new map styles are added, or new copyright credits are added, this needs to be updated.
	var m_table = new Array();
	m_table[Msn.VE.MapStyle.Oblique] = new Array();
	m_table[Msn.VE.MapStyle.Oblique][L_MapControlImageCourtesyOfPictometry_Text] = new Array();
	m_table[Msn.VE.MapStyle.Road] = new Array();
	m_table[Msn.VE.MapStyle.Road][L_MapControlNavteq_Text] = new Array();
	m_table[Msn.VE.MapStyle.Road][L_MapControlImageCourtesyOfAND_Text] = new Array();
	m_table[Msn.VE.MapStyle.Aerial] = new Array();
	m_table[Msn.VE.MapStyle.Aerial][L_MapControlImageCourtesyOfNASA_Text] = new Array();
	m_table[Msn.VE.MapStyle.Aerial][L_MapControlHarrisCorp_Text] = new Array();
	m_table[Msn.VE.MapStyle.Aerial][L_MapControlImageCourtesyOfUSGS_Text] = new Array();
	m_table[Msn.VE.MapStyle.Aerial][L_MapControlImageCourtesyOfEarthData_Text] = new Array();
	m_table[Msn.VE.MapStyle.Aerial][L_MapControlImageCourtesyOfGetmapping_Text] = new Array();
	
	//Populate the copyright table.
	//The table is hierarchical in nature to improve performance so we do not need to linearly search through the
	//entire table each time. The first level is the map style. The second level is the Copyright Credit.
	//The leaf nodes are all VECopyrightTableEntries.
	//
    //      Map Style                Credit                                                                        MinZ   MaxZ  MinLat   MinLon  MaxLat  MaxLon 
	m_table[Msn.VE.MapStyle.Oblique][L_MapControlImageCourtesyOfPictometry_Text].push( new VECopyrightTableEntry(    1,    20,    24,    -125,    49,    -66 ) );
	m_table[Msn.VE.MapStyle.Road   ][L_MapControlNavteq_Text                   ].push( new VECopyrightTableEntry(    1,     9,   -90,    -180,    90,     180) );
	m_table[Msn.VE.MapStyle.Road   ][L_MapControlNavteq_Text                   ].push( new VECopyrightTableEntry(   10,    19,    16,    -180,    90,     -50) );
	m_table[Msn.VE.MapStyle.Road   ][L_MapControlNavteq_Text                   ].push( new VECopyrightTableEntry(   10,    19,    27,     -32,    40,     -13) );
	m_table[Msn.VE.MapStyle.Road   ][L_MapControlNavteq_Text                   ].push( new VECopyrightTableEntry(   10,    19,    35,     -11,    72,      20) );
	m_table[Msn.VE.MapStyle.Road   ][L_MapControlNavteq_Text                   ].push( new VECopyrightTableEntry(   10,    19,    21,      20,    72,      32) );
	m_table[Msn.VE.MapStyle.Road   ][L_MapControlImageCourtesyOfAND_Text       ].push( new VECopyrightTableEntry(   10,    19,   -90,    -180,    90,     180) );
	m_table[Msn.VE.MapStyle.Aerial ][L_MapControlImageCourtesyOfNASA_Text      ].push( new VECopyrightTableEntry(    1,     8,   -90,    -180,    90,     180) );
	m_table[Msn.VE.MapStyle.Aerial ][L_MapControlHarrisCorp_Text               ].push( new VECopyrightTableEntry(    9,    13,   -90,    -180,    90,     180) );
	m_table[Msn.VE.MapStyle.Aerial ][L_MapControlImageCourtesyOfUSGS_Text      ].push( new VECopyrightTableEntry(   14,    19, 17.99, -150.11, 61.39,  -65.57) );
	m_table[Msn.VE.MapStyle.Aerial ][L_MapControlImageCourtesyOfEarthData_Text ].push( new VECopyrightTableEntry(   14,    19, 21.25, -158.30, 21.72, -157.64) );
	m_table[Msn.VE.MapStyle.Aerial ][L_MapControlImageCourtesyOfEarthData_Text ].push( new VECopyrightTableEntry(   14,    19, 39.99,  -80.53, 40.87,  -79.43) );
	m_table[Msn.VE.MapStyle.Aerial ][L_MapControlImageCourtesyOfEarthData_Text ].push( new VECopyrightTableEntry(   14,    19, 34.86,  -90.27, 35.39,  -89.60) );
	m_table[Msn.VE.MapStyle.Aerial ][L_MapControlImageCourtesyOfGetmapping_Text].push( new VECopyrightTableEntry(   14,    19, 49.94,   -6.35, 58.71,    1.78) );

	//   CreditsFor(mapStyle, zoomLevel, latitude, longitude)
	//      returns an array of copyright credits for the passed in parameters
	this.CreditsFor=function(mapStyle, zoomLevel, latitude, longitude)
	{
		var credits = new Array();
		//Make sure the map style is in the table
		if ( (mapStyle != "undefined") && (mapStyle != null)  && 
			 (typeof(m_tableKeys[mapStyle]) != "undefined") && (m_tableKeys[mapStyle] != null) )
		{
			//Iterate through the copyright keys for this style
			var numKeys = m_tableKeys[mapStyle].length;
			for (var k=0; k < numKeys; ++k)
			{
				//Iterate through the table entries for this copyright key
				var key = m_tableKeys[mapStyle][k];
				var keyArray = m_table[mapStyle][key];
				var numEntries = keyArray.length;
				for (var i=0; i < numEntries; ++i)
				{
					//If this key is a match, put it in the credits and
					//break out of the loop for performance reasons since we already know this key is a match
					if (keyArray[i].IsMatch(zoomLevel, latitude, longitude))
					{
						credits.push(key);
						break;
					}
				}
			}
		}
		
		return credits;
	}

	//   CreditsForView(view)
	//      returns an array of copyright credits for the passed in view
	this.CreditsForView = function(view)
	{
		var copyrightCredits = new Array();
		copyrightCredits.push(L_MapCopyrightMicrosoft);
		
		if (view.mapStyle == Msn.VE.MapStyle.Hybrid)
		{
			//For Hybrid, get the credits for both Road and Aerial
			copyrightCredits = copyrightCredits.concat(this.CreditsFor(Msn.VE.MapStyle.Road, view.zoomLevel, view.latlong.latitude, view.latlong.longitude));
			copyrightCredits = copyrightCredits.concat(this.CreditsFor(Msn.VE.MapStyle.Aerial, view.zoomLevel, view.latlong.latitude, view.latlong.longitude));
		}
		else
		{
			copyrightCredits = copyrightCredits.concat(this.CreditsFor(view.mapStyle, view.zoomLevel, view.latlong.latitude, view.latlong.longitude));
		}
		
		return copyrightCredits;
	}
}

//Static global CopyrightTable
var g_sVECopyrightTable = new VECopyrightTable();

function Copyright(parent)
{
	var bg = document.createElement("div");
	var fg = document.createElement("div");
	var copyrightHeight = 13;
	
	// x offset from right border
	var xOffset = 0;

	// y offset from bottom border
	var yOffset = 0;

	// Create the copyright elements
	this.Init = function()
	{
		//bg.unselectable = "on";
		bg.className = "Copyright CopyrightBackground";
		
		//fg.unselectable = "on";
		fg.className = "Copyright CopyrightForeground";
		
		Reposition();
		parent.appendChild(bg);
		parent.appendChild(fg);
	};
	
	this.Destroy = function()
	{
		parent.removeChild(bg);
		parent.removeChild(fg);
		bg = fg = null;
	};

	// Reposition the copyright
	function Reposition()
	{
		// minus border related offset, copyright offset, and possibly offset to center copyright between
		// the top of footer and the bottom of scale bar.
		bg.style.top = (height - copyrightHeight - 3 - yOffset - (copyrightHeight <= 13 ? 4 : 0)) + "px";

		bg.style.height = copyrightHeight + "px";
		bg.style.right = '9px';
		bg.style.display = "block";
		
		fg.style.top = (height - copyrightHeight - 3 - 1 - yOffset - (copyrightHeight <= 13 ? 4 : 0)) + "px";
		fg.style.height = copyrightHeight + "px";
		fg.style.right = '10px';
		fg.style.display = "block";
	
		
	}

	// Update the contents of the copyright for the content in view
	function Update()
	{
		var credits = g_sVECopyrightTable.CreditsForView(currentView);

		//Currently we go to the next line if there are 2 copyrights already listed.
		//Note: this assumes the copyrights fit on 2 lines and do not wrap 300px. 
		//With the current table this works. However, if we start showing more copyrights, 
		//we will need to adjust the height/width of the copyright on the map control and the scalebar.

		var copyrightString = "";
		for (var i=0; i < credits.length; ++i)
		{
			if (i > 0)
			{
				if (i== 2)
				{
					copyrightString += "<br/>";
				}
				else
				{
					copyrightString += "&nbsp;&nbsp;";
				}
			}
			copyrightString += credits[i];
		}
		
		if (credits.length <= 2)
		{
			copyrightHeight = 13;
		}
		else
		{
			copyrightHeight = 21;
		}
		
		bg.innerHTML = copyrightString;
		fg.innerHTML = copyrightString;
		Reposition();
	}
	
	function SetOffset(_xOffset, _yOffset)
	{
		xOffset = _xOffset;
		yOffset = _yOffset;
		Reposition();
	}
	
	this.Reposition = Reposition;
	this.Update = Update;
	this.SetOffset = SetOffset;
}
//------------------------------------------------------------------------------
// MapControl/Events.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, keithkin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// Creates a new map control event
function MapEvent(view, oblique, error)
{
	this.view = view;
	this.oblique = oblique;
	this.error = error;
}

// Creates a new map control event based on the current map settings.
function CreateEvent(latlong, zoomLevel, error)
{
	var view = currentView.MakeCopy();
	
	if (latlong != undefined)
	{
		//If running in API mode, use a VELatLong in the event
		if (Msn.VE.API != null)
		{
			//Instantiate a VELatLongFactory from a specification created from the MapView.
			//Generate a VELatLong that may be encoded if the current map mode is oblique.
			//Use the capital LatLong property notation to be consistent with API
			var veLatLongFactory = new VELatLongFactory(new VELatLongFactorySpecFromMapView(view));
			view.LatLong = veLatLongFactory.CreateVELatLong(latlong.latitude, latlong.longitude);
		}
		else
		{
			view.latlong = latlong;
		}
	}
	
	if (zoomLevel != undefined)
	{
		view.zoomLevel = zoomLevel;
	}
	
	if (error == undefined)
	{
		error = "";
	}
	
	var oblique = null;
	if (obliqueMode)
	{
		oblique = obliqueMode.GetEventInfo();
	}
	
	return new MapEvent(view, oblique, error);
}

// Attaches an event handler to an event
function AttachEvent(name, callback)
{
	var eventList = eventTable[name];
	
	if (!eventList)
	{
		eventList = new Array();
		eventTable[name] = eventList;
	}
	
	for (var i=0; i<eventList.length; i++)
	{
		if (eventList[i] == callback)
		{
			return true;
		}
	}
	
	eventList.push(callback);
}

// Detaches an event handler to an event
function DetachEvent(name, callback)
{
	var eventList = eventTable[name];
	
	if (!eventList)
	{
		return;
	}
	
	for (var i=0; i<eventList.length; i++)
	{
		if (eventList[i] == callback)
		{
			eventList.splice(i, 1);
		}
	}
}

// Fires an event
function Fire(name, args)
{
	var eventList = eventTable[name];
	
	if (!eventList)
	{
		return;
	}
	
	if (!args)
	{
		args = CreateEvent();
	}
	
	for (var i=0; i<eventList.length; i++)
	{
		eventList[i](args);
	}
}

// Destroys the event handler table.  This is key for releasing a lot of memory.
function DestroyEventTable()
{
	while (eventTable.length)
	{
		var eventList = eventTable.pop();
		while (eventList.length)
		{
			eventList.pop();
		}
		eventList = null;
	}
	
	eventTable = null;
}
//------------------------------------------------------------------------------
// MapControl/Keyboard.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


// Handles key down events for panning and zooming.
function KeyDown(e)
{
	e = GetEvent(e);
	
	var s = keyboardPanSpeed;
	var x = panningX;
	var y = panningY;
	
	switch (e.keyCode)
	{
		case 9: // tab
		case 18: // alt
			// we want to stop keyboard panning if focus is moving away from the map control.
			if (panning && keyboardPan)
			{
				StopContinuousPan();
			}
			return true;
			
		case 37: // left
			x = -s;
			break;
			
		case 38: // up
			y = -s;
			break;
			
		case 39: // right
			x = s;
			break;
			
		case 40: // down
			y = s;
			break;
			
		case 107: // + (numpad)
		case 187: // + (IE)
		case 61: // '=' (FF)
		case 43: // '+' (FF)
			x = 0;
			y = 0;
			ZoomIn();
			break;
			
		case 109: // - (numpad)
		case 189: // -
			x = 0;
			y = 0;
			ZoomOut();
			break;
			
		case 65: // a (aerial)
			x = 0;
			y = 0;
			SetMapStyle(aerialStyle);
			break;
			
		case 72: // h (hybrid)
			x = 0;
			y = 0;
			SetMapStyle(hybridStyle);
			break;
			
		case 82: // r (road)
		case 86: // v (vector)
			x = 0;
			y = 0;
			SetMapStyle(roadStyle);
			break;
		
		case 66: // b (bird's eye)
		case 79: // o (oblique)
			//if (obliqueMode && obliqueMode.IsAvailable())
			//{
				x = 0;
				y = 0;
				SetMapStyle(obliqueStyle);
			//}
			break;
			
		default:
			return false;
	}
	
	if (x || y)
	{
		ContinuousPan(x, y, null, true);
	}
	
	return false;
}

// Handles key up events
function KeyUp(e)
{
	e = GetEvent(e);

	var x = panningX;
	var y = panningY;
	
	switch (e.keyCode)
	{
		case 37: // left
			x = 0;
			break;
			
		case 38: // up
			y = 0;
			break;
			
		case 39: // right
			x = 0;
			break;
			
		case 40: // down
			y = 0;
			break;
			
		default:
			return false;
	}

	ContinuousPan(x, y, null, true);
	return false;
}
//------------------------------------------------------------------------------
// MapControl/Line.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, EShinn
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------
	
// Boundaries of the clipping region or lines.	
var northLatitude = 0;
var southLatitude = 0;
var westLongitude = 0;
var eastLongitude = 0;


// Add a line to the map
function AddLine(id, lats, lons, weight, color, zIndex, lineRegions, zoomLevelsForGeneralizedLines)
{
	// If they aren't providing all the necessary data, don't provide them anything back.
	if (id == null || lats == null || lons == null || 
		lineRegions == null || zoomLevelsForGeneralizedLines == null)
	{
		return null;
	}
	
	// Build the binary tree representations of all the lines.
	var regionHeap = new Array();
	for (var i = 0; i < lineRegions.length; i++)
	{
		regionHeap.push(BuildRegionHeap(lineRegions[i], 0, lineRegions[i].length - 1));
	}

	// Create the line.
	var line = new Line();
	line.Init(id, lats, lons, weight, color, zIndex, regionHeap, zoomLevelsForGeneralizedLines);
	lines.push(line);
	return line;
}

// Removes a specific line.
function RemoveLine(id)
{
	for (var i=0; i<lines.length; i++)
	{
		var line = lines[i];
		if(line.id == id)
		{
			lines.splice(i, 1);
			line.Destroy();
			return;
		}
	}
}

// Clears all lines from the map
function ClearLines()
{
	while(lines.length > 0)
		lines.pop().Destroy();
}

// Show all the lines and reposition them
function ShowLines()
{
	for(var i=0; i<lines.length; i++)
	{
		lines[i].StartLine();
		lines[i].Show();
	}
}

// Hide all of the lines
function HideLines()
{
	for(var i=0; i<lines.length; i++)
	{
		lines[i].Hide();
	}
}

// Updates all of the lines.
function UpdateLines()
{
	for(var i=0; i<lines.length; i++)
	{
		lines[i].UpdateLine();
	}
}

// Builds the regions between the start & end index into heap of regions
// This speeds up the search operations for clipping significantly.
function BuildRegionHeap(regions, startIndex, endIndex)
{
	var numberOfRegions = endIndex - startIndex + 1;
	
	if (numberOfRegions < 1)
	{
		// If we have no regions, there is no combined representation for it.
		return null;
	}
	else if (numberOfRegions == 1)
	{
		// If there's only one, the region passed in is the canonical representation.
		return regions[startIndex];
	}
	
	var leftRegion = null;
	var rightRegion = null;
	if (numberOfRegions == 2)
	{
		// If there are only two, use them
		leftRegion = regions[startIndex];
		rightRegion = regions[endIndex];
		
	}
	else
	{
		// Otherwise use the combined results of the two halves of the range.
		var i = Math.round((startIndex + endIndex) / 2);
		leftRegion = BuildRegionHeap(regions, startIndex, i);
		rightRegion = BuildRegionHeap(regions, i + 1, endIndex);
	}
	
	if (leftRegion != null && rightRegion != null)
	{
		// If we have two different regions, use them both.
		var left = leftRegion.boundingRectangle;
		var right = rightRegion.boundingRectangle;
		
		// Combine the bounding rectangles.
		var northLatitude = left[0].latitude > right[0].latitude ? left[0].latitude : right[0].latitude;
		var eastLongitude = left[0].longitude > right[0].longitude ? left[0].longitude : right[0].longitude;
		var southLatitude = left[1].latitude < right[1].latitude ? left[1].latitude : right[1].latitude;
		var westLongitude = left[1].longitude < right[1].longitude ? left[1].longitude : right[1].longitude;

		var combinedBoundingRectangle = [new Msn.VE.LatLong(northLatitude, eastLongitude), new Msn.VE.LatLong(southLatitude, westLongitude)];

		// Return the region that represents the left & right halves.
		return new Msn.VE.LineRegion(combinedBoundingRectangle, null, [leftRegion, rightRegion]);
	}
	else if (leftRegion != null)
	{
		// Otherwise, just return the left half.
		return leftRegion;
	}
	else if (rightRegion != null)
	{
		// Otherwise, just return the left right half.
		return rightRegion;
	}
	
	// Although this is unlikely, we should still return null.
	return null;
}


// The line class is a container for a map line.  It maintains
// a line's start and end lat/long location.
function Line()
{
	var defaultLineWeight = 5;
	var defaultLineColor = new Msn.Drawing.Color(0,169,235,0.7);//"#00A9EB";
	
	var routeStroke = new Msn.Drawing.Stroke();
	var defaultLineZIndex = 4;

	var element = null;
	var elementId = "";
	
	var visible = true;
	
	var strokeweight = "";
	var strokecolor = "";
	var zIndex = 0;
	
	var startLatitude = 0;
	var startLongitude = 0;
	var endLatitude = 0;
	var endLongitude = 0;
	
	var latitudes = null;
	var longitudes = null;
	var lineRegions = null;
	var zoomLevelsForGeneralizedLines = null;
	
	var startIndex = 0;
	var endIndex = 0;
	
	var lastRedrawView = null;

	// Initializes a line object.
	function Init(id, lats, lons, weight, color, zIdx, lRegions, zLevels)
	{
		// Assign defaults if no number is provided.
		if (!weight)
		{
			weight = defaultLineWeight;
		}
		if (!color)
		{
			color = defaultLineColor;
		}
		if (!zIdx)
		{
			zIdx = defaultZIndex;
		}
		
		this.id = id;
		elementId = id;
		
		strokeweight = weight + "pt";
		strokecolor = color;
		zIndex = zIdx;
		
		latitudes = lats;
		longitudes = lons;
		zoomLevelsForGeneralizedLines =  zLevels;
		lineRegions = lRegions;
		
		startLatitude = latitudes[0];
		startLongitude = longitudes[0];
		
		endLatitude = latitudes[latitudes.length - 1];
		endLongitude = longitudes[longitudes.length - 1];

		// Capture the current view.
		lastRedrawView = currentView.MakeCopy();
		routeStroke.color = defaultLineColor;
		routeStroke.width = weight;
		StartLine();
	};
	
	// Perform clean-up before exit.
	function Destroy()
	{
		RemoveFromMap();
	
		latitudes = longitudes = lineRegions = element = lastRedrawView = null;
	};

	// Removes this line from the control's map element.
	function RemoveFromMap()
	{
		graphicCanvas.Clear();
	}

	// Shows this line.
	function Show()
	{
		// If this line is not supposed to be visible, hide it (just in case)
		if (!visible)
		{
			Hide();
			return;
		}
		
		if (element)
		{
			element.style.display = "block";
		}
	};
	
	// Hides this line.
	function Hide() 
	{
		if (element)
		{
			element.style.display = "none";
		}
	};
	
	// Changes the visibility of the line.
	function ChangeVisibility(newVisibility)
	{
		visible = newVisibility;
		
		// If this is no longer visible, immediately hide it.
		// (Note: the reverse is not necessarily true because the map control may have all lines hidden at this time
		// while it performs an operation like zoom.)
		if (!visible)
		{
			Hide();
		}
	}	

	// Creates the line.
	function StartLine()
	{
		ComputeBoundaries();
		BuildLine();
		lastRedrawView.Copy(currentView);
	}
	
	// Updates the line
	function UpdateLine()
	{
		// Only redraw if the viewport has changed 25% in any direction.
		if (currentView.zoomLevel == lastRedrawView.zoomLevel && 
			MathAbs((currentView.center.x - lastRedrawView.center.x) / width) < 0.25 && 
			MathAbs((currentView.center.y - lastRedrawView.center.y) / height) < 0.25)
		{
			return;
		}
				
		ComputeBoundaries();
		BuildLine();
		lastRedrawView = currentView.MakeCopy();;
	}

	// This really should be at the map level
	function ComputeBoundaries()
	{
		// Maintain a minimum buffer size so we don't lose lines to clipping if the map is too small.
		var bufferHeight = height < 900 ? 900 : height;
		var bufferWidth = width < 900 ? 900 : width;
	
		northLatitude = GetLatitude(-0.5 * bufferHeight);
		southLatitude = GetLatitude(1.5 * bufferHeight);
		westLongitude = GetLongitude(-0.5 * bufferWidth);
		eastLongitude = GetLongitude(1.5 * bufferWidth);		
	}

	// Builds & displays the line for the current viewport.
	function BuildLine()
	{
		// Don't draw lines in oblique mode - there are issues that need to get worked out.
		if (currentView.mapStyle == obliqueStyle)
		{
			graphicCanvas.Clear();
			return;
		}
	
		var points = new Array();
				
		// Find the lowest detail generalized line that is acceptable for this zoom level.
		var generalizedLineIndex = zoomLevelsForGeneralizedLines.length - 1;		
		while (zoomLevelsForGeneralizedLines[generalizedLineIndex] < currentView.zoomLevel && generalizedLineIndex >= 0)
		{
			generalizedLineIndex--;
		}
		GetVisiblePointsFromRegion(lineRegions[generalizedLineIndex], points);		
		SetPolyline(points);
	}	
	
	// Extracts the visible points from the region.
	function GetVisiblePointsFromRegion(region, points)
	{
		// Trivially reject if the bounding rectangle lies entirely outside the viewport + buffer.
		if (RectangleDoesNotOverlapViewport(region.boundingRectangle[0], region.boundingRectangle[1]))
		{
			return;
		}
		
		if (region.childRegions != null)
		{
			// This is not a leaf region, call this method on all the child regions.
			for (var i = 0; i < region.childRegions.length; i++)
			{
				GetVisiblePointsFromRegion(region.childRegions[i], points);
			}
		}
		else
		{
			// This is a leaf region - draw using the points in this region.
			var indices = region.indices;

			var firstPoint = new Msn.VE.LatLong(latitudes[indices[0]], longitudes[indices[0]]);
			var secondPoint;
			var inVisibleSegment = false;
			
			// If the first point is visible, we need to add it in.
			if (IsVisible(firstPoint.latitude, firstPoint.longitude))
			{
				var firstPixel = currentMode.LatLongToPixel(firstPoint, currentView.zoomLevel);				
				points.push(new Msn.Drawing.Point(firstPixel.x  - originX,
															   firstPixel.y - originY));
				inVisibleSegment = true;					
			}
			
			// Go through all of the other points in the region.
			for (var pointIndex = 1; pointIndex < indices.length; pointIndex++)
			{
				secondPoint = new Msn.VE.LatLong(latitudes[indices[pointIndex]], longitudes[indices[pointIndex]]);
				if (IsVisible(secondPoint.latitude, secondPoint.longitude))
				{
					// If we are at the start of a visible segment, add the starting point.
					if (!inVisibleSegment)
					{
						var firstPixel = currentMode.LatLongToPixel(firstPoint, currentView.zoomLevel);						
						points.push(new Msn.Drawing.Point(firstPixel.x - originX,
															   firstPixel.y  - originY));
					}

					// We are now in a visible segment.					
					inVisibleSegment = true;
					
					// If we have a visible segment, add it in.
					var secondPixel = currentMode.LatLongToPixel(secondPoint, currentView.zoomLevel);
					points.push(new Msn.Drawing.Point(secondPixel.x - originX,
															   secondPixel.y - originY));
				}
				else if (inVisibleSegment)
				{
					// Otherwise, we're crossing out of a visible segment.
					inVisibleSegment = false;
					
					var secondPixel = currentMode.LatLongToPixel(secondPoint, currentView.zoomLevel);
					points.push(new Msn.Drawing.Point(secondPixel.x - originX,
															   secondPixel.y - originY));
				}
				
				firstPoint = secondPoint;
			}
		}
	}	
	
	// Creates a polyline based on the points passed in.
	function SetPolyline(points)
	{
		if(!graphicCanvas)
		{
			return;
		}
		Hide();
		graphicCanvas.Clear();
		var polyline = new Msn.Drawing.PolyLine(points);
		polyline.id = elementId;
		routeStroke.width = 4;
		graphicCanvas.SetZIndex(zIndex);
		graphicCanvas.SetStroke(routeStroke);
		graphicCanvas.DrawPolyline(polyline);
		element = document.getElementById(elementId);
		if (visible)
		{
			element.style.display = "block";
		}
		else
		{
			element.style.display = "none";
		}		
	}
	
	// Returns true if the specified point lies within the viewport + buffer.
	function IsVisible(lat, lon)
	{
		return lat >= southLatitude && lat <= northLatitude && lon >= westLongitude && lon <= eastLongitude;
	}
	
	// Returns true if the specified bounding rectangle does not overlap at all with the viewport + buffer.
	function RectangleDoesNotOverlapViewport(northEast, southWest)
	{
		return ((northEast.latitude > northLatitude && southWest.latitude > northLatitude) ||
				(northEast.latitude  < southLatitude && southWest.latitude < southLatitude) ||
				(northEast.longitude > eastLongitude && southWest.longitude > eastLongitude) ||
				(northEast.longitude < westLongitude && southWest.longitude < westLongitude));
	}
	
	// Publicly accessible methods.
	this.Init = Init;
	this.Destroy = Destroy;
	this.RemoveFromMap = RemoveFromMap;
	this.Show = Show;
	this.Hide = Hide;
	this.ChangeVisibility = ChangeVisibility;
	this.StartLine = StartLine;	
	this.UpdateLine = UpdateLine;
}
//------------------------------------------------------------------------------
// MapControl/Logo.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, keithkin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

function Logo(parent)
{
	var image = null;

	// Create the logo element
	this.Init = function()
	{	
		if (navigator.userAgent.toLowerCase().indexOf("msie") != -1)
		{
			image = document.createElement("div");
			image.className = "PoweredByLogo PoweredByLogo_ie";
			
			//Adjust the logo filter for IE if we are running the API since the image has to be served up from
			//the VE domain instead of the domain the API mashup is coming from.
			if (Msn.VE.API != null)
			{
				image.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + Msn.VE.API.Globals.vecurrentdomain + "/" + MapControl.Features.Image.PoweredLogo + "', sizingMethod='scale')";
			}
		}
		else
		{
			image = document.createElement("img");
			var imgPrefix = "http://" + location.host;
			
			//Adjust the logo location if running the API to the current domain
			if (Msn.VE.API != null)
			{
				imgPrefix = Msn.VE.API.Globals.vecurrentdomain;
			}
			image.src = imgPrefix + "/" + MapControl.Features.Image.PoweredLogo;
			image.className = "PoweredByLogo";
		}
		
		
		image.onclick = function(){window.open('http://local.live.com');};
				
		Reposition();
		parent.appendChild(image);
	};
	
	this.Destroy = function()
	{
		parent.removeChild(image);
		image = null;
	};

	// Reposition the logo
	function Reposition()
	{
		image.style.top = (height - 40) + "px";
		image.style.left = "6px";
		image.style.display = "block";
	}

	// Update the logo
	function Update()
	{
		Reposition();
	}
	
	this.Reposition = Reposition;
	this.Update = Update;
}
//------------------------------------------------------------------------------
// MapControl/Mouse.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, sstchur
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// Handles the mouse down event.  This begins a drag-pan session.
function MouseDown(e)
{
	e = GetEvent(e);	
	CancelEvent(e);
			
	// If the control is zooming, then return and ignore
	if (zooming)
	{
		return false;
	}
	
	// If the control is panning, then stop panning
	if (panning)
	{
		StopContinuousPan();
	}
	
	// If the control has oblique capabilities, cancel any availability requests
	// This is to prevent flooding the server with oblique update checks.
	if (obliqueMode)
	{
		obliqueMode.CancelRequest();
	}
	
	// If this was the middle button, use the box tool instead
	// firefox	
	if (e.which && e.which == 2)
	{
		currentTool = boxTool;
	}
	// ie
	else if (!e.which && e.button && e.button == 4)
	{
		currentTool = boxTool;		
	}
	// general
	else if (e.altKey)
	{
		currentTool = boxTool;
	}
	
	dragging = true;
	
	currentTool.OnMouseDown(e);
	
	return false;
}

// Handles mouse move.  If drag-panning, this will pan the map.
function MouseMove(e)
{
	e = GetEvent(e);	
	CancelEvent(e);
	
	if (dragging)
	{
		currentTool.OnMouseMove(e);
	}

	return false;
}

// Handles the mouse up event.  This ends a drag-pan session.
function MouseUp(e)
{
	e = GetEvent(e);
	CancelEvent(e);
	
	dragging = false;	
	currentTool.OnMouseUp(e);
	currentTool = panTool;
	
	// Get focus for keyboard control
	try
	{
		var y = window.pageYOffset;
		keyboard.focus();
		if (typeof y == 'number')
			{ window.scrollTo(0, y); }
	}
	catch(err)
	{
	}
	return false;
}

// Handles mouse double click.  This initiates an angled animated zoom.
function MouseDoubleClick(e)
{
	e = GetEvent(e);
	CancelEvent(e);
	
	UpdateFromParent();
	
	// If the control is panning or zooming, then return and ignore
	if (panning || zooming)
	{
		return false;
	}

	var view = preferredView.MakeCopy();
	view.SetCenter(new Msn.VE.Pixel(originX + offsetX + GetMouseX(e) - x, originY + offsetY + GetMouseY(e) - y));

	// If the alt key is pressed, zoom out.  Otherwise, zoom in.
	if (e.altKey)
	{
		view.SetZoomLevel(currentView.zoomLevel - 1);
	}
	else
	{
		view.SetZoomLevel(currentView.zoomLevel + 1);
	}
	
	SetView(view);
	return false;
}

// Handles the mouse wheel.  This will zoom in or out.
function MouseWheel(e)
{
	e = GetEvent(e);
	CancelEvent(e);
	
	// If the control is panning or zooming, then return and ignore
	if (panning || zooming)
	{
		return false;
	}
	
	var delta = GetMouseScrollDelta(e);
	if (delta > 0) 
	{
		ZoomIn();
	}
	else if (delta < 0)
	{
		ZoomOut();
	}
	
	return false;
}

// Handles the context menu event.  
function ContextMenu(e)
{
	e = GetEvent(e);
	CancelEvent(e);
	
	var clickX = originX + offsetX + GetMouseX(e) - x;
	var clickY = originY + offsetY + GetMouseY(e) - y;
	var clickEvent = CreateEvent(currentMode.PixelToLatLong(new Msn.VE.Pixel(clickX, clickY), currentView.zoomLevel));
	Fire("oncontextmenu", clickEvent);
		
	return false;
}
//------------------------------------------------------------------------------
// MapControl/Pan.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


// Pans the map by pixels
function PanMap(deltaX, deltaY)
{
	if (deltaX == 0 && deltaY == 0)
	{
		return;
	}
	
	// Shift the center point
	ShiftView(currentView, currentBounds, deltaX, deltaY);

	// Shift the offsets
	offsetX = currentView.center.x - originX - width/2;
	offsetY = currentView.center.y - originY - height/2;
	
	// Shift the container element
	map.style.top = -offsetY + "px"; 
	map.style.left = -offsetX + "px";
	
	// Update the copyright
	copyright.Update();
	
	// Shift the tiles
	window.setTimeout(UpdateView, 1);
	window.setTimeout(UpdateLines, 2);
}

// Starts a continuous pan by pixels.
// If count is greater than 0, it represents the number of times the pan executes.
// If count is less than or equal to 0 (or absent), the control will pan indefinitely.
// To stop the continuous pan, call StopContinuousPan.
function ContinuousPan(deltaX, deltaY, count, keyboard)
{
	// Do not continuous pan if zooming
	if (zooming)
	{
		return;
	}

	// If the count parameter was not passed or equal to 0, it's the same as no count at all.
	if (!count)
	{
		count = -1;
	}

	// Set the deltas & the pan counter.
	panningX = deltaX;
	panningY = deltaY;
	panCounter = count;
		
	// If the deltas are both 0, stop panning
	if (!deltaX && !deltaY)
	{
		StopContinuousPan();
		return;
	}
	
	// Note if this is panning caused by a keyboard.
	keyboardPan = keyboard;
		
	// If not already pannning, start the panning thread
	if (!panning)
	{		
		panning = true;
		StepPan();
		Fire("onstartcontinuouspan");
	}
}

// Internal implementation of the continuous pan.  Not designed to be called externally.
function StepPan()
{	
	// If the control is panning
	if (panning)
	{
		// Shift the map
		PanMap(panningX, panningY);
		
		// If a finite number of steps, decrement the counter
		if (panCounter > 0)
			panCounter--;
		
		// If the counter has more steps OR is ignored, continue panning
		if (panCounter != 0)
			window.setTimeout(StepPan, 10);
		else
			StopContinuousPan();
	}
}

// Stops a continuous pan
function StopContinuousPan()
{
	panningX = 0;
	panningY = 0;
	panning = false;
	keyboardPan = false;
	
	if (panLatitude != null && panLongitude != null)
	{		
		// Compute the overall deltas
		var latlong = new Msn.VE.LatLong(panLatitude, panLongitude);
		var pixel = currentMode.LatLongToPixel(latlong, currentView.zoomLevel);
		var dx = pixel.x - (originX + offsetX + width/2);
		var dy = pixel.y - (originY + offsetY + height/2);
		PanMap(dx, dy);
		
		currentView.latlong.latitude = panLatitude;
		currentView.latlong.longitude = panLongitude;
		
		preferredView.Copy(currentView);
		
		panLatitude = null;
		panLongitude = null;
		
		// Update oblique availability.  Do this here, but not in the general case
		// because ComputeCenterPoint automatically calls obliqueMode.UpdateAvailability.
		if (obliqueMode)
		{
			obliqueMode.UpdateAvailability();
		}
	}
	else
	{
		ComputeCenterPoint(true);		
	}
		
	// Notify a view listener
	Fire("onendcontinuouspan");
	Fire("onchangeview");
}

// Scrolls to a lat/long
// Implemented as a simple wrapper around ContinuousPan
function PanToLatLong(latitude, longitude)
{
	panLatitude = latitude;
	panLongitude = longitude;
	PanToPixel(currentMode.LatLongToPixel(new Msn.VE.LatLong(latitude, longitude), currentView.zoomLevel));
}

function PanToView(view)
{
	PanToPixel(view.center);
}

function PanToPixel(pixel)
{
	// If we're in oblique mode, and this point isn't in the current scene
	if (currentView.mapStyle == obliqueStyle)
	{
		var scene = obliqueMode.GetScene();
		if (!scene || !scene.ContainsPixel(pixel, currentView.zoomLevel))
		{
			var view = preferredView.MakeCopy();
			view.sceneId = null;
			view.SetCenterLatLong(obliqueMode.PixelToLatLong(pixel, currentView.zoomLevel));
			SetView(view);
			return;
		}
	}

	// Compute the overall deltas
	var dx = pixel.x - (originX + offsetX + width/2);
	var dy = pixel.y - (originY + offsetY + height/2);

	// Compute the overall distance
	var distance = Math.sqrt(dx * dx + dy * dy);

	// Jump to pan to point if the distance is too far or animated movements are disabled.
	if (!animatedMovementEnabled ||
		MathAbs(dx) > 2 * width || 
		MathAbs(dy) > 2 * height || 
		distance > 1.5 * Math.sqrt(width * width + height * height))
	{
		var view = preferredView.MakeCopy();
		view.SetCenter(pixel);
		SetView(view);
		return;
	}
	
	// Compute the direction of the scroll
	var angle = Math.atan2(dy, dx);
	
	// Compute the necessary number of steps at the "suggested" speed
	var count = MathCeil(distance / panToLatLongSpeed);
	
	// Compute the actual speed for an even number of steps
	var speed = MathRound(distance / count);
	
	// Compute the sized deltas
	dx = MathRound(Math.cos(angle) * speed);
	dy = MathRound(Math.sin(angle) * speed);
	
	// Start the pan
	ContinuousPan(dx, dy, count);
}
//------------------------------------------------------------------------------
// MapControl/Pushpin.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

function PushPinOffset(x,y)
{
	this.x = x;
	this.y = y;
}

function getPushPinOffset(poiType)
{
	// Shortcut the Msn.VE.PushPinTypes Namespace Chaind
	var pinType = Msn.VE.PushPinTypes;
	
	var offset;
	switch (poiType)
	{	
		case pinType.Annotation:			
			offset = new PushPinOffset(-2, -29/2 - 5);
			break;
			
		case pinType.SearchResult:
			offset = new PushPinOffset(0, -29/2 + 3);
			break;
			
		case pinType.Direction:
			offset = new PushPinOffset(-3, -26/2 - 3);
			break;
			
		case pinType.DirectionTemp:			
			offset =new PushPinOffset(2, -26/2 + 3);
			break;
		
		case pinType.TrafficLight:
			offset =new PushPinOffset(0, -26/2);
			break;
		
		case pinType.TrafficOthers:
			offset =new PushPinOffset(0, -29/2);
			break;		
		case pinType.YouAreHere:
			offset =new PushPinOffset(0, -26/2);
			break;
		case pinType.Default:
		default:			
			offset = new PushPinOffset(0, 0);
			break;
	}
	
	return offset;
}

// Get the pushpins
function GetPushpins()
{
	return pushpins;
}

// Adds a pushpin to the map
function AddPushpin(id, lat, lon, width, height, className, innerHtml, zIndex, pinType)
{
	var pin = new Pushpin();	
	pin.Init(id, lat, lon, width, height, className, innerHtml, zIndex, pinType);	
	pushpins.push(pin);
	
	// TODO:  Determine if this should return the Pushpin object or if it should return the DOM element
	return pin.pin;
}

// Removes a pushpin from the map
function RemovePushpin(id)
{
	for (var i=0; i<pushpins.length; i++)
	{
		var p = pushpins[i];
		if(p.id == id)
		{
			pushpins.splice(i, 1);
			p.Destroy();
			return;
		}
	}
}

// Clears all pushpins from the map
function ClearPushpins()
{
	while(pushpins.length > 0)
		pushpins.pop().Destroy();
}

// Repositions all of the pushpins according to the origin position.
function RepositionPushpins()
{
	for(var i=0; i<pushpins.length; i++)
	{
		pushpins[i].Reposition();
	}
}

// The tile class is a container for a map tile.  It maintains
// a tiles x,y, width, height, and opacity.  A tile has two states:
// current and next.  The tile can be drawn at any factor between 
// those 2 states.
function Pushpin()
{
	var pin = document.createElement("a");
	pin.href = 'javascript://pushin hover';
	pin.onclick = function(){ return ParseShiftKeyForLinks(event); };
	pin.vePushpin = this;
	this.pin = pin;
	
	var x1=0, y1=0, x2=0, y2=0;
	var center = null;
	var w = 0;
	var h = 0;
	var n = zoomTotalSteps + 1;
	var xs = new Array(n);
	var ys = new Array(n);
	var Offset;
	
	// Initializes the pushpin
	this.Init = function(id, lat, lon, width, height, className, innerHtml, zIndex, pinType)
	{
		this.id = id;
		pin.id = id;
		pin.className = className;
		pin.style.position = "absolute";
		//pin.style.zIndex = zIndex;
		pin.innerHTML = innerHtml;
		pin.pinType = pinType || Msn.VE.PushPinTypes.Default;
		
		Offset = getPushPinOffset(pin.pinType);
				
		if(!p_htParams.fixedView)
		{
			pin.attachEvent("ondblclick", DoubleClick);
			pin.attachEvent("onmousewheel", MouseWheel);
		}
		pin.unselectable = "on";

		center = new Msn.VE.LatLong(lat, lon);
		
		w = width;
		h = height;
		
		var pixel = currentMode.LatLongToPixel(center, currentView.zoomLevel);
		if (pixel)
		{
			x1 = MathRound(pixel.x - originX);
			y1 = MathRound(pixel.y - originY);
			x2 = x1;
			y2 = y1;
			PrecomputeSteps();
			SetFactor(0);
			pin.style.display = "block";
		}
		else
		{
			pin.style.display = "none";
		}
		
		map.appendChild(pin);
	};
	
	// Destroys the pushpin and frees all the associated memory
	this.Destroy = function()
	{
		pin.detachEvent("ondblclick", DoubleClick);
		pin.detachEvent("onmousewheel", MouseWheel);
		
		RemoveFromMap();
		pin.vePushpin = null;
		pin = null;
		this.pin = null;
		
		while (xs.length > 0)
		{
			xs.pop();
		}
		
		while (ys.length > 0)
		{
			ys.pop();
		}
	};
	
	// Gets the latitude of the pin.
	this.GetLatitude = function()
	{
		return center.latitude;
	};
	
	// Gets the longitude of the pin.
	this.GetLongitude = function()
	{
		return center.longitude;
	};

	// Set all steps in the array to the "current" state.
	function ClearSteps()
	{
		var n = zoomTotalSteps;
		for (var i=0; i<=n; i++)
		{
			xs[i] = (x1 - w/2 + Offset.x)+"px";
			ys[i] = (y1 - h/2 + Offset.y)+"px";
		}
	}

	// Precomputes the location for each intermediate step
	function PrecomputeSteps()
	{
		var n = zoomTotalSteps;
		for (var i=0; i<=n; i++)
		{
			var a = i / n;
			var b = 1.0 - a;
			xs[i] = MathFloor(b*x1 + a*x2 - w/2 + Offset.x) + "px";
			ys[i] = MathFloor(b*y1 + a*y2 - h/2 + Offset.y) + "px";
		}
	}

	// Updates the tile, somewhere between the current and the next state.
	function SetFactor(i)
	{		
		pin.style.left = xs[i];
		pin.style.top = ys[i];
	}

	// Swaps the current and next states.
	function SwapStates()
	{
		var t=0;
		t = x1; x1 = x2; x2 = t;
		t = y1; y1 = y2; y2 = t;
	}
	
	function Reposition()
	{
		var pixel = currentMode.LatLongToPixel(center, currentView.zoomLevel);
		if (pixel)
		{
			x1 = MathRound(pixel.x - originX);
			y1 = MathRound(pixel.y - originY);
			ClearSteps();
			SetFactor(0);
			pin.style.display = "block";
		}
		else
		{
			pin.style.display = "none";
		}
	}
	
	function PrepareForZoom(newOriginX, newOriginY, newZoom)
	{
		x1 -= offsetX;
		y1 -= offsetY;
		
		var pixel = currentMode.LatLongToPixel(center, newZoom);
		if (pixel)
		{
			x2 = MathRound(pixel.x - newOriginX);
			y2 = MathRound(pixel.y - newOriginY);
			
			PrecomputeSteps();
			pin.style.display = "block";
		}
		else
		{
			pin.style.display = "none";
		}
	}

	// Removes this tile from the control's map element.
	function RemoveFromMap()
	{
		if (pin.parentNode == map)
		{
			map.removeChild(pin);
		}
	}

	// Handles double click
	function DoubleClick(e)
	{
		e = GetEvent(e);
		CancelEvent(e);
		
		// If the control does not exist
		// or the control is panning or zooming
		// return and ignore
		if(panning || zooming)
		{
			return false;
		}

		var view = preferredView.MakeCopy();
		view.SetCenterLatLong(center);

		// If the alt key is pressed, zoom out.  Otherwise, zoom in.
		if (e.altKey)
		{
			view.SetZoomLevel(currentView.zoomLevel - 1);
		}
		else
		{
			view.SetZoomLevel(currentView.zoomLevel + 1);
		}
		
		SetView(view);
		return false;
	}

	// Handles the mouse wheel.  This will zoom in or out.
	function MouseWheel(e)
	{
		e = GetEvent(e);
		CancelEvent(e);
		
		// If the control does not exist
		// or the control is panning or zooming
		// return and ignore
		if(panning || zooming)
		{
			return false;
		}
		
		var delta = GetMouseScrollDelta(e);
		if (delta > 0) 
		{
			ZoomIn();
		}
		else if (delta < 0)
		{
			ZoomOut();
		}
		
		return false;
	}
	
	function Move(pixel, pinType)
	{
		center = PixelToLatLong(pixel);
		Reposition();
	}

	this.ClearSteps = ClearSteps;
	this.PrecomputeSteps = PrecomputeSteps;
	this.SetFactor = SetFactor;
	this.SwapStates = SwapStates;
	this.Reposition = Reposition;
	this.PrepareForZoom = PrepareForZoom;
	this.RemoveFromMap = RemoveFromMap
	this.Move = Move;
}
//------------------------------------------------------------------------------
// ScaleBar.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Codye, sstchur
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

function ScaleBar(parent)
{
	// x offset from right border
	var xOffset = 0;

	// y offset from bottom border
	var yOffset = 0;

	var labelBg = document.createElement("div");
	var labelFg = document.createElement("div");
	var barBg = document.createElement("div");
	var barFg = document.createElement("div");

	var scaleBarWidth = 150; // width of the bar (not the control, just the bar)
	
	this.Init = function()
	{
		labelBg.className = "ScaleBarLabel ScaleBarLabelBackground";
		labelFg.className = "ScaleBarLabel ScaleBarLabelForeground";
		
		barBg.className = "ScaleBar ScaleBarBackground";
		barFg.className = "ScaleBar ScaleBarForeground";
	
		Update();
		Reposition();
		
		parent.appendChild(labelBg);
		parent.appendChild(labelFg);
		parent.appendChild(barBg);
		parent.appendChild(barFg);
	};
	
	this.Destroy = function()
	{
		parent.removeChild(labelBg);
		parent.removeChild(labelFg);
		parent.removeChild(barBg);
		parent.removeChild(barFg);
		labelBg = labelFg = barBg = BarFg = null;
	};

	// Reposition the copyright
	function Reposition()
	{
		labelBg.style.top = (height - 45 - yOffset) + "px";
		labelBg.style.right = '10px';
		labelBg.style.display = "block";
		
		labelFg.style.top = (height - 46 - yOffset) + "px";
		labelFg.style.right = '11px';
		labelFg.style.display = "block";
		
		barBg.style.top = (height - 30 - yOffset) + "px";
		barBg.style.right = '9px';
		barBg.style.display = "block";
		
		barFg.style.top = (height - 31 - yOffset) + "px";
		barFg.style.right = '10px';
		barFg.style.display = "block";

	}

	// Unit conversion methods
	function MetersToKilometers(meters)
	{
		return meters * 0.001;
	}
	
	function MetersToMiles(meters)
	{
		return meters * 0.000621371192;
	}
	
	function MetersToYards(meters)
	{
		return meters * 1.0936133;
	}

	// Updates the map scale bar
	function Update()
	{
		try
		{
		
			var mpp = GetMetersPerPixel();
			var maxMeters = mpp * scaleBarWidth;

			if ( Msn.VE.Marketization.IsEnabled( MapControl.Features.ScaleBarKilometers ) ) 
			{
				// Find and display the most appropriate metric label			
				var units = L_ScaleBarKilometers_Text;
				var dMeasure = MetersToKilometers(maxMeters);
				var niceValue = LargestNiceNumber(dMeasure);
				if(niceValue < 0.5)
				{
				
					units = L_ScaleBarMeters_Text;
					dMeasure = maxMeters;
					niceValue = LargestNiceNumber(dMeasure);					
				}
				//TODO: <Localization> : Need to set the first parameter value based on Locales
				ChangeMapScaleValues("metric", units, niceValue, Math.round(niceValue/dMeasure*scaleBarWidth));			
			}
			else
			{
				// Find and display the most appropriate US label
				var units = L_ScaleBarMiles_Text;
				var dMeasure = MetersToMiles(maxMeters);
				var niceValue = LargestNiceNumber(dMeasure);
				if (niceValue < 0.5)
				{
					units = L_ScaleBarYards_Text;
					dMeasure = MetersToYards(maxMeters);
					niceValue = LargestNiceNumber(dMeasure);
				}
				//TODO: <Localization> : Need to set the first parameter value based on Locales
			ChangeMapScaleValues("us", units, niceValue, Math.round(niceValue/dMeasure*scaleBarWidth));
			}
		}
		catch(ex)
		{
			// Problems can occasionally occur with the scale bar.  Particularly at startup
			// when not all mode values and view values have been populated.
			// If something goes wrong, fail silently.  The scale bar is updated frequently, 
			// and will fix itself at the next update request.
		}
	}


	// Computes the largest nice number smaller than the input number
	function LargestNiceNumber(dIn)
	{
		//Calculate what power of 10 this number is raised to.
		var dLog10 = Math.log(dIn) / Math.log(10);
		var dExponent = Math.floor( dLog10 );
		var dExponentValue = Math.pow(10, dExponent);

		//Get the remainder after removing the exponent part.
		var dRoot = dIn / dExponentValue;

		//If first digit is 3 or more, just use that first digit followed by zeros.
		var dIntegerRoot = Math.floor(dRoot);
		if (dIntegerRoot >= 3.0)
		{
			return dIntegerRoot * dExponentValue;
		}

		//Otherwise reduce to the nearest multiple of 0.5, i.e. you get 1.0, 1.5, 2.0 or 2.5
		var dNiceRoot = Math.floor(dRoot * 2.0) * 0.5;
		return dNiceRoot * dExponentValue;
	}


	//TODO: <Localization> : Need to use the first parameter value (locale specific) in the function 
	// Change the actual values and sizes of the map scale bars
	function ChangeMapScaleValues(type, units, value, width)
	{
		if(value < 1)
		{
			value = value.toFixed(1);
		}
		
		var text = value + " " + units;
		labelBg.innerHTML = text;
		labelFg.innerHTML = text;
		
		barBg.style.width = width;
		barFg.style.width = width;
	}
	
	function SetOffset(_xOffset, _yOffset)
	{
		xOffset = _xOffset;
		yOffset = _yOffset;
		Reposition();
	}
	
	this.Update = Update;
	this.Reposition = Reposition;
	this.SetOffset = SetOffset;
}
//------------------------------------------------------------------------------
// MapControl/Tile.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, a-jayab
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// The cumulative total time spent waiting for tiles.  Time spent waiting in parallel is
// counted multiple times.  Tiles that don't load are not counted (incremented on load or on error).
var totalRequestTime = 0;

// The cumulative total number of tile requests.  Tiles that don't load are not counted 
// (incremented on load or on error).
var totalRequestCount = 0;

// The cumulative total number of tile requests that failed (401, 404, etc).  Tiles that don't 
// load are not counted (incremented on load or on error).
var totalFailureCount = 0;

// The range ceilings, which define the time buckets.
var responseRangeCeilings = new Array();
responseRangeCeilings[roadStyle] = [ 325, 975 ];
responseRangeCeilings[aerialStyle] = [ 350, 1050 ];
responseRangeCeilings[hybridStyle] = [ 425, 1275 ];
responseRangeCeilings[obliqueStyle] = [ 450, 1350 ];

// The range counts.  There is 1 more value than the range ceiligns, which is the catch all
// for requests that last even longer.
var responseRangeCounts = [ 0, 0, 0 ];

// Requests a new tile.  The tile is queued for loading
function RequestTile(x, y, z, s, type)
{
	var t = new Tile();
	t.Init(x, y, z, s, (x * tileSize - originX), (y * tileSize - originY), type);
	return t;
}

// Clears all the tiles from the internal array and the dom element.
function ClearTiles(tilesList)
{
	while (tilesList.length > 0)
	{
		var tile = tilesList.pop();
		tile.Destroy();
		tile = null;
	}
}

// Returns an array of counts that correspond to the number of tiles that loaded
// within that bucket's time range.
function GetResponseRangeCounts()
{
	var total = 0;
	for (var i=0; i<responseRangeCounts.length; i++)
	{
		total += responseRangeCounts[i];
	}
	
	// If the total count is zero, just return an array of all zeros
	if (total == 0)
	{
		return responseRangeCounts;
	}

	var responseRangePercentages = new Array(responseRangeCounts.length);
	for (var i=0; i<responseRangeCounts.length; i++)
	{
		responseRangePercentages[i] = responseRangeCounts[i] / total;
	}
	
	return responseRangePercentages;
}

// Resets the response range counts to zero.
function ResetResponseRangeCounts()
{
	for (var i=0; i<responseRangeCounts.length; i++)
	{
		responseRangeCounts[i] = 0;
	}
}

// Returns the percentage of tiles that failed to load.
function GetFailureRate()
{
	return totalFailureCount / totalRequestCount;
}

function Tile()
{
	var img = null;
	var request = null;
	var overlay = document.createElement("div");
	
	var tileX = 0;
	var tileY = 0;
	var tileZoom = 0;
	var mapStyle = 0;
	var zIndex = 0;
	
	var n = zoomTotalSteps + 1;
	var xs = new Array(n);
	var ys = new Array(n);
	var ws = new Array(n);
	var hs = new Array(n);
	
	var animated = false;
	
	var x1=0, y1=0, w1=0, h1=0;
	var x2=0, y2=0, w2=0, h2=0;
	
	var startTime = null;
	var tiletype = 0;

	// The tile class is a container for a map tile.  It maintains
	// a tiles x,y, width, height, and opacity.  A tile has two states:
	// current and next.  The tile can be drawn at any factor between 
	// those 2 states.
	this.Init = function(tx, ty, zm, ms, x, y, type)
	{
		tileX = tx;
		tileY = ty;
		tileZoom = zm;
		mapStyle = ms;
		
		overlay.style.font = "7pt Verdana, sans-serif";
		overlay.style.color = "Red";
		overlay.style.backgroundColor = "White";
		
		// Make sure the tile isn't completely out of the realm
		// If it is, this tile just won't have an image on it.
		if (!currentMode.IsValidTile(tileX, tileY, tileZoom))
		{
			return;
		}
		
		SetCurrentState(x, y, tileSize, tileSize);
		SetNextState(x, y, tileSize, tileSize);
		PrecomputeSteps();

		tiletype = type;
		request = new Image();
		request.onload = Load;
		request.onerror = Error;
		startTime = new Date();
		request.src = currentMode.GetFilename(tileX, tileY, tileZoom, type);			
	};
	
	this.Destroy = function()
	{
		if(img)
		{
			img.onmousedown = null;
		}
		
		RemoveFromMap();
		
		while (xs.length > 0)
		{
			xs.pop();
		}
		
		while (ys.length > 0)
		{
			ys.pop();
		}
		
		while (ws.length > 0)
		{
			ws.pop();
		}
		
		while (hs.length > 0)
		{
			hs.pop();
		}
		
		xs = ys = ws = hs = null;
	};
	
	// Sets the properties for the current state.
	function SetCurrentState(x, y, w, h)
	{
		x1 = x;
		y1 = y;
		w1 = w;
		h1 = h;
	}
	this.SetCurrentState = SetCurrentState;

	// Sets the properties for the next state.
	function SetNextState(x, y, w, h)
	{
		x2 = x;
		y2 = y;
		w2 = w;
		h2 = h;
	}
	this.SetNextState = SetNextState;

	// Set all steps in the array to the "current" state.
	function ClearSteps()
	{
		for (var i=0; i<=zoomTotalSteps; i++)
		{
			xs[i] = x1 + "px";
			ys[i] = y1 + "px";
			ws[i] = w1 + "px";
			hs[i] = h1 + "px";
		}
	}
	this.ClearSteps = ClearSteps;

	// Precomputes the location and size for each intermediate step
	function PrecomputeSteps()
	{
		for (var i=0; i<=zoomTotalSteps; i++)
		{
			var a = i / zoomTotalSteps;
			var b = 1.0 - a;
			xs[i] = MathFloor(b*x1 + a*x2) + "px";
			ys[i] = MathFloor(b*y1 + a*y2) + "px";
			ws[i] = MathCeil(b*w1 + a*w2) + "px";
			hs[i] = MathCeil(b*h1 + a*h2) + "px";
		}
	}
	this.PrecomputeSteps = PrecomputeSteps;

	// Updates the tile, somewhere between the current and the next state.
	function SetFactor(i)
	{
		// If this image is null, then obviously we can't set it's styles
		// If we're zooming and this tile is not animated, then also ignore
		if (img == null || (zooming && !animated))
		{
			return;
		}
	
		var style = img.style;
		style.left = xs[i];
		style.top = ys[i];
		style.width = ws[i];
		style.height = hs[i];
		
		var overlayStyle = overlay.style;
		if (debug && i == 0)
		{
			style.border = "1px dashed red";
			overlayStyle.left = xs[i];
			overlayStyle.top = ys[i];
		}

		// If the image hasn't been added to the map yet, 
		// add it to the map and set a few necessary styles.
		// Important to do this after setting styles, otherwise
		// will incur a perf hit
		if (img.parentNode != map)
		{
			style.position = "absolute";
			//style.cursor = "pointer";
			style.zIndex = zIndex;
			if (tiletype > 0)
			{						
				style.zIndex = tiletype + 1;	
				if(style && typeof style.filter != 'undefined')
					style.filter = "alpha(opacity=60);opacity:.60;";
				else				
					style.opacity = .60;									
			}	
			map.appendChild(img);
			
			if (debug && overlay.parentNode != map)
			{
				var path = img.src;
				overlay.innerHTML = path.substring(path.lastIndexOf("/") + 1, path.lastIndexOf("."));
				overlayStyle.position = "absolute";
				overlayStyle.zIndex = (zIndex + 1);
				map.appendChild(overlay);
			}
		}
	}
	this.SetFactor = SetFactor;

	// Swaps the current and next states.
	function SwapStates()
	{
		var t = 0;
		t = x1; x1 = x2; x2 = t;
		t = y1; y1 = y2; y2 = t;
		t = w1; w1 = w2; w2 = t;
		t = h1; h1 = h2; h2 = t;
	}
	this.SwapStates = SwapStates;

	// Removes this tile from the control's map element.
	function RemoveFromMap()
	{
		if (request)
		{
			request.onload = null;
			request.onerror = null;
			request.src = null;
			request = null;
		}
		
		if (img)
		{
			if (img.parentNode == map)
			{
				map.removeChild(img);
			}			
			img = null;
		}
		
		if (overlay)
		{
			if (overlay.parentNode == map)
			{
				map.removeChild(overlay);
			}
			
			overlay = null;
		}
	}
	this.RemoveFromMap = RemoveFromMap;

	// Loads the tile
	function Load()
	{
		if (tileZoom != currentView.zoomLevel || request == null)
		{
			return;
		}
		
		var endTime = new Date();
		var lastTime = endTime.getTime() - startTime.getTime();
		UpdateResponseRange(lastTime);
		
		totalRequestTime += lastTime;
		totalRequestCount++;
		
		if (debug)
		{
			window.status = "last=" + lastTime + ", average=" + (totalRequestTime / totalRequestCount);
		}
	
		request.onload = null;
		request.onerror = null;		
		img = request;
		img.onmousedown = function(e) { return false;};
		request = null;
				
		if (!zooming)
		{
			SetFactor(zoomCounter);
		}
	}
	
	// Handles the error case.
	function Error()
	{
		if (tileZoom != currentView.zoomLevel || request == null)
		{
			return;
		}
		
		var endTime = new Date();
		var lastTime = endTime.getTime() - startTime.getTime();
		UpdateResponseRange(lastTime);
		
		totalRequestTime += lastTime;
		totalRequestCount++;
		totalFailureCount++;
		
		request.onload = null;
		request.onerror = null;
		request = null;
	}
	
	// Updates the appropriate response range bucket.  The ranges
	// are defined by the range ceilings.  For the first bucket with a ceiling
	// greater than the specified response time, increment the count by one.
	function UpdateResponseRange(responseTime)
	{
		for (var i=0; i<responseRangeCeilings[mapStyle].length; i++)
		{
			if (responseTime < responseRangeCeilings[mapStyle][i])
			{
				responseRangeCounts[i]++;
				return;
			}
		}
		
		// If it wasn't in one of the first buckets, it must be greater than the 
		// largest ceiling.  Increment the last bucket
		responseRangeCounts[responseRangeCounts.length - 1]++;
	}
	
	// Prepares a tile as a base tile for the animated zoom.
	// Base tiles are already on the map at the old zoom level.  The next state must be computed,
	// and the intermediate steps interpolated.
	function PrepareBaseTile(oldOriginX, oldOriginY, oldZoom, newOriginX, newOriginY, newZoom)
	{
		SetCurrentState(x1-offsetX, y1-offsetY, w1, h1);
		
		var deltaZoom = newZoom - oldZoom;
		var zoomFactor = Math.pow(2, deltaZoom);
		
		x2 = MathFloor((oldOriginX + x1) * zoomFactor - newOriginX);
		y2 = MathFloor((oldOriginY + y1) * zoomFactor - newOriginY);
		w2 = MathCeil((oldOriginX + x1 + w1) * zoomFactor - newOriginX) - x2;
		h2 = MathCeil((oldOriginY + y1 + h1) * zoomFactor - newOriginY) - y2;
		
		// Base tiles are always animated.  They're in front of the 
		// swap tiles, so they must be visible.
		animated = true;
		
		PrecomputeSteps();
		
		zIndex = baseZIndex;
		if (img != null)
		{
			img.style.zIndex = zIndex;
		}
	}
	this.PrepareBaseTile = PrepareBaseTile;
	
	// Prepares a tile as a swap tile for the animated zoom.
	// Swap tiles are new tiles coming onto the map.  The next state is already computed, but in
	// thet current state place.  The starting steps are computed and placed into the next state.
	// The two states are then swapped and the intermediate steps are interpolated.
	function PrepareSwapTile(oldOriginX, oldOriginY, oldZoom, newOriginX, newOriginY, newZoom)
	{
		var deltaZoom = oldZoom - newZoom;
		var zoomFactor = Math.pow(2, deltaZoom);
		
		x2 = MathFloor((newOriginX + x1) * zoomFactor - oldOriginX);
		y2 = MathFloor((newOriginY + y1) * zoomFactor - oldOriginY);
		w2 = MathCeil((newOriginX + x1 + w1) * zoomFactor - oldOriginX) - x2;
		h2 = MathCeil((newOriginY + y1 + h1) * zoomFactor - oldOriginY) - y2;
		
		var quarterWidth = MathCeil(tileViewportWidth * 0.25);
		var quarterHeight = MathCeil(tileViewportHeight * 0.25);
		
		// Swap tiles are only animated if the view is zooming out and the tile is on the outside border
		animated = 
			newZoom < oldZoom &&
			(tileX < tileViewportX1 + quarterWidth ||
			tileX > tileViewportX2 - quarterWidth ||
			tileY < tileViewportY1 + quarterHeight ||
			tileY > tileViewportY2 - quarterHeight);
		
		SwapStates();
		PrecomputeSteps();
		
		zIndex = swapZIndex;
	}
	this.PrepareSwapTile = PrepareSwapTile;
	
	// Enables or disables the debug overlays
	function Debug(d)
	{
		if (img != null)
		{
			img.style.border = d ? "1px dashed red" : "0px";
		}
		
		overlay.style.display = d ? "block" : "none";
	}
	this.Debug = Debug;
}

//------------------------------------------------------------------------------
// MapControl/View.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, a-jayab, keithkin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// Starts thet map tiles for the current settings.
function StartView()
{
	// Clear the existing tiles
	ClearTiles(currentTilesList);
	
	// Reposition the map
	map.style.top = "0px";
	map.style.left = "0px";

	// Lock down a new origin point
	// This prevents x/y numbers from getting out-of-control large
	originX = MathRound(currentView.center.x - width/2);
	originY = MathRound(currentView.center.y - height/2);
	
	// Offsets determine how many pixels the users viewport is from the origin
	offsetX = 0;
	offsetY = 0;
	
	tileViewportX1 = MathFloor((originX - buffer) / tileSize);
	tileViewportY1 = MathFloor((originY - buffer) / tileSize);
	tileViewportX2 = MathFloor((originX + width + buffer) / tileSize);
	tileViewportY2 = MathFloor((originY + height + buffer) / tileSize);
	
	tileViewportWidth = tileViewportX2 - tileViewportX1 + 1;
	tileViewportHeight = tileViewportY2 - tileViewportY1 + 1;
	
	for (var y=tileViewportY1; y<=tileViewportY2; y++)
	{
		for (var x=tileViewportX1; x<=tileViewportX2; x++)
		{
			//Original tile
			var tile = RequestTile(x, y, currentView.zoomLevel, currentView.mapStyle, 0);
			currentTilesList.push(tile);
		}
	}
}

// Updates the tiles on the map, trimming off tiles that aren't necessary and adding in new tiles.
// The basic flow is to first figure out the boundaries in tile indexes.  Then extend or retract
// each of the 4 edges accordingly.  
function UpdateView()
{
	// No updates during zoom.  UpdateView is really only applicable during panning.
	if (zooming)
	{
		return;
	}
	
	var ox = originX + offsetX;
	var oy = originY + offsetY;

	var x1 = MathFloor((ox - buffer) / tileSize);
	var y1 = MathFloor((oy - buffer) / tileSize);
	var x2 = MathFloor((ox + width + buffer) / tileSize);
	var y2 = MathFloor((oy + height + buffer) / tileSize);
	
	var X1 = tileViewportX1;
    var X2 = tileViewportX2;
    var Y1 = tileViewportY1;
    var Y2 = tileViewportY2;
    var W1 = tileViewportWidth;
    var H1 = tileViewportHeight;
		
	// While the map is too far to the left
	while (tileViewportX1 < x1)
	{
		// Remove each of the tiles in the left column
		// Start from the bottom and work backwards so the tiles on top retain their correct indexes
		for (var y=tileViewportHeight-1; y>=0; y--)
		{
			var tile = currentTilesList.splice(y * tileViewportWidth, 1)[0];
			try
			{
				tile.RemoveFromMap();
			}
			catch(ex)
			{
				//swallow
			}
	
			//Traffic
			if(trafficAvailable && trafficAvailable == true)
			{					
				var ttile = currentTrafficTilesList.splice(y * tileViewportWidth, 1)[0];
				try
				{
					ttile.RemoveFromMap();
				}
				catch(ex)
				{
					//swallow
				}
			}

		}
		
		tileViewportX1++;
		tileViewportWidth--;
	}
	
	// While the map isn't far enough to the left
	while (tileViewportX1 > x1)
	{
		// Add tiles to a new left column
		tileViewportX1--;
		tileViewportWidth++;
		
		for (var y=0; y<tileViewportHeight; y++)
		{
			var tile = RequestTile(tileViewportX1, tileViewportY1 + y, currentView.zoomLevel, currentView.mapStyle, 0);
			currentTilesList.splice(y * tileViewportWidth, 0, tile);

			//Traffic stuff			
			if(trafficAvailable && trafficAvailable == true)
			{								
				var ttile = RequestTile(tileViewportX1, tileViewportY1 + y, currentView.zoomLevel, currentView.mapStyle, 1);
				currentTrafficTilesList.splice(y * tileViewportWidth, 0, ttile);
			}
		}
	}
	
	// While the map is too far to the top
	while (tileViewportY1 < y1)
	{
		// Remove the top row
		for (var x=0; x<tileViewportWidth; x++)
		{
			var tile = currentTilesList.shift();
			try
			{
				tile.RemoveFromMap();
			}
			catch(ex)
			{
				//swallow
			}

			//Traffic stuff						
			if(trafficAvailable && trafficAvailable == true)
			{								
				var ttile = currentTrafficTilesList.shift();
				try
				{
					ttile.RemoveFromMap();
				}
				catch(ex)
				{
					//swallow
				}			
			}
		}		
		
		tileViewportY1++;
		tileViewportHeight--;
	}
	
	// While the map isn't far enough to the top
	while (tileViewportY1 > y1)
	{
		// Add a row to the top
		tileViewportY1--;
		tileViewportHeight++;
		
		// Start from the right side of the row so the tiles can be added to the front each time
		for (var x=tileViewportWidth-1; x>=0; x--)
		{
			var tile = RequestTile(tileViewportX1 + x, tileViewportY1, currentView.zoomLevel, currentView.mapStyle, 0);
			currentTilesList.unshift(tile);			

			//Traffic stuff			
			if(trafficAvailable && trafficAvailable == true)
			{								
				var ttile = RequestTile(tileViewportX1 + x, tileViewportY1, currentView.zoomLevel, currentView.mapStyle, 1);
				currentTrafficTilesList.unshift(ttile);
			}
		}
	}
	
	// While the map is too far to the right
	while (tileViewportX2 > x2)
	{
		// Remove each of the tiles in the right column
		// Start from the bottom and work backwards so the tiles on top retain their correct indexes
		for (var y=tileViewportHeight-1; y>=0; y--)
		{
			var tile = currentTilesList.splice(y * tileViewportWidth + tileViewportWidth - 1, 1)[0];
			try
			{
				tile.RemoveFromMap();
			}
			catch(ex)
			{
				//swallow
			}

			//Traffic			
			if(trafficAvailable && trafficAvailable == true)
			{								
				var ttile = currentTrafficTilesList.splice(y * tileViewportWidth + tileViewportWidth - 1, 1)[0];
				try
				{
					ttile.RemoveFromMap();
				}
				catch(ex)
				{
					//swallow
				}
			}
			
		}
		
		tileViewportX2--;
		tileViewportWidth--;
	}
	
	// While the map isn't far enough to the right
	while (tileViewportX2 < x2)
	{
		// Add tiles to a new right column
		tileViewportX2++;
		tileViewportWidth++;
		
		for (var y=0; y<tileViewportHeight; y++)
		{
			var tile = RequestTile(tileViewportX2, tileViewportY1 + y, currentView.zoomLevel, currentView.mapStyle, 0);					
			currentTilesList.splice(y * tileViewportWidth + tileViewportWidth - 1, 0, tile);

			//Traffic stuff			
			if(trafficAvailable && trafficAvailable == true)
			{								
				var ttile = RequestTile(tileViewportX2, tileViewportY1 + y, currentView.zoomLevel, currentView.mapStyle, 1);		
				currentTrafficTilesList.splice(y * tileViewportWidth + tileViewportWidth - 1, 0, ttile);
			}			
		}		
	}
	
	// While the map is too far down
	while (tileViewportY2 > y2)
	{
		// Remove the bottom row
		for (var x=0; x<tileViewportWidth; x++)
		{
			var tile = currentTilesList.pop();
			try
			{
				tile.RemoveFromMap();
			}
			catch(ex)
			{
				//swallow
			}

			//Traffic stuff			
			if(trafficAvailable && trafficAvailable == true)
			{								
				var ttile = currentTrafficTilesList.pop();
				try
				{
					ttile.RemoveFromMap();
				}
				catch(ex)
				{
					//swallow
				}
			}
			
		}
		
		tileViewportY2--;
		tileViewportHeight--;
	}
	
	// While the map isn't far down enough
	while (tileViewportY2 < y2)
	{
		// Add a row to the bottom
		tileViewportY2++;
		tileViewportHeight++;
		
		// Start from the right side of the row so the tiles can be added to the front each time
		for (var x=0; x<tileViewportWidth; x++)
		{
			var tile = RequestTile(tileViewportX1 + x, tileViewportY2, currentView.zoomLevel, currentView.mapStyle, 0);
			currentTilesList.push(tile);
			
			//Traffic stuff
			if(trafficAvailable && trafficAvailable == true)
			{								
				var ttile = RequestTile(tileViewportX1 + x, tileViewportY2, currentView.zoomLevel, currentView.mapStyle, 1);
				currentTrafficTilesList.push(ttile);			
			}
		}
	}		
	
	//Cthota
	//Moving to inline for perf reasons
	//BTW, moving to async does not work
	//window.setTimeout(UpdateLayer, 1);
}

// Change the zoom level
// If the requested zoom is within 1 zoom level of the current and animated 
// zoom is enabled, this will start a thread to do the animation.
// Otherwise, this will just swap in new tiles for old tiles
function SetView(requestedView)
{
	// If already zooming or dragging, ignore it.  They can try again when it is done.
	if (zooming || dragging)
	{
		return true;
	}
	
	//If the map is panning, go ahead and stop it. This allows other view changes
	//to be accepted during the pan. i.e. if the user wants to change the zoom level,
	//then we will jump to the end of the pan and zoom in. This also allows consecutive 
	//API calls to work properly if one of the calls starts a pan.
	if(panning)
	{
		StopContinuousPan();
	}
	
	// If the requested view came in as a latlong rectangle, we have to take special care
	// to preserve the true center.  In the process of resolving it to a pixel based view,
	// the true center point can be lost, especially in oblique mode.
	var centerLatLong = requestedView.latlong;
	if (requestedView.GetViewType() == "latlongRect")
	{
		centerLatLong = requestedView.latlongRect.Center();
	}
		
	// Have to handle some special cases for oblique mode requests
	if (requestedView.mapStyle == obliqueStyle)
	{
		// If we don't have oblique capabilities, ignore this request.
		if (obliqueMode == null)
		{
			return true;
		}
		
		// First capture the unresolved requested view.  If we make it through all the oblique
		// checks, we'll capture the resolved view again.
		preferredView.Copy(requestedView);
		
		currentMode = obliqueMode;
		p_elSource.style.backgroundColor = "black";
		requestedView.Resolve(currentMode, width, height);
	
		// If we don't have a scene, then we need to make a server request to 
		// check for availability
		// If the requested scene is not the same as our current scene
		// If the user explicitly requested a scene by id, and this is not that scene,
		// then go back to the server and find the requested scene.
		var scene = obliqueMode.GetScene();
		if ((!scene || scene.GetID() != requestedView.sceneId) && requestedView.sceneId != null)
		{
			obliqueMode.RequestScene(requestedView.sceneId);
			return true;
		}
			
		// If this scene does not actually contain the requested point,
		// then go back to the server and look for a scene at the point
		if (!scene || 
			(!scene.ContainsLatLong(centerLatLong, requestedView.zoomLevel) && scene.GetID() != requestedView.sceneId) ||
			scene.GetOrientation() != requestedView.sceneOrientation)
		{
			obliqueMode.RequestSceneAtLatLong(centerLatLong, requestedView.sceneOrientation, true);
			return true;
		}
	}
	else
	{
		currentMode = orthoMode;
		if (requestedView.mapStyle == 'r')
		{
			p_elSource.style.backgroundColor = "#e9e7d4";
		}
		else
		{
			p_elSource.style.backgroundColor = "black";
		}
		requestedView.Resolve(currentMode, width, height);
	}
	
	// Now grab the resolved center latlong
	centerLatLong = requestedView.latlong;
	
	// Capture the preferred center point
	preferredView.Copy(requestedView);
	
	// Validate the zoom level
	currentMode.ValidateZoomLevel(requestedView);
	
	// Get the current bounds
	currentBounds = currentMode.GetBounds(requestedView);
	
	// Clip the view, make sure it's valid
	ClipView(requestedView, currentBounds);
	
	// Resolve the view again to update the latlong
	requestedView.Resolve(currentMode, width, height);
	
	// If the views are the same thing, ignore the request.
	if (requestedView.Equals(currentView))
	{
		return false;
	}

	// Compute the distance of the transition
	var deltaX = requestedView.GetX(currentView.zoomLevel) - currentView.center.x;
	var deltaY = requestedView.GetY(currentView.zoomLevel) - currentView.center.y;
	var distance = Math.sqrt(deltaX * deltaX + deltaY * deltaY);
	
	// To determine if animated pan is possible, consider these checks:
	// 1. It is within viewing distance
	// 2. It is at the same zoom level
	// 3. Dynamic movements are enabled
	// 4. Same map style
	// 5. Same oblique scene (or not in oblique at all)
	var animatedPan =
		(distance < width && distance < height) && 
		(requestedView.zoomLevel == currentView.zoomLevel) &&
		animatedMovementEnabled &&
		(requestedView.mapStyle == currentView.mapStyle) &&
		(requestedView.sceneId == null || requestedView.sceneId == currentView.sceneId);
	
	// If it passed the checks, do it.
	if (animatedPan)
	{
		PanToLatLong(centerLatLong.latitude, centerLatLong.longitude);
		return true;
	}
	
	// If the zoom level is changing, capture the current zoom and fire the event.
	previousZoomLevel = currentView.zoomLevel;
	if (currentView.zoomLevel != requestedView.zoomLevel)
	{
		Fire("onstartzoom");
		zooming = true;
	}
	
	// To determine if animated zoom is possible, consider these checks:
	// 1. It is within viewing distance
	// 2. It is within one zoom level away and not the current zoom level
	// 3. Dynamic movements are enabled
	// 4. Same map style
	// 5. Same oblique scene (or not in oblique at all)
	var animatedZoom = 
		(distance < width && distance < height) && 
		(requestedView.zoomLevel == currentView.zoomLevel-1 || requestedView.zoomLevel == currentView.zoomLevel+1) &&
		animatedMovementEnabled &&
		(requestedView.mapStyle == currentView.mapStyle) &&
		(requestedView.sceneId == null || requestedView.sceneId == currentView.sceneId);
	
	// If it passed all the checks, do it.
	if (animatedZoom)
	{
		// Track the old origin.  It must be reset to the top corner of the screen so that the 
		// map container can be set at left=0px, top=0px
		var oldOriginX = originX + offsetX;
		var oldOriginY = originY + offsetY;
		var oldZoom = currentView.zoomLevel;
		var newZoom = requestedView.zoomLevel;
		
		// New origin
		var newOriginX = MathRound(requestedView.center.x - width/2);
		var newOriginY = MathRound(requestedView.center.y - height/2);
		
		// Keep the old tiles in a separate bucket
		// Create a new array for new tiles
		oldTilesList = currentTilesList;
		currentTilesList = new Array();
			
		for (var i=0; i<oldTilesList.length; i++)
		{
			oldTilesList[i].PrepareBaseTile(oldOriginX, oldOriginY, oldZoom, newOriginX, newOriginY, newZoom);
		}
		
		for(var i=0; i<pushpins.length; i++)
		{
			pushpins[i].PrepareForZoom(newOriginX, newOriginY, newZoom);
		}
		
		HideLines();
		currentView.Destroy();
		currentView = requestedView;
		StartView();
		SetLayerView();				
		for (var i=0; i<currentTilesList.length; i++)
		{
			currentTilesList[i].PrepareSwapTile(oldOriginX, oldOriginY, oldZoom, newOriginX, newOriginY, newZoom);
		}

		//cthota: traffic stuff
		//Removing swap layer call w/ inline call due to perf reasons
		if(trafficAvailable && trafficAvailable == true)		
		{
			for(var i=0; i<currentTrafficTilesList.length; i++)
			{
				currentTrafficTilesList[i].PrepareSwapTile(oldOriginX, oldOriginY, oldZoom, newOriginX, newOriginY, newZoom);
			}
		}
				
		zoomCounter = 1;
		StepAnimation();
		return true;
	}

	// Otherwise, if not doing a dynamic zoom, do the standard jump zoom
	oldTilesList = currentTilesList;
	currentTilesList = new Array();
	currentView.Destroy();
	currentView = requestedView;
	HideLines();
	StartView();
	SetLayerView();				
	FinalizeView();
	RepositionPushpins();
	return true;	
}

// Steps the animation
// This is a static member because timer callbacks cannot be member functions.
function StepAnimation()
{
	// If we're not zooming, get out
	if (!zooming)
	{
		return;
	}

	for (var i=0; i<oldTilesList.length; i++)
	{
		oldTilesList[i].SetFactor(zoomCounter);
	}
	
	for (var i=0; i<currentTilesList.length; i++)
	{
		currentTilesList[i].SetFactor(zoomCounter);
	}
	
	for (var i=0; i<pushpins.length; i++)
	{
		pushpins[i].SetFactor(zoomCounter);
	}
		
	if (zoomCounter < zoomTotalSteps)
	{
		zoomCounter++;
		window.setTimeout(StepAnimation, 1);
	}
	else
	{
		zoomCounter = 0;
		FinalizeView();
	}
}

// Finish the zoom.  Clean up the old tiles. 
function FinalizeView()
{
	// Remove the old tiles
	if(oldTilesList!= null)
	{
		ClearTiles(oldTilesList);
		oldTilesList = null;
	}
	
	//Any other layers - including traffic
	ClearLayer();
	
	// End zooming state
	zooming = false;
	
	// Set the final transition to be the starting point
	for(var i=0; i<currentTilesList.length; i++)
	{
		currentTilesList[i].SwapStates();
		currentTilesList[i].ClearSteps();
		currentTilesList[i].SetFactor(0);

		//Traffic stuff
		if(trafficAvailable && trafficAvailable == true)				
		{
			if(currentTrafficTilesList[i] != null)
			{
				currentTrafficTilesList[i].SwapStates();
				currentTrafficTilesList[i].ClearSteps();			
				currentTrafficTilesList[i].SetFactor(0);
			}
		}
	}
	
	//cthota - moved to inline due to perf
	//tried async but some visual wierdness 
	//shows up due to delayed tile swapping
	//SetLayer();
	
	for(var i=0; i<pushpins.length; i++)
	{
		pushpins[i].SwapStates();
		pushpins[i].ClearSteps();
		pushpins[i].SetFactor(0);
	}
	
	currentTilesIndexes = null;
	oldTilesIndexes = null;
	
	// Delay the line by a split second
	// Give the tiles a chance to load first
	// Otherwise, there's an ugly period of time where
	// the tiles are half baked
	window.setTimeout(ShowLines, 250);
	
	// Update the copyright
	if (copyright)
	{
		copyright.Update();
	}
	
	// Notify the map style listeners
	if (previousMapStyle != currentView.mapStyle)
	{
		Fire("onchangemapstyle");
	}
	
	// Notify the zoom level listeners
	if (previousZoomLevel != currentView.zoomLevel)
	{
		Fire("onendzoom");
	}
	
	// Notify a view listener
	Fire("onchangeview");
	
	// Update oblique availability
	if (obliqueMode)
	{
		window.setTimeout(obliqueMode.UpdateAvailability, 100);
	}
	
	// In IE we can force a garbage collect
	try
	{
		CollectGarbage();
	}
	catch (ex)
	{
		// Ignore exception if browsers other than IE complain
	}
}
//------------------------------------------------------------------------------
// MapControl/Viewport.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, keithkin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


// Finds the best viewport for the specified lat/long rectangle
function SetViewport(lat1, lon1, lat2, lon2)
{
	var view = preferredView.MakeCopy();
	view.sceneId = null;
	
	//Set the LatLong rectangle of the view.
	//Note: The latlongs have to be clipped in case they are outside the acceptable min/max range.
	//If the latlongs are not clipped, the lat/long to pixel conversions in Mercator projections 
	//can mess up calculations. For example, a latitude of 90 degrees that is converted to pixels 
	//approaches infinity, so 85 degrees is the max.
	view.SetLatLongRectangle(
		new Msn.VE.LatLongRectangle(
			new Msn.VE.LatLong(ClipLatitude(lat1), ClipLongitude(lon1)), 
			new Msn.VE.LatLong(ClipLatitude(lat2), ClipLongitude(lon2)) ));
	return SetView(view);
}

// Sets the map view for an array of lat/longs.
// l is an array of objects that have latitude and longitude properties
function SetBestMapView(l)
{
	if(!l || l.constructor != Array)
	{
		return;
	}

	var a = l[0].latitude;
	var b = l[0].longitude;
	var c = a;
	var d = b;
	
	for (var i=1; i<l.length; i++)
	{
		a = MathMin(a, l[i].latitude);
		b = MathMin(b, l[i].longitude);
		c = MathMax(c, l[i].latitude);
		d = MathMax(d, l[i].longitude);
	}
	
	var dLat = (c - a) * 0.1;
	var dLon = (d - b) * 0.1;
	
	a -= dLat;
	b -= dLon;
	c += dLat;
	d += dLon;
		
	SetViewport(
		ClipLatitude(a), 
		ClipLongitude(b), 
		ClipLatitude(c), 
		ClipLongitude(d));
}


// Grows the viewport to a best map view of the current center point and the lat/long parameters
function IncludePointInViewport(latitude, longitude)
{
	var latlong = new Msn.VE.LatLong(latitude, longitude);
	
	// If the user is in oblique and the requested latlong is not in the current scene,
	// then we have to kick back out into ortho mode.
	if (currentView.mapStyle == obliqueStyle)
	{
		var scene = obliqueMode.GetScene();
		if (!scene || !scene.ContainsLatLong(latlong))
		{
			SetMapStyle(lastOrthoMapStyle);
		}
	}
	
	SetBestMapView(new Array(currentView.latlong, latlong));
}


/// Clips a latitude value, which forces it between the minimum and maximum
/// latitudes.
function ClipLatitude(latitude)
{
	return Clip(latitude, minLatitude, maxLatitude);
}


/// Clips a longitude value, which forces it between the minimum and maximum
/// longitudes.
function ClipLongitude(longitude)
{
	return Clip(longitude, minLongitude, maxLongitude);
}


/// Clips a value between two extremes.  If the value is less than the lower bound,
/// the lower bound is returned.  If the value is greater than the upper bound,
/// the upper bound is returned.  Otherwise, the value is returned untouched.
function Clip(n, minValue, maxValue)
{
	if(n < minValue)
	{
		return minValue;
	}
	if(n > maxValue)
	{
		return maxValue;
	}
	return n;
}

//------------------------------------------------------------------------------
// MapControl/XmlHttp.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// Gets an XmlHttp object, if the browser supports it.
function GetXmlHttp()
{
	var x = null;
	try
	{ 
		x = new ActiveXObject("Msxml2.XMLHTTP");
	}
	catch (ex)
	{ 
		try
		{
			x = new ActiveXObject("Microsoft.XMLHTTP");
		}
		catch (ex)
		{
			x = null;
		}
	}
	
	if (!x && typeof XMLHttpRequest != "undefined")
	{
		x = new XMLHttpRequest();
	}
	
	return x;
}
//------------------------------------------------------------------------------
// MapControl/Zoom.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


// Sets the zoom level.  This is a simple wrapper around SetCenterAndZoom which 
// uses the existing center point.
function SetZoom(zoomLevel)
{
	var view = preferredView.MakeCopy();
	view.SetZoomLevel(zoomLevel);
	SetView(view);
}

// Simple wrapper around SetZoom, which zooms in by one.
function ZoomIn()
{
	var view = preferredView.MakeCopy();
	view.SetZoomLevel(currentView.zoomLevel + 1);
	SetView(view);
}

// Simple wrapper around SetZoom, which zooms out by one.
function ZoomOut()
{
	var view = preferredView.MakeCopy();
	view.SetZoomLevel(currentView.zoomLevel - 1);
	SetView(view);
}

// Change the zoom level
// If the requested zoom is within 1 zoom level of the current and animated 
// zoom is enabled, this will start a thread to do the animation.
// Otherwise, this will just swap in new tiles for old tiles
function SetCenterAndZoom(latitude, longitude, zoomLevel)
{
	var view = preferredView.MakeCopy();
	view.sceneId = null;
	view.SetCenterLatLong(new Msn.VE.LatLong(latitude, longitude));
	view.SetZoomLevel(zoomLevel);
	SetView(view);
}

//------------------------------------------------------------------------------
// MapControl/Modes/ObliqueMode.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Codye
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// A subset of the map control functionality that is specific to viewing in ortho 
// mode has been refactored out of the control.  The same functionality has been 
// reimplemented for oblique mode.  (This is conceptually an interface for a view 
// mode that will be implemented for both ortho mode and oblique mode, except 
// JavaScript does not have the notion of an interface.)
//
// Each view mode will include the following functionality:
// 
// * Boundary checking
//   * Determining tile validity
//   * Determining zoom validity
//   * Restricting panning and zooming to the edges of the image
// * Building tile filenames
// * Pixel to latlong & latlong to pixel conversions

// The implementation of view mode for oblique imagery.  Oblique mode also includes
// a few helper methods for determining oblique availality.
function ObliqueMode()
{
	var scene = null;
	var available = false;
	var availableBefore = false;
	var xmlHttp = null;
	var obliqueUrl = null;
	var showOnLoad = false;
	var requestUrl = null;
	var timerId = -1;
	var bounds = [ __mapControlObliqueBounds__ ];
	
	// Initializes the oblique mode
	this.Init = function(url)
	{
		obliqueUrl = url;
	};
	
	// Destroys the oblique mode
	this.Destroy = function()
	{
	};
	
	// Determines if a tile is valid within a scene
	function IsValidTile(tileX, tileY, zoomLevel)
	{
		return scene.IsValidTile(tileX, tileY, zoomLevel);
	}
	
	// Gets the tile filename
	function GetFilename(tileX, tileY, zoom)
	{
		return scene.GetTileFilename(tileX, tileY, zoom);
	}

	// Computes the mercator meters per pixel at a specified zoom level.
	function MetersPerPixel(zoomLevel)
	{
		if (!scene)
		{
			return 0;
		}
		
		var pixel = new Msn.VE.Pixel(MathRound(originX + offsetX + width/2), MathRound(originY + offsetY + height/2));
		var latlong1 = scene.PixelToLatLong(pixel, zoomLevel);
		pixel.x++;
		var latlong2 = scene.PixelToLatLong(pixel, zoomLevel);
		
		var sinLat1 = Math.sin(DegToRad(latlong1.latitude));
		var sinLat2 = Math.sin(DegToRad(latlong2.latitude));
		var metersHeight = earthRadius / 2 * MathAbs(Math.log((1 + sinLat1) / (1 - sinLat1)) - Math.log((1 + sinLat2) / (1 - sinLat2)));
		var metersWidth = earthRadius * MathAbs(DegToRad(latlong1.longitude) - DegToRad(latlong2.longitude));
		
		return Math.sqrt(metersWidth * metersWidth + metersHeight * metersHeight);
	}
	
	// Converts an absolute pixel point to a latitude longitude coordinate.
	function PixelToLatLong(pixel, zoomLevel)
	{
		return scene ? scene.PixelToLatLong(pixel, zoomLevel) : null;
	}
	
	// Converts a latitude longitude coordinate to an absolute pixel point.
	function LatLongToPixel(latlong, zoomLevel)
	{
		return scene ? scene.LatLongToPixel(latlong, zoomLevel) : null;
	}

	// Determines if the user can zoom in with the currently set viewport
	function ValidateZoomLevel(view)
	{
		if (view.zoomLevel < 1)
		{
			view.SetZoomLevel(1);
		}
		else if (view.zoomLevel > 2)
		{
			view.SetZoomLevel(2);
		}
	}
	
	function GetScene()
	{
		return scene;
	}
	
	function GetBounds()
	{
		return scene.GetBounds();
	}
	
	function IsAvailable()
	{
		return available;
	}
	
	function GetEventInfo()
	{
		if (!available)
		{
			return null;
		}
		
		var info = new Object();
		return info;
	}
	
	// Kicks off a server side check for oblique availability.  
	// This request passes up the center latlong
	function UpdateAvailability()
	{
		if (currentView.mapStyle == obliqueStyle)
		{
			return;
		}
		
		//If the zoomLevel is invalid, get out
		if (currentView.zoomLevel <= 0) 
		{
			return;
		}
				
		if (currentView.zoomLevel < MapControl.Features.BirdsEyeAtZoomLevel )
		{		
			scene = null;
			availableBefore = available;
			available = false;
			NotifyListeners();
			return;
		}
		
		RequestSceneAtLatLong(currentView.latlong, "North", false, __obliqueUpdateDelay__);
	}
	
	// Kicks off a server side request for an oblique scene at any location 
	// This request passes up a latlong 
	function RequestSceneAtLatLong(latlong, orientation, show, delay)
	{
		CancelRequest();
		
		showOnLoad = show;
		
		// If the point isn't even in the realm of oblique imagery, 
		// save the time and just notify the listeners.
		if (!InBounds(latlong))
		{
			scene = null;
			availableBefore = available;
			available = false;
			NotifyListeners();
			return;
		}
		
		requestUrl = obliqueUrl + "?ver=3&lat=" + latlong.latitude + "&lon=" + latlong.longitude;
		if (orientation)
		{
			requestUrl += "&o=" + orientation;
		}
		
		if (delay)
		{
			timerId = window.setTimeout(SendRequest, delay);
		}
		else
		{
			SendRequest();
			timerId = -1;
		}
	}
	
	// Kicks off a server side request for one specific scene.
	// This request passes up the image id.
	function RequestScene(id)
	{
		if (scene && scene.GetID() == id)
		{
			return;
		}
	
		CancelRequest();
		showOnLoad = true;
		requestUrl = obliqueUrl + "?ver=3&id=" + id;
		SendRequest();
	}
	
	// Cancels any existing requests.
	function CancelRequest()
	{
		try
		{
			if (timerId != -1)
			{
				window.clearTimeout(timerId);
			}
		}
		catch(ex)
		{
			// swallow, the thread may have completed
		}
		
		timerId = -1;
		
		try
		{
			if (xmlHttp)
			{
				xmlHttp.onreadystatechange = null;
				xmlHttp.abort();
			}
		}
		catch(ex)
		{
			// Ignore any problems
		}
	}
	
	// Sends the request on deck.
	function SendRequest()
	{
		CancelRequest();
		
		if (!requestUrl)
		{
			return;
		}
		
		if(Msn.VE.API != null)
		{
			var network = new VENetwork();
			network.ServiceUrl = requestUrl;
			network.BeginInvoke("EndInvokeImagery", null, APIResponseHandler);	
		}
		else
		{
			if (!xmlHttp)
			{
				xmlHttp = GetXmlHttp();
			}
			
			if (xmlHttp)
			{
				xmlHttp.open("POST", requestUrl, true);
				xmlHttp.onreadystatechange = ResponseHandler;
				xmlHttp.send("");
			}
		}
	}
	
	// Handles the oblique response.  This response handler is shared by UpdateAvailability
	// and RequestScene
	function APIResponseHandler(object)
	{
		if(object != null)
		{
			scene = object;
			available = true;			
		}
		else
		{
			scene = null;
			available = false;					
		}		
		NotifyListeners();		
	}	
	function ResponseHandler()
	{
		// Ignore all states other than the final one
		if (!xmlHttp || xmlHttp.readyState != 4) 
		{
			return;
		}
		
		// Clear the timer
		timerId = -1;
		
		availableBefore = available;
		var code = xmlHttp.responseText;
		if (code)
		{
			try
			{
				scene = eval(code + "EndInvokeImagery();");
				if(scene != null)				
					available = true;
				else
					available = false;				
			}
			catch(ex)
			{
				scene = null;
				available = false;
			}
		}
		else
		{
			scene = null;
			available = false;
		}
		
		NotifyListeners();
	}
	
	// Fires all events.  If we need to show on load, make the appropriate SetView call.
	function NotifyListeners()
	{
		// If we're supposed to show on load, display the oblique.
		if (showOnLoad)
		{
			showOnLoad = false;
			
			if (available)
			{
				var view = preferredView.MakeCopy();
				view.SetMapStyle(obliqueStyle, scene.GetID(), scene.GetOrientation());
				SetView(view);
				
				Fire("onobliquechange");
			}
			else
			{
				// The user requested oblique imagery, but we don't have any for this latlong.  Show the last ortho map style instead
				var view = preferredView.MakeCopy();
				view.SetMapStyle(lastOrthoMapStyle);
				
				// We need a way to determine what the zoom level should be when we pop out into ortho.  Unless we
				// have a lat long rectangle, we'll need to revert back to the last ortho zoom level.
				if (view.GetViewType() != "latlongRect")
				{
					view.SetZoomLevel(lastOrthoZoomLevel);
				}
				
				SetView(view);
				
				Fire("onerror", CreateEvent(currentView.latlong, currentView.zoomLevel, L_ObliqueModeImageNotAvailable_Text ));
			}
		}
		
		// Fire the appropriate events if the availability changed
		if (availableBefore != available)
		{
			if (available)
			{
				Fire("onobliqueenter");
			}
			else
			{
				Fire("onobliqueleave");
			}
		}
	}
	
	// Determines if this latlong is in a set of bounds where we have oblique imagery.
	function InBounds(latlong)
	{
		if (!latlong || !bounds || bounds.length == 0)
		{
			return false;
		}
		
		// Build a quad key at the current latlong
		// Note that we generate the quad key at the zoom level of the
		// first element in the bounds list.
		// (zoom level = length(quad key))
		var quadKey = LatLongToQuadKey(latlong, bounds[0].length);
		
		// Search for the quad key in our list of bounds
		return BinarySearchBounds(quadKey, 0, bounds.length - 1);
	}
	
	// Converts a lat/long to a quad key at the requested zoom level
	function LatLongToQuadKey(latlong, zoomLevel)
	{
		var pixel = orthoMode.LatLongToPixel(latlong, zoomLevel);
		var tileX = MathFloor(pixel.x / tileSize);
		var tileY = MathFloor(pixel.y / tileSize);
	
		var quadKey = "";
		for (var i=zoomLevel; i>0; i--)
		{
			var cell = 0;
			var mask = 1 << (i-1);
			
			if ((tileX & mask) != 0)
			{
				cell++;
			}
			
			if ((tileY & mask) != 0)
			{
				cell += 2;
			}
			
			quadKey += (cell + "");
		}
		
		return quadKey;
	}
	
	// Performs a recursive binary search, looking for the quadKey in the bounds array
	function BinarySearchBounds(quadKey, left, right)
	{
		if (right < left)
			return false;
		
		var middle = MathFloor((left + right) / 2);
		
		if (bounds[middle] == quadKey)
			return true;
		
		if (quadKey < bounds[middle])
			return BinarySearchBounds(quadKey, left, middle-1);
		
		return BinarySearchBounds(quadKey, middle+1, right);
	}

	this.IsValidTile = IsValidTile;
	this.GetFilename = GetFilename;
	this.MetersPerPixel = MetersPerPixel;
	this.PixelToLatLong = PixelToLatLong;
	this.LatLongToPixel = LatLongToPixel;
	this.GetBounds = GetBounds;
	this.ValidateZoomLevel = ValidateZoomLevel;
	this.IsAvailable = IsAvailable;
	this.UpdateAvailability = UpdateAvailability;
	this.CancelRequest = CancelRequest;
	this.GetEventInfo = GetEventInfo;
	this.GetScene = GetScene;
	this.RequestSceneAtLatLong = RequestSceneAtLatLong;
	this.RequestScene = RequestScene;
}
//------------------------------------------------------------------------------
// MapControl/Modes/OrthoMode.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Codye, a-jayab
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// A subset of the map control functionality that is specific to viewing in ortho 
// mode has been refactored out of the control.  The same functionality has been 
// reimplemented for oblique mode.  (This is conceptually an interface for a view 
// mode that will be implemented for both ortho mode and oblique mode, except 
// JavaScript does not have the notion of an interface.)
//
// Each view mode will include the following functionality:
// 
// * Boundary checking
//   * Determining tile validity
//   * Determining zoom validity
//   * Restricting panning and zooming to the edges of the image
// * Building tile filenames
// * Pixel to latlong & latlong to pixel conversions


// The implementation of view mode for ortho imagery.
function OrthoMode()
{
	var bounds = [ __mapControlOrthoBounds__ ];
	
	this.Init = function()
	{
	};
	
	this.Destroy = function()
	{
	};
	
	function IsValidTile(tileX, tileY, zoomLevel)
	{
		var max = 1 << zoomLevel;
		return tileX >= 0 && tileY >= 0 && tileX < max && tileY < max;
	}
	
	function GetFilename(tileX, tileY, zoom,type)
	{
		var key = "";
		var cell = 0;
		for(var i=zoom; i>0; i--)
		{
			cell = 0;
			var mask = 1 << (i-1);
			if((tileX & mask) != 0)
			{
				cell++;
			}
			if((tileY & mask) != 0)
			{
				cell += 2;
			}
			key += cell + "";
		}
		//Standard map
		if( type == 0)
			return "http://" +
				currentView.mapStyle + 
				cell + 
				".__orthoTileServer__" + 
				currentView.mapStyle + 
				key + 
				(currentView.mapStyle == roadStyle ? ".png" : ".jpeg") + 
				"?g=" + generations[currentView.mapStyle];		
		//Traffic
		else if( type == 1)
		{
			//We have to use the cell but we only have two traffic servers
			//so here we go
			var i = (cell % 2);
			return "__trafficTileServer__".replace(/%1/g,i) +key+".png";
		}
			
	}

	// Computes the mercator meters per pixel at a specified zoom level.
	function MetersPerPixel(zoomLevel)
	{
		return earthCircumference / ((1 << zoomLevel) * tileSize);
	}

	// Converts an absolute pixel point to a latitude longitude coordinate.
	function PixelToLatLong(pixel, zoomLevel)
	{
		var metersPerPixel = MetersPerPixel(zoomLevel);
		var metersX = pixel.x * metersPerPixel - projectionOffset;
		var metersY = projectionOffset - pixel.y * metersPerPixel;

		var latlong = new Msn.VE.LatLong();
		latlong.latitude = RadToDeg(Math.PI/2 - 2 * Math.atan(Math.exp(-metersY / earthRadius)));
		latlong.longitude = RadToDeg(metersX / earthRadius);
		return latlong;
	}
	
	// Converts a latitude longitude coordinate to an absolute pixel point.
	function LatLongToPixel(latlong, zoomLevel)
	{
		var sinLat = Math.sin(DegToRad(latlong.latitude));
		var metersX = earthRadius * DegToRad(latlong.longitude);
		var metersY = earthRadius/2 * Math.log((1 + sinLat) / (1 - sinLat));

		var metersPerPixel = MetersPerPixel(zoomLevel);
		var pixel = new Msn.VE.Pixel();
		pixel.x = ((projectionOffset + metersX) / metersPerPixel);
		pixel.y = ((projectionOffset - metersY) / metersPerPixel);
		return pixel;
	}
	
	function GetBounds(view)
	{
		if (view == undefined)
		{
			view = currentView;
		}
	
		var zoomLevel = view.zoomLevel;
		var x = view.center.x;
		var y = view.center.y;
		
		for (var i=0; i<bounds.length; i++)
		{
			var deltaZ = zoomLevel - bounds[i].z1;
			var factor = tileSize * Math.pow(2, deltaZ);
			var minX = bounds[i].x1 * factor;
			var maxX = bounds[i].x2 * factor;
			var minY = bounds[i].y1 * factor;
			var maxY = bounds[i].y2 * factor;
			
			if (x >= minX && x <= maxX && y >= minY && y <= maxY)
			{
				if (zoomLevel >= bounds[i].z1 && zoomLevel <= bounds[i].z2)
				{
					return bounds[i];
				}
			}
		}
	}

	// Determines if the user can zoom in with the currently set viewport
	function ValidateZoomLevel(view)
	{		
		var x = view.center.x;
		var y = view.center.y;
		var maxZoom = 0;
		
		// Find the maximum zoomLevel for a point.
		for (var i=0; i<bounds.length; i++)
		{
			var factor = tileSize * Math.pow(2, view.zoomLevel - bounds[i].z1);
			var minX = bounds[i].x1 * factor;
			var maxX = bounds[i].x2 * factor;
			var minY = bounds[i].y1 * factor;
			var maxY = bounds[i].y2 * factor;
			
			if (x >= minX && x <= maxX && y >= minY && y <= maxY)
			{
				if (bounds[i].z2 >= view.zoomLevel)
				{
					return;
				}
				else if (bounds[i].z2 > maxZoom)
				{
					maxZoom = bounds[i].z2;
				}
			}
		}
		
		view.SetZoomLevel(maxZoom);
	}
	
	this.IsValidTile = IsValidTile;
	this.GetFilename = GetFilename;
	this.MetersPerPixel = MetersPerPixel;
	this.PixelToLatLong = PixelToLatLong;
	this.LatLongToPixel = LatLongToPixel;
	this.GetBounds = GetBounds;
	this.ValidateZoomLevel = ValidateZoomLevel;
}

//------------------------------------------------------------------------------
// MapControl/Tools/BoxTool.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Codye
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

function BoxTool()
{
	var bg = document.createElement("div");
	var fg = document.createElement("div");
	var x1=0, y1=0, x2=0, y2=0;
	
	this.Init = function()
	{
		bg.className = "ZoomBox_bg";
		fg.className = "ZoomBox_fg";
		
		// The elements have to reference the parent map control's mouse handlers.
		// This is only for firefox, because it lacks setCapture/releaseCapture capabilities
		bg.attachEvent("onmouseup", MouseUp);
		fg.attachEvent("onmouseup", MouseUp);
		
		if(map != null)
		{
			map.appendChild(bg);
			map.appendChild(fg);
		}
	};
	
	this.Destroy = function()
	{
		bg.detachEvent("onmouseup", MouseUp);
		fg.detachEvent("onmouseup", MouseUp);
		if(map != null)
		{
			map.removeChild(bg);
			map.removeChild(fg);
		}
	};

	function OnMouseDown(e)
	{
		if(VE_ContextMenu != null)
		{
			VE_ContextMenu.RemoveContextPin();
			VE_ContextMenu.CloseMenu();
		}
		x1 = x2 = GetMouseX(e) - x + offsetX;
		y1 = y2 = GetMouseY(e) - y + offsetY;

		SetBox(x1, y1, 1, 1);
		Show();
		
		if (fg.setCapture)
		{
			fg.setCapture();
		}
	}
	
	function OnMouseMove(e)
	{
		x2 = GetMouseX(e) - x + offsetX;
		y2 = GetMouseY(e) - y + offsetY;
		SetBox(
			MathMin(x1, x2), 
			MathMin(y1, y2), 
			MathMax(1, MathAbs(x2 - x1)), 
			MathMax(1, MathAbs(y2 - y1)));
	}
	
	function OnMouseUp(e)
	{
		if (MathAbs(x1 - x2) > 1 && MathAbs(y1 - y2) > 1)
		{
			var view = preferredView.MakeCopy();
			view.SetZoomLevel(currentView.zoomLevel); // Have to first specify what zoom level the pixel coordinates are coming in at.
			view.SetPixelRectangle(new Msn.VE.PixelRectangle(new Msn.VE.Pixel(originX + x1, originY + y1), new Msn.VE.Pixel(originX + x2, originY + y2)));
			SetView(view);
		}
		
		Hide();
		
		if (fg.releaseCapture)
		{
			fg.releaseCapture();
		}
	}
	
	function SetBox(x, y, w, h)
	{
		SetElement(bg, x+1, y+1, w, h);
		SetElement(fg, x, y, w, h);
	}
	
	function SetElement(el, x, y, w, h)
	{
		el.style.left = x + "px";
		el.style.top = y + "px";
		el.style.width = w + "px";
		el.style.height = h + "px";
	}
		
	function Show()
	{
		bg.style.display = "block";
		fg.style.display = "block";
	}
	
	function Hide()
	{
		bg.style.display = "none";
		fg.style.display = "none";
	}
	
	this.OnMouseDown = OnMouseDown;
	this.OnMouseMove = OnMouseMove;
	this.OnMouseUp = OnMouseUp;
}

//------------------------------------------------------------------------------
// MapControl/Tools/PanTool.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Codye
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

function PanTool()
{
	var moved = false;
	
	this.Init = function()
	{
	};
	
	this.Destroy = function()
	{
	};

	// The mouse down handler.  This just sets up a drag-pan session.
	function OnMouseDown(e)
	{
		moved = false;
		lastMouseX = GetMouseX(e);
		lastMouseY = GetMouseY(e);
		
		if (p_elSource.setCapture)
		{
			p_elSource.setCapture();
		}
		
		var clickX = originX + offsetX + GetMouseX(e) - x;
		var clickY = originY + offsetY + GetMouseY(e) - y;
		Fire("onstartcontinuouspan", CreateEvent(currentMode.PixelToLatLong(new Msn.VE.Pixel(clickX, clickY), currentView.zoomLevel)));	
	}
	
	function OnMouseMove(e)
	{
		var mouseX = GetMouseX(e);
		var mouseY = GetMouseY(e);
		PanMap(lastMouseX - mouseX, lastMouseY - mouseY);
		lastMouseX = mouseX;
		lastMouseY = mouseY;
		moved = true;
	}
	
	function OnMouseUp(e)
	{
		ComputeCenterPoint(true);
		
		if (p_elSource.releaseCapture)
		{
			p_elSource.releaseCapture();
		}
		
		// If a pan took place, call end pan
		if (moved)
		{
			Fire("onendcontinuouspan");
			Fire("onchangeview");
			moved = false;
		}
		
		// Call the click handler
		var clickX = originX + offsetX + GetMouseX(e) - x;
		var clickY = originY + offsetY + GetMouseY(e) - y;
		var clickEvent = CreateEvent(currentMode.PixelToLatLong(new Msn.VE.Pixel(clickX, clickY), currentView.zoomLevel));
		Fire("onmouseup", clickEvent);
		Fire("onclick", clickEvent);
	}
	
	this.OnMouseDown = OnMouseDown;
	this.OnMouseMove = OnMouseMove;
	this.OnMouseUp = OnMouseUp;
}


//------------------------------------------------------------------------------
// MapControl/Traffic.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: a-jayab, cthota
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------
//Sets Traffic 
//Returning whether traffic is already visible
function GetTrafficAvailability()
{	
	return trafficAvailable;
}

function GetSlidingExpirationForAutoRefresh()
{
	return __trafficSlidingExpirationTime__;
}

function GetAutoRefreshRate()
{
	return __trafficAutoRefreshRate__;
}

function GetMarketsFile()
{	
	return "__trafficMarkets__";
}

function GetIncidentsFile()
{
	return "__trafficIncidents__";
}	

var setTrafficViewflag = true;

function SetTrafficView()
{
	if(setTrafficViewflag)
	{
		setTrafficViewflag = false;
		trafficAvailable = true;	   			
		oldTrafficList = currentTrafficTilesList;
		// Clear the existing tiles
		ClearTiles(currentTrafficTilesList);
		currentTrafficTilesList = new Array();
		
		//then call traffic tiling	
		window.setTimeout(StartTrafficView, 1);
	}
	else
		window.setTimeout(SetTrafficView, 1);
}

//This function gets traffic tiles from traffic server based on current viewport
//It should only be called from SetTrafficView.
function StartTrafficView()
{	
	if(setTrafficViewflag) //just in case
		return;
		
	for (var y=tileViewportY1; y<=tileViewportY2; y++)
	{
		for (var x=tileViewportX1; x<=tileViewportX2; x++)
		{
			//1 is reserved for traffic
			var tile = RequestTile(x, y, currentView.zoomLevel, currentView.mapStyle, 1);
			currentTrafficTilesList.push(tile);			
		}
	}
	
	setTrafficViewflag = true;
}

//This function removes the traffic layer using the Traffic legend
function RemoveTrafficLayer()
{
	trafficAvailable = false; 
	if(currentTrafficTilesList != null)
		ClearTiles(currentTrafficTilesList);	
	ClearTrafficLayer();
}

//This function removes the traffic layer
function ClearTrafficLayer()
{	
	// Remove the old traffic tiles
	if(oldTrafficList!= null)
	{		
		ClearTiles(oldTrafficList);
		oldTrafficList = null;
	}
}

//This function lays traffic tiles over road tiles
function SetTrafficLayer()
{
	for(var i=0; i<currentTrafficTilesList.length; i++)
	{
		currentTrafficTilesList[i].SwapStates();
		currentTrafficTilesList[i].ClearSteps();			
		currentTrafficTilesList[i].SetFactor(0);
	}
}

//This function swaps tiles for reconstructing traffic views on zoom change
function SwapTrafficLayer()
{
	// map container can be set at left=0px, top=0px
	var oldOriginX = originX + offsetX;
	var oldOriginY = originY + offsetY;
	var oldZoom = currentView.zoomLevel;
	var newZoom = layerRequestedView.zoomLevel;
	
	// New origin
	var newOriginX = MathRound(layerRequestedView.center.x - width/2);
	var newOriginY = MathRound(layerRequestedView.center.y - height/2);

	for(var i=0; i<currentTrafficTilesList.length; i++)
	{
		currentTrafficTilesList[i].PrepareSwapTile(oldOriginX, oldOriginY, oldZoom, newOriginX, newOriginY, newZoom);
	}
}

function UpdateTrafficLayer()
{
	// No updates during zoom.  UpdateView is really only applicable during panning.
	if (zooming)
	{
		return;
	}
	
	var ox = originX + offsetX;
	var oy = originY + offsetY;

	var x1 = MathFloor((ox - buffer) / tileSize);
	var y1 = MathFloor((oy - buffer) / tileSize);
	var x2 = MathFloor((ox + width + buffer) / tileSize);
	var y2 = MathFloor((oy + height + buffer) / tileSize);
	
	var X1 = tileViewportX1;
    var X2 = tileViewportX2;
    var Y1 = tileViewportY1;
    var Y2 = tileViewportY2;
    var W1 = tileViewportWidth;
    var H1 = tileViewportHeight;
    
    	// While the map is too far to the left
	while (tileViewportX1 < x1)
	{
		// Remove each of the tiles in the left column
		// Start from the bottom and work backwards so the tiles on top retain their correct indexes
		for (var y=tileViewportHeight-1; y>=0; y--)
		{			
			var ttile = currentTrafficTilesList.splice(y * tileViewportWidth, 1)[0];
			try
			{
				ttile.RemoveFromMap();
			}
			catch(ex)
			{
				//swallow
			}
			
		}
		
		tileViewportX1++;
		tileViewportWidth--;
	}
	
	// While the map isn't far enough to the left
	while (tileViewportX1 > x1)
	{
		// Add tiles to a new left column
		tileViewportX1--;
		tileViewportWidth++;
		
		for (var y=0; y<tileViewportHeight; y++)
		{			
			var ttile = RequestTile(tileViewportX1, tileViewportY1 + y, currentView.zoomLevel, currentView.mapStyle, 1);
			currentTrafficTilesList.splice(y * tileViewportWidth, 0, ttile);
		}
	}
	
	// While the map is too far to the top
	while (tileViewportY1 < y1)
	{
		// Remove the top row
		for (var x=0; x<tileViewportWidth; x++)
		{			
			var ttile = currentTrafficTilesList.shift();
			try
			{
				ttile.RemoveFromMap();
			}
			catch(ex)
			{
				//swallow
			}
		}		
		
		tileViewportY1++;
		tileViewportHeight--;
	}
	
	// While the map isn't far enough to the top
	while (tileViewportY1 > y1)
	{
		// Add a row to the top
		tileViewportY1--;
		tileViewportHeight++;
		
		// Start from the right side of the row so the tiles can be added to the front each time
		for (var x=tileViewportWidth-1; x>=0; x--)
		{
			var ttile = RequestTile(tileViewportX1 + x, tileViewportY1, currentView.zoomLevel, currentView.mapStyle, 1);
			currentTrafficTilesList.unshift(ttile);
		}
	}
	
	// While the map is too far to the right
	while (tileViewportX2 > x2)
	{
		// Remove each of the tiles in the right column
		// Start from the bottom and work backwards so the tiles on top retain their correct indexes
		for (var y=tileViewportHeight-1; y>=0; y--)
		{			
			var ttile = currentTrafficTilesList.splice(y * tileViewportWidth + tileViewportWidth - 1, 1)[0];
			try
			{
				ttile.RemoveFromMap();
			}
			catch(ex)
			{
				//swallow
			}
		}
		
		tileViewportX2--;
		tileViewportWidth--;
	}
	
	// While the map isn't far enough to the right
	while (tileViewportX2 < x2)
	{
		// Add tiles to a new right column
		tileViewportX2++;
		tileViewportWidth++;
		
		for (var y=0; y<tileViewportHeight; y++)
		{			
			var ttile = RequestTile(tileViewportX2, tileViewportY1 + y, currentView.zoomLevel, currentView.mapStyle, 1);		
			currentTrafficTilesList.splice(y * tileViewportWidth + tileViewportWidth - 1, 0, ttile);
		}
	}
	
	// While the map is too far down
	while (tileViewportY2 > y2)
	{
		// Remove the bottom row
		for (var x=0; x<tileViewportWidth; x++)
		{
			var ttile = currentTrafficTilesList.pop();
			try
			{
				ttile.RemoveFromMap();
			}
			catch(ex)
			{
				//swallow
			}
		}
		
		tileViewportY2--;
		tileViewportHeight--;
	}
	
	// While the map isn't far down enough
	while (tileViewportY2 < y2)
	{
		// Add a row to the bottom
		tileViewportY2++;
		tileViewportHeight++;
		
		// Start from the right side of the row so the tiles can be added to the front each time
		for (var x=0; x<tileViewportWidth; x++)
		{
			var ttile = RequestTile(tileViewportX1 + x, tileViewportY2, currentView.zoomLevel, currentView.mapStyle, 1);
			currentTrafficTilesList.push(ttile);
		}
	}		
}
//------------------------------------------------------------------------------
// MapControl/Layer.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: a-jayab, cthota
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// The current tiles list is a 1-dimensional array of Traffic tile objects.  The order of the tiles
// array is very important and must be preserved for UpdateView to function properly.
// The order starts at the top left, moves to the right across the top row, then starts
// again at the left most tile on the next row down.
var currentTrafficTilesList = new Array();	
	
var oldTrafficList = null;

var layerRequestedView = null;
	
//This function is called when we have to clear the layers
function ClearLayer()
{
	if(trafficAvailable && trafficAvailable == true)
		ClearTrafficLayer();
}

//This function is called to overlay a layer of tiles(eg traffic tiles) over existing route
function SetLayer()
{
	if(trafficAvailable && trafficAvailable == true)
		SetTrafficLayer();	
}

//This function is called to request tiles layer from the tile server
function SetLayerView()
{
	if(trafficAvailable && trafficAvailable == true)
		SetTrafficView();
}

//This function is called to swap tile layer tiles during zoom.
function SwapLayer()
{
	if(trafficAvailable && trafficAvailable == true)
		SwapTrafficLayer();
}

//This function is called to update tile layer tiles during panning.
function UpdateLayer()
{	
	if(trafficAvailable && trafficAvailable == true)
	{		
		UpdateTrafficLayer();
	}
}

	// Publish the public methods.  With the javascript closure pattern, functions are, by default, not visible
	// to external code.  Therefore, we must publish the methods by making them publicly accessible to the "this"
	// object.
	this.SetCenter = SetCenter;
	this.SetMapStyle = SetMapStyle;
	this.GetCenterLatitude = GetCenterLatitude;
	this.GetCenterLongitude = GetCenterLongitude;
	this.GetLatitude = GetLatitude;
	this.GetLongitude = GetLongitude;
	this.GetY = GetY;
	this.GetX = GetX;
	this.LatLongToPixel = LatLongToPixel;
	this.PixelToLatLong = PixelToLatLong;
	this.GetZoomLevel = GetZoomLevel;
	this.GetMapStyle = GetMapStyle;
	this.GetMetersPerPixel = GetMetersPerPixel;
	this.Resize = Resize;
	this.PanMap = PanMap;
	this.ContinuousPan = ContinuousPan;
	this.StopContinuousPan = StopContinuousPan;
	this.StopKeyboardPan = StopKeyboardPan;
	this.PanToLatLong = PanToLatLong;
	this.GetPushpins = GetPushpins;
	this.AddPushpin = AddPushpin;
	this.RemovePushpin = RemovePushpin;
	this.ClearPushpins = ClearPushpins;
	this.SetViewport = SetViewport;
	this.SetBestMapView = SetBestMapView;
	this.IncludePointInViewport = IncludePointInViewport;
	this.SetZoom = SetZoom;
	this.ZoomIn = ZoomIn;
	this.ZoomOut = ZoomOut;
	this.SetCenterAndZoom = SetCenterAndZoom;
	this.AddLine = AddLine;
	this.RemoveLine = RemoveLine;
	this.ClearLines = ClearLines;
	this.AttachEvent = AttachEvent;
	this.DetachEvent = DetachEvent;
	this.IsObliqueAvailable = IsObliqueAvailable;
	this.GetObliqueScene = GetObliqueScene;
	this.SetAnimationEnabled = SetAnimationEnabled;
	this.IsAnimationEnabled = IsAnimationEnabled;
	this.SetObliqueScene = SetObliqueScene;
	this.SetObliqueOrientation = SetObliqueOrientation;
	this.SetView = SetView;
	this.Debug = Debug;
	this.GetResponseRangeCounts = GetResponseRangeCounts;
	this.ResetResponseRangeCounts = ResetResponseRangeCounts;
	this.GetFailureRate = GetFailureRate;
	this.SetTrafficView = SetTrafficView;
	this.GetTrafficAvailability = GetTrafficAvailability;
	this.RemoveTrafficLayer = RemoveTrafficLayer;
	this.GetMarketsFile = GetMarketsFile;
	this.GetIncidentsFile = GetIncidentsFile;
	this.GetSlidingExpirationForAutoRefresh = GetSlidingExpirationForAutoRefresh;
	this.GetAutoRefreshRate = GetAutoRefreshRate;
	this.SetCopyrightOffset = SetCopyrightOffset;
	this.SetFocus = SetFocus;	
};

//------------------------------------------------------------------------------
// MapControl/Bounds.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


// Creates a new bounds object
Msn.VE.Bounds = function(z1, z2, x1, y1, x2, y2)
{
	this.z1 = z1;
	this.z2 = z2;
	
	this.x1 = x1;
	this.y1 = y1;
	this.x2 = x2;
	this.y2 = y2;
};
//------------------------------------------------------------------------------
// MapControl/Dashboard/Dashboard.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Codye, sstchur
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// The dashboard is a widget that can control the map.  It includes links for adjusting the map
// style, a compass for panning, a zoom slider, notification for oblique, and oblique controls
// when in that mode.
Msn.VE.Dashboard = function(element, map, size)
{
	// Header
	var header = document.createElement('div');
	header.className = 'header';
	element.appendChild(header);
	var toggleGlyph = new Microsoft.Web.UI.IEGlyph(null, 'toggleGlyph');
	var toggleGlyphElement = toggleGlyph.getElement();
	header.appendChild( toggleGlyphElement );
	
	// Dashboard starts out expanded
	element.className += ' expanded';

	// The tab objects are just the links for the corresponding map styles.
	var roadTab = document.createElement("div");
	var aerialTab = document.createElement("div");
	var obliqueTab = document.createElement("div");
	var selectedTab = null;
	
	var separator = document.createElement("hr");
	
	// The labels container wraps the toggle labels checkbox and the corresponding tooltip.
	var labelsContainer = document.createElement("div");
	var labelsCheckbox = document.createElement("input");
	
	// IE won't let you change the value of a checkbox before it has been displayed.  We want
	// to default to checked (labels on, hybrid mode), so we have to keep track of the first
	// aerial view.  If it's the first view, we override the value of the checkbox and force 
	// hybrid mode.
	var firstAerial = true;
	
	// The compass control
	var compass = null;
	
	var obliqueCompass = null;
	
	// The ortho zoom widget.  This is the slider control, only used in ortho modes.
	var orthoZoom = null;
	
	// The oblique zoom widget.  This is just 2 boxes representing the 2 zoom levels, only used in oblique.
	var obliqueZoom = null;
		
	// The oblique notification shows a image thumbnail and a brief message which subtly alerts
	// the user that oblique imagery is now available.  It is only displayed in ortho modes.
	var obliqueNotification = null;
	
	// The oblique selector is the 3x3 set of images representing neighboring images and the current image.
	// It also includes up to 3 links below for rotated images in roughly the same spot.
	var obliqueSelector = null;
	
	var containerTable = document.createElement("table");
	containerTable.className = "dashboardContainerTable";
	var containerTBody = document.createElement("tbody");
	var compassZoomRow = document.createElement("tr");
	containerTable.appendChild(containerTBody);
	containerTBody.appendChild(compassZoomRow);
	
	var compassCell  = document.createElement("td");
	
	var zoomCell = document.createElement("td");
	zoomCell.vAlign = "top";
	
	var notificationCell = document.createElement("td");
	notificationCell.colSpan = 2;
	notificationCell.setAttribute("colspan", 2);
	notificationCell.className = "obliqueSelectorTable";
	
	compassZoomRow.appendChild(compassCell);
	compassZoomRow.appendChild(zoomCell);
	
	var notificationRow = document.createElement("tr");
	notificationRow.appendChild(notificationCell);
	
	containerTBody.appendChild(notificationRow);
		
	// Creates the control and sets up the event listeners
	this.Init = function()
	{
		var mapStyle = map.GetMapStyle();
		
		if ( Msn.VE.Marketization.IsEnabled( MapControl.Features.MapStyle.Road ) )
			CreateTab(roadTab, L_DashboardRoad_Text , OnRoad);
		if ( Msn.VE.Marketization.IsEnabled( MapControl.Features.MapStyle.Aerial ) )
			CreateTab(aerialTab, L_DashboardAerial_Text, OnAerial);
		if ( Msn.VE.Marketization.IsEnabled( MapControl.Features.MapStyle.BirdsEye ) )
			CreateTab(obliqueTab, L_DashboardBirdsEye_Text , OnOblique); 

		separator.className = "Dashboard_separator";
		element.appendChild(separator);
		
		element.appendChild(containerTable);
		if (!size || size == Msn.VE.DashboardSize.Normal)
		{
			compass = new Compass(compassCell, 5, 30);
			compass.Init();
			compass.Show();
		}	    
	    
		obliqueCompass = new ObliqueCompass(compassCell);
		obliqueCompass.Hide();
		
		orthoZoom = new OrthoZoomBar(zoomCell, 100, 30);
		orthoZoom.Init();
		
		obliqueZoom = new ObliqueZoomBar(zoomCell);
		
		//Hide the ToggleGlyph by default
		this.HideToggleGlyph();
		
		// Create show labels option only if supported
		if ( Msn.VE.Marketization.IsEnabled( MapControl.Features.MapStyle.Hybrid ) )
		{
			CreateLabelsToggle();
		}
		// create Oblique selector only if supported
		if ( Msn.VE.Marketization.IsEnabled( MapControl.Features.MapStyle.BirdsEye ) )
		{
			CreateObliqueNotification();		
			obliqueSelector = new ObliqueSelector(notificationCell);
			obliqueSelector.Init();
		}	
		
		map.AttachEvent("onendzoom", OnZoom);
		map.AttachEvent("onchangemapstyle", OnChangeMapStyle);
		
		// attach event to the Oblique mode only if supported
		if ( Msn.VE.Marketization.IsEnabled( MapControl.Features.MapStyle.BirdsEye ) )
		{
			map.AttachEvent("onobliqueenter", OnObliqueEnter);
			map.AttachEvent("onobliqueleave", OnObliqueLeave);
			map.AttachEvent("onobliquechange", OnObliqueChange);
		}	
		// Enable/Disable Oblique only if supported
		if ( Msn.VE.Marketization.IsEnabled( MapControl.Features.MapStyle.BirdsEye ) )
		{
			if (map.IsObliqueAvailable())
			{
				EnableOblique();
			}
			else
			{
				DisableOblique();
			}
		}
		
		switch (mapStyle)
		{
			case 'r':
				SetRoadTab();
				break;
			
			case 'a':
			case 'h':
				SetAerialTab();
				break;
				
			case 'o':
				SetObliqueTab();
				break;
		}
	};
	
	// Destroys the dashboard and attempts to free up as much memory as possible.
	// Unhooks all events and dereferences all objects.
	this.Destroy = function()
	{
		// Clean up the tabs
		if ( Msn.VE.Marketization.IsEnabled( MapControl.Features.MapStyle.Road ) )
			DestroyTab(roadTab, OnRoad);
		if ( Msn.VE.Marketization.IsEnabled( MapControl.Features.MapStyle.Aerial ) )
			DestroyTab(aerialTab, OnAerial);
		if ( Msn.VE.Marketization.IsEnabled( MapControl.Features.MapStyle.BirdsEye ) )
			DestroyTab(obliqueTab, OnOblique);
		
		selectedTab = roadTab = aerialTab = obliqueTab = null;
		
		header.removeChild( toggleGlyphElement );
		element.removeChild( header );		
		
		header = toggleGlyphElement = toggleGlyph = null;
		
		// detach events and elements for show labels option only if supported
		if ( Msn.VE.Marketization.IsEnabled( MapControl.Features.MapStyle.Hybrid ) )
		{
			// The toggle labels UI
			labelsContainer.removeChild(labelsCheckbox);
			zoomCell.removeChild(labelsContainer);
			labelsContainer.detachEvent("onclick", OnToggleLabels);
			labelsContainer = labelsCheckbox = null;
		}
		
		// Destroy the compass
		if (compass)
		{
			compass.Destroy();
			compass = null;
		}
		
		if ( obliqueCompass )
		{		
			obliqueCompass.Destroy();
			obliqueCompass = null;
		}
		if ( orthoZoom )
		{
			orthoZoom.Destroy();
			orthoZoom = null;
		}
		if(obliqueZoom)
		{
			obliqueZoom.Destroy();
			obliqueZoom = null;
		}
		
		if ( obliqueNotification )
		{
			obliqueNotification.detachEvent("onclick", OnOblique);
			obliqueNotification = null;
		}	
		// Destroy the oblique imagery selector
		if (obliqueSelector)
		{
			obliqueSelector.Destroy();
			obliqueSelector = null;
		}
		
		// Unhook from map events and null out the reference to the map
		if (map)
		{
			map.DetachEvent("onendzoom", OnZoom);
			map.DetachEvent("onchangemapstyle", OnChangeMapStyle);
			
			// detachevent to the Oblique mode only if supported
			if ( Msn.VE.Marketization.IsEnabled( MapControl.Features.MapStyle.BirdsEye ) )
			{
				map.DetachEvent("onobliqueenter", OnObliqueEnter);
				map.DetachEvent("onobliqueleave", OnObliqueLeave);
				map.DetachEvent("onobliquechange", OnObliqueChange);
			}	
			
			map = null;
		}
		
	};
	
	
	// Added by sstchur:
	// Sets the X position of the dashboard	
	this.SetX = function(xPos)
	{
		element.style.left = xPos + 'px';
	};
	
	// Added by sstchur:
	// Get a reference to the Dashboard element
	this.GetElement = function()
	{
		return element;
	};
	
	this.GetHeader = function()
	{
		return header;
	};
	
	// Returns the top of the dashboard element
	this.GetY = function()
	{
		return GetTopPosition(element);
	};
	
	// Returns the height of the dashboard element
	this.GetHeight = function()
	{
		return element.offsetHeight;
	};
	
	// Show the Toggle Glyph on Dashboard
	this.ShowToggleGlyph = function()
	{
		if ((toggleGlyphElement != null) && (toggleGlyphElement != "undefined"))
		{
			toggleGlyphElement.style.display = "block";
		}
	};

	// Hide the Toggle Glyph on Dashboard
	this.HideToggleGlyph = function()
	{
		if ((toggleGlyphElement != null) && (toggleGlyphElement != "undefined"))
		{
			toggleGlyphElement.style.display = "none";
		}
	};

	// Creates a new tab element
	function CreateTab(tab, name, callback, selected)
	{
		tab.className = "Dashboard_tab Dashboard_unselected";
		tab.href = "javascript:void(0)";
		tab.innerText = name ; 		
		tab.attachEvent("onclick", callback);

		var lastChild = header.lastChild;
		if (lastChild && typeof lastChild != 'undefined')
			{ header.insertBefore(tab, lastChild); }
		else
			{ header.appendChild(tab); }
	}
	
	// Destroys a tab
	function DestroyTab(tab, callback)
	{	
		tab.detachEvent("onclick", callback);
		//Two levels of checks
		//null check for header
		//removeChild exceptions 
		if(header != null)
		{	try
			{		
				header.removeChild(tab);
			}
			catch(exp)
			{
				//swallow
			}
		}
	}
	
	// Selects a tab.  If a different tab was previously selected, it
	// reverts it to unselected state.
	function SelectTab(tab)
	{
		if (selectedTab)
		{
			selectedTab.className = "Dashboard_tab Dashboard_unselected";
		}
		
		tab.className = "Dashboard_tab Dashboard_selected";
		selectedTab = tab;
	}
	
	// Creates the labels toggler, which is only used in aerial mode.  The toggle
	// is a way for users to more easily understand the difference between
	// aerial and hybrid map styles.
	function CreateLabelsToggle()
	{
		labelsCheckbox.type = "checkbox";
		labelsContainer.className = "Dashboard_toggler";
		labelsContainer.style.display = "none";
		labelsContainer.attachEvent("onclick", OnToggleLabels);
		labelsContainer.appendChild(labelsCheckbox);
		labelsContainer.appendChild(document.createTextNode(L_DashboardShowLabels_Text));
		zoomCell.appendChild(labelsContainer);
	}

	// Creates the oblique notification area.  The notification shows a thumbnail
	// of the best image for the current location and a short message.  If the user
	// clicks on the notification, the map should change to oblique mode, just as if
	// the user had clicked on the oblique link.
	function CreateObliqueNotification()
	{
		obliqueNotification = document.createElement("div");
		obliqueNotification.className = "Dashboard_notification";
		obliqueNotification.innerHTML = "<div id=\"obliqueNotifyIcon\">&nbsp;</div> " + L_DashboardBirdsEyeText_Text;
		obliqueNotification.style.display = "none";
		obliqueNotification.attachEvent("onclick", OnOblique);
		notificationCell.appendChild(obliqueNotification);
	}
	
	// Sets the road tab.  
	// * Turns off the label toggler if it's visible.  
	// * Turns off the oblique selector if it's visible.
	// * Turns on the oblique notification if it's applicable.
	function SetRoadTab()
	{	
		SelectTab(roadTab);		
		
		// hide show labels option only if supported
		if ( Msn.VE.Marketization.IsEnabled( MapControl.Features.MapStyle.Hybrid ) )
		{
			labelsContainer.style.display = "none";
		}	
		
		if ( obliqueSelector )
			obliqueSelector.Hide();
		obliqueZoom.Hide();
		orthoZoom.Show();
		
		// display Birds eye view only if supported
		if (map.IsObliqueAvailable() && Msn.VE.Marketization.IsEnabled( MapControl.Features.MapStyle.BirdsEye ) )
		{
			obliqueNotification.style.display = "block";
			
		}
		if (compass)
		{
			compass.Show();
		}
		obliqueCompass.Hide();
	}
	
	// Sets the aerial tab
	// * Turns on the label toggler if it's visible.  
	// * Turns off the oblique selector if it's visible.
	// * Sets the checkbox to the appropriate value
	// * Turns on the oblique notification if it's applicable.
	function SetAerialTab()
	{	
		SelectTab(aerialTab);
		
		// display show labels option only if supported
		if ( Msn.VE.Marketization.IsEnabled( MapControl.Features.MapStyle.Hybrid ) )
		{
			labelsContainer.style.display = "block";
		}	
		if ( obliqueSelector ) 
			obliqueSelector.Hide();
		obliqueZoom.Hide();
		orthoZoom.Show();
		
		// Check/uncheck "show labels" option only if supported
		if ( Msn.VE.Marketization.IsEnabled( MapControl.Features.MapStyle.Hybrid ) )
		{
			if (map.GetMapStyle() == 'h'  )
			{
				labelsCheckbox.checked = true;
			}
			else
			{
				labelsCheckbox.checked = false;
			}
		}	
		
		// display Birds eye view only if supported
		if (map.IsObliqueAvailable() && Msn.VE.Marketization.IsEnabled( MapControl.Features.MapStyle.BirdsEye ) )
		{
			obliqueNotification.style.display = "block";
		}
		if (compass)
		{
			compass.Show();
		}
		obliqueCompass.Hide();
	}
	
	// Sets the oblique tab
	// * Turns off the label toggler if it's visible. 
	// * Turns off the oblique notification if it's applicable. 
	// * Turns on the oblique selector if it's visible.
	function SetObliqueTab()
	{
		SelectTab(obliqueTab);
		labelsContainer.style.display = "none";
		obliqueNotification.style.display = "none";
		obliqueSelector.Show();
		orthoZoom.Hide();
		obliqueZoom.Show();
		if (compass)
		{
			compass.Hide();
		}
		obliqueCompass.Show();
	}
	
	// Enables the oblique link and shows the oblique notification.
	function EnableOblique()
	{
		obliqueTab.className = "Dashboard_tab Dashboard_unselected";
		obliqueNotification.style.display = "block";
	}
	
	// Disables the oblique link and hides the oblique notification
	function DisableOblique()
	{
		obliqueTab.className = "Dashboard_tab Dashboard_disabled";
		obliqueNotification.style.display = "none";
	}
	
	// Handler for the road link.  Sends the message to the map control and
	// updates the dashboard UI.
	function OnRoad()
	{	
		map.SetMapStyle('r');
	}
	
	// Handler for the aerial link.  Sends the message to the map control and
	// updates the dashboard UI.
	function OnAerial()
	{
		// set Mapstyle to hybrid only if supported
		if ( (firstAerial || labelsCheckbox.checked) && Msn.VE.Marketization.IsEnabled( MapControl.Features.MapStyle.Hybrid ) )
		{
			map.SetMapStyle('h');
		}
		else
		{
			map.SetMapStyle('a');
		}
		firstAerial = false;
	}
	
	// Handler for the oblique link.  Sends the message to the map control and
	// updates the dashboard UI.
	function OnOblique()
	{
		map.SetMapStyle('o');
	}
	
	// Handler for the labels checkbox when in aerial mode.  The labels checkbox
	// is a simple toggle between aerial and hybrid map styles.
	function OnToggleLabels(e)
	{	
		var mapStyle = map.GetMapStyle();
		if (mapStyle == 'a')
		{
			map.SetMapStyle('h');
			labelsCheckbox.checked = true;
		}
		else if (mapStyle == 'h')
		{
			map.SetMapStyle('a');
			labelsCheckbox.checked = false;
		}
	}
	
	// Handler for when the map control zooms.  Updates the appropriate zoom widgets.
	function OnZoom(e)
	{
		orthoZoom.UpdateFromMap();
		obliqueZoom.UpdateFromMap();
	}

	// Handler for when oblique imagery becomes available.  Enables links, shows the notification.
	function OnObliqueEnter(e)
	{
		if (map.GetMapStyle() == "o")
		{
			return;
		}
	
		EnableOblique();
		obliqueCompass.UpdateFromMap();
	}
	
	// Handler for when oblique is no longer available.  Disables links, hides the notification.
	function OnObliqueLeave(e)
	{
		DisableOblique();
	}
	
	// Handler for when the map control changes map styles by another means (perhaps keyboard shortcuts 
	// or another UI control).  Updates the UI accordingly
	function OnChangeMapStyle(e)
	{
		switch (e.view.mapStyle)
		{
			case 'r':
				SetRoadTab();
				break;
			
			case 'a':
			case 'h':
				SetAerialTab();
				break;
				
			case 'o':
				SetObliqueTab();
				break;
		}
	}
	
	// Handler for when oblique changes images.  Update the selector's neighbor and rotation links
	function OnObliqueChange(e)
	{
		obliqueSelector.Update();
		obliqueCompass.UpdateFromMap();
	}
	
//------------------------------------------------------------------------------
// MapControl/Dashboard/Compass.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Codye
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// Constructor.  Creates a new compass that is added to the specified parent element.
function Compass(parent)
{
	// The dom element for the control
	var element = document.createElement("div");
	
	// The position of the compass control.  The position is recalculated
	// at every mouse down event.
	var x=0, y=0;

	// Represents whether or not the control is currently panning
	var panning = false;

	// The maximum speed that the pan control will allow
	var maxScrollSpeed = 15;

	// Creates the control and sets up the event listeners
	this.Init = function()
	{
		element.className = "Compass";
		element.attachEvent("onmousedown", MouseDown);
		element.attachEvent("onmouseup", MouseUp);
		element.attachEvent("onmousemove", MouseMove);
		element.attachEvent("ondblclick", IgnoreEvent);
		parent.appendChild(element);
	};
	
	// Unhooks events and nulls out elements to release memory.
	this.Destroy = function()
	{
		element.detachEvent("onmousedown", MouseDown);
		element.detachEvent("onmouseup", MouseUp);
		element.detachEvent("onmousemove", MouseMove);
		element.detachEvent("ondblclick", IgnoreEvent);
		
		element = null;
	};

	// Handles the mouse down event, starting the continuous pan.
	function MouseDown(e)
	{
		// Get and cancel the event.  Don't want it to bubble up to the parent element.
		e = GetEvent(e);
		CancelEvent(e);
		
		// Compute the position at every mouse down.  This is necessary if the 
		// position of the control changes.
		x = GetLeftPosition(element);
		y = GetTopPosition(element);
	
		if(element.setCapture)
		{
			element.setCapture();
		}
		
		var dx = GetMouseX(e) - x - (element.offsetWidth/2);
		var dy = GetMouseY(e) - y - (element.offsetHeight/2);
		dx = Math.min(Math.max(dx, -maxScrollSpeed), maxScrollSpeed);
		dy = Math.min(Math.max(dy, -maxScrollSpeed), maxScrollSpeed);
		map.ContinuousPan(dx, dy);
		panning = true;
		
		return false;
	}
	
	// Handles the mouse move event, adjusting the speed and direction of the pan.
	function MouseMove(e)
	{
		// Get and cancel the event.  Don't want it to bubble up to the parent element.
		e = GetEvent(e);
		CancelEvent(e);
		
		// Mouse move only matters if the mouse is down and we're actually panning.
		if(panning)
		{
			var dx = GetMouseX(e) - x - (element.offsetWidth/2);
			var dy = GetMouseY(e) - y - (element.offsetHeight/2);
			dx = Math.min(Math.max(dx, -maxScrollSpeed), maxScrollSpeed);
			dy = Math.min(Math.max(dy, -maxScrollSpeed), maxScrollSpeed);
			map.ContinuousPan(dx, dy);
		}
		
		return false;
	}

	// Handles the mouse up event, ending the continuous pan.
	function MouseUp(e)
	{
		// Get and cancel the event.  Don't want it to bubble up to the parent element.
		e = GetEvent(e);
		CancelEvent(e);
		
		if(element.releaseCapture)
		{
			element.releaseCapture();
		}
		
		map.StopContinuousPan();
		panning = false;
		
		return false;
	}
	
	function Hide()
	{
		element.style.display = "none";
	}
	
	function Show()
	{
		element.style.display = "block";
	}
	
	this.Hide = Hide;
	this.Show = Show;
}
//------------------------------------------------------------------------------
// MapControl/Dashboard/ObliqueSelector.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Codye
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// The oblique selector is the UI element that displays thumbnails of the neighboring
// scenes to assist the user in oblique navigation.
function ObliqueSelector(parent)
{
	// The primary element is the table.
	var element = document.createElement("table");
	
	// Cells is a 2d array of ObliqueSelectorLink objects
	var cells = new Array(3);
	
	// Initializes the selector
	this.Init = function()
	{
		element.className = "obliqueSelectorTable";
	
		// By default, the selector is hidden.
		Hide();
		
		// Add the table to the parent element.
		parent.appendChild(element);
		
		// Create the TBODY.  This is required for FirFox.
		var tbody = document.createElement("tbody");
		tbody.className = "obliqueSelectorTable";
		element.appendChild(tbody);
		
		// Create the links
		for (var i=0; i<3; i++)
		{
			var row = document.createElement("tr");
			tbody.appendChild(row);
			cells[i] = new Array(3);
			
			for (var j=0; j<3; j++)
			{
				var link = document.createElement("div");
				
				var cell = document.createElement("td");
				row.appendChild(cell);
				
				cell.appendChild(link);
				
				link.className = "Dashboard_thumbnail";
				
				if (i == 1 && j == 1)
				{
					// The center cell has a unique class and is not enabled
					cells[i][j] = new ObliqueSelectorLink(link, false);
					cell.className = "obliqueSelectorCellCenter";
					//link.style.padding = "1px";
				}
				else
				{
					cells[i][j] = new ObliqueSelectorLink(link, true);
					cell.className = "obliqueSelectorCellOff";
				}
				
				cells[i][j].Init();
			}
		}
	};
	
	// Destroys the selector
	this.Destroy = function()
	{
		parent.removeChild(element);
		element = null;
		
		for (var i=0; i<cells.length; i++)
		{
			for (var j=0; j<cells[i].length; j++)
			{
				cells[i][j].Destroy();
				cells[i][j] = null;
			}
		}
		
		cells = null;
	};
	
	// Shows the selector
	function Show()
	{
		Update();
		element.style.display = "block";
	}
	
	// Hides the selector
	function Hide()
	{
		element.style.display = "none";
	}
	
	// Updates all the links with the latest scene in the map control.
	function Update()
	{
		var scene = map.GetObliqueScene();
		if (!scene)
		{
			return;
		}
				
		cells[1][1].SetScene(scene);
		
		switch (scene.GetOrientation())
		{
			case "North":
				cells[0][0].SetScene(scene.GetNeighbor("Northwest"));
				cells[0][1].SetScene(scene.GetNeighbor("North"));
				cells[0][2].SetScene(scene.GetNeighbor("Northeast"));
				
				cells[1][0].SetScene(scene.GetNeighbor("West"));
				cells[1][2].SetScene(scene.GetNeighbor("East"));
				
				cells[2][0].SetScene(scene.GetNeighbor("Southwest"));
				cells[2][1].SetScene(scene.GetNeighbor("South"));
				cells[2][2].SetScene(scene.GetNeighbor("Southeast"));
				break;
				
			case "East":
				cells[0][0].SetScene(scene.GetNeighbor("Northeast"));
				cells[0][1].SetScene(scene.GetNeighbor("East"));
				cells[0][2].SetScene(scene.GetNeighbor("Southeast"));
				
				cells[1][0].SetScene(scene.GetNeighbor("North"));
				cells[1][2].SetScene(scene.GetNeighbor("South"));
				
				cells[2][0].SetScene(scene.GetNeighbor("Northwest"));
				cells[2][1].SetScene(scene.GetNeighbor("West"));
				cells[2][2].SetScene(scene.GetNeighbor("Southwest"));
				break;
				
			case "West":
				cells[0][0].SetScene(scene.GetNeighbor("Southwest"));
				cells[0][1].SetScene(scene.GetNeighbor("West"));
				cells[0][2].SetScene(scene.GetNeighbor("Northwest"));
				
				cells[1][0].SetScene(scene.GetNeighbor("South"));
				cells[1][2].SetScene(scene.GetNeighbor("North"));
				
				cells[2][0].SetScene(scene.GetNeighbor("Southeast"));
				cells[2][1].SetScene(scene.GetNeighbor("East"));
				cells[2][2].SetScene(scene.GetNeighbor("Northeast"));
				break;
				
			case "South":
				cells[0][0].SetScene(scene.GetNeighbor("Southeast"));
				cells[0][1].SetScene(scene.GetNeighbor("South"));
				cells[0][2].SetScene(scene.GetNeighbor("Southwest"));
				
				cells[1][0].SetScene(scene.GetNeighbor("East"));
				cells[1][2].SetScene(scene.GetNeighbor("West"));
				
				cells[2][0].SetScene(scene.GetNeighbor("Northeast"));
				cells[2][1].SetScene(scene.GetNeighbor("North"));
				cells[2][2].SetScene(scene.GetNeighbor("Northwest"));
				break;
		}
	}
	
	// The oblique selector link is a wrapper around the links.
	// This provides a nice clean way of handling the click events for the thumbnails.
	function ObliqueSelectorLink(link, enabled)
	{
		var scene = null;
		
		this.Init = function()
		{
			link.title = L_ObliqueSelectorSelectThumbnail_Text;			
			
			if (enabled)
			{
				link.attachEvent("onclick", OnClick);
				link.attachEvent("onmouseover", OnMouseOver);
				link.attachEvent("onmouseout", OnMouseOut);
			}
		};
		
		this.Destroy = function()
		{
			if (enabled)
			{
				link.detachEvent("onclick", OnClick);
				link.detachEvent("onmouseover", OnMouseOver);
				link.detachEvent("onmouseout", OnMouseOut);
			}
		};
		
		this.SetScene = function(s)
		{
			scene = s;
			
			if (scene)
			{
				link.innerHTML = "<img src=\"" + scene.GetThumbnailFilename() + "\" width=48 height=48 border=0>";
				
				if (enabled)
			    {
					link.style.cursor = "pointer";
			    }
			}
			else
			{
				link.innerHTML = "";
				link.style.cursor = "default";
			}
			
			if (enabled)
			{
				link.parentNode.className = "obliqueSelectorCellOff";
			}
		};
		
		function OnClick()
		{
			if (!scene)
			{
				return;
			}
			
			map.SetObliqueScene(scene.GetID());
		}
		
		function OnMouseOver(e)
		{
			link.parentNode.className = "obliqueSelectorCellOn";
		}
		
		function OnMouseOut(e)
		{
			link.parentNode.className = "obliqueSelectorCellOff";
		}
	}
	
	this.Update = Update;
	this.Show = Show;
	this.Hide = Hide;
}
//------------------------------------------------------------------------------
// MapControl/Dashboard/OrthoZoomBar.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Codye
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// OrthoZoomBar constructor, creates the zoom widget at the specified
// location and starting at the specified zoom level
function OrthoZoomBar(parent)
{
	var container = document.createElement("div");
    var plus = document.createElement("div");
    var bar = document.createElement("div");
    var slider = document.createElement("div");
	var minus = document.createElement("div");
	
	var x = 0, y = 0;
	var dragging = false;
	
	this.Init = function()
	{
		minus.className = "ZoomBar_minus";
		minus.unselectable = "on";
		minus.attachEvent("onclick", Minus);
		
		slider.className = "ZoomBar_slider";
		slider.unselectable = "on";
		slider.attachEvent("onmousedown", MouseDown);
		slider.attachEvent("onmousemove", MouseMove);
		slider.attachEvent("onmouseup", MouseUp);
		slider.attachEvent("onclick", IgnoreEvent);

		bar.className = "ZoomBar_bar";
		bar.unselectable = "on";
		bar.appendChild(slider);
		bar.attachEvent("onclick", Jump);
		
		plus.className = "ZoomBar_plus";
		plus.unselectable = "on";
		plus.attachEvent("onclick", Plus);

		container.className = "ZoomBar";
		container.appendChild(minus);
		container.appendChild(bar);
		container.appendChild(plus);
		container.attachEvent("onmousedown", IgnoreEvent);
		container.attachEvent("onmouseup", IgnoreEvent);
		container.attachEvent("onclick", IgnoreEvent);
		container.attachEvent("ondblclick", IgnoreEvent);
				
		parent.appendChild(container);
		
		UpdateFromMap();
	};
	
	this.Destroy = function()
	{
		minus.detachEvent("onclick", Minus);
		
		slider.detachEvent("onmousedown", MouseDown);
		slider.detachEvent("onmousemove", MouseMove);
		slider.detachEvent("onmouseup", MouseUp);
		slider.detachEvent("onclick", IgnoreEvent);
		
		bar.removeChild(slider);
		bar.detachEvent("onclick", Jump);
		
		plus.detachEvent("onclick", Plus);
		
		container.removeChild(plus);
		container.removeChild(bar);
		container.removeChild(minus);
		container.detachEvent("onmousedown", IgnoreEvent);
		container.detachEvent("onmousedown", IgnoreEvent);
		container.detachEvent("onclick", IgnoreEvent);
		container.detachEvent("ondblclick", IgnoreEvent);
		
		parent.removeChild(container);
		
		map.DetachEvent("onendzoom", UpdateFromMap);
		
		minus = slider = bar = plus = container = parent = map = null;
	};
	
	function Show()
	{
		container.style.display = "block";
	}
	
	function Hide()
	{
		container.style.display = "none";
	}
	
	// Updates the position tracking variables so the control can perform
	// calculations based on positions.
	function UpdatePosition()
	{
		x = GetLeftPosition(container);
		y = GetTopPosition(container);
	}
	
	// MouseDown handler for the slider control.
	function MouseDown(e)
	{
		e = GetEvent(e);
		CancelEvent(e);
		
		UpdatePosition();
		
		if (slider.setCapture)
		{
			slider.setCapture();
		}
		
		dragging = true;
		return false;
	}
	
	// MouseMove handler for the slider control.  If dragging, 
	// moves the slider around as appropriate.
	function MouseMove(e)
	{
		e = GetEvent(e);
		CancelEvent(e);
	    
		if (dragging)
		{
			slider.style.left = AdjustMouseXbyOffsets(GetMouseX(e)) + "px";
		}
		
		return false;
	}

	// MouseUp handler for the slider control.  Gets the x
	// position and attempts to set the best zoom level.
	function MouseUp(e)
	{
		e = GetEvent(e);
		CancelEvent(e);
    
		if (slider.releaseCapture)
		{
			slider.releaseCapture();
		}
		
		dragging = false;
		SetPosition(AdjustMouseXbyOffsets(GetMouseX(e)));
		orthoZoom.UpdateFromMap();
		obliqueZoom.UpdateFromMap();
		return false;
	}
	
	// OnClick handler for the "plus" button, which zooms in.  Note that this
	// does not actually adjust the position of the slider.  That happens
	// in response to the zoom level changing.
	function Plus(e)
	{
		map.ZoomIn();
	}
	
	// OnClick handler for the "minus" button, which zooms out.  Note that this
	// does not actually adjust the position of the slider.  That happens
	// in response to the zoom level changing.
	function Minus(e)
	{
		map.ZoomOut();
	}
	
	// OnClick handler for the bar beneath the slider.  If clicked,
	// attempts to jump to the best zoom level for that location.
	function Jump(e)
	{
		e = GetEvent(e);
		CancelEvent(e);
		UpdatePosition();
		SetPosition(AdjustMouseXbyOffsets(GetMouseX(e)));
		return false;
	}
	
	function AdjustMouseXbyOffsets(mouseX)
	{
		mouseX -= x + minus.offsetWidth + slider.offsetWidth;
		var max = bar.offsetWidth - slider.offsetWidth;
	            
		if(mouseX < 0)
		{
			mouseX = 0;
		}
		else if(mouseX > max) 
		{
			mouseX = max;
		}
	    
		return mouseX;
	}
	
	// Finds the best zoom level for an x-location.  Note that this
	// does not actually adjust the position of the slider.  That happens
	// in response to the zoom level changing.
	function SetPosition(pos)
	{
		var max = bar.offsetWidth - slider.offsetWidth;
		var zoom = 1 + MathRound(pos / max * 18);
		map.SetZoom(zoom);
	}
	
	// Updates the slider position based on the map's current zoom level
	function UpdateFromMap()
	{
		var max = bar.offsetWidth - slider.offsetWidth;
		var pos = (map.GetZoomLevel() - 1) / 18 * max;
		slider.style.left = pos + "px";
	}
	
	this.UpdateFromMap = UpdateFromMap;
	this.Show = Show;
	this.Hide = Hide;
}
//------------------------------------------------------------------------------
// MapControl/Dashboard/ObliqueZoomBar.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: a-bwrigh
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


function ObliqueZoomBar(parent)
{
	var container       = document.createElement("div");
	var smallViewButton = document.createElement("div");
	var largeViewButton = document.createElement("div");
	
	container.title = L_ObliqueZoomBarSelectZoom_Text;
	
	container.setAttribute("id","obliqueZoomContainer");
	smallViewButton.setAttribute("id","obliqueZoomSmall");
	smallViewButton.className = "obliqueZoomSmallOn";
	
	largeViewButton.setAttribute("id","obliqueZoomLarge");
	largeViewButton.className = "obliqueZoomLargeOff";
	
	smallViewButton.attachEvent("onclick",OnSmallClick);
	
	largeViewButton.attachEvent("onclick",OnLargeClick);
	
	container.appendChild(smallViewButton);
	container.appendChild(largeViewButton);
	
	
	parent.appendChild(container);
	
	function Show()
	{
		container.style.display = "block";
	}
	
	function Hide()
	{
		container.style.display = "none";
	}
	
	function OnSmallClick(e)
	{
		map.ZoomOut();
		smallViewButton.className = "obliqueZoomSmallOn";
		largeViewButton.className = "obliqueZoomLargeOff";
	}
	
	function OnLargeClick(e)
	{
		map.ZoomIn();
		smallViewButton.className = "obliqueZoomSmallOff";
		largeViewButton.className = "obliqueZoomLargeOn";
	}
	
	function Destroy()
	{
		smallViewButton.detachEvent("onclick",OnSmallClick);
		largeViewButton.detachEvent("onclick",OnLargeClick);
		container.removeChild(smallViewButton);
		container.removeChild(largeViewButton);
		smallViewButton = null;
		largeViewButton = null;
		container.parentNode.removeChild(container);
		container = null;
	}
	// Updates the slider position based on the map's current zoom level
	function UpdateFromMap()
	{
		if(map.GetZoomLevel() == 1)
		{
			smallViewButton.className = "obliqueZoomSmallOn";
			largeViewButton.className = "obliqueZoomLargeOff";
		}
		else 
		{
			smallViewButton.className = "obliqueZoomSmallOff";
			largeViewButton.className = "obliqueZoomLargeOn";
		}
	}
	
	this.Destroy = Destroy;
	this.Show = Show;
	this.Hide = Hide;
	this.UpdateFromMap = UpdateFromMap;
}
//------------------------------------------------------------------------------
// MapControl/Dashboard/ObliqueSelector.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: a-bwrigh
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


/** Class represents a rotatable compass point 
  *
  */
function ObliqueCompassPoint(id,dir,pos)
{
	var element = document.createElement("div");
	element.setAttribute("id",id);
	element.innerHTML = dir;
	var previousClass = "obliqueCompassPointOff";
	
	var currentPositionIndex = pos;
		
	element.attachEvent("onmouseover", OnMouseOver);
	element.attachEvent("onmouseout", OnMouseOut);
	element.attachEvent("onclick", OnClick);	
	
	this.onclick     = null;
	this.onmouseover = null;
	this.onmouseout  = null;	
	
	var me = this;
	
	var disabled = false;
	
	var rotator = new Rotator(element,17,17);
	
	/* handle mouse over events. Ignores mouse over events
	 * if compass point is disabled 
	 */
	function OnMouseOver(e)
	{
		if(disabled)
		{
			return ;
		}
		previousClass = element.className;
		element.className = "obliqueCompassPointHover";
		if(me.onmouseover)
		{
			me.onmouseover(e);
		}
	}
	/* handle mouse onclick events. Ignores mouse click events
	 * if compass point is disabled 
	 */
	function OnClick(e)
	{		
		if(disabled)
		{
			return ;
		}
		OnMouseOver(e);
				
		previousClass =  "obliqueCompassPointOn";
		if(me.onclick)
		{
			me.onclick(e);
		}
	}
	/* handle mouse out events. Ignores mouse out events
	 * if compass point is disabled 
	 */
	function OnMouseOut(e)
	{
		if(disabled)
		{
			return ;
		}
		element.className = previousClass;
		if(me.onmouseout)
		{
			me.onmouseout(e);
		}
	}
	
	/**   
	  * set the point to on state
      */
	function On()
	{		
		previousClass =  "obliqueCompassPointOn";
		element.className = "obliqueCompassPointOn";
	}
	/**   
	  * set the point to off state
      */
	function Off()
	{		
		previousClass =  "obliqueCompassPointOff";
		element.className = "obliqueCompassPointOff";
	}
	
	/**
	  * Disable the point to ignore mouse events
	  */
	function Disable()
	{
		disabled = true;
		Off();
	}
	/**
	  * enable the point to accept mouse events
	  */
	function Enable()
	{
		disabled = false;
		On();
	}
	
	function GetElement()
	{
		return element;
	}
	
	function GetCurrentPositionIndex()
	{
		return currentPositionIndex;
	}
	
	function SetCurrentPositionIndex(pos)
	{
		currentPositionIndex = pos;
	}
	/**
	  * Set the point to it's initial state and enable it
	  */
	function Reset()
	{
		rotator.Reset();
		Enable();
	}
	
	function SetCurrentPosition(position)
	{
		element.style.left = position.left;
		element.style.top  = position.top;
		
	}
	
	
	/**
	  * Class used to animation compass point in a circle
	  * param fulcrumX and fulcrumY is the center point
	  * around which the compass point will be rotated.
	  */
	function Rotator(elm,fulcrumX,fulcrumY)
	{
		var element = elm;
		var currentAngle = 0;
		var deltaAngle =  0.3;
		var targetAngle = 0;
		var deltaTime = 40;
		var radius = 25;
		var animating = false;
		var quartCircle = Math.PI / 2; //radians
		var isCCW = true;
		var limit = deltaAngle+0.1;
		
		/**
		  * Utility function to test if val1 is within 
	      * range of val2 using limit
	      */
	  
		function IsInRange(limit,val1,val2)
		{
			if(val1 >= val2-limit && val1 <= val2+limit)
			{
				return true;
			}
			return false;
		}
		
		/**
		  * Run loop that handles circular animation
		  */
		function Run()
		{			
			currentAngle+=deltaAngle;	
			if(currentAngle > Math.PI*2)
					currentAngle -= Math.PI*2;
			else if(currentAngle < 0)
			{
				currentAngle += Math.PI*2
			}
			if(IsInRange(limit,currentAngle,targetAngle))
			{		
				deltaAngle = 0.3;
				currentAngle = targetAngle;
				
				MoveToAngle(currentAngle);
				animating = false;
				return;
			}
			MoveToAngle(currentAngle);
			window.setTimeout(Run,deltaTime);
		}
		
		/**
		  * Move the element to the specified angle
		  * angle is in radians.
		  */
		function MoveToAngle(angle)
		{
			var x =  fulcrumX + (radius*Math.sin(angle));
			var y = fulcrumY + (radius*Math.cos(angle));
			element.style.left = x+"px";
			element.style.top = y+"px";
			
		}
		
		/**
		  * Kick off an animation to rotate the 
		  * element to the param angle
		  */
		function RotateTo(angle)
		{
			if(animating)
			return;
			animating = true;
			targetAngle = angle;
			Run();
		}
		
		/**
		  * rotate element to specified index 
		  * CCW is a bool value to define CCW or CW rotation
		  * index values are as follows:
		  * 0 - bottom
		  * 1 - right
		  * 3 - top
		  * 4 - left
		  */
		function RotateToIndex(index,CCW)
		{		
			isCCW = CCW;
			if(!isCCW)
			{   //negate the angle
				deltaAngle*=-1;
			}
			RotateTo(quartCircle*index);
		}
		
		function Reset()
		{
			animating = false;
			currentAngle = 0;
		}
		this.RotateTo = RotateTo;
		this.RotateToIndex = RotateToIndex;
		this.Reset = Reset;
	}	
	
	function Destroy()
	{
		element.parentNode.removeChild(element);
		element.detachEvent("onmouseover", OnMouseOver);
		element.detachEvent("onmouseout", OnMouseOut);
		element.detachEvent("onclick", OnClick);			
		element = null;
	}
	
	this.GetElement = GetElement;
	this.GetCurrentPositionIndex = GetCurrentPositionIndex;
	this.SetCurrentPositionIndex = SetCurrentPositionIndex;
	this.SetCurrentPosition = SetCurrentPosition;
	this.On = On;
	this.Off = Off;
	this.RotateToIndex = rotator.RotateToIndex;
	this.Reset = Reset;
	this.Disable = Disable;
	this.Enable = Enable;	
	this.Destroy = Destroy;
}

/**
  * Class: ObliqueCompass
  * UI Widget that manages the Oblique compass view 
  * and controls the rotation of the Oblique map
  */
function ObliqueCompass(container)
{
	var pointPositions = new Array();
	pointPositions.push({"top":"-8px","left":"17px"});
	pointPositions.push({"top":"17px","left":"42px"});
	pointPositions.push({"top":"42px","left":"17px"});
	pointPositions.push({"top":"17px","left":"-8px"});	
	
	var compassContainer = document.createElement("div");
	compassContainer.setAttribute("id","obliqueCompassContainer");
	compassContainer.title = L_ObliqueCompassSelectDirection_Text;	
	
	var northElm = new ObliqueCompassPoint("obliqueCompassPointN","N",0);
	var northElmRef = northElm.GetElement();
	northElmRef.attachEvent("onclick", OnNorthClick);
	northElmRef.attachEvent("onmouseover", OnNorthOver);
	northElmRef.attachEvent("onmouseout", SetArrowUp);
	
	var eastElm = new ObliqueCompassPoint("obliqueCompassPointE","E",1);
	var eastElmRef = eastElm.GetElement();
	eastElmRef.attachEvent("onclick", OnEastClick);
	eastElmRef.attachEvent("onmouseover", OnEastOver);
	eastElmRef.attachEvent("onmouseout", SetArrowUp);
			
	var southElm = new ObliqueCompassPoint("obliqueCompassPointS","S",2);
	var southElmRef = southElm.GetElement();
	southElmRef.attachEvent("onclick", OnSouthClick);
	southElmRef.attachEvent("onmouseover", OnSouthOver);
	southElmRef.attachEvent("onmouseout", SetArrowUp);
	
	var westElm = new ObliqueCompassPoint("obliqueCompassPointW","W",3);
	var westElmRef = westElm.GetElement();
	westElmRef.attachEvent("onclick", OnWestClick);
	westElmRef.attachEvent("onmouseover", OnWestOver);
	westElmRef.attachEvent("onmouseout", SetArrowUp);
		
	var arrowElm = document.createElement("div");
	
	compassContainer.appendChild(northElmRef);
	compassContainer.appendChild(eastElmRef);
	compassContainer.appendChild(southElmRef);
	compassContainer.appendChild(westElmRef);
	compassContainer.appendChild(arrowElm);
	
	container.appendChild(compassContainer);
	
	// Update the position from the map
	UpdateFromMap();

	/**
	  * Make sure the position of the points is always within range
	  */
	function WrapPosition(pos)
	{
		if(pos < 0)
		{
			pos = 4 - Math.abs(pos);
		}
		return pos;
	}
	
	/**
	  * Rotate all 4 points based on the current position of "compassPoint"
	  * If the point that was clicked is at position 3 then all points will
	  * be rotate CCW otherwise they'll be rotated CW.
	  */
	function RotatePointACWToTop(compassPoint)
	{
		var pos = compassPoint.GetCurrentPositionIndex();
		
		eastElm.SetCurrentPositionIndex(WrapPosition(eastElm.GetCurrentPositionIndex()-pos));
		westElm.SetCurrentPositionIndex(WrapPosition(westElm.GetCurrentPositionIndex()-pos));
		northElm.SetCurrentPositionIndex(WrapPosition(northElm.GetCurrentPositionIndex()-pos));
		southElm.SetCurrentPositionIndex(WrapPosition(southElm.GetCurrentPositionIndex()-pos));		
		var ccw = true;
		if(pos == 3)
		{
			ccw = false;
		}

		northElm.RotateToIndex(2-northElm.GetCurrentPositionIndex() < 0 ? northElm.GetCurrentPositionIndex(): 2-northElm.GetCurrentPositionIndex(),ccw);
		eastElm.RotateToIndex(2-eastElm.GetCurrentPositionIndex() < 0? eastElm.GetCurrentPositionIndex() : 2-eastElm.GetCurrentPositionIndex(),ccw);
		southElm.RotateToIndex(2-southElm.GetCurrentPositionIndex() < 0? southElm.GetCurrentPositionIndex(): 2-southElm.GetCurrentPositionIndex(),ccw );
		westElm.RotateToIndex(2-westElm.GetCurrentPositionIndex() < 0 ? westElm.GetCurrentPositionIndex(): 2-westElm.GetCurrentPositionIndex(),ccw);
	}
	
	/**
	  * Set the compass arrow direction based on the index value
	  * 0: up
	  * 1: right
	  * 2: down
	  * 3: left
	  */
	function SetArrowDirectionForIndex(index)
	{
		switch(index)
		{
			case 0 : SetArrowUp();break;
			case 1 : SetArrowRight();break;
			case 2 : SetArrowDown();break;
			case 3 : SetArrowLeft();break;
		}
	}
	
	function SetArrowUp()
	{
		arrowElm.className = "obliqueCompassArrowU";
	}
	
	function SetArrowDown()
	{
		arrowElm.className = "obliqueCompassArrowD";
	}
	
	function SetArrowRight()
	{
		arrowElm.className = "obliqueCompassArrowR";
	}
	
	function SetArrowLeft()
	{
		arrowElm.className = "obliqueCompassArrowL";
	}
	
	/**
	  * Handle south point clicked. This kicks off compass rotation
	  */
	function OnSouthClick(e)
	{
		RotatePointACWToTop(southElm);
		SetArrowDirectionForIndex(0);
		var scene = map.GetObliqueScene();
		if(scene)
		{
			var aScene = scene.GetRotation("South");
			if(aScene)
			{
				//map.SetObliqueScene(aScene.GetID());
				map.SetObliqueOrientation("South");
			}
		}
	}
	
	/**
	  * Handle north point clicked. This kicks off compass rotation
	  */
	function OnNorthClick(e)
	{
		RotatePointACWToTop(northElm);	
		SetArrowDirectionForIndex(0);
		var scene = map.GetObliqueScene();
		if(scene)
		{
			var aScene = scene.GetRotation("North");
			if(aScene)
			{
				//map.SetObliqueScene(aScene.GetID());
				map.SetObliqueOrientation("North");
			}
		}
	}
	
	/**
	  * Handle east point clicked. This kicks off compass rotation
	  */
	function OnEastClick(e)
	{
		RotatePointACWToTop(eastElm);
		SetArrowDirectionForIndex(0);
		var scene = map.GetObliqueScene();
		if(scene)
		{
			var aScene = scene.GetRotation("East");
			if(aScene)
			{
				//map.SetObliqueScene(aScene.GetID());
				map.SetObliqueOrientation("East");
			}
		}
	}
	/**
	  * Handle west point clicked. This kicks off compass rotation
	  */
	function OnWestClick(e)
	{
		RotatePointACWToTop(westElm);
		SetArrowDirectionForIndex(0);
		var scene = map.GetObliqueScene();
		if(scene)
		{
			var aScene = scene.GetRotation("West");
			if(aScene)
			{
				//map.SetObliqueScene(aScene.GetID());
				map.SetObliqueOrientation("West");
			}
		}
	}
	
	function OnSouthOver(e)
	{
		SetArrowDirectionForIndex(southElm.GetCurrentPositionIndex());
	}
	
	function OnEastOver(e)
	{
		SetArrowDirectionForIndex(eastElm.GetCurrentPositionIndex());
	}
	
	function OnWestOver(e)
	{
		SetArrowDirectionForIndex(westElm.GetCurrentPositionIndex());
	}
	
	function OnNorthOver(e)
	{
		SetArrowDirectionForIndex(northElm.GetCurrentPositionIndex());
	}
	
	function Hide()
	{
		compassContainer.style.display = "none";
	}
	
	function Show()
	{
		compassContainer.style.display = "block";
	}
	
	/**
	  * When the oblique view changes we need to make sure
	  * the compass is in the correct state. Enable all points
	  * that have valid scenes
	  */
	function UpdateFromMap()
	{
		var scene = map.GetObliqueScene();
		if (!scene)
		{
			return;
		}
		
		switch (scene.GetOrientation())
		{
			case "North":
				RotatePointACWToTop(northElm);
				break;
				
			case "South":
				RotatePointACWToTop(southElm);
				break;
				
			case "East":
				RotatePointACWToTop(eastElm);
				break;
				
			case "West":
				RotatePointACWToTop(westElm);
				break;
		}
		
		// Set the arrow up
		SetArrowDirectionForIndex(0);
		
		if (scene.GetRotation("North"))
		{
			northElm.Enable();
		}
		else
		{
			northElm.Disable();
		}
		
		if (scene.GetRotation("South"))
		{
			southElm.Enable();
		}
		else
		{
			southElm.Disable();
		}		
		
		if (scene.GetRotation("East"))
		{
			eastElm.Enable();
		}
		else
		{
			eastElm.Disable();
		}
		
		if (scene.GetRotation("West"))
		{
			westElm.Enable();
		}
		else
		{
			westElm.Disable();
		}
	}
	
	function Destroy()
	{
		northElm.Destroy();
		eastElm.Destroy();
		southElm.Destroy();
		westElm.Destroy();
		
		northElmRef.detachEvent("onclick", OnNorthClick);
		northElmRef.detachEvent("onmouseover", OnNorthOver);
		northElmRef.detachEvent("onmouseout", SetArrowUp);
		
		eastElmRef.detachEvent("onclick", OnEastClick);
		eastElmRef.detachEvent("onmouseover", OnEastOver);
		eastElmRef.detachEvent("onmouseout", SetArrowUp);
			
		southElmRef.detachEvent("onclick", OnSouthClick);
		southElmRef.detachEvent("onmouseover", OnSouthOver);
		southElmRef.detachEvent("onmouseout", SetArrowUp);
	
		westElmRef.detachEvent("onclick", OnWestClick);
		westElmRef.detachEvent("onmouseover", OnWestOver);
		westElmRef.detachEvent("onmouseout", SetArrowUp);
	
		compassContainer.parentNode.removeChild(compassContainer);
		compassContainer = null;
	}

	this.Hide = Hide;
	this.Show = Show;	
	this.UpdateFromMap = UpdateFromMap;
	this.Destroy = Destroy;	
}
};
//------------------------------------------------------------------------------
// MapControl/Dashboard/DashboardSize.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Codye
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

Msn.VE.DashboardSize = new function()
{
	this.Normal = "normal";
	this.Small = "small";
	this.Tiny = "tiny";
};
//------------------------------------------------------------------------------
// MapControl/LatLong.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

Msn.VE.LatLong = function(latitude, longitude)
{
	this.latitude = latitude;
	this.longitude = longitude;
	
	this.ToString = function()
	{
		return "(" + this.latitude + ", " + this.longitude + ")";
	};
	
	this.Copy = function(latlong)
	{
		if (!latlong)
		{
			return;
		}
		
		this.latitude = latlong.latitude;
		this.longitude = latlong.longitude;
	};
};
//------------------------------------------------------------------------------
// MapControl/LatLongRectangle.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

Msn.VE.LatLongRectangle = function(northwest, southeast)
{
	this.northwest = northwest;
	this.southeast = southeast;
	
	this.ToString = function()
	{
		return "(" + (this.northwest ? this.northwest.ToString() : "null") + ", " + (this.southeast ? this.southeast.ToString() : "null") + ")";
	};
	
	this.Copy = function(rect)
	{
		if (!rect)
		{
			return;
		}
		
		if (!this.northwest)
		{
			this.northwest = new Msn.VE.LatLong();
		}
		
		if (!this.southeast)
		{
			this.southeast = new Msn.VE.LatLong();
		}
		
		this.northwest.Copy(rect.northwest);
		this.southeast.Copy(rect.southeast);
	};
	
	// Computes the center latlong of the rectangle.
	this.Center = function()
	{
		var sinLat1 = Math.sin(this.northwest.latitude * Math.PI / 180.0);
		var sinLat2 = Math.sin(this.southeast.latitude * Math.PI / 180.0);
		var average = 0.25 * (Math.log((1.0 + sinLat1) / (1.0 - sinLat1)) + Math.log((1.0 + sinLat2) / (1.0 - sinLat2)));

		var center = new Msn.VE.LatLong();
		center.latitude = Math.atan(Math.exp(average)) * 360.0 / Math.PI - 90.0;
		center.longitude = 0.5 * (this.northwest.longitude + this.southeast.longitude);

		return center;
	};
	
	// Determines if a latlong is inside this latlong rectangle
	this.Contains = function(latlong)
	{
		return latlong.latitude <= northwest.latitude && 
			latlong.longitude >= northwest.longitude && 
			latlong.latitude >= southeast.latitude && 
			latlong.longitude <= southeast.longitude;
	};
};

//------------------------------------------------------------------------------
// MapControl/MapStyle.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

Msn.VE.MapStyle = new function()
{
	this.Road = "r";
	this.Aerial = "a";
	this.Hybrid = "h";
	this.Oblique = "o";
};

//------------------------------------------------------------------------------
// MapControl/MapView.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, keithkin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// A view consists of a lat/long, a zoom level and a map style
Msn.VE.MapView = function()
{
	this.zoomLevel = 0;
	this.mapStyle = null;
	this.center = new Msn.VE.Pixel();
	this.latlong = new Msn.VE.LatLong();
	this.pixelRect = new Msn.VE.PixelRectangle();
	this.latlongRect = new Msn.VE.LatLongRectangle();
	this.sceneId = null;
	this.sceneOrientation = null;
	
	// Private accessor to "this";
	var p_this = this;
	
	// The view type tracks what the defining type of the view is.  It can have one of
	// the following values: pixel, latlong,  pixelrect, latlongrect.
	// Pixel is the default and the preferred view type.  When setting a view, the map control
	// will always first try to resolve the view into a pixel view type.
	var viewType = "pixel";
	
	// Destroys this view, frees up object references.
	this.Destroy = function()
	{
		this.center = this.latlong = p_this = null;
	};
	
	this.GetViewType = function()
	{
		return viewType;
	};
	
	// Makes a new View object with the same contents.
	function MakeCopy()
	{
		var copy = new Msn.VE.MapView();
		copy.Copy(p_this);
		return copy;
	}
	
	// Copies the values of another view to this view.
	function Copy(view)
	{
		p_this.zoomLevel = view.zoomLevel;
		p_this.mapStyle = view.mapStyle;
		p_this.center.Copy(view.center);
		p_this.latlong.Copy(view.latlong);
		p_this.pixelRect.Copy(view.pixelRect);
		p_this.latlongRect.Copy(view.latlongRect);
		p_this.sceneId = view.sceneId;
		p_this.sceneOrientation = view.sceneOrientation;
		viewType = view.GetViewType();
	}
	
	// Tests for equality with another view object.  This is only applicable
	// when viewType = pixel.
	function Equals(view)
	{
		return view != null &&
			p_this.zoomLevel == view.zoomLevel &&
			p_this.mapStyle == view.mapStyle && 
			MathAbs(p_this.center.x - view.center.x) < 0.000001 &&
			MathAbs(p_this.center.y - view.center.y) < 0.000001 &&
			p_this.sceneId == view.sceneId &&
			p_this.sceneOrientation == view.sceneOrientation;
	}
	
	// Creates a string representation of this view object.
	function ToString()
	{
		return "(" + p_this.latlong.ToString() + ", " + p_this.zoomLevel + ", " + p_this.mapStyle + ")";
	}
	
	// Sets the center pixel.  Also updates the center latlong using the currentMode.
	function SetCenter(pixel)
	{
		if (!pixel)
		{
			return;
		}
		
		p_this.center = pixel;
		viewType = "pixel";
	}
	
	// Sets the center latlong.  Also updates the center pixel using the currentMode.
	function SetCenterLatLong(latlong)
	{
		if (!latlong)
		{
			return;
		}
		
		p_this.latlong = latlong;
		viewType = "latlong";
	}
	
	function SetPixelRectangle(pixelRect)
	{
		p_this.pixelRect = pixelRect;
		viewType = "pixelRect";
	}
	
	function SetLatLongRectangle(latlongRect)
	{
		p_this.latlongRect = latlongRect;
		viewType = "latlongRect";
	}
	
	// Sets the zoom level.  Updates the center pixel by scaling accordingly.
	// The center latlong should not need to change.
	function SetZoomLevel(zoomLevel)
	{
		// Zoom levels can never be less than or equal to zero.
		// If the zoom level drops below 1, set it to the min zoom level which is 1.
		if (zoomLevel <= 0)
		{
			zoomLevel = 1;
		}
		
		switch (viewType)
		{
			case "pixel":
				var factor = Math.pow(2, zoomLevel - p_this.zoomLevel);
				p_this.center.x *= factor;
				p_this.center.y *= factor;
				break;
				
			case "pixelRect":
				var factor = Math.pow(2, zoomLevel - p_this.zoomLevel);
				p_this.pixelRect.topLeft.x *= factor;
				p_this.pixelRect.topLeft.y *= factor;
				p_this.pixelRect.bottomRight.x *= factor;
				p_this.pixelRect.bottomRight.y *= factor;
				break;
		}
		
		p_this.zoomLevel = zoomLevel;
	}
	
	function SetMapStyle(mapStyle, sceneId, sceneOrientation)
	{
		p_this.mapStyle = mapStyle;
		
		if (viewType == "pixel")
		{
			viewType = "latlong";
		}
		
		if (mapStyle != 'o')
		{
			p_this.sceneId = null;
			p_this.sceneOrientation = null
		}
		else
		{
			p_this.sceneId = sceneId;
			p_this.sceneOrientation = sceneOrientation;
		}
	}
	
	// Gets the x at a zoom level.  This involves scaling the value by a power of 2.
	function GetX(zoomLevel)
	{
		if (zoomLevel)
		{
			return p_this.center.x * Math.pow(2, zoomLevel - p_this.zoomLevel);
		}
		
		return p_this.center.x;
	}
	
	// Gets the y at a zoom level.  This involves scaling the value by a power of 2.
	function GetY(zoomLevel)
	{
		if (zoomLevel)
		{
			return p_this.center.y * Math.pow(2, zoomLevel - p_this.zoomLevel);
		}
		
		return p_this.center.y;
	}
	
	// Gets the center point
	function GetCenter(zoomLevel)
	{
		if (zoomLevel == undefined)
		{
			return p_this.center;
		}
		
		return new Msn.VE.Pixel(p_this.GetX(zoomLevel), p_this.GetY(zoomLevel));
	}
	
	// Resolves the view into a pixel type view.  Also populates the center latlong object.
	// All of the view types can ultimately be boiled down to a center pixel and zoom level, 
	// given a view mode (which provides latlong to pixel conversion) and the control dimensions.
	function Resolve(viewMode, width, height)
	{
		switch (viewType)
		{
			case "pixel":
				p_this.latlong = viewMode.PixelToLatLong(p_this.center, p_this.zoomLevel);
				break;
			
			case "latlong":
				p_this.center = viewMode.LatLongToPixel(p_this.latlong, p_this.zoomLevel);
				break;
				
			case "pixelRect":
				ResolveRectangle(viewMode, width, height);
				break;
			
			case "latlongRect":
				if (p_this.mapStyle == "o")
				{
					p_this.zoomLevel = 1;
						
					var scene = viewMode.GetScene();
					if (!scene.ContainsLatLong(p_this.latlongRect.northwest) || !scene.ContainsLatLong(p_this.latlongRect.southeast))
					{
						p_this.latlong = p_this.latlongRect.Center();
						p_this.center = viewMode.LatLongToPixel(p_this.latlong, p_this.zoomLevel);
					}
					else
					{
						p_this.pixelRect.topLeft = viewMode.LatLongToPixel(p_this.latlongRect.northwest, p_this.zoomLevel);
						p_this.pixelRect.bottomRight = viewMode.LatLongToPixel(p_this.latlongRect.southeast, p_this.zoomLevel);
						ResolveRectangle(viewMode, width, height);
					}
				}
				else
				{
					p_this.zoomLevel = 12;
					p_this.pixelRect.topLeft = viewMode.LatLongToPixel(p_this.latlongRect.northwest, p_this.zoomLevel);
					p_this.pixelRect.bottomRight = viewMode.LatLongToPixel(p_this.latlongRect.southeast, p_this.zoomLevel);
					ResolveRectangle(viewMode, width, height);
				}
				
				break;			
		}
		
		viewType = "pixel";
	}
	
	// Resolves the pixel rectangle to a center point.  
	function ResolveRectangle(viewMode, width, height)
	{
		var zoomPivot = 19;
		var zoomFactor = Math.pow(2, zoomPivot - p_this.zoomLevel);
		var viewportWidth = MathMax(1, MathAbs(p_this.pixelRect.topLeft.x - p_this.pixelRect.bottomRight.x) * zoomFactor);
		var viewportHeight = MathMax(1, MathAbs(p_this.pixelRect.topLeft.y - p_this.pixelRect.bottomRight.y) * zoomFactor);
		var log2 = Math.log(2);
		
		var horizontalZoom = zoomPivot - Math.ceil(Math.log(viewportWidth / width) / log2);
		var verticalZoom = zoomPivot - Math.ceil(Math.log(viewportHeight / height) / log2);
		var newZoom = MathMin(horizontalZoom, verticalZoom);		
		// Zoom levels can never be less than or equal to zero.
		// If the zoom level drops below 1, set it to the min zoom level which is 1.
		if (newZoom <= 0)
		{
			newZoom = 1;
		}
		
		zoomFactor = Math.pow(2, newZoom - p_this.zoomLevel);
		p_this.center.x = 0.5 * (p_this.pixelRect.topLeft.x + p_this.pixelRect.bottomRight.x) * zoomFactor;
		p_this.center.y = 0.5 * (p_this.pixelRect.topLeft.y + p_this.pixelRect.bottomRight.y) * zoomFactor;
		p_this.zoomLevel = newZoom;
		p_this.latlong = viewMode.PixelToLatLong(p_this.center, p_this.zoomLevel);
	}
	
	this.MakeCopy = MakeCopy;
	this.Copy = Copy;
	this.Equals = Equals;
	this.ToString = ToString;
	this.SetCenter = SetCenter;
	this.SetCenterLatLong = SetCenterLatLong;
	this.SetPixelRectangle = SetPixelRectangle;
	this.SetLatLongRectangle = SetLatLongRectangle;
	this.SetZoomLevel = SetZoomLevel;
	this.SetMapStyle = SetMapStyle;
	this.GetX = GetX;
	this.GetY = GetY;
	this.GetCenter = GetCenter;
	this.Resolve = Resolve;
	this.SetZoomLevel = SetZoomLevel;
};

//------------------------------------------------------------------------------
// MapControl/ObliqueScene.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// The ObliqueScene class represents one oblique image.
// The id is a unique identifier for this image that is used when creating
// tile and thumbnail filenames.
// The orientation is the direction that this oblique image is facing in degrees.
// Points is an array of latlong points that define the scene.  It starts in the top left corner
// and goes around clockwise.
// Neighbors is an array of oblique id's for the neighboring images.
// Rotations is an array of oblique id's for different orientations of the same location.
Msn.VE.ObliqueScene = function(id, quadKey, runtimeIndex, orientation, baseZoom, stripe, maxTileX, maxTileY, pixelToLatLongMatrix, latLongToPixelMatrix, neighbors, rotations)
{
	// The size of one tile
	var tileSize = 256;
	
	this.neighborScenes = neighbors;
	
	// The bounds of the image.  It is defined in the top zoom level (1 in this case), so we
	// need to scale down the tile extents.
	var bounds = new Msn.VE.Bounds(1, 2, 0, 0, maxTileX / 2, maxTileY / 2);
	
	// Converts a pixel to a lat/long using the precomputed matrix
	function PixelToLatLong(pixel, zoomLevel)
	{
		var zoomFactor = Math.pow(2, zoomLevel - 2);
		var vector = [[ pixel.x / zoomFactor ], [ pixel.y / zoomFactor ], [ 1 ]];
		var result = MatrixMultiply(pixelToLatLongMatrix, vector);

		var latlong = new Msn.VE.LatLong();
		latlong.longitude = result[0][0] / result[2][0];
		latlong.latitude = result[1][0] / result[2][0];

		return latlong;
	}
	
	// Converts a lat/long to a pixel using the precomputed matrix
	function LatLongToPixel(latlong, zoomLevel)
	{
		var zoomFactor = Math.pow(2, zoomLevel - 2);
		var vector = [[ latlong.longitude ], [ latlong.latitude ], [ 1 ]];
		var result = MatrixMultiply(latLongToPixelMatrix, vector);

		var pixel = new Msn.VE.Pixel();
		pixel.x = result[0][0] / result[2][0] * zoomFactor;
		pixel.y = result[1][0] / result[2][0] * zoomFactor;

		return pixel;
	}
	
	// Determines if the tile is within valid range for a zoom level.
	function IsValidTile(tileX, tileY, zoomLevel)
	{
		if (tileX < 0 || tileY < 0)
		{
			return false;
		}
		
		if (zoomLevel == 1)
		{
			return tileX < (maxTileX / 2) && tileY < (maxTileY / 2);
		}
		
		return tileX < maxTileX && tileY < maxTileY;
	}
	
	// Returns the id of the scene
	function GetID()
	{
		return id;
	}
	
	// Builds a filename for a tile
	function GetTileFilename(tileX, tileY, zoomLevel)
	{
		var tileId = tileY * (zoomLevel == 1 ? maxTileX / 2 : maxTileX) + tileX;
		return "http://c" + (tileX % 2) + ".p" + stripe + ".__obliqueTileServer__o" + quadKey + "-" + runtimeIndex + "-" + (baseZoom + zoomLevel - 2) + "-" + tileId + ".jpeg?g=__obliqueGeneration__";
	}
	
	// Builds a filename for a tile
	function GetThumbnailFilename()
	{
		return "http://thumbs.__obliqueTileServer__ot" + id + ".jpeg?g=__obliqueGeneration__";
	}
	
	// Gets a neighbor
	function GetNeighbor(i)
	{
		var sceneId = neighbors[i];
		if (sceneId == null || sceneId == -1)
		{
			return null;
		}
		
		return new Msn.VE.ObliqueScene(sceneId);
	}
	
	// Gets a rotation
	function GetRotation(i)
	{
		var sceneId = rotations[i];
		if (sceneId == null || sceneId == -1)
		{
			return null;
		}
		
		return new Msn.VE.ObliqueScene(sceneId);
	}
	
	// Gets the orientation of this scene
	function GetOrientation()
	{
		return orientation;
	}
	
	// Gets the tile bounds of this scene
	function GetBounds()
	{
		return bounds;
	}
	
	// Gets the width of the scene
	function GetWidth()
	{
		return maxTileX * tileSize;
	}
	
	// Gets the height of the scene
	function GetHeight()
	{
		return maxTileY * tileSize;
	}
	
	// Determines if this scene contains a latlong
	function ContainsLatLong(latlong)
	{
		if (!latlong)
		{
			return false;
		}
	
		var pixel = LatLongToPixel(latlong, 2);
		return ContainsPixel(pixel, 2);
	}
	
	// Determines if this scene contains a pixel point
	function ContainsPixel(pixel, zoomLevel)
	{
		var zoomFactor = Math.pow(2, 2 - zoomLevel);
		var x = pixel.x * zoomFactor;
		var y = pixel.y * zoomFactor;
		return x >=0 && y >= 0 && x < GetWidth() && y < GetHeight();	
	}

	this.PixelToLatLong = PixelToLatLong;
	this.LatLongToPixel = LatLongToPixel;
	this.IsValidTile = IsValidTile;
	this.GetID = GetID;
	this.GetTileFilename = GetTileFilename;
	this.GetThumbnailFilename = GetThumbnailFilename;
	this.GetNeighbor = GetNeighbor;
	this.GetRotation = GetRotation;
	this.GetOrientation = GetOrientation;
	this.GetBounds = GetBounds;
	this.GetWidth = GetWidth;
	this.GetHeight = GetHeight;
	this.ContainsLatLong = ContainsLatLong;
	this.ContainsPixel = ContainsPixel;
};
//------------------------------------------------------------------------------
// MapControl/Orientation.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

Msn.VE.Orientation = new function()
{
	this.North = "North";
	this.East = "East";
	this.West = "West";
	this.South = "South";
};


//------------------------------------------------------------------------------
// MapControl/Pixel.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

Msn.VE.Pixel = function(x, y)
{
	this.x = x;
	this.y = y;
	
	this.ToString = function()
	{
		return "(" + this.x + ", " + this.y + ")";
	};
	
	this.Copy = function(pixel)
	{
		if (!pixel)
		{
			return;
		}
		
		this.x = pixel.x;
		this.y = pixel.y;
	};
};

//------------------------------------------------------------------------------
// MapControl/PixelRectangle.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

Msn.VE.PixelRectangle = function(topLeft, bottomRight)
{
	this.topLeft = topLeft;
	this.bottomRight = bottomRight;
	
	this.ToString = function()
	{
		return "(" + (this.topLeft ? this.topLeft.ToString() : "null") + ", " + (this.bottomRight ? this.bottomRight.ToString() : "null") + ")";
	};
	
	this.Copy = function(rect)
	{
		if (!rect)
		{
			return;
		}
		
		if (!this.topLeft)
		{
			this.topLeft = new Msn.VE.Pixel();
		}
		
		if (!this.bottomRight)
		{
			this.bottomRight = new Msn.VE.Pixel();
		}
		
		this.topLeft.Copy(rect.topLeft);
		this.bottomRight.Copy(rect.bottomRight);
	};
};

//------------------------------------------------------------------------------
// MapControl/LineRegion.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: EShinn
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// Describes a section of a line.
Msn.VE.LineRegion = function(boundingRectangle, indices, childRegions)
{
	this.boundingRectangle = boundingRectangle;
	this.indices = indices;
	this.childRegions = childRegions;
	
	function ToString()
	{
		return "Bounding Rectangle: " + this.boundingRectangle[0].ToString() + " to " + this.boundingRectangle[1].ToString() + " | Indices: [" + indices + "]";
	};
	this.ToString = ToString;
}
//------------------------------------------------------------------------------
// NumberEncoding.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: keithkin
//
// <header>	$NumberEncoding$</header>
//------------------------------------------------------------------------------

//Exceptions that can be thrown
var L_integerencodingoutofrange_text = "VEIntegerEncoding: The number encoded is out of supported range";
var L_floatintegermapencodingoutofrange_text = "VEFloatIntegerMap: The number encoded is out of supported range";
var L_integerencodinginvalidstringlength_text = "VEIntegerEncoding: Invalid string length";
var L_integerencodingunknowndigit_text = "VEIntegerEncoding: The encoded string has an unknown digit";

//VEIntegerEncoding
//   Encodes an integer as a string using base N notation with the passed in digits to use as characters.
//   The algorithm is from BBeatty.
//
//   interface:
//      VEIntegerEncoding(digits, valueLength)
//         constructor
//         digits: string of characters to use in the string encoding. Each char must be unique.
//         valueLength: the number of encoding chars to use in the string when encoding
//   
//      MaxValue()
//         returns max possible integer value
// 
//      ValueLength()
//         returns length of encoded value
//
//      Encode(numValue)
//         numValue: integer
//         encodes numvalue and returns encoded string
//         throws exception if numValue is out of range
//
//      Decode(str)
//         str: encoded string
//         decodes string value and returns decoded integer
//         throws exception if there is an invalid digit in the string
//         throws exception if string is incorrect length
//
//		DigitValue(digit)
//         digit: encoded digit
//         returns decoded integer value for digit.
//         throws exception if digit is not in the hashtable
//
function VEIntegerEncoding(digits, valueLength)
{
	var m_digits = digits;
	var m_base = digits.length;
	var m_valueLength = valueLength;
	
	//calculate the max value that can be stored
	var power=1;
	for (var i=0; i < m_valueLength; ++i)
	{
		power *= m_base;
	}
	var m_maxValue = power - 1;
	
	//map from digits to values
	var m_digitMap = new Array();
	for (var digitValue=0; digitValue < m_digits.length; ++digitValue)
	{
		m_digitMap[m_digits.substr(digitValue,1)] = digitValue;
	}

	//MaxValue
	this.MaxValue = function()
	{
		return m_maxValue;
	}
	
	//ValueLength
	this.ValueLength = function()
	{
		return m_valueLength;
	}
	
	//Encode
	this.Encode = function(numValue)
	{
		if (numValue <= m_maxValue)
		{
			var encodedString = "";

			//create an array of digits
			var digitValues = new Array();
			
			//initialize the digit values in the array to 0
			for (var i=0; i < m_valueLength; ++i)
			{
				digitValues[i] = 0;
			}

			//populate digits from the provided value. Start from least-significant to most-significant
			var digitIndex = m_valueLength - 1;
			while (numValue > 0)
			{
				digitValues[digitIndex] = Math.floor(numValue % m_base);
				numValue = Math.floor(numValue / m_base);
				--digitIndex;
			}

			//Build the encoded string from the provided value
			for (var i=0; i < digitValues.length; ++i)
			{
				encodedString += m_digits.substr(digitValues[i],1);
			}
			
			return encodedString;
		}
		else
		{
			//out of range exception
			throw L_integerencodingoutofrange_text;
		}
	}
	
	//Decode
	this.Decode = function(strValue)
	{
		if (strValue.length == m_valueLength)
		{
			var numValue = 0;
			for( var i=0; i < strValue.length; ++i)
			{
				numValue *= m_base;
				numValue += this.DigitValue(strValue.substr(i,1));
			}
			
			return numValue;
		}
		else
		{
			//invalid string length exception
			throw L_integerencodinginvalidstringlength_text;
		}
	}
	
	//DigitValue
	this.DigitValue = function(digit)
	{
		if ((m_digitMap[digit] != null) && (m_digitMap[digit] != "undefined"))
		{
			return m_digitMap[digit];
		}
		else
		{
			//Unknown digit exception
			throw L_integerencodingunknowndigit_text;
		}
	}
}

//VEFloatIntegerMap
//   Maps a range of floating-point values to range of integers
//   The algorithm is from BBeatty.
//
//   interface:
//      VEFloatIntegerMap(minFloat, maxFloat, maxInt)
//         constructor
//            minFloat: min float value
//            maxFloat: max float value
//            maxInt: max int value
//   
//      MinFloat()
//         returns min possible float value
// 
//      MaxFloat()
//         returns max possible float value
//
//      MaxInt()
//         returns max possible int value
//
//      FloatToInt(floatValue)
//         floatValue: floating point number
//         returns mapped integer value from floating point value 
//         throws exception if floatValue is out of range
//
//      IntToFloat(intValue)
//         intValue: integer
//         returns mapped floating point value from passed in int value
//         throws exception if intValue is out of range
//
function VEFloatIntegerMap(minFloat, maxFloat, maxInt)
{
	var m_minFloat = minFloat;
	var m_maxFloat = maxFloat;
	var m_maxInt = maxInt;
	
	this.MinFloat = function() { return m_minFloat; }
	this.MaxFloat = function() { return m_maxFloat; }
	this.MaxInt = function() { return m_maxInt; }
	
	//FloatToInt
	this.FloatToInt = function(floatValue)
	{
		if ((floatValue >= m_minFloat) && (floatValue <= m_maxFloat))
		{
			var fraction = (floatValue - m_minFloat) / (m_maxFloat - m_minFloat);
			var intValue = (fraction * m_maxInt) + 0.5;
			return Math.min(Math.floor(intValue), m_maxInt);
		}
		else
		{
			//Out of range exception
			throw L_floatintegermapencodingoutofrange_text;
		}
	}
	
	//IntToFloat
	this.IntToFloat = function(intValue)
	{
		if (intValue <= m_maxInt)
		{
			var fraction = intValue / m_maxInt;
			var floatNumber = m_minFloat + fraction * (m_maxFloat - m_minFloat);
			return floatNumber;
		}
		else
		{
			//Out of range exception
			throw L_floatintegermapencodingoutofrange_text;
		}	
	}
}
//------------------------------------------------------------------------------
// LatLongEncoding.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: keithkin
//
// <header>	$LatLongEncoding$</header>
// Dependencies:
//   NumberEncoding.js
//------------------------------------------------------------------------------

var L_velatlongencodinginvalidstringlength_text = "VELatLongEncoding: Invalid string length";

//VELatLongEncoding
//   Encodes/Decodes latitude/longitude coordinates to a hash string
//   The algorithm is from BBeatty.
//
//   interface:
//      VELatLongEncoding()
//         constructor
//
//      Encode(latitude, longitude)
//         takes a float latitude and float longitude and returns encoded string
//         throws exception if latitude or longitude is out of range
//
//      Decode(str)
//         takes an encoded string and returns decoded latitude and longitude parameters in an array
//         the first element in the array is the latitude.
//         the second element in the array is the longitude.
//         throws exception if string is invalid length
//         throws exception if there is an invalid digit in the encoding
//
function VELatLongEncoding()
{
	var m_minLatitude = -90;
	var m_maxLatitude = 90;
	var m_minLongitude = -180;
	var m_maxLongitude = 180;
	var m_digits = "0123456789bcdfghjkmnpqrstvwxyz";
	var m_valueLength = 6;	//value length of the string encoding
	
	var m_integerEncoding = new VEIntegerEncoding(m_digits, m_valueLength);
	var m_latitudeMap = new VEFloatIntegerMap(m_minLatitude, m_maxLatitude, m_integerEncoding.MaxValue());
	var m_longitudeMap = new VEFloatIntegerMap(m_minLongitude, m_maxLongitude, m_integerEncoding.MaxValue());
	
	//Encode
	this.Encode = function(latitude, longitude)
	{
		var s = m_integerEncoding.Encode(m_latitudeMap.FloatToInt(latitude)) + 
				m_integerEncoding.Encode(m_longitudeMap.FloatToInt(longitude)) ;
		return s;
	}
	
	//Decode
	this.Decode = function(str)
	{
		if (str.length == 2 * m_integerEncoding.ValueLength())
		{
			var valueLength = m_integerEncoding.ValueLength();
			var strLatitude = str.substr(0, valueLength);
			var strLongitude = str.substr(valueLength, valueLength);
			var intLatitude = m_integerEncoding.Decode(strLatitude);
			var intLongitude = m_integerEncoding.Decode(strLongitude);
			var latLongArray  =new Array();
			latLongArray[0]= m_latitudeMap.IntToFloat(intLatitude);
			latLongArray[1]= m_longitudeMap.IntToFloat(intLongitude);
			return latLongArray;
		}
		else
		{
			//invalid string length exception
			throw L_velatlongencodinginvalidstringlength_text;
		}
	}
}
